#*************************************************************************
#
#   OpenOffice.org - a multi-platform office productivity suite
#
#   $RCSfile: makefile.mk,v $
#
#   $Revision: 1.5 $
#
#   last change: $Author: rt $ $Date: 2005/09/07 23:34:59 $
#
#   The Contents of this file are made available subject to
#   the terms of GNU Lesser General Public License Version 2.1.
#
#
#     GNU Lesser General Public License Version 2.1
#     =============================================
#     Copyright 2005 by Sun Microsystems, Inc.
#     901 San Antonio Road, Palo Alto, CA 94303, USA
#
#     This library is free software; you can redistribute it and/or
#     modify it under the terms of the GNU Lesser General Public
#     License version 2.1, as published by the Free Software Foundation.
#
#     This library is distributed in the hope that it will be useful,
#     but WITHOUT ANY WARRANTY; without even the implied warranty of
#     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
#     Lesser General Public License for more details.
#
#     You should have received a copy of the GNU Lesser General Public
#     License along with this library; if not, write to the Free Software
#     Foundation, Inc., 59 Temple Place, Suite 330, Boston,
#     MA  02111-1307  USA
#
#*************************************************************************

PRJ=..$/..

PRJNAME=canvas
TARGET=directxcanvas
ENABLE_EXCEPTIONS=TRUE


# --- Settings -----------------------------------------------------------

.INCLUDE :	settings.mk

# --- Common ----------------------------------------------------------

.IF "$(ENABLE_DIRECTX)" != ""

.IF "$(verbose)"!="" || "$(VERBOSE)"!=""
CDEFS+= -DVERBOSE
.ENDIF

# --- This is Windows only! { ----------------------------------------------------------------

.IF "$(GUI)" == "WNT"

SLOFILES = \
	$(SLO)$/dx_canvasbitmap.obj 			\
	$(SLO)$/dx_canvascustomsprite.obj 		\
	$(SLO)$/dx_canvasfont.obj 				\
	$(SLO)$/dx_canvashelper.obj				\
	$(SLO)$/dx_device.obj 					\
	$(SLO)$/dx_gdiplususer.obj				\
	$(SLO)$/dx_gdisurface.obj				\
	$(SLO)$/dx_impltools.obj 				\
	$(SLO)$/dx_linepolypolygon.obj 			\
	$(SLO)$/dx_plainsurface.obj				\
	$(SLO)$/dx_parametricpolypolygon.obj	\
	$(SLO)$/dx_spritecanvas.obj 			\
	$(SLO)$/dx_surfacegraphics.obj			\
	$(SLO)$/dx_surfacemanager.obj 			\
	$(SLO)$/dx_textlayout.obj				\
	$(SLO)$/dx_textlayout_drawhelper.obj	\
	$(SLO)$/dx_texture.obj					\
	$(SLO)$/dx_windowgraphicdevice.obj

SHL1TARGET=$(TARGET).uno

SHL1STDLIBS= $(CPPULIB) $(SALLIB) $(COMPHELPERLIB) $(CPPUHELPERLIB) $(BASEGFXLIB) $(CANVASTOOLSLIB) $(VCLLIB) $(TOOLSLIB)

#SHL1VERSIONMAP=$(TARGET).map

SHL1IMPLIB=i$(TARGET)
SHL1LIBS=$(SLB)$/$(TARGET).lib
SHL1DEF=$(MISC)$/$(SHL1TARGET).def

DEF1NAME=$(SHL1TARGET)
DEF1EXPORTFILE=exports.dxp

# Generic Windows specifica
SHL1STDLIBS += gdi32.lib

# DirectX specifica
SHL1STDLIBS += ddraw.lib
SHL1STDLIBS += d3dx.lib

# GDIPlus specifica
SHL1STDLIBS += gdiplus.lib

.ENDIF # IF "$(GUI)" == "WNT"
.ENDIF # IF "$(ENABLE_DIRECTX)" != ""

# --- This is Windows only! } ----------------------------------------------------------------

# ==========================================================================

.INCLUDE :	target.mk
