/*************************************************************************
 *
 *  OpenOffice.org - a multi-platform office productivity suite
 *
 *  $RCSfile: brwcontrollistener.hxx,v $
 *
 *  $Revision: 1.3 $
 *
 *  last change: $Author: rt $ $Date: 2005/09/08 20:04:48 $
 *
 *  The Contents of this file are made available subject to
 *  the terms of GNU Lesser General Public License Version 2.1.
 *
 *
 *    GNU Lesser General Public License Version 2.1
 *    =============================================
 *    Copyright 2005 by Sun Microsystems, Inc.
 *    901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *    This library is free software; you can redistribute it and/or
 *    modify it under the terms of the GNU Lesser General Public
 *    License version 2.1, as published by the Free Software Foundation.
 *
 *    This library is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *    Lesser General Public License for more details.
 *
 *    You should have received a copy of the GNU Lesser General Public
 *    License along with this library; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *    MA  02111-1307  USA
 *
 ************************************************************************/

#ifndef _EXTENSIONS_PROPCTRLR_BRWCONTROLLISTENER_HXX_
#define _EXTENSIONS_PROPCTRLR_BRWCONTROLLISTENER_HXX_

//............................................................................
namespace pcr
{
//............................................................................

	class IBrowserControl;
	//========================================================================
	//= IBrowserControlListener
	//========================================================================
	class IBrowserControlListener
	{
	public:
		virtual void	Modified	(IBrowserControl* _pControl)					= 0;
		virtual void	GetFocus	(IBrowserControl* _pControl)					= 0;
		virtual void	Commit		(IBrowserControl* _pControl)					= 0;
		virtual void	KeyInput	(IBrowserControl* _pControl, const KeyCode&)	= 0;
		virtual void	TravelLine	(IBrowserControl* _pControl)					= 0;
	};

//............................................................................
} // namespace pcr
//............................................................................

#endif // _EXTENSIONS_PROPCTRLR_BRWCONTROLLISTENER_HXX_

