/*************************************************************************
 *
 *  OpenOffice.org - a multi-platform office productivity suite
 *
 *  $RCSfile: indexdata_ko_dict.h,v $
 *
 *  $Revision: 1.2 $
 *
 *  last change: $Author: rt $ $Date: 2005/09/07 17:13:35 $
 *
 *  The Contents of this file are made available subject to
 *  the terms of GNU Lesser General Public License Version 2.1.
 *
 *
 *    GNU Lesser General Public License Version 2.1
 *    =============================================
 *    Copyright 2005 by Sun Microsystems, Inc.
 *    901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *    This library is free software; you can redistribute it and/or
 *    modify it under the terms of the GNU Lesser General Public
 *    License version 2.1, as published by the Free Software Foundation.
 *
 *    This library is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *    Lesser General Public License for more details.
 *
 *    You should have received a copy of the GNU Lesser General Public
 *    License along with this library; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *    MA  02111-1307  USA
 *
 ************************************************************************/
#include <sal/types.h>

static sal_Unicode idxStr[] = {
	0x0000, // 0
	0x3131, 0x0000, // 1 (1)
	0x3134, 0x0000, // 3 (2)
	0x3137, 0x0000, // 5 (3)
	0x3139, 0x0000, // 7 (4)
	0x3141, 0x0000, // 9 (5)
	0x3142, 0x0000, // 11 (6)
	0x3145, 0x0000, // 13 (7)
	0x3147, 0x0000, // 15 (8)
	0x3148, 0x0000, // 17 (9)
	0x314A, 0x0000, // 19 (10)
	0x314B, 0x0000, // 21 (11)
	0x314C, 0x0000, // 23 (12)
	0x314D, 0x0000, // 25 (13)
	0x314E, 0x0000, // 27 (14)
};

static sal_uInt16 idx1[] = {
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 0000
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 1000
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 2000
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 3000
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0x0100,   // 4000
	0x0200, 0x0300, 0x0400, 0x0500, 0x0600, 0x0700, 0x0800, 0x0900, 0x0A00, 0x0B00, 0x0C00, 0x0D00, 0x0E00, 0x0F00, 0x1000, 0x1100,   // 5000
	0x1200, 0x1300, 0x1400, 0x1500, 0x1600, 0x1700, 0x1800, 0x1900, 0x1A00, 0x1B00, 0x1C00, 0x1D00, 0x1E00, 0x1F00, 0x2000, 0x2100,   // 6000
	0x2200, 0x2300, 0x2400, 0x2500, 0x2600, 0x2700, 0x2800, 0x2900, 0x2A00, 0x2B00, 0x2C00, 0x2D00, 0x2E00, 0x2F00, 0x3000, 0x3100,   // 7000
	0x3200, 0x3300, 0x3400, 0x3500, 0x3600, 0x3700, 0x3800, 0x3900, 0x3A00, 0x3B00, 0x3C00, 0x3D00, 0x3E00, 0x3F00, 0x4000, 0x4100,   // 8000
	0x4200, 0x4300, 0x4400, 0x4500, 0x4600, 0x4700, 0x4800, 0x4900, 0x4A00, 0x4B00, 0x4C00, 0x4D00, 0x4E00, 0x4F00, 0x5000, 0x5100,   // 9000
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x5200, 0x5300, 0x5400, 0x5500,   // A000
	0x5600, 0x5700, 0x5800, 0x5900, 0x5A00, 0x5B00, 0x5C00, 0x5D00, 0x5E00, 0x5F00, 0x6000, 0x6100, 0x6200, 0x6300, 0x6400, 0x6500,   // B000
	0x6600, 0x6700, 0x6800, 0x6900, 0x6A00, 0x6B00, 0x6C00, 0x6D00, 0x6E00, 0x6F00, 0x7000, 0x7100, 0x7200, 0x7300, 0x7400, 0x7500,   // C000
	0x7600, 0x7700, 0x7800, 0x7900, 0x7A00, 0x7B00, 0x7C00, 0x7D00, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // D000
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // E000
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x7E00, 0xFFFF, 0x7F00, 0x8000, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // F000
};
static sal_uInt16 idx2[] = {
	15, 17,  0, 19,  0,  0,  0,  9, 17, 13, 13, 27,  0, 11,  0,  0,   // 4E00 - 4E0F
	 0, 19,  0,  0, 19, 11, 13,  0,  1, 11,  0,  0,  0,  0, 13,  0,   // 4E10 - 4E1F
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 17,  0,  0,   // 4E20 - 4E2F
	 0,  0,  1,  0,  0,  0,  0,  0, 27,  5,  0, 17,  0,  0,  0,  0,   // 4E30 - 4E3F
	 0,  0, 15,  3,  0,  1,  0,  0,  0,  0,  0, 17,  0, 13, 27, 25,   // 4E40 - 4E4F
	 0,  0,  0,  0,  0,  0,  1,  0, 13, 15,  0,  0,  0,  1,  1, 15,   // 4E50 - 4E5F
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  1,  0,  5,  0,  0,   // 4E60 - 4E6F
	 0,  0,  0, 15,  0,  0, 11, 13,  0,  0,  0,  0,  0,  0,  1,  0,   // 4E70 - 4E7F
	 0,  0,  7,  0,  0,  0,  7,  0, 15,  0,  0, 13, 15,  0, 15,  0,   // 4E80 - 4E8F
	15, 15, 27,  0, 15, 17,  0,  0,  1,  0,  0, 13,  0,  0, 15,  0,   // 4E90 - 4E9F
	 0,  9, 27,  0,  1, 27, 15,  0, 27,  0,  0, 27,  1, 17,  7,  0,   // 4EA0 - 4EAF
	 0,  0,  0,  0,  0,  0,  5,  0,  0,  0, 15,  0,  0,  0,  0,  0,   // 4EB0 - 4EBF
	13, 15,  0,  0, 19,  0,  0,  1,  0,  0,  1,  1,  0, 15,  0,  0,   // 4EC0 - 4ECF
	 0,  0,  0,  0, 17, 13, 23, 17, 11, 13,  0,  0,  0,  5,  0, 19,   // 4ED0 - 4EDF
	 0,  0,  0,  5,  7, 15,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 4EE0 - 4EEF
	15,  0, 17,  0,  0,  0,  1,  1,  0,  0,  0, 15,  0,  0,  0,  0,   // 4EF0 - 4EFF
	 0,  1,  0,  0,  0,  0,  0,  0,  0, 27, 15,  1,  0, 15,  1, 11,   // 4F00 - 4F0F
	11, 27,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 4F10 - 4F1F
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 11,   // 4F20 - 4F2F
	 0,  0,  0,  0, 11,  0,  7,  0, 13,  0, 13,  0, 13,  1,  0,  0,   // 4F30 - 4F3F
	 0,  0,  0, 17,  0,  0,  5, 17, 25,  0,  0,  0,  0, 15, 17, 17,   // 4F40 - 4F4F
	17, 15,  0,  0,  0, 27,  0,  0,  0, 15, 15, 11, 17,  0,  0,  0,   // 4F50 - 4F5F
	 0,  0,  0,  0,  0,  0,  0,  0,  0, 25,  0,  0,  0,  0,  0, 15,   // 4F60 - 4F6F
	11,  0,  0,  1,  0,  0,  1,  0,  0,  0, 17,  0,  0,  0, 15, 13,   // 4F70 - 4F7F
	 0, 13,  0,  1, 17,  0,  7,  0, 19,  0,  1,  7,  0, 13,  0, 17,   // 4F80 - 4F8F
	 0, 15,  0,  0,  0,  0,  7,  0, 19,  0,  0,  1,  0, 15,  0,  0,   // 4F90 - 4F9F
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  9, 27,   // 4FA0 - 4FAF
	 0,  0,  0,  0,  0, 19,  7,  0,  0,  0,  0,  0,  0,  0,  0, 25,   // 4FB0 - 4FBF
	 0,  0,  1, 19, 15,  0,  0,  0,  0, 15, 17,  0,  0,  0, 17,  0,   // 4FC0 - 4FCF
	 0, 15,  0,  1, 27,  0,  0, 13,  0,  0,  7,  0,  0, 11,  0, 13,   // 4FD0 - 4FDF
	27, 13,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 13, 11,   // 4FE0 - 4FEF
	 0,  1,  0, 11,  0, 25,  0,  0, 11,  0, 15,  0,  0,  0,  0,  0,   // 4FF0 - 4FFF
	 0,  0, 11,  0,  0,  0,  7,  0,  0, 19,  0,  1,  0, 11,  0,  0,   // 5000 - 500F
	 0,  9,  5,  0,  0,  0, 27,  0,  0, 27, 15,  0, 19,  0,  1, 19,   // 5010 - 501F
	 0, 19,  0, 11, 19,  0,  1, 17,  1,  0, 15,  7, 23, 15,  0,  0,   // 5020 - 502F
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 15,  0,  0,  0,  0,   // 5030 - 503F
	 0,  0,  0, 15,  0,  0,  0,  1,  1, 15,  0,  0,  0,  0,  0, 25,   // 5040 - 504F
	 0,  0,  0,  0,  0, 27,  0,  0,  0,  0, 17,  0, 17,  0,  0,  0,   // 5050 - 505F
	 0,  0,  0,  0,  0,  1,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 5060 - 506F
	 0,  0,  0,  0, 19, 17, 15,  0, 23,  0,  0,  0,  0,  0,  0,  0,   // 5070 - 507F
	 1,  0,  0,  0,  0, 11,  0,  0,  0,  0,  0,  0,  0, 11,  0,  0,   // 5080 - 508F
	 0,  1,  0,  0,  0,  0,  0,  0, 13, 11,  0,  0,  0,  0,  0,  0,   // 5090 - 509F
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 19, 15,  0,  0,   // 50A0 - 50AF
	 0,  0, 15, 17,  0, 19,  0, 13,  0,  0,  0,  0,  0,  0,  1,  0,   // 50B0 - 50BF
	 0,  0,  0,  0,  0,  1,  0,  0,  0, 19, 13,  0,  0,  0,  0, 13,   // 50C0 - 50CF
	 0,  1,  0,  0,  0, 11, 27,  0,  0,  0,  7,  0,  0,  0, 15,  0,   // 50D0 - 50DF
	 0,  0,  0,  0,  0, 15,  0, 13,  0,  0,  0,  0,  0, 19,  0,  0,   // 50E0 - 50EF
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  1,  0, 11,  0,  0,  0, 13,   // 50F0 - 50FF
	15, 17,  0,  0, 15,  0,  1,  0,  0,  1,  0,  0,  0,  0,  0,  0,   // 5100 - 510F
	 0,  0, 15,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 13,   // 5110 - 511F
	 0,  7,  0,  0,  0,  0,  0,  0,  0,  0, 15,  0,  0,  0,  0,  0,   // 5120 - 512F
	 0,  0, 17,  0,  0,  0,  0,  7,  0,  0,  3,  0, 15,  0,  0,  0,   // 5130 - 513F
	15, 15,  0, 15, 27, 19, 17, 27, 13,  1,  0,  1, 23,  9, 23,  0,   // 5140 - 514F
	 0,  0, 15,  0,  0,  0,  0,  0,  0,  0,  0,  0,  5,  0,  0,  0,   // 5150 - 515F
	 0,  0,  1,  0,  0, 15,  0,  3, 17,  7, 15, 25,  1,  7, 27,  0,   // 5160 - 516F
	 0,  1,  0,  0,  0, 11,  1,  1, 17,  0,  0,  0,  1,  0,  0,  0,   // 5170 - 517F
	 1,  0,  0,  0,  0,  0, 15,  0,  0,  0, 19,  0,  0, 17,  0,  0,   // 5180 - 518F
	 0,  0,  9,  0,  0,  9,  0, 15,  0,  0,  0,  0,  0,  0,  0,  0,   // 5190 - 519F
	 1,  0,  0,  0,  0,  9,  0,  0,  0,  0,  9,  0,  5,  0,  0,  0,   // 51A0 - 51AF
	 0,  0,  0,  0,  0,  0, 15,  7,  0,  0,  0,  0,  0,  7,  0,  0,   // 51B0 - 51BF
	 0,  0,  0,  0, 19,  0, 17,  0,  0,  7,  0, 17,  7,  5,  0,  0,   // 51C0 - 51CF
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  7, 15, 27,  0,   // 51D0 - 51DF
	 0, 11,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 51E0 - 51EF
	27,  1,  0,  0,  0,  0, 27,  0, 19, 15, 19,  0,  0, 27,  0,  0,   // 51F0 - 51FF
	 5,  0,  0, 15,  0,  0, 11, 17, 15,  0,  1,  0,  0,  0,  9,  0,   // 5200 - 520F
	 0, 27,  0,  0,  0,  0,  0,  7,  0,  0,  0,  0,  0, 19,  0,  0,   // 5210 - 521F
	 0,  0,  0,  0, 25, 11,  0,  0,  0,  7, 13,  0,  0,  0,  1,  0,   // 5220 - 522F
	 5,  0,  0,  0,  0,  0, 17, 13,  1, 19, 17,  1,  0,  0,  0,  0,   // 5230 - 523F
	 0,  0,  0, 19,  0,  0,  0, 19,  0,  0, 13,  1,  7, 17,  0,  0,   // 5240 - 524F
	 0,  0,  0,  0, 19,  0, 11,  0,  0,  0,  0,  1,  0, 11,  0,  0,   // 5250 - 525F
	 0, 13,  0,  0,  0,  0,  0,  0,  0, 15, 17,  0,  0,  0,  0, 11,   // 5260 - 526F
	 0,  0, 27,  0,  0, 19,  0,  0,  0,  0,  0,  0,  0, 25,  0, 19,   // 5270 - 527F
	 0,  0,  0, 27,  0,  0,  0,  1, 11,  7,  0,  0,  0,  1,  0,  0,   // 5280 - 528F
	 0, 17,  1,  0,  0,  0,  0,  0,  0,  0,  0,  7,  0,  0,  0,  1,   // 5290 - 529F
	 1,  0,  0,  7,  1,  0,  0,  0,  0, 17,  3,  1,  0,  0,  0,  0,   // 52A0 - 52AF
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 27,  0,   // 52B0 - 52BF
	 0,  1,  0, 11,  0, 19,  0, 15,  0,  9,  0,  0,  0,  1,  0,  0,   // 52C0 - 52CF
	 0,  0,  7,  0,  0,  5, 15,  0,  1,  9,  0, 27,  0, 13,  7,  9,   // 52D0 - 52DF
	 0,  0, 13, 17,  1,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 52E0 - 52EF
	 0,  0,  0, 27,  0,  7,  0,  0,  1,  0, 17,  1,  0,  0,  1,  9,   // 52F0 - 52FF
	 0,  0,  0,  0,  0, 25,  0,  0, 27,  0,  0,  0,  0, 25,  0, 25,   // 5300 - 530F
	11,  0,  0,  0,  0, 11, 27, 11,  0, 13,  0,  0,  0,  0,  0,  0,   // 5310 - 531F
	17,  1,  0,  1,  0,  0,  0,  0,  0,  0, 11,  0,  0,  0,  0, 27,   // 5320 - 532F
	 0,  0,  0,  0,  0,  0,  0,  0,  0, 25,  0,  0,  0,  0,  0,  3,   // 5330 - 533F
	 1, 13,  0, 19, 15,  0,  0, 13, 15, 27, 11,  0,  0,  9,  0,  0,   // 5340 - 534F
	 0, 11, 17, 23, 27,  0,  0,  3,  0,  0, 11,  0, 11,  0, 11,  0,   // 5350 - 535F
	17,  0,  0,  0,  0,  0,  1,  0, 13,  0,  0,  0,  0,  0,  0,  9,   // 5360 - 536F
	15, 15,  0,  0,  1,  7,  0,  1,  0,  0,  0,  0,  0, 17,  0,  1,   // 5370 - 537F
	 0,  0,  0,  0, 15,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 5380 - 538F
	 0,  0,  0, 15,  0,  0,  0,  0,  7,  0, 27,  0,  0,  0,  0, 15,   // 5390 - 539F
	19,  0,  0,  0,  0,  1, 27,  0,  0,  0,  0,  0,  0, 15,  0,  0,   // 53A0 - 53AF
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  1,  0,  0,  0,  0,   // 53B0 - 53BF
	 0,  0,  0, 19,  0,  0,  0,  0, 15, 19,  1, 15,  0, 11,  0,  0,   // 53C0 - 53CF
	 0,  0,  0,  0, 13,  0, 19, 13,  0,  0,  0, 11,  0,  0,  0,  0,   // 53D0 - 53DF
	 0, 15, 19,  1,  1,  1,  0,  0,  0,  1, 17,  1, 13, 25,  0,  1,   // 53E0 - 53EF
	23, 17, 13, 15,  0,  0,  0,  0, 13,  0,  0,  0,  0,  0,  0,  0,   // 53F0 - 53FF
	 0,  0,  0, 27,  1,  0,  0,  0, 27,  1, 17,  0,  5,  9, 27,  7,   // 5400 - 540F
	23, 27,  0,  0,  0,  0,  0,  0,  0,  0,  0,  1,  0,  7,  0, 15,   // 5410 - 541F
	25,  0,  0,  0,  0,  0, 11,  0,  0, 11,  0, 27,  0,  0,  0,  0,   // 5420 - 542F
	 0,  0,  0, 15,  0,  0,  0,  0, 27, 19,  0,  9, 27,  0, 15,  0,   // 5430 - 543F
	 0,  0,  7,  0,  0,  0,  0,  0, 17,  0,  1,  0,  0,  0,  0,  0,   // 5440 - 544F
	 0, 23,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 5450 - 545F
	 0,  0,  0,  0,  0,  0,  0,  0, 17,  0, 17,  0,  0,  0,  0,  0,   // 5460 - 546F
	 0,  1,  0,  9,  0,  1,  0,  0,  0,  0,  0, 13, 27,  9,  0,  0,   // 5470 - 547F
	17,  0,  0,  0,  0,  0, 25,  0,  0,  0,  0,  0, 27,  0,  1,  0,   // 5480 - 548F
	11,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 5490 - 549F
	 0,  0,  0,  0, 23,  0,  0,  0, 17,  0,  0, 17,  1,  0,  0,  0,   // 54A0 - 54AF
	 0,  0,  0, 27,  0,  0,  0,  0, 27,  0,  0,  0,  0, 15,  0,  0,   // 54B0 - 54BF
	15, 25,  0,  0, 27,  0,  0,  0, 27, 17,  0,  0,  0,  0,  0,  0,   // 54C0 - 54CF
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 54D0 - 54DF
	 0, 15,  0,  0,  0,  1,  0,  0, 19,  0,  0,  0,  0,  1, 27,  0,   // 54E0 - 54EF
	 0,  0, 19,  0,  0,  0,  0,  0,  0,  0, 25,  0,  0,  0,  0,  0,   // 54F0 - 54FF
	 0,  0,  0,  0, 25,  0, 13, 17,  0,  0,  0,  0,  0,  0,  7,  0,   // 5500 - 550F
	 5,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  9,  0,  0,  0,   // 5510 - 551F
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 15,   // 5520 - 552F
	 0, 19,  0,  0,  0, 15,  0,  0,  0,  0,  0,  0,  0,  0, 23,  0,   // 5530 - 553F
	 0,  0,  0,  0, 23,  0, 13,  0,  0,  0,  0,  0,  0,  0,  0,  9,   // 5540 - 554F
	 0,  0,  0,  1,  0,  0,  5,  0,  0,  0,  0,  0,  0,  0, 15,  0,   // 5550 - 555F
	 0,  0,  0, 27,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 5560 - 556F
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 17,  0,  0,  0,   // 5570 - 557F
	 1,  0,  0,  0, 13,  0, 19,  7,  0, 27, 27,  0,  0,  0,  0,  0,   // 5580 - 558F
	 0,  0,  0,  0,  0,  0,  0,  0, 19, 27, 27,  0, 27,  1,  0,  0,   // 5590 - 559F
	 0,  0,  0,  0,  0,  0,  0, 27,  0, 15, 13,  1,  1,  0,  5,  0,   // 55A0 - 55AF
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 55B0 - 55BF
	 0,  0,  0,  0,  0, 27,  0, 13,  0,  0,  0,  0,  0,  0,  0,  0,   // 55C0 - 55CF
	 0,  0,  0,  0, 17,  0,  0,  0,  0,  0, 15,  0,  1,  0,  0, 19,   // 55D0 - 55DF
	 0,  0,  0, 13, 19,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 55E0 - 55EF
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 13, 17,  0,   // 55F0 - 55FF
	 0,  0,  0,  0,  0,  0, 23,  0,  0,  1,  0,  0,  0,  0,  0,  0,   // 5600 - 560F
	 0,  0,  0,  0,  1,  0,  0, 13,  0,  0,  0,  0,  0,  0,  0,  0,   // 5610 - 561F
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 13,   // 5620 - 562F
	 0,  0, 17,  0, 19,  0, 13,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 5630 - 563F
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 5640 - 564F
	 0,  0,  0, 27,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 5650 - 565F
	 0,  0,  0,  0,  0,  0,  0,  0,  1,  0,  0, 27,  0,  0,  0,  0,   // 5660 - 566F
	 0,  0,  0,  0, 11,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 5670 - 567F
	 0,  0,  0,  0,  0,  0, 27,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 5680 - 568F
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 5690 - 569F
	 0,  0,  0,  0,  0, 15,  0,  0,  0,  0,  0,  0, 11,  0, 27,  0,   // 56A0 - 56AF
	 0,  0,  0,  0, 15,  0,  0,  0,  0,  0,  0,  0, 17,  0,  0,  0,   // 56B0 - 56BF
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  3,  0,  0, 27,  0,  0,   // 56C0 - 56CF
	 0, 19,  0,  0,  0,  0,  0,  0,  0,  0, 13, 13,  0,  0, 27,  0,   // 56D0 - 56DF
	15,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 56E0 - 56EF
	 1,  0,  0,  0,  0,  0,  0,  0,  0,  7,  1,  0,  0,  0,  0,  0,   // 56F0 - 56FF
	 0,  0,  0, 25, 15,  0,  0,  0,  1,  0,  0,  1,  0, 15,  0,  0,   // 5700 - 570F
	 0,  0, 15, 15,  0,  0,  5,  0,  5,  0,  0,  0,  0,  0,  0, 23,   // 5710 - 571F
	 0,  0,  0,  0,  0,  0,  0,  0, 17,  0,  0,  0,  0,  1,  0,  0,   // 5720 - 572F
	17,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  1,  0,  0,  0,  0,   // 5730 - 573F
	17,  0, 25,  0,  0,  0,  0,  1,  0,  0, 11,  0,  0,  5,  1,  0,   // 5740 - 574F
	17,  1,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 5750 - 575F
	 0, 25,  0,  0,  1,  0, 23,  0,  0,  0, 25,  0,  0,  0,  5,  0,   // 5760 - 576F
	 1,  0,  0,  0,  0,  1,  0,  0,  0,  0,  0,  0, 23,  0,  0,  0,   // 5770 - 577F
	 0,  0, 13,  0,  0,  0,  0,  0,  5,  0,  0, 27,  0,  0,  0,  0,   // 5780 - 578F
	 0,  0,  0, 27,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 5790 - 579F
	15,  0,  1, 15,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 57A0 - 57AF
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 57B0 - 57BF
	 0,  0,  0, 15,  0,  0,  0, 15, 17,  0,  0,  9,  0,  0, 13,  0,   // 57C0 - 57CF
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 15,   // 57D0 - 57DF
	11,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 57E0 - 57EF
	19,  0,  0,  0, 13,  0,  0, 17,  0, 11,  1,  0,  1,  0,  0,  0,   // 57F0 - 57FF
	 1,  0,  5,  0,  0,  1, 23,  0,  1, 15, 15,  0,  0,  0,  0,  0,   // 5800 - 580F
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 19,  0,   // 5810 - 581F
	 0, 11,  0,  0, 17,  0,  0, 15,  0,  0,  1,  0,  0,  0,  0, 15,   // 5820 - 582F
	15, 11,  0,  0, 17,  5,  0,  0,  0,  0,  1,  0,  0,  0,  0,  0,   // 5830 - 583F
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  1, 15,  0,  0,  0,  1,   // 5840 - 584F
	 0, 13,  0,  0, 23,  0,  0,  5,  5,  0, 19,  0,  0,  0, 13,  0,   // 5850 - 585F
	 0, 17, 15,  0, 27,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 5860 - 586F
	 0,  0,  0,  0,  0, 17,  0,  0,  0, 19,  0,  0, 17,  0, 13,  0,   // 5870 - 587F
	 0,  0,  0,  1,  0, 13,  0,  0,  0, 15,  0,  0,  0,  0,  0,  0,   // 5880 - 588F
	 0,  0,  0,  9,  0,  0,  0,  0,  0,  0,  0,  0, 19,  0, 17, 27,   // 5890 - 589F
	 0,  0,  0,  0,  0,  0,  0,  0,  9,  5,  0,  0,  0,  0, 23,  0,   // 58A0 - 58AF
	 0,  0,  0, 11,  0,  0,  0,  0,  0,  0, 15, 17,  0,  0,  1,  0,   // 58B0 - 58BF
	 0, 11,  0,  0,  0, 15,  0,  5,  0,  0,  0,  0,  0,  0, 27,  0,   // 58C0 - 58CF
	 0, 27,  0, 15,  0, 27,  0,  0,  7,  1,  0,  0,  0,  0,  1,  7,   // 58D0 - 58DF
	 0,  0,  0,  0, 15,  0,  0,  0,  0,  0,  0, 13, 15,  0,  0, 17,   // 58E0 - 58EF
	 0,  0,  0,  0,  0,  0,  0,  0,  0, 15, 27, 13,  0, 13,  0,  0,   // 58F0 - 58FF
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 27,   // 5900 - 590F
	 0,  0,  0,  0,  1, 13, 15,  0,  0, 13,  5,  0, 15,  0,  0,  0,   // 5910 - 591F
	 0,  0,  9,  0,  0,  0,  0,  5,  0, 19, 23, 11,  0, 15, 15,  0,   // 5920 - 592F
	 0, 13,  0,  0,  0,  0,  0, 15,  0,  0,  0,  0,  0,  0, 27,  0,   // 5930 - 593F
	 0,  0,  0,  0, 15,  0,  0,  1,  3, 11,  0,  0,  0,  0,  1, 17,   // 5940 - 594F
	27,  1,  0,  0, 11, 27,  0, 23,  0,  0, 27,  0,  0,  0,  0,  0,   // 5950 - 595F
	17,  0, 13,  0,  0,  0,  0, 15,  0,  0, 23, 15, 17, 13, 11,  0,   // 5960 - 596F
	 0,  0,  0,  3,  3,  0,  0,  0,  1,  0,  0,  0,  0, 27,  0,  0,   // 5970 - 597F
	 0,  0, 15, 11,  9,  0,  0,  0,  0,  0, 15,  0,  0,  0,  0,  0,   // 5980 - 598F
	 0,  0,  0,  1,  0,  0, 15,  1,  0,  9,  0,  0,  0,  0,  0,  0,   // 5990 - 599F
	 0,  0,  0,  0,  0, 23,  0,  0, 11,  0,  0,  0, 23,  0,  0,  0,   // 59A0 - 59AF
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  9,  0, 19,  0,  0, 19,  0,   // 59B0 - 59BF
	 0,  0,  0, 17,  0,  0,  9,  0,  0, 17,  0, 13,  0,  0,  0,  0,   // 59C0 - 59CF
	17,  1,  0, 13, 15,  0,  0,  0,  0, 15, 15,  0,  1, 17,  0,  0,   // 59D0 - 59DF
	 0,  0,  0,  0,  0,  0,  1,  0, 15,  0, 17,  0, 27,  0, 27,  0,   // 59E0 - 59EF
	 0,  0,  0,  0,  0,  0,  0,  0, 15,  0,  0, 15,  0,  0,  0, 17,   // 59F0 - 59FF
	 0, 15,  0, 15,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 5A00 - 5A0F
	 0, 13,  0,  0,  0,  0,  0,  0,  3,  0,  0, 15,  3,  0,  0, 15,   // 5A10 - 5A1F
	13,  0,  0,  0,  0, 15,  0,  0,  0,  9,  0,  0,  0,  0,  0,  0,   // 5A20 - 5A2F
	 0,  0,  0,  0,  0,  0, 19,  0,  0,  0,  0,  0, 19,  0,  0,  0,   // 5A30 - 5A3F
	 0,  7,  0,  0,  0,  0, 25,  0,  0, 15,  0,  0,  0,  0,  0,  0,   // 5A40 - 5A4F
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 27,  0,  0,  0,  0,  0,   // 5A50 - 5A5F
	 0,  0, 11,  0,  0,  0, 11,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 5A60 - 5A6F
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 5A70 - 5A7F
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 5A80 - 5A8F
	 0,  0,  9,  0,  0,  0,  0,  0,  0,  0,  9, 15,  0,  0,  0,  0,   // 5A90 - 5A9F
	 0,  0,  0,  0, 13,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 5AA0 - 5AAF
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 5AB0 - 5ABF
	 0,  1, 13,  0, 15,  0,  0,  0,  0, 17,  0,  0, 27,  0,  0,  0,   // 5AC0 - 5ACF
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 5AD0 - 5ADF
	 0, 17,  0,  0,  0,  0, 27,  0,  0,  3,  0,  0,  0,  0,  0,  0,   // 5AE0 - 5AEF
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 5AF0 - 5AFF
	 0,  0,  0,  0,  0, 27,  0,  0,  0, 27,  0, 13,  1,  0,  0,  0,   // 5B00 - 5B0F
	 0,  0,  0,  0,  0,  0, 25,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 5B10 - 5B1F
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 11,  0,  0,  0,  0,  0,   // 5B20 - 5B2F
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 5B30 - 5B3F
	13,  0,  0, 15,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 5B40 - 5B4F
	17, 27,  0,  0,  1, 15,  0, 17, 17,  0, 11,  0, 17, 27,  0,  9,   // 5B50 - 5B5F
	 0,  0,  0,  1,  1,  0,  0,  0,  0, 27,  0, 13,  0,  0,  0,  0,   // 5B60 - 5B6F
	13, 17,  0,  0,  0, 11,  0,  0, 27,  0, 15,  0, 15,  0,  0,  0,   // 5B70 - 5B7F
	 0,  0,  0,  0,  0,  5,  0, 15, 13, 15,  0, 13, 15,  0,  0,  1,   // 5B80 - 5B8F
	 0,  0,  0, 11,  0, 23, 27, 17,  1, 17, 17, 15, 15,  0,  0,  0,   // 5B90 - 5B9F
	 0,  0,  1, 13, 13, 15, 27,  0,  0,  0,  0,  0, 13,  0,  1,  0,   // 5BA0 - 5BAF
	17,  0,  0, 27, 15, 13,  1,  0, 13, 15,  0,  0,  0,  0,  0, 13,   // 5BB0 - 5BBF
	19,  0, 17, 15,  1, 15,  9,  1,  0,  0,  0,  0, 11,  0,  0,  0,   // 5BC0 - 5BCF
	 9,  0, 27, 15, 13,  0,  0,  3,  0,  0,  0,  0,  0,  0,  9, 19,   // 5BD0 - 5BDF
	 0,  1, 19,  0, 15, 15, 13,  3, 19, 13,  0, 13,  1,  0,  7, 17,   // 5BE0 - 5BEF
	 0,  0,  0,  0,  0, 19, 11,  0, 19,  0, 13,  0,  0,  0,  0,  0,   // 5BF0 - 5BFF
	 0, 11,  0,  0, 13,  0,  0, 17, 17, 15, 17, 13,  0,  5,  5, 13,   // 5C00 - 5C0F
	 0, 13,  0,  0,  0,  0, 19,  0,  0, 13,  0,  0,  0,  0,  0,  0,   // 5C10 - 5C1F
	 0,  0,  0,  0, 15,  0,  0,  0, 11,  0,  0,  0,  0,  0,  0,  0,   // 5C20 - 5C2F
	 0, 19,  0,  0,  0,  0,  0,  0, 13, 15, 19,  1,  3,  0,  9,  3,   // 5C30 - 5C3F
	 1,  0,  0,  0,  0,  1,  1,  0,  1,  0,  0, 15,  0, 13, 13,  0,   // 5C40 - 5C4F
	 0, 13,  0,  0,  0, 17,  0,  0,  0,  0,  0, 11,  0,  0,  0,  0,   // 5C50 - 5C5F
	 5,  0,  7,  0, 19,  7,  0,  0,  0,  0,  0,  0, 13,  0,  0,  5,   // 5C60 - 5C6F
	 0, 13,  0,  0,  0,  0,  0,  0,  0, 27,  0,  0,  0,  0,  0,  0,   // 5C70 - 5C7F
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 5C80 - 5C8F
	 1, 17,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 5C90 - 5C9F
	 0,  1,  0,  0,  0,  0,  0,  0,  0, 15,  0, 13,  1,  0,  0,  0,   // 5CA0 - 5CAF
	 0,  5,  0, 15,  0, 27,  0,  9, 15,  0,  7,  0,  0,  0, 17,  0,   // 5CB0 - 5CBF
	13,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 5CC0 - 5CCF
	 0,  0,  0,  0,  0,  0,  0,  0,  0, 19,  0,  0,  0,  0,  0,  0,   // 5CD0 - 5CDF
	13,  0,  0,  0,  0,  0,  0,  0, 15,  0,  0,  0,  0,  0,  0, 11,   // 5CE0 - 5CEF
	11,  0,  0,  0, 27,  0,  5,  0,  0,  0,  0, 17,  0, 27,  0,  0,   // 5CF0 - 5CFF
	 0,  0,  0,  0,  0,  0,  0, 13,  0,  0,  0,  0,  0,  7,  1,  0,   // 5D00 - 5D0F
	 0,  1,  0,  0, 19,  0, 15,  1,  0,  7,  0,  0,  0,  0,  0,  0,   // 5D10 - 5D1F
	 0,  0,  0,  0,  0,  0,  0, 13,  0, 11,  0,  0,  0,  0,  0,  0,   // 5D20 - 5D2F
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 5D30 - 5D3F
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  9,  1,  0,  0,  0,   // 5D40 - 5D4F
	 7,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 5D50 - 5D5F
	 0,  0,  0,  0,  0,  0,  0,  0,  0, 13,  0,  0, 15,  0,  0, 19,   // 5D60 - 5D6F
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 5D70 - 5D7F
	 0,  0,  0,  0,  0,  0,  0,  1,  0,  0,  0,  5,  0,  0,  0,  0,   // 5D80 - 5D8F
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  5,  0,  0,   // 5D90 - 5D9F
	 1,  0, 15,  0,  0,  0,  0,  0,  0,  0, 15,  0,  0,  0,  0,  0,   // 5DA0 - 5DAF
	 0,  0,  0,  0,  0,  0,  0,  0, 15,  0,  7,  0, 13, 15,  0,  0,   // 5DB0 - 5DBF
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 15,  0,  0,   // 5DC0 - 5DCF
	 0,  0,  9,  0,  0,  0, 15,  0,  0,  0,  0,  0,  0, 19, 17,  0,   // 5DD0 - 5DDF
	 0, 13, 13,  0,  0,  1, 17,  1,  1,  0,  0,  9,  0,  0, 19,  0,   // 5DE0 - 5DEF
	 0,  1, 15, 13, 25,  0,  0, 27,  0,  0,  0,  0,  0, 13,  1,  0,   // 5DF0 - 5DFF
	 0,  0, 13, 25,  0,  0, 11,  0,  0,  0,  0,  0, 27,  0,  0,  0,   // 5E00 - 5E0F
	 0, 23,  0,  0,  0,  0, 19,  0,  0, 17,  0, 11,  0, 17,  0,  0,   // 5E10 - 5E1F
	 0,  0,  0,  0,  0, 13,  0,  0,  0,  0,  0, 13,  0, 13,  0,  0,   // 5E20 - 5E2F
	 0,  0,  0, 17,  0,  0,  5,  0, 13,  0,  0,  0,  0,  9,  0, 27,   // 5E30 - 5E3F
	17,  0,  0,  0, 15, 25,  0, 11,  0,  0,  0,  0, 27,  0,  0,  0,   // 5E40 - 5E4F
	 0,  0,  0,  0,  0,  9,  0,  0,  0,  0,  0,  0,  0,  0,  0, 19,   // 5E50 - 5E5F
	 0, 11,  5, 25,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 5E60 - 5E6F
	 0,  0,  1, 25,  3,  0,  0, 11, 27,  1,  0, 27, 15, 15,  1,  0,   // 5E70 - 5E7F
	 0,  0,  0,  0, 17,  0,  0, 11,  0,  0, 13,  0,  0,  0,  0, 13,   // 5E80 - 5E8F
	 0,  0,  0,  0,  0, 17,  0, 17,  0,  0,  1,  0, 11,  0,  0,  0,   // 5E90 - 5E9F
	13,  0,  0,  0,  0,  0,  5, 17,  0,  0,  0,  1,  0, 17,  0,  0,   // 5EA0 - 5EAF
	 0,  0,  0,  0,  0, 15, 13,  1, 15,  0,  0,  0,  0,  0, 15,  0,   // 5EB0 - 5EBF
	 0,  0, 13,  0,  0,  0,  0,  0, 27,  7,  7,  0,  0,  0,  0,  0,   // 5EC0 - 5ECF
	 1,  0,  0,  1,  0,  0,  7,  0,  0,  0, 17, 17,  0,  0,  0,  9,   // 5ED0 - 5EDF
	19,  0, 25,  1,  0,  0,  0,  0,  0,  0,  0,  0,  7,  0,  0,  0,   // 5EE0 - 5EEF
	 0,  0,  0, 19,  0,  0, 15, 17,  0,  0,  1, 27,  0,  0,  0,  0,   // 5EF0 - 5EFF
	 0, 11,  0,  0,  7,  0,  0,  0,  0,  0, 25,  0,  0,  0,  0, 13,   // 5F00 - 5F0F
	 0, 13,  0,  1, 17, 15,  0, 11, 27,  0,  0, 15,  0,  0,  0, 17,   // 5F10 - 5F1F
	 0,  0,  0,  0,  0,  0, 27, 27,  0,  3,  0,  0,  0,  0,  0,  0,   // 5F20 - 5F2F
	 0, 15,  0,  0,  0, 17,  0,  0,  0,  0,  1,  0, 25,  0,  0,  0,   // 5F30 - 5F3F
	 0,  0,  0,  0,  0,  0,  0,  0, 23,  0,  1,  0,  9,  0,  9,  0,   // 5F40 - 5F4F
	 0,  0,  0,  0,  0,  0,  5, 27,  0, 27,  0, 15,  0,  0,  0,  0,   // 5F50 - 5F5F
	 0,  0, 27,  0,  0,  0, 15, 15,  0, 19, 25, 17, 11, 25,  0,  0,   // 5F60 - 5F6F
	19, 15,  0,  0,  0,  0,  0, 11,  0, 15,  0,  0, 25,  0,  0, 11,   // 5F70 - 5F7F
	15, 17,  0,  0,  0,  5,  0, 13,  0,  0, 27,  7, 27,  0,  0,  0,   // 5F80 - 5F8F
	13,  1,  5,  0,  0,  0,  0,  5, 11, 13,  0,  0,  0,  0, 17,  0,   // 5F90 - 5F9F
	 7, 15,  0,  0,  0,  0,  0,  0, 27, 11, 13,  0,  0,  0,  9,  0,   // 5FA0 - 5FAF
	 0,  0,  0,  0,  0, 17,  0,  5,  0, 19,  0,  0,  0, 27,  0,  0,   // 5FB0 - 5FBF
	 0,  0,  0, 13,  0, 25,  0,  0,  0,  0,  0,  0,  1, 15,  0,  0,   // 5FC0 - 5FCF
	 0,  0,  0,  0,  0,  0, 19, 17,  9,  9,  0,  0,  0,  0,  0,  0,   // 5FD0 - 5FDF
	19,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 21,  0,  0,  0,  0,   // 5FE0 - 5FEF
	 0,  0,  0,  0,  0,  3,  0,  0,  0,  0,  0,  0,  0, 27,  0, 11,   // 5FF0 - 5FFF
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 15,   // 6000 - 600F
	 0,  0,  3,  0,  0,  0, 25,  0,  0,  0,  0,  0,  7, 13,  0,  0,   // 6010 - 601F
	23, 15,  0,  0,  0,  1,  0, 13, 15,  0,  1,  0,  0,  0,  0,  1,   // 6020 - 602F
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 6030 - 603F
	 0, 15, 13, 13,  0,  0,  0,  0,  0,  0,  0,  0,  0, 27,  0,  0,   // 6040 - 604F
	 1,  0, 27,  0,  0, 13,  0,  0,  0, 15,  0,  0,  0,  1,  0,  0,   // 6050 - 605F
	 0,  0, 27, 17, 27, 19,  0,  0, 27, 15,  1,  0,  3,  1,  0, 13,   // 6060 - 606F
	27,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 6070 - 607F
	 0,  0,  0,  0,  0, 15,  0,  0,  0, 13,  0,  0, 17, 27,  0,  0,   // 6080 - 608F
	 0,  0,  0,  0, 27,  0, 25,  0,  0,  0, 13, 17,  0,  0,  0, 15,   // 6090 - 609F
	15,  0,  0, 27, 19,  0,  0,  7,  0,  0,  0,  0,  0,  0,  0,  0,   // 60A0 - 60AF
	17,  0, 11,  5, 19,  0,  9,  0,  1,  0,  0,  0,  5, 19,  0,  0,   // 60B0 - 60BF
	 0,  0,  0,  0,  0, 17,  0,  5,  0,  0,  0,  0,  0,  0,  0,  0,   // 60C0 - 60CF
	 0, 27,  0,  0,  0,  0,  0,  0,  0,  0, 27,  0, 13,  0,  0, 15,   // 60D0 - 60DF
	27, 15,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 60E0 - 60EF
	23,  3,  0, 13,  0,  0, 27,  0,  0, 15, 13, 19,  0,  0,  0,  0,   // 60F0 - 60FF
	 0, 13,  0,  0,  0,  0,  1,  0, 15, 15,  0,  0,  0,  9, 25, 15,   // 6100 - 610F
	 0,  0,  0,  0,  0, 15,  0,  0,  0,  0, 15, 15,  0,  0,  0,  1,   // 6110 - 611F
	 0,  0,  0,  0,  0,  0,  0,  1,  0,  0,  0,  0,  0,  0,  0,  0,   // 6120 - 612F
	27,  0,  0,  0, 19,  0,  0,  1,  0,  0,  0,  0, 13,  0,  1, 15,   // 6130 - 613F
	 0,  0, 15,  0,  7,  0,  0, 15, 17,  0,  1, 23, 27,  0,  0,  0,   // 6140 - 614F
	 0,  0,  0, 25,  0,  9,  0,  0, 19, 19,  0,  0,  0, 23,  0, 23,   // 6150 - 615F
	 0,  0,  9,  1,  1,  0,  0, 27,  1,  0,  0, 17,  0,  0,  7,  0,   // 6160 - 616F
	15,  0,  0,  0,  0,  0,  1,  1,  0,  0,  0,  0,  0, 19, 15,  0,   // 6170 - 617F
	 0, 19, 15,  0,  0,  0,  0,  0,  0,  0, 11,  0,  0,  0, 17,  0,   // 6180 - 618F
	 7, 11,  0,  0, 19,  0,  0,  0, 27, 27, 23,  0,  0,  0,  0,  0,   // 6190 - 619F
	 0,  0,  0,  0, 11,  0,  0,  5,  0,  1,  0,  9,  1,  0,  9,  0,   // 61A0 - 61AF
	 0,  0, 27,  0,  0,  0, 15,  0,  0,  0,  5,  0,  0,  0,  1,  0,   // 61B0 - 61BF
	 0,  0,  0,  1,  0,  0,  0,  1, 27, 15, 15,  9,  0,  0,  0,  0,   // 61C0 - 61CF
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 61D0 - 61DF
	 0,  0,  0,  0,  0,  0,  3,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 61E0 - 61EF
	 0,  0, 17,  0,  0,  0,  7, 27, 27,  0, 19,  0,  1,  0,  0, 15,   // 61F0 - 61FF
	 7,  0,  0,  0,  0,  0,  0,  5,  1,  0,  9,  0, 13, 13, 15,  0,   // 6200 - 620F
	13, 15,  1,  0,  0,  0, 27,  0,  0,  0, 19,  0,  0,  0,  0,  1,   // 6210 - 621F
	 0,  1,  0,  0,  0,  0,  0,  0,  0,  0, 17,  0,  0,  0,  7,  0,   // 6220 - 622F
	17, 27,  0,  0,  5,  0, 27,  0,  0,  0,  0,  0,  0,  0,  7, 11,   // 6230 - 623F
	13, 25,  0,  0,  0,  0,  0, 13, 27, 11,  0, 13,  0, 17,  0,  0,   // 6240 - 624F
	 0,  0,  0, 23,  0,  0,  0,  0, 23,  0,  0,  0,  0,  0,  0,  0,   // 6250 - 625F
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 11,  0,   // 6260 - 626F
	 0,  1,  0,  0,  0,  0, 11,  0,  0, 11,  0,  0, 15,  0,  0, 13,   // 6270 - 627F
	 1,  0,  0,  0, 19,  0,  0,  0,  0,  1, 25,  0,  0,  0,  0,  0,   // 6280 - 628F
	 0, 15, 13,  0,  0, 23,  0, 27, 17,  0,  0, 25,  0,  0,  0,  0,   // 6290 - 629F
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 25,  0,  0,  0,  0,   // 62A0 - 62AF
	 0, 25,  0,  0,  0, 17,  0,  0,  0,  9,  0,  0, 15, 19,  0,  0,   // 62B0 - 62BF
	 0,  0, 11,  0,  0,  0,  0,  9,  3,  7,  0,  0, 11, 11,  0,  3,   // 62C0 - 62CF
	 1,  0,  1, 19, 11,  0, 23, 15,  1, 17,  0, 19, 11,  0,  0,  0,   // 62D0 - 62DF
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  1, 13,  1, 17,   // 62E0 - 62EF
	 0,  1,  0,  1,  0,  0,  0,  1,  0,  0,  0,  0,  0,  0, 13,  3,   // 62F0 - 62FF
	 0, 17,  0,  0,  0,  0,  0, 17,  0, 15,  0,  0,  0,  0,  0,  0,   // 6300 - 630F
	 0,  5,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 6310 - 631F
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 17,  0,  0,  0, 17,   // 6320 - 632F
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 17, 15,  0,  9, 27,  0,   // 6330 - 633F
	 0,  0,  0,  0,  0,  0,  0,  0,  0, 19,  0,  0, 25,  0,  0,  3,   // 6340 - 634F
	15,  0,  0,  0,  0, 25,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 6350 - 635F
	 0,  0,  0,  0,  0,  0,  0, 11, 13,  0,  0,  0,  0,  0,  1,  0,   // 6360 - 636F
	 0,  0,  1,  0,  0,  0,  0, 19,  0,  0,  3,  3,  0,  0,  0, 13,   // 6370 - 637F
	 0,  0,  0, 13,  0,  0,  0,  0, 13,  5,  0,  0, 17,  0,  0,  0,   // 6380 - 638F
	 0,  0, 11,  0,  0,  0, 15,  0,  1,  0,  0,  1,  0,  0,  0,  0,   // 6390 - 639F
	 7, 19, 23,  0,  0, 17,  0,  1, 19, 15, 17,  0,  0,  0,  0,  0,   // 63A0 - 63AF
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 63B0 - 63BF
	 1,  0,  0,  0, 15,  0,  1,  0,  0,  0,  0,  0,  0,  0,  0,  9,   // 63C0 - 63CF
	17,  0,  0,  0,  0,  0, 15,  0,  0,  0, 15, 27,  0,  0,  0,  0,   // 63D0 - 63DF
	 0, 15,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  1, 27,  0,   // 63E0 - 63EF
	 0,  0,  0,  0, 15,  0, 15, 13,  0,  0,  0,  0,  0,  0,  0,  0,   // 63F0 - 63FF
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 13,  0, 11,   // 6400 - 640F
	 0,  0,  0,  0, 13,  0, 15,  5,  0,  0,  0,  0, 13,  0,  0,  0,   // 6410 - 641F
	 0,  0, 17,  0,  0,  0,  0,  0,  0,  0,  0,  0, 11, 23,  0,  0,   // 6420 - 642F
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 27,  0,  0,  0, 19,  0,   // 6430 - 643F
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 6440 - 644F
	 0,  0,  0,  0,  0,  0,  0,  0, 17,  0,  0,  0,  0,  0,  0,  0,   // 6450 - 645F
	19,  0,  0,  0,  0,  0,  0,  0,  0,  9,  0,  0,  0,  0,  0, 17,   // 6460 - 646F
	 0,  0,  0,  0,  0,  0,  0,  0,  9,  9, 17,  0,  0,  0,  0,  0,   // 6470 - 647F
	 0,  0,  0,  0,  0,  0,  0,  0,  7,  0,  0,  0,  0,  0,  0,  0,   // 6480 - 648F
	 0, 23, 13, 15,  0,  0,  0,  0,  0,  0,  3,  0,  0,  0,  5,  0,   // 6490 - 649F
	 0,  0,  0,  0, 19, 11,  0,  0,  0,  0,  0,  9,  0, 25, 19,  0,   // 64A0 - 64AF
	19,  0, 11,  0,  0,  0,  0,  0,  0,  0,  0,  5,  0,  0,  0,  0,   // 64B0 - 64BF
	 0, 15,  0,  0,  7, 19,  0, 23,  0,  0,  1,  0,  0, 17,  1,  0,   // 64C0 - 64CF
	 0,  0,  1,  0,  5,  0,  0,  0, 11,  0,  1,  0,  0,  0,  0,  0,   // 64D0 - 64DF
	 0,  5, 23,  0,  0,  7, 19,  1,  0,  0,  0,  0, 15,  0,  0,  0,   // 64E0 - 64EF
	 0,  0, 19,  0, 27,  0,  0,  0,  0,  0, 25,  0,  0,  0, 15,  0,   // 64F0 - 64FF
	11,  0,  0,  0, 23,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 6500 - 650F
	 0,  0,  0,  0,  0,  0,  0,  0, 15,  0,  0,  0,  0, 13,  0,  0,   // 6510 - 651F
	 0,  0,  0,  7,  0,  0,  0,  0,  0,  0,  1, 27,  7,  0,  0, 17,   // 6520 - 652F
	 0,  0,  0,  0,  0,  0, 13,  1, 15,  1,  0,  1,  0,  0, 11, 17,   // 6530 - 653F
	 0,  0,  0,  0,  0,  1,  0,  0, 27,  0,  0,  0,  0, 13,  1,  9,   // 6540 - 654F
	 0,  1,  0,  0,  0,  0, 15, 25,  0,  0,  0,  0,  0,  0, 19,  0,   // 6550 - 655F
	 0,  0,  1, 13,  0,  0,  5,  0,  0,  0,  0,  0,  1, 15,  0,  0,   // 6560 - 656F
	 0,  0,  1,  0, 17, 17,  0, 11, 13,  0,  0,  0,  0,  0, 13,  0,   // 6570 - 657F
	 0,  0,  7, 25,  0, 27,  0,  9,  0,  0,  0,  0, 11,  0,  0,  0,   // 6580 - 658F
	11, 11,  0,  0,  0,  0,  0,  5,  0,  7,  0,  1, 13,  0,  0, 17,   // 6590 - 659F
	 0, 15,  0,  0,  1, 19,  0, 11,  0,  0,  0, 17, 19,  0,  0, 13,   // 65A0 - 65AF
	13,  0,  0,  0,  0,  0,  0,  5,  0, 11,  0,  0, 15, 13,  0,  0,   // 65B0 - 65BF
	 0, 11,  0,  0,  0,  7,  0,  0,  0,  0,  0, 13, 17,  0,  0, 17,   // 65C0 - 65CF
	 0,  0,  7,  0,  0,  0,  0,  1,  0,  0,  0,  0,  0,  0,  0,  0,   // 65D0 - 65DF
	 9,  0,  0,  1,  0, 15,  5,  0, 17, 17,  0,  0, 13, 15,  0,  0,   // 65E0 - 65EF
	 0, 27,  0,  0, 15,  0,  0,  0,  0,  0, 15,  9,  9,  5,  0, 15,   // 65F0 - 65FF
	 0,  0,  0,  0,  0,  0,  1, 13,  0, 11, 27,  0, 19,  0,  9, 27,   // 6600 - 660F
	11,  1,  0, 15, 13, 27,  0,  0,  0,  0,  0,  0,  0,  0, 11, 13,   // 6610 - 661F
	15,  0,  0,  0,  0, 19,  0,  9, 17,  0,  0,  0,  0, 13,  0, 13,   // 6620 - 662F
	27, 15,  0,  0,  9,  0, 19,  0,  0,  0, 11, 15,  0,  0,  0,  0,   // 6630 - 663F
	 0, 17, 13, 27, 27,  0,  0,  0,  0, 17,  0, 17,  0,  0,  0, 15,   // 6640 - 664F
	 0,  0,  0,  0,  0,  0,  0,  0,  0, 17,  0, 27,  0, 17, 27, 13,   // 6650 - 665F
	 0,  0,  0,  0, 15, 27, 27, 27, 13,  9,  0, 23,  0,  0, 11,  1,   // 6660 - 666F
	 0,  0,  0, 13, 19,  0, 17,  1, 17,  0, 17,  0,  0,  0,  0,  0,   // 6670 - 667F
	 0,  0,  0,  0, 27,  0,  0,  1, 27, 27,  0,  0,  0,  0, 15,  0,   // 6680 - 668F
	15, 13,  0,  0,  0,  0,  3, 15, 15,  0,  0,  0,  0,  9,  0,  0,   // 6690 - 669F
	 1,  0, 19,  0,  0,  0,  0,  0,  0,  0,  0, 17,  0,  0,  9,  0,   // 66A0 - 66AF
	 0,  0, 17, 27, 25,  0,  0,  0,  0, 13,  0,  1,  0,  0,  5,  0,   // 66B0 - 66BF
	 0,  0,  0,  0, 15,  0,  7,  5,  0, 27,  0,  0,  0,  0,  0,  0,   // 66C0 - 66CF
	 0,  0,  0,  0,  0,  0, 15,  0,  0, 13,  0,  0, 15, 25,  0,  0,   // 66D0 - 66DF
	 1,  0,  0,  0,  0,  0, 27,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 66E0 - 66EF
	15,  0,  1, 15,  1,  0,  0,  1, 13, 17, 17,  0,  9,  0, 17, 19,   // 66F0 - 66FF
	19,  0,  0, 27,  0,  0,  0,  0, 15, 15,  0, 11,  0, 11,  0,  0,   // 6700 - 670F
	 0,  0,  0,  0, 13, 17,  0,  7,  0,  0,  0,  9,  0, 17,  1,  1,   // 6710 - 671F
	 0,  0,  0,  0,  0,  0,  9,  7,  9,  0,  9,  9, 11, 19, 19,  0,   // 6720 - 672F
	 0, 17,  0,  0, 11,  0, 23,  0,  0,  0,  1,  0,  0, 27,  0,  0,   // 6730 - 673F
	 0,  0,  0,  0,  0,  0,  1,  0,  0, 13,  0,  0,  0,  0,  7, 27,   // 6740 - 674F
	17, 19,  0, 25,  0,  0, 17,  0,  0,  0,  0,  0,  5,  0,  1, 13,   // 6750 - 675F
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 27,  0, 11,   // 6760 - 676F
	 1,  5,  0,  9,  0, 17,  0, 25,  0,  0,  0,  3,  0,  0, 13, 25,   // 6770 - 677F
	 0,  0,  0,  0,  0,  0,  0, 11,  0, 15,  0, 11,  0,  0,  0,  3,   // 6780 - 678F
	13,  0,  0,  5,  0, 19,  0,  7,  0,  0,  9,  0,  1, 17,  0,  0,   // 6790 - 679F
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  1,   // 67A0 - 67AF
	25,  0,  0, 17,  0,  0,  1,  1,  1,  0,  0,  0,  0,  0, 13,  0,   // 67B0 - 67BF
	 0,  0,  0,  0, 11,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 11,   // 67C0 - 67CF
	 9,  1, 19, 15, 15,  0,  0,  0,  0,  0, 15,  0,  0, 23,  0,  0,   // 67D0 - 67DF
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  1,  0,  0,  1,  0,  0,  1,   // 67E0 - 67EF
	 3, 17,  0,  7, 13, 19, 13,  0,  0,  0,  0, 13,  0,  0, 17,  0,   // 67F0 - 67FF
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 6800 - 680F
	 0,  0, 13, 17,  0,  0, 13,  7,  0,  0,  0,  0,  0,  0,  0,  0,   // 6810 - 681F
	 0,  1, 11,  0,  0,  0,  0,  0,  0,  0, 17,  0,  0,  0,  0, 15,   // 6820 - 682F
	 0,  0,  0,  0,  0,  0,  0,  0, 27,  1,  0,  0,  1, 17,  0,  0,   // 6830 - 683F
	 1, 27,  1,  5,  0,  0,  0,  0, 15,  0,  0,  0,  0,  0, 17,  0,   // 6840 - 684F
	 5, 13,  0, 27,  1,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 6850 - 685F
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 17,  0,  0,   // 6860 - 686F
	 0,  0,  0,  0,  0,  0, 23,  0,  0,  0,  0,  0,  0,  0,  0,  1,   // 6870 - 687F
	 0,  7,  0,  0,  0,  9,  0,  0,  0,  0,  0,  0,  0,  0,  0,  1,   // 6880 - 688F
	 0,  0,  0, 17, 19,  0,  0,  1,  0,  0,  0,  0,  0, 17,  0, 27,   // 6890 - 689F
	 0, 15, 19,  0,  0,  0,  0, 15,  7,  0,  0,  0,  0, 13,  0, 17,   // 68A0 - 68AF
	 1,  1,  0, 13,  0, 11,  9,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 68B0 - 68BF
	 0,  0,  0,  0,  1, 11,  0,  0,  0,  9,  0,  1,  0,  1,  0,  0,   // 68C0 - 68CF
	 0,  0, 11,  0,  0, 17,  0, 17,  1,  0, 11,  0,  0,  0,  0,  5,   // 68D0 - 68DF
	 5,  0,  0,  0,  0,  0,  0, 17,  1,  0,  0,  0,  0,  0, 13,  0,   // 68E0 - 68EF
	 0,  0, 13,  0,  0,  0,  0,  0,  0,  5,  1,  0,  0,  0,  0,  0,   // 68F0 - 68FF
	15,  0,  0,  0,  0, 15,  0,  0,  0,  0,  0,  0,  0, 13, 19,  0,   // 6900 - 690F
	 0,  0, 19,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 6910 - 691F
	 0,  0,  0,  0,  0,  0,  0,  9,  0,  0,  0,  0,  0,  0,  0,  0,   // 6920 - 692F
	15,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 15,  0, 19,   // 6930 - 693F
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 15,  0,  0,  0,  0,  0,   // 6940 - 694F
	 0,  0,  0, 25, 13, 23,  0,  1,  0,  9, 19,  0,  0,  0,  7,  0,   // 6950 - 695F
	 3, 15, 15,  9,  0,  0,  0,  0, 17,  0,  0, 17,  0, 15, 17, 13,   // 6960 - 696F
	 0,  0,  0,  0,  0,  1,  0, 27, 19, 15,  0,  0,  0,  0,  0,  0,   // 6970 - 697F
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 6980 - 698F
	 0,  0,  0,  0,  0, 15,  0,  0,  0,  0,  0, 17, 11,  0,  0,  0,   // 6990 - 699F
	 0,  0,  0,  0,  0, 27,  0, 11,  0,  0,  0,  0,  0,  0, 15,  0,   // 69A0 - 69AF
	 0,  0,  0,  0,  7,  0,  0,  0,  0,  0,  0, 23,  0,  0,  0,  0,   // 69B0 - 69BF
	 0,  1,  0, 11,  0,  0,  0,  0,  0,  0,  0,  1, 23, 19,  0,  0,   // 69C0 - 69CF
	 1,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 69D0 - 69DF
	 0,  0,  0,  0,  0,  0,  0,  0,  1,  0,  1,  0,  0,  0,  0,  0,   // 69E0 - 69EF
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  1,  0, 17,  0,  1,   // 69F0 - 69FF
	 0,  0, 15,  0,  0,  0,  0,  0,  0,  0, 11,  0,  0,  0,  0,  0,   // 6A00 - 6A0F
	 0,  7,  0,  7,  0,  0,  0, 17,  0, 25,  0,  0,  0,  0, 19, 17,   // 6A10 - 6A1F
	 0,  9,  0, 15,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 6A20 - 6A2F
	 0,  0,  0,  0,  0, 19,  0,  0, 11, 13, 27,  0,  0, 17,  0,  0,   // 6A30 - 6A3F
	 0,  0,  0,  0,  1,  0,  0,  0, 15,  0,  0,  1,  0,  0,  0,  0,   // 6A40 - 6A4F
	 0,  0, 15, 13,  0,  0,  0,  0,  1,  5,  0,  0,  0,  0,  0,  1,   // 6A50 - 6A5F
	 0, 13,  0,  0,  0,  0,  0,  0,  0,  0,  0, 27,  0,  0,  0,  0,   // 6A60 - 6A6F
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 6A70 - 6A7F
	 5,  0,  0,  0,  1,  0,  0,  0,  0, 17,  0,  0,  0, 15,  1,  0,   // 6A80 - 6A8F
	 0,  0,  0,  0,  0,  0,  0, 11,  0,  0,  0,  0, 27,  0,  0,  0,   // 6A90 - 6A9F
	 0,  0,  1, 17,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 6AA0 - 6AAF
	 0,  0,  0, 11,  0,  0,  0,  0,  0,  0,  0, 27,  0,  0,  0,  0,   // 6AB0 - 6ABF
	 0,  0,  5,  1,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 6AC0 - 6ACF
	 0,  0,  0,  7,  0,  0,  0,  0,  0,  0,  7, 17,  0,  0,  0,  0,   // 6AD0 - 6ADF
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 6AE0 - 6AEF
	 0,  0,  0,  0,  0,  0, 27,  0,  0,  0,  0, 15,  0,  0,  0,  0,   // 6AF0 - 6AFF
	 0,  0,  0,  0,  7,  0,  0,  0,  0,  0,  1,  0, 17,  0,  0,  0,   // 6B00 - 6B0F
	 0,  0,  7,  0,  0,  0,  7,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 6B10 - 6B1F
	27, 19,  0, 27,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 6B20 - 6B2F
	 0,  0, 15,  0,  0,  0,  0,  0,  0,  0,  1,  0,  0, 27,  1,  0,   // 6B30 - 6B3F
	 0,  0,  0,  0,  0,  0, 27, 27,  0,  0,  0,  0,  1,  0, 23,  0,   // 6B40 - 6B4F
	 1,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 15,   // 6B50 - 6B5F
	 0, 27, 17, 17, 19, 11,  9,  0,  0,  0, 15,  0,  0,  0,  0,  0,   // 6B60 - 6B6F
	 0,  0, 13,  0,  0,  0,  0,  7,  1,  0,  0, 13,  0,  0,  0,  9,   // 6B70 - 6B7F
	 0,  0,  0, 15, 17,  0, 23,  0,  0, 13, 13,  0,  0,  0,  0,  0,   // 6B80 - 6B8F
	 0,  0,  0,  0,  0,  0, 13,  0, 17,  0,  0,  0,  0,  0, 15,  0,   // 6B90 - 6B9F
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  7, 11,   // 6BA0 - 6BAF
	 0,  0, 13,  0,  0,  5,  0, 15,  0,  0, 13,  0,  1,  0,  0, 17,   // 6BB0 - 6BBF
	 0, 27,  0,  0,  0, 15,  1,  0,  0,  0,  0,  9,  0,  9,  0,  9,   // 6BC0 - 6BCF
	 0,  0,  5, 15, 11,  0, 11, 11, 11,  0,  0,  9,  0,  0,  0,  0,   // 6BD0 - 6BDF
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 27,  1,  0,  0,  0,   // 6BE0 - 6BEF
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 6BF0 - 6BFF
	 0,  0,  0,  0,  0,  0,  0,  0, 17,  0,  0,  0,  0,  0,  0, 13,   // 6C00 - 6C0F
	 0,  9,  0,  9,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 6C10 - 6C1F
	 0,  0,  0,  1,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 6C20 - 6C2F
	 0,  0,  0,  0, 13,  0,  0, 11, 15,  0,  0,  0,  0,  0, 11,  0,   // 6C30 - 6C3F
	17, 17,  1,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 11,  0,   // 6C40 - 6C4F
	13,  0,  0,  0,  0, 13,  0, 27,  0,  0, 15,  0,  0, 15, 27,  1,   // 6C50 - 6C5F
	17,  0,  0,  0,  0,  0,  0,  0,  1,  0, 15,  0,  0, 15,  0,  0,   // 6C60 - 6C6F
	23,  0,  1,  0,  0,  0,  9,  0,  0,  0,  1,  0,  0,  1, 11,  0,   // 6C70 - 6C7F
	 0, 13,  1, 15,  0, 15, 27, 15, 19,  0,  0,  0,  5,  0,  0,  0,   // 6C80 - 6C8F
	 9,  0,  9,  5,  9,  9, 19,  0,  0, 13, 17, 25,  0,  0,  0,  0,   // 6C90 - 6C9F
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  9,  0,  0, 17,  0,   // 6CA0 - 6CAF
	 0,  0,  0, 27,  0,  0,  0,  0, 11, 15,  0, 19, 13,  1, 19, 15,   // 6CB0 - 6CBF
	 0, 27, 27,  0, 13,  0,  0,  0,  0, 19, 11,  0, 25,  0,  0,  0,   // 6CC0 - 6CCF
	 0,  0,  0, 27,  0, 11,  0, 13,  0,  0,  0, 11,  0,  0,  0,  0,   // 6CD0 - 6CDF
	 0, 25, 25, 15,  0,  3,  0,  0, 17,  0,  0, 27,  0,  0, 11,  9,   // 6CE0 - 6CEF
	23,  0,  0, 15,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 6CF0 - 6CFF
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 15,  7,  0,  0,  0,   // 6D00 - 6D0F
	 0, 11,  0,  0,  0,  0,  0, 13,  0, 13,  0,  7,  0,  0,  5,  0,   // 6D10 - 6D1F
	 0,  0,  0,  0,  0, 17,  0, 15,  0, 13, 27,  0,  0,  0,  0,  0,   // 6D20 - 6D2F
	 0,  0, 17,  0,  0, 13, 27,  0,  1, 15,  0, 27,  0, 27, 25,  0,   // 6D30 - 6D3F
	 0,  7,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 6D40 - 6D4F
	 0,  0,  0,  0,  0,  0,  0,  0,  0, 17, 17,  0, 11,  0,  0,  0,   // 6D50 - 6D5F
	 0,  0,  0, 15,  0,  0, 25,  0,  0, 27,  7,  0,  7,  0, 11,  0,   // 6D60 - 6D6F
	 0,  0,  0,  0, 15,  0,  0, 27, 19, 27,  0,  0,  0,  0,  0, 25,   // 6D70 - 6D7F
	 0,  0,  0,  0,  0, 15,  0,  1, 13, 13,  0,  0, 15, 27, 15,  0,   // 6D80 - 6D8F
	 0, 13,  0, 15,  0, 19,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 6D90 - 6D9F
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 15,   // 6DA0 - 6DAF
	 0,  0, 15,  0,  0, 27,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 6DB0 - 6DBF
	17,  0,  0,  1, 19, 13, 27,  1,  0,  0,  0,  7,  0,  0,  0, 27,   // 6DC0 - 6DCF
	 0, 13,  0,  0,  0,  0,  0,  0,  5, 17,  7,  0,  0,  0, 13,  0,   // 6DD0 - 6DDF
	 0,  5,  0,  0,  0,  0,  0,  0, 17,  0,  7, 15,  0,  0, 27,  0,   // 6DE0 - 6DEF
	 0, 13,  0, 13,  0, 15,  0, 27, 19, 15, 19, 19,  0,  0,  0,  0,   // 6DF0 - 6DFF
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 6E00 - 6E0F
	 0,  0,  0,  0,  0,  0,  0, 13,  0, 27, 17,  1,  0,  0,  0, 17,   // 6E10 - 6E1F
	 1,  5,  0, 13, 11, 15, 15,  0,  0,  0,  0, 13, 19, 15,  0, 27,   // 6E20 - 6E2F
	 0,  0, 13,  0,  1,  0, 15,  0, 15,  0,  9,  0,  9, 17, 27,  0,   // 6E30 - 6E3F
	 0,  0,  0, 11,  9,  0,  0,  0,  0,  0, 17,  0,  0,  5,  0,  0,   // 6E40 - 6E4F
	 0,  0,  0,  0,  0,  0, 27,  0, 13,  0,  0,  5, 13,  0, 17, 27,   // 6E50 - 6E5F
	 0,  0,  0,  0,  0,  0,  0, 15,  0,  0,  0, 19,  0,  0, 15, 23,   // 6E60 - 6E6F
	 0,  0, 15,  3,  0,  0,  0,  0,  0,  0, 11,  0,  0,  0,  0,  0,   // 6E70 - 6E7F
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 6E80 - 6E8F
	15,  0,  0,  0,  0,  0, 17,  0,  0,  0,  0,  0,  7,  1,  0,  9,   // 6E90 - 6E9F
	 0,  0, 15,  0,  0, 11,  0,  0,  0,  0,  1, 15,  0,  0,  0, 13,   // 6EA0 - 6EAF
	 0, 17,  0,  0,  0,  0, 15,  0,  0,  0,  3,  0,  0,  0,  0,  0,   // 6EB0 - 6EBF
	 0,  0, 11,  0, 19,  9,  0,  0,  0, 27,  0, 17, 19,  0, 27,  0,   // 6EC0 - 6ECF
	 0, 27,  0, 17,  5,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 6ED0 - 6EDF
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 19,   // 6EE0 - 6EEF
	 0,  0,  0,  0, 17,  0,  0,  0, 27,  0,  0,  0,  0,  0,  1,  9,   // 6EF0 - 6EFF
	 0, 15, 25,  0,  0,  0, 19,  0,  0,  0,  0,  0,  0,  0,  0,  7,   // 6F00 - 6F0F
	 0,  1,  0,  0, 15, 17,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 6F10 - 6F1F
	 9,  0, 27,  7,  0,  0,  0,  0,  0,  0,  0,  9, 17,  0,  0,  0,   // 6F20 - 6F2F
	 0, 13, 19,  0,  0,  0,  0,  0, 17,  0,  0,  0,  0,  0,  0, 17,   // 6F30 - 6F3F
	 0, 15,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 6F40 - 6F4F
	 0, 11,  0,  0,  1,  0,  0, 17, 11,  0, 13, 17,  0,  0,  7, 13,   // 6F50 - 6F5F
	 0,  0, 27,  0, 15,  0,  0,  0,  0,  0,  0,  0,  0,  5, 17,  0,   // 6F60 - 6F6F
	 1,  0,  0,  0,  0,  0,  0,  0,  0,  0, 17,  0,  5, 11,  7,  0,   // 6F70 - 6F7F
	 0, 13,  0,  0, 17,  0,  0,  0, 19,  0,  0,  0,  0, 17, 25,  0,   // 6F80 - 6F8F
	15,  0,  0,  0, 27,  0,  0,  1,  0,  0,  0,  0,  0,  0,  0,  0,   // 6F90 - 6F9F
	 0,  0,  0, 27, 23,  0,  0,  7,  0,  0,  0,  0,  0,  0, 27, 19,   // 6FA0 - 6FAF
	 0, 17,  0, 15,  0,  0,  0,  0,  0,  5,  0,  0,  0,  0,  5,  0,   // 6FB0 - 6FBF
	 1, 23,  7,  3,  0,  0,  0,  0,  0,  0, 15,  0,  0,  0,  0,  0,   // 6FC0 - 6FCF
	 0,  0,  0,  0,  0, 13,  0,  0,  0,  0, 15,  0,  0,  0,  0, 17,   // 6FD0 - 6FDF
	27, 15,  0,  0,  5,  0,  0,  0,  0, 27,  0,  7, 17,  0,  0, 23,   // 6FE0 - 6FEF
	 0, 11,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  7,  0,   // 6FF0 - 6FFF
	 0, 15,  0,  0,  0, 27,  5,  0,  0, 13,  0, 13,  0,  0,  0,  7,   // 7000 - 700F
	 0, 25,  0,  0,  0, 11,  0,  0,  7,  0, 27, 15, 15,  7, 17, 13,   // 7010 - 701F
	 0,  0,  0, 27,  0,  0,  0,  7,  7,  0,  0,  0,  0,  0,  0, 15,   // 7020 - 702F
	 0,  0,  0,  0,  0,  0,  0, 15,  0,  0,  0,  0,  0,  0,  7,  0,   // 7030 - 703F
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  1,  0,  0,  0,   // 7040 - 704F
	27, 13,  0,  0,  0,  0,  0,  0, 23,  0,  0,  0,  0, 27,  0,  0,   // 7050 - 705F
	 0,  0,  0,  9,  0,  0,  0,  0,  0,  0,  0, 27,  0,  0,  0,  0,   // 7060 - 706F
	27,  0,  0,  0,  0,  0,  0,  0,  1,  0,  0,  0, 17, 17,  0,  0,   // 7070 - 707F
	 0,  0,  0,  0,  0,  1,  0,  0,  0,  0, 19,  0,  0,  0, 15,  0,   // 7080 - 708F
	 0,  0, 19,  0,  0,  0,  0,  0, 27, 17,  1,  0,  0,  0,  0,  0,   // 7090 - 709F
	 0, 17,  0,  0, 13,  0,  0,  0,  0,  0,  0, 27,  1, 23,  0, 27,   // 70A0 - 70AF
	 0,  0,  0, 11,  0,  0,  0, 17, 17, 17,  0,  0,  0,  0,  0,  0,   // 70B0 - 70BF
	 0,  0,  0,  0,  0,  0,  0,  0,  7,  0,  0, 27,  0,  0,  0, 15,   // 70C0 - 70CF
	 0,  0,  0,  0,  0,  0,  0,  0, 27,  7,  0,  0,  0, 17,  0, 15,   // 70D0 - 70DF
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 70E0 - 70EF
	 0,  1,  0,  0,  0,  0,  0,  0,  0, 25,  0,  0,  0, 11,  0,  0,   // 70F0 - 70FF
	 0,  0,  0,  0, 27,  0,  0,  0,  0, 15,  0,  0, 17,  0,  0,  0,   // 7100 - 710F
	 0,  0,  0,  0,  0,  0,  0,  0,  0, 11, 11,  0,  0,  0,  5,  0,   // 7110 - 711F
	 0,  9,  0,  0,  0,  0, 19,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 7120 - 712F
	15,  0,  0,  0,  0,  0, 15,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 7130 - 713F
	 0,  0,  0,  0,  0,  0,  0, 27,  0,  7, 27,  0, 27,  0, 17,  0,   // 7140 - 714F
	15,  0,  0,  0,  0,  0,  3,  0,  0, 15,  0,  0, 15,  0, 13,  0,   // 7150 - 715F
	 0,  0,  0,  0,  9, 27, 27, 17,  0, 11,  0,  0, 15,  0, 17,  0,   // 7160 - 716F
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 13,  0,  0,   // 7170 - 717F
	 0,  0,  0,  0, 13,  0,  0,  0,  0, 15, 15,  0,  0,  0,  0, 27,   // 7180 - 718F
	 0,  0, 27,  0, 15,  0,  0,  0,  0, 27,  0,  0,  0,  0,  0, 13,   // 7190 - 719F
	 0,  0, 11,  0,  0,  0,  0,  0,  0,  0,  0,  0, 15,  0,  0,  0,   // 71A0 - 71AF
	 0, 15,  0,  0,  0,  0,  0,  0,  0, 27, 27,  0,  0,  0, 19,  0,   // 71B0 - 71BF
	 0, 15,  0, 15,  0,  0,  0,  0,  5,  5,  0,  0,  0,  0,  7,  0,   // 71C0 - 71CF
	 7,  0, 13,  0, 11, 15,  0,  0,  0,  0,  0,  0,  0,  0,  0, 15,   // 71D0 - 71DF
	 0,  0,  0,  0,  0, 17, 19, 13,  0,  0,  0,  0,  0, 19, 13,  0,   // 71E0 - 71EF
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 27, 13,  0,  5, 15,   // 71F0 - 71FF
	27,  0,  0,  0,  0,  0, 25,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 7200 - 720F
	 7,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  7,  0,  0,  0,  0,   // 7210 - 721F
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 17,  0, 25, 17,  0,  0,   // 7220 - 722F
	15,  0, 15,  0,  0, 17, 11,  0,  0,  0, 15, 27,  0, 13, 15,  0,   // 7230 - 723F
	13,  0,  0,  0,  0,  0, 17, 25, 25,  0,  0,  0, 25,  0,  0,  0,   // 7240 - 724F
	 0,  0, 19,  0,  0,  0,  0,  0,  5, 15,  0, 15,  0, 11,  0,  9,   // 7250 - 725F
	 0,  9,  7,  0,  0,  0,  0,  9,  0,  9,  0,  0,  0,  0,  0,  0,   // 7260 - 726F
	 0,  0, 13,  0,  0,  0,  0,  0,  0, 23,  0,  0,  0,  1,  0,  0,   // 7270 - 727F
	13,  7,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 7280 - 728F
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 7290 - 729F
	 0,  0,  5,  0,  0,  0,  0, 27,  0,  0,  0,  0,  1,  0,  0, 11,   // 72A0 - 72AF
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 72B0 - 72BF
	13,  0,  1,  0, 17,  0,  0,  0,  0,  0,  0,  0,  0,  0, 15,  0,   // 72C0 - 72CF
	27,  0,  0,  0,  0,  0,  0,  1,  0, 17,  0,  0,  0,  0,  0,  0,   // 72D0 - 72DF
	 0,  1,  0,  0,  0,  0,  0,  0,  0, 13,  0,  0,  0,  0,  0,  0,   // 72E0 - 72EF
	 0,  0,  0,  0,  0,  0,  0,  0,  7, 27,  0,  0,  7, 25,  0,  0,   // 72F0 - 72FF
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 15,  0,  0,  0,  0,  0,   // 7300 - 730F
	 0,  0,  0,  0,  0,  0, 19,  0,  0,  0,  0,  9, 13, 17,  0,  0,   // 7310 - 731F
	 0,  0,  0,  0,  0, 15,  0,  0,  0, 13, 17,  9,  0,  0,  0,  0,   // 7320 - 732F
	 0,  0,  0,  0,  0,  0, 15, 15,  0,  0,  0,  0,  0,  0, 27, 15,   // 7330 - 733F
	 0,  0,  0,  0, 15, 13,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 7340 - 734F
	17,  0, 15,  0,  0,  0,  0,  1,  0,  0,  0,  0,  0,  0,  0,  0,   // 7350 - 735F
	 0,  0,  0,  0,  0,  0,  0,  0,  5,  0, 27,  0,  0,  0,  0,  0,   // 7360 - 736F
	15,  0, 27,  0,  0,  7,  0,  0, 13,  0,  5, 27,  0,  0,  0,  0,   // 7370 - 737F
	 0,  0,  0,  0, 27,  0, 17, 13,  0, 15,  0, 15,  0,  0, 17,  0,   // 7380 - 738F
	 0,  0,  0,  0, 19,  0,  1, 15,  1,  0,  0,  0,  0,  0,  0,  9,   // 7390 - 739F
	 0,  0,  0,  0,  0,  0,  0, 15,  0, 15,  0,  0,  0, 11,  0,  0,   // 73A0 - 73AF
	 0,  0,  7,  5,  0,  0,  0,  0,  0, 27,  0,  0,  0,  0,  0,  0,   // 73B0 - 73BF
	11,  0,  1,  0,  0,  0,  0,  0,  0,  9, 13,  0, 25, 17,  0,  1,   // 73C0 - 73CF
	 0,  0,  0,  0,  0,  0,  1,  0,  0,  1,  0,  0,  0, 27,  7,  0,   // 73D0 - 73DF
	17,  0,  0, 13, 11, 15, 27,  0,  0, 27,  1,  0,  0, 11,  0,  0,   // 73E0 - 73EF
	 0,  0,  0,  0,  0,  0,  0,  9,  0, 13,  0,  0,  0, 17, 27,  0,   // 73F0 - 73FF
	 0, 13,  0,  1,  0,  7,  7, 13,  0,  7,  0,  0,  0,  0,  0,  0,   // 7400 - 740F
	 0,  0,  0, 15,  0,  0,  0,  0,  0,  0,  0, 19,  0,  0,  0,  0,   // 7410 - 741F
	17, 13, 23,  0,  0, 27,  1,  0,  1,  0,  1, 11, 15,  0, 17,  1,   // 7420 - 742F
	15,  0,  0,  7,  1, 11, 25,  0, 23,  0, 11,  0,  0,  0,  0, 27,   // 7430 - 743F
	15,  9,  0, 19, 13,  0,  0,  0,  0,  0,  0, 15,  0,  0,  0,  0,   // 7440 - 744F
	 0,  0,  0,  0,  0, 27,  0, 15,  0,  3, 27, 15, 15,  0, 13, 13,   // 7450 - 745F
	 7,  0, 15,  0, 15, 15,  0,  0, 17, 27,  9,  0,  0,  0,  0,  7,   // 7460 - 746F
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  1,  0,   // 7470 - 747F
	 0,  0,  1,  7,  0,  0,  0, 13,  0,  7,  0, 17,  0,  0,  0,  0,   // 7480 - 748F
	 0,  0,  0,  0,  0,  0,  0,  0,  7,  0,  0,  0, 27,  0, 11,  1,   // 7490 - 749F
	 0, 17,  0,  1,  0,  1,  0, 11, 19,  0, 17,  0,  0,  0,  0,  0,   // 74A0 - 74AF
	27,  0, 13,  0,  0, 15,  0,  0,  0, 13,  0,  0,  0, 13,  0, 13,   // 74B0 - 74BF
	 0,  0,  0,  0,  0,  0, 17,  0,  0,  0,  1,  0,  0,  0,  0,  7,   // 74C0 - 74CF
	 0,  0,  0,  0, 15,  0,  0,  0,  1,  0, 19,  0,  1,  0,  0,  0,   // 74D0 - 74DF
	27,  0, 25, 25,  0,  0, 15,  0,  0,  0,  0,  0,  0,  0, 15,  0,   // 74E0 - 74EF
	 0,  0,  0,  0,  0,  0,  0, 17,  0,  0,  0,  0,  0,  0,  0,  0,   // 74F0 - 74FF
	 0, 11,  0,  0,  1,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 7500 - 750F
	 0, 17,  0,  0,  0, 15,  0,  0,  1,  0, 13, 19,  0,  0,  0, 13,   // 7510 - 751F
	 0,  0,  0, 13,  0, 13, 13,  0, 15,  0,  0, 11, 15,  0,  0,  0,   // 7520 - 752F
	17, 15,  1, 13,  0,  0,  0,  3, 17,  0, 17,  0,  0,  0,  0,  0,   // 7530 - 753F
	 0,  0,  0,  0,  0,  0,  0,  1,  0,  0,  0,  0,  1,  0,  0, 15,   // 7540 - 754F
	 0, 17,  0,  5, 11,  0,  0,  0,  0,  7,  0, 17, 19,  9,  0,  0,   // 7550 - 755F
	 0,  0, 25,  0,  0,  7, 27,  0,  0,  0, 11,  0,  0,  0,  0, 17,   // 7560 - 756F
	15,  0,  0,  0,  0, 27,  5,  0,  1,  0,  1,  0,  0,  0,  0,  1,   // 7570 - 757F
	 0,  0,  0,  0,  0,  0,  1, 17,  0,  0, 19, 25,  0,  0, 13, 13,   // 7580 - 758F
	 0, 15,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 13,  0,  0,   // 7590 - 759F
	 0,  0,  0,  0,  0,  1,  0,  0,  0,  0,  0, 15,  0,  0,  0,  0,   // 75A0 - 75AF
	 0, 25, 25,  1,  0, 17,  0,  0,  5, 17,  0,  0,  5, 17, 17,  0,   // 75B0 - 75BF
	 0,  0,  1,  0,  0, 11,  0, 17,  0,  0,  0,  0,  0, 15,  0,  0,   // 75C0 - 75CF
	 0,  0, 15,  0, 19, 27,  0,  0,  5,  1,  0, 23,  0,  0,  0,  0,   // 75D0 - 75DF
	 0,  0,  7,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 75E0 - 75EF
	 5,  0,  9,  0, 19,  0,  0,  0,  0,  0, 11,  0,  1,  0,  0,  0,   // 75F0 - 75FF
	15,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 15,  0,  0,   // 7600 - 760F
	 0,  0,  0,  0,  0,  0,  0,  0,  0, 13,  0,  0,  0,  0,  0, 15,   // 7610 - 761F
	19, 19, 11,  0,  7,  0, 13,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 7620 - 762F
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  7,  0,  0,  0,  0,   // 7630 - 763F
	 0,  0,  7,  0,  0,  0,  0,  0,  0,  0,  0,  0, 15,  0,  1,  0,   // 7640 - 764F
	 0,  0, 15,  0,  0,  0, 11,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 7650 - 765F
	 0, 19,  0,  0, 17,  0,  0,  0,  0,  7,  0,  0, 13,  0,  0,  0,   // 7660 - 766F
	15,  0, 17,  0,  0,  0,  0,  0,  1,  0,  0,  5, 11, 11, 11,  0,   // 7670 - 767F
	 0,  0,  0,  0, 17,  0,  1, 27,  0,  0,  0,  0,  0,  0,  1,  0,   // 7680 - 768F
	 1,  0,  0, 27,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 7690 - 769F
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 25,  0,   // 76A0 - 76AF
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 19,  0,  0,  0,  0,  9,   // 76B0 - 76BF
	 0,  0, 15, 11,  0,  0, 11,  0, 15,  0, 15,  0,  0,  0,  0,  0,   // 76C0 - 76CF
	 0,  0, 27,  0,  0,  0,  1,  0,  0,  0,  0, 13,  5,  0, 17,  9,   // 76D0 - 76DF
	 0, 17,  0,  1, 11,  0,  0,  7,  0,  0,  0,  0,  0,  0,  9,  0,   // 76E0 - 76EF
	 0,  0,  9,  0, 17,  0,  0,  0, 13,  0,  0,  0, 11,  0, 13,  0,   // 76F0 - 76FF
	 0, 13,  0,  0,  9,  0,  0,  0, 23,  9,  0,  1,  0,  0,  0,  0,   // 7700 - 770F
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 17,  0,   // 7710 - 771F
	 9,  0,  0,  0,  0,  0,  0,  0,  0, 27,  0,  0,  0,  0,  0,  0,   // 7720 - 772F
	 0,  0,  0,  0,  0,  0,  0,  1,  9,  0, 17,  0, 15,  0,  0,  0,   // 7730 - 773F
	19,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 27,  0,  0,   // 7740 - 774F
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 17,  0,  0,  0,  0,   // 7750 - 775F
	 0, 13,  0,  5,  0,  0,  9,  0,  0,  0,  0, 19,  0,  0,  0,  0,   // 7760 - 776F
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  5,  0,  0,  0,  0,  1, 15,   // 7770 - 777F
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 17,  0,  0,  0,  0,   // 7780 - 778F
	 0,  9,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  9,  0,   // 7790 - 779F
	 0,  0,  0,  0,  0, 11,  0,  0,  0,  0,  0,  0, 13,  7,  0,  0,   // 77A0 - 77AF
	 1,  0,  0,  5,  0,  0,  0,  0,  0,  0,  0, 19,  1,  0,  0,  1,   // 77B0 - 77BF
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 77C0 - 77CF
	 0,  0,  0,  0,  0,  0,  0, 19,  0,  0,  0,  9,  1,  0,  0,  0,   // 77D0 - 77DF
	 0,  0, 13, 15,  0, 17,  0,  0,  0,  1,  0,  0,  0,  5, 15,  1,   // 77E0 - 77EF
	 0,  0,  0, 13,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 77F0 - 77FF
	 0,  0, 13,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 7800 - 780F
	 0,  0, 11,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 7810 - 781F
	 0,  0,  0,  0,  0, 17, 19, 19,  0,  0,  0,  0,  7,  0,  0,  0,   // 7820 - 782F
	 0,  0, 25,  0, 25,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 7830 - 783F
	 0,  0,  0,  0,  0,  1,  0,  0,  0,  0,  0,  0,  0,  0,  0, 15,   // 7840 - 784F
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 19,  0,  0,   // 7850 - 785F
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  7,  1,  0,  0, 15,   // 7860 - 786F
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 11,  0,  0,  0,   // 7870 - 787F
	 0,  1,  0,  0,  0,  0,  0, 17,  0,  0,  0,  0,  7, 15, 13,  0,   // 7880 - 788F
	 0, 11,  0,  0,  0,  0,  0, 15,  0,  0,  0,  0,  0,  0,  0,  0,   // 7890 - 789F
	 0,  0,  0,  1,  0,  0,  0, 11,  0, 13,  0,  0,  0,  0,  0,  0,   // 78A0 - 78AF
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 27, 27,  9,  0,  0,  0,   // 78B0 - 78BF
	 0, 17,  0,  0,  0, 11,  0,  0,  0,  0,  7, 19,  0,  0,  1,  0,   // 78C0 - 78CF
	11,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 78D0 - 78DF
	 0,  0,  0,  0,  0,  0,  0,  0,  9,  0,  0,  0,  1,  0,  0,  1,   // 78E0 - 78EF
	 0,  0,  0,  0,  0,  1,  0,  0,  0,  0,  0, 11,  0,  0,  0,  0,   // 78F0 - 78FF
	 0, 19,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 19,  0,   // 7900 - 790F
	 0,  0,  0,  0,  0,  0, 15,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 7910 - 791F
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  7,  7, 11,  0,  0,  0,   // 7920 - 792F
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 13,  0,  0,  0, 13,  0,   // 7930 - 793F
	13,  1,  0,  0,  0,  0,  0,  1,  1, 17,  0,  0,  0,  0,  0,  0,   // 7940 - 794F
	15,  0,  0,  0,  0,  0, 17, 17,  0,  0, 17,  1, 27, 19, 13,  0,   // 7950 - 795F
	13,  0,  0,  0,  0, 13,  0,  0, 25,  0,  0,  0,  0, 17,  0,  0,   // 7960 - 796F
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  1,  0,  0,  0,  0,  7,   // 7970 - 797F
	 0,  1,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 27, 17, 11,   // 7980 - 798F
	 0, 15,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 7990 - 799F
	 0,  0,  0,  0,  0,  0, 15, 27,  0,  0, 13,  0,  0,  0,  7,  0,   // 79A0 - 79AF
	 0,  5,  0, 15,  0,  0,  0,  0,  0, 15,  0,  0,  0,  1, 27,  5,   // 79B0 - 79BF
	13, 13,  0,  0,  0,  0,  0,  0,  0, 11,  3, 19,  0,  0,  0,  0,   // 79C0 - 79CF
	 0,  1, 19,  0,  0, 11,  0,  0, 11,  0,  0,  0,  0,  0,  0, 17,   // 79D0 - 79DF
	 0,  0,  0,  0, 19,  0, 17, 15,  0, 17,  0,  0,  0,  0,  0,  0,   // 79E0 - 79EF
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 15,  0,  0,  0,  0,   // 79F0 - 79FF
	27,  0,  0,  0,  0, 13,  0,  0,  1,  0,  0, 17,  0, 19,  0,  0,   // 7A00 - 7A0F
	 0,  0,  0,  0, 15,  0,  0, 25,  0, 17, 19,  0,  7,  0,  0, 25,   // 7A10 - 7A1F
	17,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 17,  0,   // 7A20 - 7A2F
	 0, 19,  0,  0,  0,  0, 15, 17,  0,  0,  0,  5,  1,  1,  0,  1,   // 7A30 - 7A3F
	 1,  0,  0,  0,  0,  0,  9,  0,  0, 19,  0,  0,  0, 17, 15,  0,   // 7A40 - 7A4F
	 0,  0,  0,  0,  0,  0,  0, 13,  0,  0,  0,  0,  0,  0,  0,  0,   // 7A50 - 7A5F
	 0, 13, 15,  0,  0,  0,  0,  0,  0, 15,  0, 27,  0,  0,  0,  0,   // 7A60 - 7A6F
	15,  0,  0,  0, 27,  0,  1,  0,  0,  1,  1,  0,  0, 17,  0, 19,   // 7A70 - 7A7F
	 0,  5,  0,  0, 19,  0,  0,  0, 15,  0,  0,  0,  0,  0,  0,  0,   // 7A80 - 7A8F
	 0,  0, 17, 19,  0, 17,  0,  0,  1,  0,  0,  0,  0,  0,  0,  1,   // 7A90 - 7A9F
	 0,  0,  0,  0,  0,  0,  0,  0,  0, 15, 15,  0,  0,  0,  1, 15,   // 7AA0 - 7AAF
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  1,  0,  0,  0,  0,  0,   // 7AB0 - 7ABF
	 0,  0,  0,  0, 19,  1,  0,  5,  0,  0, 17,  7,  0,  0,  0,  0,   // 7AC0 - 7ACF
	 0,  0,  0,  0,  0,  0,  0,  9,  0, 19,  0,  0,  0, 11,  0,  1,   // 7AD0 - 7ADF
	17,  0,  0, 17,  0,  5,  0,  0,  0,  0, 13,  0,  0,  1,  0,  5,   // 7AE0 - 7AEF
	 0,  0,  0,  0,  0,  0,  1,  0,  0, 17, 19,  0,  0,  0,  0,  1,   // 7AF0 - 7AFF
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 27,   // 7B00 - 7B0F
	 0, 13,  0,  0,  0,  0,  0,  0,  0, 13,  0, 17,  0,  0, 23,  0,   // 7B10 - 7B1F
	 7,  0,  0,  0,  0,  0, 11,  0,  0,  0,  0,  0, 17,  7,  0,  0,   // 7B20 - 7B2F
	 0,  0,  0,  0,  0,  0,  0,  0,  0, 13,  0,  0,  0,  0,  0,  0,   // 7B30 - 7B3F
	 0,  0,  0,  0,  0,  0, 25,  0,  0,  5,  0,  1, 17, 13,  0, 11,   // 7B40 - 7B4F
	 1, 19, 23,  0,  5,  0, 19,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 7B50 - 7B5F
	 1,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 13,  0, 13,  0,   // 7B60 - 7B6F
	 0,  0,  0,  0,  0, 15,  0,  0,  0,  0,  0,  0,  0, 15,  0,  0,   // 7B70 - 7B7F
	 0,  0,  0,  0,  0,  0,  0,  1,  0,  0,  0, 17,  0,  0,  0, 17,   // 7B80 - 7B8F
	 0,  0,  0,  0, 11,  1,  0, 13,  0,  0, 19,  0,  0,  1,  0,  0,   // 7B90 - 7B9F
	 0,  1,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 17,  0,  0,   // 7BA0 - 7BAF
	 0, 13,  0,  0, 17,  0,  0,  0, 17,  0,  0,  0,  0,  0,  0,  0,   // 7BB0 - 7BBF
	17, 27,  0,  0, 11,  0, 17, 25,  0, 19,  0,  0,  0,  0,  0,  0,   // 7BC0 - 7BCF
	 0,  0, 13,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 7BD0 - 7BDF
	13,  0,  0,  0,  5,  0,  0,  0,  0, 13,  0,  0,  0,  0,  0,  0,   // 7BE0 - 7BEF
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 7BF0 - 7BFF
	 0,  0,  0,  0,  0,  0,  0, 17,  0,  0,  0,  0,  0,  0,  0,  0,   // 7C00 - 7C0F
	 0,  0, 19,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  5,  0,   // 7C10 - 7C1F
	 0,  1,  0,  0,  0,  0,  0, 27,  0,  0, 17, 13,  0,  0,  0,  0,   // 7C20 - 7C2F
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 19,  7, 11,   // 7C30 - 7C3F
	 0,  0,  0,  7,  0,  0,  0,  0,  0,  0,  0,  0, 17, 17,  0,  0,   // 7C40 - 7C4F
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 7C50 - 7C5F
	 7,  0,  0,  0, 19,  0,  0,  0,  0,  0,  0,  0,  7,  0,  0,  0,   // 7C60 - 7C6F
	 0,  0,  0,  9,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 7C70 - 7C7F
	 0,  0,  0, 11,  0,  0,  0,  0,  0, 11,  0,  0,  0,  0,  0,  0,   // 7C80 - 7C8F
	 0,  0,  7,  0,  0, 11,  0, 17, 17,  0,  0,  0,  0,  0,  0, 13,   // 7C90 - 7C9F
	 0,  0,  0,  0,  0, 17,  0, 17,  0,  0,  0,  0,  0,  0,  7,  0,   // 7CA0 - 7CAF
	 0,  7, 19,  1,  0,  0,  0,  0,  0, 13,  0,  0,  0,  0, 17,  0,   // 7CB0 - 7CBF
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 27,  0,  0,  0,  0,  0,   // 7CC0 - 7CCF
	 0,  0,  0,  0,  0,  0,  5,  0,  0,  0,  0,  0,  0,  0, 11, 17,   // 7CD0 - 7CDF
	 1,  0,  0,  0,  0,  0,  0,  7,  0,  0,  0,  0,  0,  0,  0,  0,   // 7CE0 - 7CEF
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  1,  0,  0,  1,  0,   // 7CF0 - 7CFF
	 1,  0, 17,  0, 15, 27, 15, 27, 27,  0,  9,  9,  0,  3,  0,  0,   // 7D00 - 7D0F
	 3,  0,  0,  0, 13,  0,  0, 13,  1, 17,  1, 11,  0,  0,  0,  0,   // 7D10 - 7D1F
	13, 11, 13,  0,  0,  0,  0,  0,  0,  0,  0, 17, 17,  0, 19,  7,   // 7D20 - 7D2F
	13,  0,  0, 13,  0, 17,  0,  0,  0, 13,  1,  0,  0,  0,  0,  0,   // 7D30 - 7D3F
	 0,  0, 17, 27, 17,  1, 11,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 7D40 - 7D4F
	 1,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  1,  0,   // 7D50 - 7D5F
	 0,  7, 27,  0,  0,  0,  1,  0, 15,  0, 15,  0,  0,  0, 13,  0,   // 7D60 - 7D6F
	 0, 23, 13,  1,  0,  0, 17,  0,  0,  1,  0,  0,  0,  0,  0,  1,   // 7D70 - 7D7F
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 17, 13,   // 7D80 - 7D8F
	 0,  0,  0,  1,  0,  0,  0,  0,  0,  0,  0,  0, 17,  0,  0,  0,   // 7D90 - 7D9F
	 7,  0, 17,  0,  0,  0,  0,  0,  0,  0,  0,  0, 13, 15,  0,  0,   // 7DA0 - 7DAF
	 0,  1,  9,  0, 19, 19,  0,  0,  7,  0,  1, 23,  0, 17,  7,  9,   // 7DB0 - 7DBF
	 0,  0,  0,  0,  0,  0,  0, 19,  0,  0,  1, 11,  0,  0,  0,  0,   // 7DC0 - 7DCF
	 0,  0,  0,  0,  0,  0, 13,  0, 27,  0, 13,  0,  0, 17,  5,  0,   // 7DD0 - 7DDF
	19,  9,  0, 15,  0,  0,  0,  0, 25, 15,  0,  0,  9,  0,  0, 15,   // 7DE0 - 7DEF
	 0,  0,  0,  0,  7,  0,  0,  0,  0,  0,  0, 19,  0,  0,  0,  0,   // 7DF0 - 7DFF
	 0,  0,  0,  0,  0,  0,  0,  0,  0, 17, 15,  0,  0,  0,  0,  0,   // 7E00 - 7E0F
	 0,  0,  0,  0,  0, 15,  0,  0,  0,  0,  0, 11,  0, 17, 27, 15,   // 7E10 - 7E1F
	 0, 17,  0, 27,  0,  0,  0,  0,  0,  0,  0, 11,  0,  0, 19, 15,   // 7E20 - 7E2F
	 0, 17,  0,  0,  0,  0,  0,  7,  0,  0,  0,  0,  0, 19, 17,  0,   // 7E30 - 7E3F
	 0, 11,  0, 11,  0,  0,  9, 15,  0,  0,  0,  0,  0,  0,  0,  0,   // 7E40 - 7E4F
	 0,  0, 17,  0, 17, 13,  0,  0,  0,  0,  0,  0,  0,  0, 15,  0,   // 7E50 - 7E5F
	 0, 13,  0,  0,  0,  0,  0,  0,  0, 13, 27,  1,  0,  1,  0,  0,   // 7E60 - 7E6F
	17,  0,  0,  0,  0,  0,  0,  0,  0, 15,  0,  0,  1,  0,  0,  0,   // 7E70 - 7E7F
	 0,  0, 19,  0,  0,  0,  0,  0,  0,  0,  0,  0, 13,  0,  0, 17,   // 7E80 - 7E8F
	 0,  0,  0, 15,  0,  0, 13,  0, 19,  0,  0,  5,  7,  0,  0,  0,   // 7E90 - 7E9F
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 7EA0 - 7EAF
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 7EB0 - 7EBF
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 7EC0 - 7ECF
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 7ED0 - 7EDF
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 7EE0 - 7EEF
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 7EF0 - 7EFF
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 7F00 - 7F0F
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 7F10 - 7F1F
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 7F20 - 7F2F
	 0,  0,  0,  0,  0,  0, 11,  0, 27,  0,  1,  0,  0,  0,  0,  0,   // 7F30 - 7F3F
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 15,  0,  0,  0,   // 7F40 - 7F4F
	 1,  0,  0,  0,  9, 27,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 7F50 - 7F5F
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 17,  1,  0,  0, 19,  0,   // 7F60 - 7F6F
	11,  0, 13,  0,  0,  9,  0, 25,  0,  7,  0,  0,  0,  0,  0,  0,   // 7F70 - 7F7F
	 0,  0,  0,  0,  0,  7,  0,  0,  1,  0, 15,  0,  1,  0,  9,  0,   // 7F80 - 7F8F
	 0,  0,  0,  0,  1,  0,  0,  0,  0,  0,  7,  0,  0,  0, 13,  0,   // 7F90 - 7F9F
	 0,  0,  0,  0,  1,  0,  0,  0, 13, 15,  0,  0,  0,  0,  0,  0,   // 7FA0 - 7FAF
	 0,  0, 27,  0,  0,  0,  0,  0,  7,  1,  0,  0,  0, 15,  0,  0,   // 7FB0 - 7FBF
	 0, 15,  0,  0,  0, 13,  0,  0,  0,  0, 15,  0, 15,  0,  7,  0,   // 7FC0 - 7FCF
	 0,  0, 13,  0, 13, 27,  0,  0,  0,  0,  0,  0,  0,  0,  0, 17,   // 7FD0 - 7FDF
	19, 11,  0,  0,  0,  0,  0,  0,  0, 25,  0, 15,  0,  0,  0,  0,   // 7FE0 - 7FEF
	27,  0,  0,  0,  0,  0,  0,  0,  0,  1,  0,  0, 15,  0,  0,  0,   // 7FF0 - 7FFF
	15,  7,  0,  1,  0, 17,  1,  0,  0,  1,  0,  0, 15,  0,  0,  0,   // 8000 - 800F
	 3,  0,  0,  0,  0,  1,  0,  9, 15,  0,  0,  0,  0,  0,  0,  0,   // 8010 - 801F
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  1,  0,  0,   // 8020 - 802F
	 0,  0,  0, 15,  0,  0, 15,  0,  0,  0,  0,  0,  0, 23,  0,  1,   // 8030 - 803F
	 0,  0,  0,  5,  0,  0,  7,  0,  0,  0,  7,  0,  0,  0,  0,  0,   // 8040 - 804F
	 0,  0,  0,  0,  0,  0, 13,  0, 11,  0, 19,  0,  0,  0,  9,  0,   // 8050 - 805F
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  7,   // 8060 - 806F
	19,  0, 13, 15,  0,  0,  0, 17,  0,  0,  0,  0,  0, 19,  7, 15,   // 8070 - 807F
	 0,  0,  0,  0, 15, 13, 13, 17,  0, 15,  0,  7,  1,  0,  0,  0,   // 8080 - 808F
	 0,  0,  0,  0,  0,  0, 19,  0,  0,  0,  0, 27,  0,  1,  0,  0,   // 8090 - 809F
	 0,  1, 17,  0,  0, 11,  0,  0,  0,  1, 11,  0,  0,  0,  0,  1,   // 80A0 - 80AF
	 0,  1, 15,  0, 27,  0,  0,  0,  0,  0, 25,  0,  0,  0,  0,  0,   // 80B0 - 80BF
	 0,  0,  0, 15, 17,  0,  0,  0,  0,  0,  0,  0, 11,  0, 23,  0,   // 80C0 - 80CF
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 11,  1,  0,  0, 25,  0,   // 80D0 - 80DF
	 0, 27,  0,  0, 15, 13,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 80E0 - 80EF
	 0,  1,  0,  0,  5,  0,  0,  0, 27,  0,  0,  0,  0,  3,  0,  0,   // 80F0 - 80FF
	 0,  0, 17,  0,  0, 27, 19, 27,  9,  0, 19,  0,  0,  0,  0,  0,   // 8100 - 810F
	 0,  0,  0,  0,  0,  0,  0,  0, 15,  0,  1,  1,  0,  0,  0,  0,   // 8110 - 811F
	 0,  0,  0, 13,  0,  0,  0,  0,  0, 13,  0, 23,  0,  0,  0, 25,   // 8120 - 812F
	 0,  0,  0,  0,  0,  0,  0,  0,  0, 19,  0,  0,  0,  0, 11,  0,   // 8130 - 813F
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 15,  0,  0, 13,  0,   // 8140 - 814F
	11, 11,  0,  0,  1, 15,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 8150 - 815F
	 0,  0,  0,  0,  0, 13,  3,  0,  0,  0,  0, 17,  0,  0,  0,  0,   // 8160 - 816F
	15,  1,  0,  0,  0,  0,  0,  0, 17, 11, 13,  0,  0,  0,  0, 23,   // 8170 - 817F
	11,  0,  0,  0,  0,  0,  0,  0,  1,  0, 11,  0,  0,  0,  0,  1,   // 8180 - 818F
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 11,  0,  9, 13,  0,  0,   // 8190 - 819F
	 1,  0,  0, 17,  0,  0,  0,  0, 25,  0,  0,  0,  0,  0,  0,  0,   // 81A0 - 81AF
	 0,  0,  0, 13,  0, 19,  0,  0,  0,  0, 15,  0,  0,  5, 27,  3,   // 81B0 - 81BF
	 5,  0, 11,  0,  0,  0, 15,  0,  0,  0,  0,  0,  0, 17,  0,  0,   // 81C0 - 81CF
	 0,  0,  0,  0,  0,  0,  0,  0,  7,  0,  0,  0,  0,  0,  0, 17,   // 81D0 - 81DF
	 0,  0,  0, 13,  0, 15,  0, 17,  7,  0, 17,  0,  0, 19,  0,  0,   // 81E0 - 81EF
	 0,  0,  0, 17, 19,  0,  0,  0,  0,  0,  5, 17,  1,  0, 15,  0,   // 81F0 - 81FF
	 0,  0,  0,  0,  0,  1,  0, 15, 27,  0,  1,  0, 13, 13,  0,  0,   // 8200 - 820F
	 0,  0, 13,  0,  0,  0,  0,  0,  0,  0,  0, 19, 13,  0,  9, 17,   // 8210 - 821F
	 0,  1,  0,  0,  0,  0,  0,  0,  0,  0, 27, 11, 11,  0,  0,  0,   // 8220 - 822F
	 0,  0,  0,  0,  0, 23, 11, 27,  0, 13,  0,  0,  0,  0,  0,  0,   // 8230 - 823F
	11,  0,  0,  0,  0, 15,  0, 17,  0,  0,  0,  0,  0,  0,  0,  0,   // 8240 - 824F
	 0,  0,  0,  0,  0,  0,  0,  0,  0, 19,  0,  0,  0,  0,  0,  0,   // 8250 - 825F
	 0,  0,  0,  0, 15,  0, 27,  0,  0,  0,  0,  0,  0,  0,  1,  7,   // 8260 - 826F
	 0,  1, 13,  0,  0,  0, 15,  0, 19,  0,  0,  0,  0,  0, 15,  0,   // 8270 - 827F
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 15,  0, 17,  1,  0,   // 8280 - 828F
	 0,  0,  9,  0,  0,  0,  0,  0,  0, 11,  5,  0,  0, 17,  0, 13,   // 8290 - 829F
	 0,  0,  0,  0,  0,  1, 27,  0,  0,  1,  0,  0, 11, 25, 15, 13,   // 82A0 - 82AF
	 0, 27,  0, 11,  0,  0,  0, 17, 15,  1,  0, 19,  9, 15,  0, 15,   // 82B0 - 82BF
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 82C0 - 82CF
	 0, 15, 15,  0, 23, 19,  0,  9,  0,  0,  0,  1,  0,  0, 25,  1,   // 82D0 - 82DF
	 0, 15,  0,  0,  0, 15,  1, 17,  0,  0,  0,  0,  0,  0,  0,  0,   // 82E0 - 82EF
	 0, 15,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  1, 25,  0,   // 82F0 - 82FF
	 0, 17,  9, 11,  1,  9,  0,  0,  0,  9,  0,  0,  0,  0,  0,  0,   // 8300 - 830F
	 0,  0,  0,  0,  0,  0,  0,  9,  0,  0,  0,  0,  0,  0,  0,  0,   // 8310 - 831F
	 0,  0,  0,  0,  0,  0,  0,  0, 17,  0,  0,  9,  0,  0,  0, 11,   // 8320 - 832F
	 0, 13,  0,  0, 27, 15,  5,  0, 15, 15,  0,  0,  0,  0,  0,  0,   // 8330 - 833F
	13,  0,  0,  0,  0,  0,  0, 27,  0, 19, 27,  0,  0,  0,  0, 15,   // 8340 - 834F
	 0, 15, 27,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 8350 - 835F
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 8360 - 836F
	 0,  0,  0,  5,  0,  0,  0, 27,  0,  0,  0, 17,  0,  0,  0,  0,   // 8370 - 837F
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  7, 17,  0,  0,  0, 13,  0,   // 8380 - 838F
	 0,  0,  0,  0,  0,  0,  1,  0, 13,  0,  0,  0,  0,  0, 15,  0,   // 8390 - 839F
	 0,  0, 27,  0,  0,  0,  0,  0,  0, 11, 15,  9,  0,  0,  0,  0,   // 83A0 - 83AF
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  9,  0,  0,   // 83B0 - 83BF
	 0, 19,  0,  0,  0,  1,  0,  0,  0,  7,  1,  0,  1,  0,  0,  0,   // 83C0 - 83CF
	 0,  0,  0,  1,  0,  0, 19,  0,  0,  0,  0,  0, 19,  0,  0,  0,   // 83D0 - 83DF
	 0,  0,  0,  0,  0,  0,  0,  0,  0, 11,  0,  1,  0,  0,  0, 27,   // 83E0 - 83EF
	 1,  7, 11,  0, 15,  0,  0,  0,  0, 17,  0,  0,  0, 13,  0,  0,   // 83F0 - 83FF
	 0,  0,  0, 19,  5,  0,  0,  0,  0,  0,  7,  0,  9, 25, 15,  0,   // 8400 - 840F
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 8410 - 841F
	 0,  0,  0,  0,  0,  0,  0,  0,  0, 19,  0,  0,  9,  0,  0,  0,   // 8420 - 842F
	 0, 27,  0,  0,  0,  0,  0,  0, 15,  0,  0,  0,  0,  7,  0,  0,   // 8430 - 843F
	 0,  0,  0,  0,  0,  0,  0,  0,  0, 15,  0,  0,  0,  0,  0,  0,   // 8440 - 844F
	 0,  0,  0,  0,  0,  0,  0, 17,  0,  0,  0,  1,  0,  0,  0,  0,   // 8450 - 845F
	 0, 25,  0,  5,  0,  0, 15,  0,  0,  0,  0, 27, 17,  0,  0, 15,   // 8460 - 846F
	 0,  0,  0,  0,  0,  1,  0,  0,  0,  0, 17,  0,  0,  0,  0,  0,   // 8470 - 847F
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 8480 - 848F
	13,  0,  0,  0, 13,  0,  0,  0,  0,  9,  0,  0, 13,  0,  0,  0,   // 8490 - 849F
	 0, 11,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 84A0 - 84AF
	 0,  0, 25,  0,  0,  0,  0,  0, 17,  0,  0, 15, 19,  0,  0, 27,   // 84B0 - 84BF
	13,  0,  9,  0, 19,  0, 13,  0,  0, 15,  0,  1,  0, 13,  0,  0,   // 84C0 - 84CF
	 0, 13,  0,  0,  0,  0,  0,  0,  0,  0, 13,  0,  0,  0,  0,  0,   // 84D0 - 84DF
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 11,  0,  7,  0,   // 84E0 - 84EF
	 0,  0,  0,  0, 13,  0,  0,  0,  0,  0,  0,  0,  7,  0,  0,  0,   // 84F0 - 84FF
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 8500 - 850F
	 0,  9,  0,  9, 11,  0,  0, 17, 13,  0, 15,  0,  0,  0,  7,  0,   // 8510 - 851F
	 0, 19,  0, 17,  0, 19,  0,  0,  0,  0,  0,  0, 13, 15,  0, 17,   // 8520 - 852F
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 25,  0, 15,   // 8530 - 853F
	 0,  5,  0, 11,  0,  0,  0,  0,  0, 19,  0,  0,  0,  0,  1,  0,   // 8540 - 854F
	 0,  0,  0, 15,  0,  0,  0,  0,  0, 27,  0,  0,  0,  0,  0,  0,   // 8550 - 855F
	 0,  0,  0, 13,  0,  0,  0,  0,  1, 23,  9,  0,  0, 13,  0,  0,   // 8560 - 856F
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 8570 - 857F
	 0,  0,  0,  0, 11,  0,  0,  9,  0,  0,  0,  0,  0,  0,  0, 15,   // 8580 - 858F
	 0,  1,  0,  0, 17,  0,  0,  0,  0,  0,  0, 13,  0,  0,  0,  0,   // 8590 - 859F
	 0,  0,  0,  0,  0,  0, 19,  0, 27, 13, 13,  0,  0,  0,  0, 13,   // 85A0 - 85AF
	27,  0,  0,  0,  0,  0,  0,  0,  0,  0, 17,  0,  0,  0,  0,  0,   // 85B0 - 85BF
	 0,  1,  0,  0,  0,  0,  0,  0,  0, 17,  0,  0,  0,  7, 13, 17,   // 85C0 - 85CF
	 0,  0,  0,  0,  0, 15,  0,  0,  0,  0,  0,  0,  7, 15,  0,  0,   // 85D0 - 85DF
	 0,  0,  0,  0,  5, 15,  0,  0,  0, 11, 13,  0,  0,  0,  0,  0,   // 85E0 - 85EF
	 0,  0,  0,  0,  0,  0,  0, 17,  0,  0,  7, 17,  0,  0,  0,  1,   // 85F0 - 85FF
	 0,  0, 15,  0,  0,  0,  7, 13,  0,  0, 15,  0,  0,  0,  0,  0,   // 8600 - 860F
	 0,  0,  0,  0,  0,  0, 15, 11,  0,  0, 13,  0,  0,  0,  0,  0,   // 8610 - 861F
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  7,  0,  0,   // 8620 - 862F
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  7,   // 8630 - 863F
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 27,  0,   // 8640 - 864F
	27,  0,  0,  0,  1, 19,  0,  0,  0,  0,  0, 27,  7,  0, 15, 27,   // 8650 - 865F
	 0,  0,  0,  0,  0,  0,  0, 27,  0,  0,  0,  0,  0,  0,  0,  0,   // 8660 - 866F
	 0,  0,  0,  0,  0,  0,  0,  0,  0, 27,  0,  0,  0,  0,  0,  0,   // 8670 - 867F
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  9,  0, 11,  0,  0,  0,   // 8680 - 868F
	 0,  0,  0, 15,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 8690 - 869F
	 0,  0,  0,  1, 17,  0,  0,  0,  0, 19,  0,  0,  0,  0,  0,  0,   // 86A0 - 86AF
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 86B0 - 86BF
	 0,  0,  0,  0,  0,  0,  0, 13,  0,  0,  0,  5,  0,  0,  0,  0,   // 86C0 - 86CF
	 0,  0,  0,  0, 27,  0,  0,  0,  0, 15,  0, 17,  0,  0,  0,  1,   // 86D0 - 86DF
	 0,  0,  0,  0, 27,  0,  0,  0,  0,  0,  0,  0,  0, 17,  0,  0,   // 86E0 - 86EF
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 15,  0,   // 86F0 - 86FF
	19,  0, 11, 13,  0,  0,  0,  0, 15,  0,  0,  0,  0,  0,  0,  0,   // 8700 - 870F
	 0,  0,  0,  0,  0,  0,  0,  0, 17,  0, 11,  0,  9,  0,  0,  0,   // 8710 - 871F
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 8720 - 872F
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 8730 - 873F
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  1,  0,   // 8740 - 874F
	 0,  0,  0,  0,  0, 13,  0, 27,  0,  0,  0,  0,  0,  0,  0, 15,   // 8750 - 875F
	 0,  0,  0,  0,  0,  0, 27,  0, 13,  0,  0,  0,  0,  0,  0,  0,   // 8760 - 876F
	 0,  0,  0,  0, 27,  0, 17,  0, 15,  0,  0,  0,  0,  0,  0,  0,   // 8770 - 877F
	 0,  0,  7,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 15,  0,  0,   // 8780 - 878F
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  9,   // 8790 - 879F
	 0,  0, 27,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 87A0 - 87AF
	 0,  0,  0,  5,  0,  0,  0,  0,  0,  0,  7,  0,  0,  0,  0,  0,   // 87B0 - 87BF
	 0,  0,  0,  0, 19,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 87C0 - 87CF
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 87D0 - 87DF
	11,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 13,  0,  0, 15,   // 87E0 - 87EF
	 0,  0, 19,  0,  0,  0,  0,  0,  0, 27,  0, 15,  0,  0, 13,  0,   // 87F0 - 87FF
	 0,  0,  0,  0,  0, 13,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 8800 - 880F
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  7,   // 8810 - 881F
	 0,  0, 17,  7,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 8820 - 882F
	 0,  1,  0,  0,  0,  0, 17,  0,  0,  0,  0,  9,  0,  0,  0,  0,   // 8830 - 883F
	27,  0,  0,  0,  0,  0, 17,  0,  0,  0,  0,  0, 27, 15,  0,  0,   // 8840 - 884F
	 0,  0, 27, 13,  0,  0,  0,  1,  0, 15,  0, 15,  0, 19,  0,  0,   // 8850 - 885F
	 0, 27,  1, 15,  0,  0,  0,  0, 25,  0,  0, 13,  0,  0,  0,  0,   // 8860 - 886F
	13,  0,  3,  0,  0,  0,  0, 19,  0,  0,  0,  0,  0,  0,  1,  1,   // 8870 - 887F
	 0, 15,  9,  0,  0,  0,  0,  0,  1,  0,  0,  5,  0, 25,  0,  0,   // 8880 - 888F
	 0,  0,  5,  0,  0,  0, 13, 17,  0,  0,  0,  0,  0,  0,  1,  0,   // 8890 - 889F
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 25,  0,  0,  0,  0,   // 88A0 - 88AF
	 0,  0,  0,  0,  1,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 88B0 - 88BF
	 0, 17,  7,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  7,   // 88C0 - 88CF
	 0,  0,  0,  0, 15, 15,  0,  0,  0,  1,  0,  0, 11, 17,  0, 13,   // 88D0 - 88DF
	 0,  7,  0,  0,  0,  0,  0,  0, 11,  0,  0,  0,  0,  0,  0,  0,   // 88E0 - 88EF
	 0,  0,  0, 13, 11, 11,  0,  0,  7,  0,  0,  0,  0, 17,  0,  0,   // 88F0 - 88FF
	 0,  0,  0,  0,  0,  0,  0, 11,  0,  0,  0,  0,  0,  0,  0,  0,   // 8900 - 890F
	 1,  0, 25, 11,  0,  0,  0,  0, 15, 11,  0,  0,  0,  0,  0,  0,   // 8910 - 891F
	 0,  0,  0,  0,  0, 15,  0,  0,  0,  0, 23,  0,  0,  0,  0,  0,   // 8920 - 892F
	 0,  0,  0,  0,  0,  0, 13,  0,  7,  0,  0, 13,  0,  0,  0,  0,   // 8930 - 893F
	 0,  1,  0,  0, 15,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 8940 - 894F
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  1,   // 8950 - 895F
	 0,  0,  0,  0,  7,  0,  0,  0,  0,  0,  9,  0,  0,  0,  0,  0,   // 8960 - 896F
	 0,  0, 13,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 13,   // 8970 - 897F
	 0, 15,  0,  5,  0,  0, 11, 25,  0,  0,  0,  1,  0,  0,  0,  1,   // 8980 - 898F
	 0,  0,  0,  9,  0,  0, 13,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 8990 - 899F
	 0,  1,  0,  0,  0,  0,  0,  0,  0,  5, 19,  0,  0,  0,  0,  0,   // 89A0 - 89AF
	 0,  0,  1,  0,  0,  0,  0,  0,  0,  0,  1,  0,  0,  7,  0,  0,   // 89B0 - 89BF
	 1,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 89C0 - 89CF
	 0,  0,  1,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 89D0 - 89DF
	 0,  0,  0, 27,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 89E0 - 89EF
	 0,  0,  0,  0, 13,  0,  0,  0, 19,  0,  0,  0,  0,  0,  0,  0,   // 89F0 - 89FF
	15,  0, 17, 11,  0,  0,  0,  0,  1,  0, 13,  0, 27,  0, 23,  0,   // 8A00 - 8A0F
	 0,  0,  0, 27,  0,  0, 27, 23,  1,  0,  0, 15,  0, 15,  0, 13,   // 8A10 - 8A1F
	 0,  0,  0,  1,  0,  3,  0,  0,  0,  0, 11,  0,  0, 13,  0,  0,   // 8A20 - 8A2F
	 0, 27,  0,  0, 13,  0,  1,  0,  0,  0, 17, 17,  0,  0,  0,  0,   // 8A30 - 8A3F
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 8A40 - 8A4F
	13,  0,  0,  0, 17, 25,  0,  0,  0,  0,  0, 17,  0,  0, 13,  0,   // 8A50 - 8A5F
	15,  0, 13, 15,  0,  0, 13,  0,  0, 13,  0,  0,  0,  1, 17,  0,   // 8A60 - 8A6F
	27, 27, 27, 13,  0, 13,  0,  0,  0, 19,  0,  0,  0,  0,  0,  0,   // 8A70 - 8A7F
	 0,  0,  0,  0,  0, 17,  0,  1,  0,  0,  0,  0, 17, 15,  0,  0,   // 8A80 - 8A8F
	 0,  0,  0, 13,  0, 23,  0,  0, 15,  0,  0,  0,  0,  0, 15,  0,   // 8A90 - 8A9F
	13,  1,  0,  9, 15,  1, 13,  0, 27,  0, 13,  0,  0,  0,  0,  0,   // 8AA0 - 8AAF
	13,  0,  1,  0,  0,  0,  0,  0,  0, 11,  0,  0, 15,  0, 15, 17,   // 8AB0 - 8ABF
	 0,  0, 19,  0, 13,  0,  0,  5,  0,  0,  0, 19,  0, 17,  0, 19,   // 8AC0 - 8ACF
	 0,  0,  7,  0,  0,  0,  7,  0,  0,  0,  0, 15, 19,  0,  0,  0,   // 8AD0 - 8ADF
	 0, 13,  0,  0,  0,  0, 19, 27,  0,  0, 17,  1,  0, 15, 17,  0,   // 8AE0 - 8AEF
	 0, 27,  0,  0,  0,  0, 13, 25, 17,  0, 15,  0,  0,  0,  3,  0,   // 8AF0 - 8AFF
	 9, 15, 15,  0,  5,  0,  0,  0,  0,  0,  0,  0,  0,  0,  9,  0,   // 8B00 - 8B0F
	 9,  0,  0,  0, 27,  0, 13, 11,  0,  1, 15,  1,  0, 13,  0,  0,   // 8B10 - 8B1F
	15,  0,  0,  0,  0,  0,  0,  0,  9,  0,  0, 17,  7,  0,  0,  0,   // 8B20 - 8B2F
	 0,  0,  0,  1,  0,  0,  0,  0,  0,  1,  0,  0,  0,  0,  0,  0,   // 8B30 - 8B3F
	 0, 27,  0,  0,  0,  0,  0,  0,  0, 17,  0,  0,  0,  0, 27,  1,   // 8B40 - 8B4F
	 0,  0,  0,  0,  0,  0,  0,  0, 13,  0,  5,  0, 11,  0,  0,  0,   // 8B50 - 8B5F
	 0,  0,  0,  0,  0,  0,  1,  0,  0,  0,  0,  0, 11,  0,  0, 15,   // 8B60 - 8B6F
	15,  0,  0,  0,  1,  0,  0, 27,  0,  0,  0,  0,  0, 15,  0,  0,   // 8B70 - 8B7F
	 5,  0,  0,  0,  0,  0,  0,  0,  0,  0, 11,  0,  0,  0,  0,  0,   // 8B80 - 8B8F
	13,  0, 19, 15,  0,  0, 19,  0,  0,  0, 19,  0,  0,  0,  0,  0,   // 8B90 - 8B9F
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 8BA0 - 8BAF
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 8BB0 - 8BBF
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 8BC0 - 8BCF
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 8BD0 - 8BDF
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 8BE0 - 8BEF
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 8BF0 - 8BFF
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 8C00 - 8C0F
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 8C10 - 8C1F
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 8C20 - 8C2F
	 0,  0,  0,  0,  0,  0,  0,  1,  0,  0,  0,  0,  0,  0,  0,  1,   // 8C30 - 8C3F
	 0, 27,  0,  0,  0,  0,  5,  0,  1,  0, 25,  0, 15,  0,  0,  0,   // 8C40 - 8C4F
	 0,  0,  0,  0,  0, 13,  0,  0,  0,  0,  5,  0,  0,  0,  0,  0,   // 8C50 - 8C5F
	 0, 13,  0,  0,  0,  0,  0,  0,  0,  0, 27, 15,  0,  0,  0,  0,   // 8C60 - 8C6F
	 0,  0,  0,  0,  0,  0,  0,  0,  0, 25, 13,  0,  0,  0,  0,  0,   // 8C70 - 8C7F
	 0,  0, 19,  0,  0,  0,  0,  0,  0,  0,  9,  0,  9,  0,  0,  0,   // 8C80 - 8C8F
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 25, 17,  0,   // 8C90 - 8C9F
	11, 17,  1,  0,  0,  0,  0, 11, 27, 25, 23,  1, 19,  0,  0, 17,   // 8CA0 - 8CAF
	13,  0,  0, 15,  1,  0, 25,  9,  5,  0,  0, 11, 19, 15,  0,  9,   // 8CB0 - 8CBF
	27, 11,  7, 15, 27,  0,  0, 17,  1,  0, 17,  0,  0,  0,  0,  0,   // 8CC0 - 8CCF
	 0, 17,  0, 11,  0,  0,  0,  0,  0,  0,  7,  0, 13,  0, 13,  0,   // 8CD0 - 8CDF
	11,  0, 27,  9, 19,  0, 11,  0,  0,  0, 17,  0,  0,  5,  0,  0,   // 8CE0 - 8CEF
	 0,  0,  0,  0,  7,  0,  0,  0,  0,  0,  0, 11,  1, 13,  0,  0,   // 8CF0 - 8CFF
	 0,  0,  0,  0, 17, 19,  0, 15, 17,  0, 19,  0,  0, 13,  0,  0,   // 8D00 - 8D0F
	 0,  0,  0, 17,  0,  0, 13,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 8D10 - 8D1F
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 8D20 - 8D2F
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 8D30 - 8D3F
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 8D40 - 8D4F
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 8D50 - 8D5F
	 0,  0,  0,  0, 17,  0, 13,  0,  0,  0,  0, 27,  0,  0,  0,  0,   // 8D60 - 8D6F
	17,  0,  0,  1, 11,  0,  0,  1,  0,  0,  0,  0,  0,  0,  0,  0,   // 8D70 - 8D7F
	 0,  0,  0,  0,  0, 19,  0,  0,  0,  0, 15,  0,  0,  0,  0,  0,   // 8D80 - 8D8F
	 0,  0,  0,  0,  0,  0,  0,  0,  0, 17,  0,  0,  0,  0,  0,  0,   // 8D90 - 8D9F
	 0,  0,  0, 19,  0,  0,  0,  0, 19,  0,  0,  0,  0,  0,  0,  0,   // 8DA0 - 8DAF
	 0,  0,  0, 17,  0,  0,  0,  0,  0,  0, 11,  0,  0,  0, 17,  0,   // 8DB0 - 8DBF
	 0,  0,  0,  0,  0,  0, 23,  0,  0,  0,  0, 11, 17,  0,  0,  1,   // 8DC0 - 8DCF
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 25,  0,  1,  0,  0,   // 8DD0 - 8DDF
	 0, 17,  0, 13,  0,  0,  0,  0,  1,  0,  0,  0,  0,  0,  0,  7,   // 8DE0 - 8DEF
	 0,  0,  0,  5,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 8DF0 - 8DFF
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 15,  0,  0,  0,  0,  5,   // 8E00 - 8E0F
	19,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  1,  0,   // 8E10 - 8E1F
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 17,  0,  0,  0,  0,  0,   // 8E20 - 8E2F
	15,  0,  0,  0,  0, 17,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 8E30 - 8E3F
	 0,  0, 15,  0, 17,  0,  0,  1,  5, 19, 27,  0,  0,  0,  0,  0,   // 8E40 - 8E4F
	 0,  0,  0,  0,  0,  0,  0,  0,  0, 19,  0,  0,  0,  0,  0, 17,   // 8E50 - 8E5F
	19,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 8E60 - 8E6F
	 0,  0,  0,  0, 19,  0,  1,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 8E70 - 8E7F
	 0, 17,  0,  0,  0,  0,  0, 17,  0,  0, 17,  0,  0, 15,  0,  0,   // 8E80 - 8E8F
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 8E90 - 8E9F
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  7, 13,  1,  0,  0,  0,   // 8EA0 - 8EAF
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 8EB0 - 8EBF
	 1,  0,  0,  0,  0,  0,  0,  0,  0,  0, 19, 15,  1,  1,  0,  0,   // 8EC0 - 8ECF
	 0,  0, 27,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 15,   // 8ED0 - 8EDF
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 17,  0,  0,  0,  0,   // 8EE0 - 8EEF
	 0,  0,  0,  0,  0,  0,  0,  0, 19,  0,  0,  1,  0,  0, 13,  0,   // 8EF0 - 8EFF
	 0,  0,  0,  1,  0,  7,  0,  0,  0, 17,  0,  0,  0,  0,  0,  0,   // 8F00 - 8F0F
	 0,  0, 19,  9, 11,  1,  0,  0,  0,  0,  0,  7, 19, 27,  9, 19,   // 8F10 - 8F1F
	 0,  0,  0,  0,  0,  0,  7, 11,  0, 11,  7,  0,  0,  0,  0, 17,   // 8F20 - 8F2F
	 0,  0,  0, 17,  0,  0,  0,  0, 13, 11,  0, 11,  0,  0, 17, 15,   // 8F30 - 8F3F
	 0,  0,  0,  0, 27, 15,  0,  0,  0, 17,  0,  0,  0, 19,  1,  0,   // 8F40 - 8F4F
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 15,  0,  1,   // 8F50 - 8F5F
	 0,  0,  7,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 8F60 - 8F6F
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 8F70 - 8F7F
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 8F80 - 8F8F
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 13,  1,  0,  0,  0,   // 8F90 - 8F9F
	 0,  0,  0,  7,  0,  0, 25,  0, 11,  0,  0,  0,  0, 13,  0, 11,   // 8FA0 - 8FAF
	17, 15,  3,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 8FB0 - 8FBF
	 0,  0, 15,  0,  0, 13,  0,  0,  0,  0,  0,  0,  0,  0, 15,  0,   // 8FC0 - 8FCF
	 0,  1,  0,  0, 11,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 8FD0 - 8FDF
	 0,  0,  0,  0,  0,  0,  1,  0,  0,  0, 17, 11,  0, 17,  0,  0,   // 8FE0 - 8FEF
	13,  0,  1,  0,  0,  0,  0,  9,  0, 17,  0,  0,  0, 19,  0,  0,   // 8FF0 - 8FFF
	23, 13,  1,  5,  0, 27, 15,  0, 27,  0,  0, 25,  0, 13,  0, 23,   // 9000 - 900F
	19,  1,  0,  0,  5,  1,  0,  5,  0, 17, 23,  0,  0, 13,  7, 13,   // 9010 - 901F
	17, 17, 11,  7,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 19,  0,   // 9020 - 902F
	 0, 17, 17,  0,  0,  1,  0,  0, 15,  0,  0,  0, 25,  0, 15,  0,   // 9030 - 903F
	 0,  5, 13,  0,  0,  0,  0, 15,  0,  0, 15, 15,  0, 25,  1,  0,   // 9040 - 904F
	27, 27,  0,  5,  5, 15,  0,  0,  0, 15,  0,  0, 13,  5, 19,  0,   // 9050 - 905F
	15, 13,  0,  1,  0,  0,  0,  0,  0, 17,  0,  0,  0, 17, 19,  5,   // 9060 - 906F
	 0,  0, 17,  0,  0, 17,  0, 19, 13,  0, 15,  0,  7,  1,  0, 25,   // 9070 - 907F
	15,  9, 27, 13, 27,  0,  0, 15,  9,  0, 11,  0,  0,  0,  0,  7,   // 9080 - 908F
	 0, 15,  0,  0,  0, 15,  0,  0,  0,  9,  0,  0,  0,  0,  0,  0,   // 9090 - 909F
	 0,  0, 27,  3,  0,  0, 11,  0, 19,  0, 13,  0,  0,  0,  0,  1,   // 90A0 - 90AF
	23,  1,  0,  0,  0, 13,  0,  0, 17,  0,  0,  0,  0,  0,  0,  0,   // 90B0 - 90BF
	 0, 15,  0,  0,  0,  0,  0,  0,  0,  0,  1,  0,  0,  0,  0,  0,   // 90C0 - 90CF
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  7,  0,   // 90D0 - 90DF
	 0,  1,  0,  0,  0,  0,  0,  0, 11,  0,  0,  0,  0,  1,  0,  0,   // 90E0 - 90EF
	 0,  0,  0,  0,  0, 15,  0,  0,  0,  0,  0,  0,  0,  5,  0,  0,   // 90F0 - 90FF
	 0,  0, 15,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 9100 - 910F
	 0,  0, 19,  0,  0, 27,  0,  0,  0, 11,  0,  0,  0,  0,  0,  0,   // 9110 - 911F
	 0,  0,  0,  0,  0,  0,  0,  5,  0,  0,  0,  0,  0, 17,  0,  0,   // 9120 - 912F
	 0,  0,  5,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 9130 - 913F
	 0,  0,  0,  0,  0,  0,  0,  0,  0, 15, 17, 19, 17, 11, 17,  0,   // 9140 - 914F
	 0,  0, 17,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 9150 - 915F
	 0,  0, 19,  0,  0,  0,  0,  0,  0,  9,  7,  0, 13,  0,  0,  0,   // 9160 - 916F
	 0,  0,  0,  0,  0, 27,  0, 27, 13,  0,  0,  0,  0,  0,  0,  0,   // 9170 - 917F
	 0,  0,  0,  0,  0,  0,  0, 13,  0, 19,  0, 19,  0, 17,  0,  0,   // 9180 - 918F
	 0,  0, 13,  0,  0,  0,  0,  0,  0,  0,  0,  0, 19,  0,  0,  0,   // 9190 - 919F
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 15, 17,  0, 19, 27,   // 91A0 - 91AF
	 0, 11,  0,  0,  7,  1,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 91B0 - 91BF
	15,  0,  0,  0,  0,  0,  0, 19,  0, 15,  0, 13,  7, 17, 15,  7,   // 91C0 - 91CF
	 7,  1,  0,  0,  0,  0,  0, 13, 17,  0,  0,  0, 11, 19,  0,  0,   // 91D0 - 91DF
	 0,  0,  0, 17,  0,  0,  0, 19,  0,  0, 15,  0,  0,  0,  0,  0,   // 91E0 - 91EF
	 0,  0,  0,  0,  0, 19,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 91F0 - 91FF
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  5,  0,  0,   // 9200 - 920F
	 1, 25, 13,  0,  0,  0,  0, 15,  0,  0,  0,  0,  0,  0,  1,  0,   // 9210 - 921F
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 9220 - 922F
	 0,  0,  0,  0,  7,  0,  0,  0,  0,  0, 15,  0,  0,  0,  0, 17,   // 9230 - 923F
	 1,  0,  0,  0,  0,  1,  0,  0,  0, 27,  0,  0,  0,  0,  0,  0,   // 9240 - 924F
	 0,  0,  0,  0,  0,  0,  0,  1,  0,  0,  0, 15,  0,  0, 15,  0,   // 9250 - 925F
	 0,  0, 11,  0,  1, 13, 17,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 9260 - 926F
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 9270 - 927F
	15,  0,  0, 19,  0,  5,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 9280 - 928F
	 0, 13,  0, 17,  0,  0, 13,  0,  9,  0,  0,  0, 27,  0,  0,  0,   // 9290 - 929F
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 92A0 - 92AF
	 0,  0,  0, 15,  0,  0,  1, 13,  0, 13,  0,  0,  0,  0,  0,  0,   // 92B0 - 92BF
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 17,  0,  0, 27,   // 92C0 - 92CF
	 0,  0, 11,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 92D0 - 92DF
	 0,  0,  0,  0, 13,  0,  0,  0,  0,  0, 25,  0,  0,  0,  0,  0,   // 92E0 - 92EF
	 0,  0,  0,  0,  0,  0,  0,  0,  1,  0,  0,  0,  1,  0,  0,  0,   // 92F0 - 92FF
	 0,  0,  0,  0,  7,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 9300 - 930F
	19,  0,  0,  0,  0,  0,  0,  0, 19,  0, 17,  0,  0,  0, 13,  5,   // 9310 - 931F
	17,  1, 17,  0,  1,  0,  1,  0,  9,  0,  0, 13,  0,  0,  1, 19,   // 9320 - 932F
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 9330 - 933F
	 0,  0,  0,  0,  0,  0,  0,  0, 15,  0,  7,  1,  0,  5,  0,  0,   // 9340 - 934F
	 0,  0,  0,  0, 15,  0,  0,  0,  0,  0,  0,  5,  0,  0,  0,  0,   // 9350 - 935F
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 15,  0,   // 9360 - 936F
	 0,  0,  0,  0,  0,  1,  0,  0,  0,  0,  0,  0, 19,  0, 17,  0,   // 9370 - 937F
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  1,  0,  0,  0,   // 9380 - 938F
	 0,  0,  0,  0, 15,  0, 13,  0,  0,  0, 19,  0,  0,  0,  0,  0,   // 9390 - 939F
	 0,  0,  0, 27,  0,  0,  0,  1,  0,  0,  0,  0, 27, 17,  0,  0,   // 93A0 - 93AF
	15,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 93B0 - 93BF
	 0,  0,  0, 17,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 93C0 - 93CF
	 0, 17,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 15,  0,   // 93D0 - 93DF
	 0,  1,  0,  0,  7,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 93E0 - 93EF
	 0,  0,  0,  0,  0,  0, 17,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 93F0 - 93FF
	 0,  0,  0,  0, 27,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 9400 - 940F
	 0,  0,  0,  0,  0,  0,  0,  0, 17,  0,  0,  0,  0,  0,  0,  0,   // 9410 - 941F
	 0,  0,  0,  0,  0, 13,  0,  0,  0,  0,  0, 17,  0,  0,  0,  0,   // 9420 - 942F
	 0,  0,  0,  0,  0, 19,  0,  0, 23,  0,  0,  0,  0,  0,  0,  0,   // 9430 - 943F
	 0,  0,  0,  0, 17,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 9440 - 944F
	 0,  1,  1,  0,  0,  0,  0,  0,  0,  0,  0,  1,  0,  0,  0,  0,   // 9450 - 945F
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 9460 - 946F
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 19,  0, 19,   // 9470 - 947F
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 9480 - 948F
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 9490 - 949F
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 94A0 - 94AF
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 94B0 - 94BF
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 94C0 - 94CF
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 94D0 - 94DF
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 94E0 - 94EF
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 94F0 - 94FF
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 9500 - 950F
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 9510 - 951F
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 9520 - 952F
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 9530 - 953F
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 9540 - 954F
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 9550 - 955F
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 9560 - 956F
	 0,  0,  0,  0,  0,  0,  0, 17,  0,  0,  0,  0,  0,  0,  0,  0,   // 9570 - 957F
	 9,  0,  0, 13,  0,  0,  0,  0,  0, 25,  0,  1,  0,  0,  0, 15,   // 9580 - 958F
	 0, 27, 27,  1,  9,  0,  0,  0,  1,  0,  0,  0,  0,  0,  0,  0,   // 9590 - 959F
	 0,  0,  0,  1, 27, 11,  0,  0,  1,  0,  0,  0,  0,  7,  0,  0,   // 95A0 - 95AF
	 0, 15,  0,  0,  0,  0,  0,  0,  0,  0,  0, 15, 15,  0,  0,  0,   // 95B0 - 95BF
	 0,  0,  0,  0,  0,  0,  0, 15,  0,  0, 27,  0,  0,  0,  0,  0,   // 95C0 - 95CF
	 0,  0,  0,  0, 27,  1, 23,  0,  0,  0,  0,  0,  1,  0,  0,  0,   // 95D0 - 95DF
	 0, 19, 11,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 95E0 - 95EF
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 95F0 - 95FF
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 9600 - 960F
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 11,  0,  0,  0,   // 9610 - 961F
	 0, 19,  0,  0,  0,  0,  0,  0,  0,  0, 25,  0,  0,  0, 15,  0,   // 9620 - 962F
	 0,  0, 11,  0,  0,  0,  0,  0,  0,  0,  0, 17,  0,  0,  0, 15,   // 9630 - 963F
	23,  0, 25,  0, 11,  0,  0,  0,  0,  0,  0,  7,  9,  1,  0,  0,   // 9640 - 964F
	27,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 25, 27, 13, 13, 19,   // 9650 - 965F
	 0,  0, 15, 17, 17,  0,  0,  0,  0,  0, 11,  0,  0,  0,  0,  0,   // 9660 - 966F
	15,  0,  0, 17,  0,  7,  5, 27,  7,  0,  0,  0,  0, 15,  0,  0,   // 9670 - 967F
	 0,  0,  0,  0,  0, 15,  7,  0,  0,  0,  5, 13,  0, 27,  1,  0,   // 9680 - 968F
	 0,  0,  0,  0,  1, 15,  0,  0, 15,  1,  0, 17, 17,  0,  0,  0,   // 9690 - 969F
	 0,  0,  0,  7,  0,  0,  0, 13, 13,  0, 27,  0,  0,  0,  0,  0,   // 96A0 - 96AF
	 0, 15,  0,  0,  0,  0,  0,  7,  0,  0,  0, 19,  0,  0,  0,  0,   // 96B0 - 96BF
	17, 15,  0,  0, 15, 15, 17,  1,  0, 19,  0, 17, 17, 15, 17,  0,   // 96C0 - 96CF
	 0,  0,  0,  0,  0, 17, 13,  0,  0, 13,  0, 19, 17,  0,  0,  0,   // 96D0 - 96DF
	 0,  0,  7,  3,  0,  0,  0,  0, 15, 15, 13,  0,  0,  0,  0,  9,   // 96E0 - 96EF
	11,  0, 15,  0,  0,  0,  7,  7,  0, 11,  0, 17,  0,  0,  0,  0,   // 96F0 - 96FF
	13,  0,  0,  0,  0,  0, 17, 17,  0,  0,  0,  0,  0,  0,  0,  0,   // 9700 - 970F
	 0, 17,  0, 15,  0,  0,  7,  0,  0, 15,  0,  0, 13,  0, 27,  0,   // 9710 - 971F
	 0,  0,  0,  0,  0,  0,  0,  9,  0,  0,  0,  0,  0,  0,  0,  0,   // 9720 - 972F
	13,  0,  7,  0,  0,  0,  0,  0,  0, 11,  0,  0,  0, 17,  0,  0,   // 9730 - 973F
	 0,  0,  7,  0, 15,  0,  0,  0,  7,  0,  0,  0,  0,  0,  0,  0,   // 9740 - 974F
	 0, 19,  0,  0,  0,  0, 17,  0,  0,  0,  0,  0, 17,  0, 11,  0,   // 9750 - 975F
	 0,  9,  9,  0,  0,  0,  0,  0,  0, 27,  0,  0,  0, 15,  0,  0,   // 9760 - 976F
	 0,  0,  0,  0, 27,  0,  0, 15,  0,  0,  9,  0,  0,  0,  0,  0,   // 9770 - 977F
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 27,  0, 15,  0,  1,   // 9780 - 978F
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 9790 - 979F
	 1,  0,  0,  0,  0,  0,  0,  0,  1,  0,  0,  1,  0, 25,  0,  0,   // 97A0 - 97AF
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 97B0 - 97BF
	 0,  0,  0,  0,  0,  0, 19,  0,  0,  0,  0, 15,  0,  0,  0,  0,   // 97C0 - 97CF
	 0,  0,  0, 27,  0,  0,  0,  0,  0,  0,  0,  0,  5,  0,  0,  0,   // 97D0 - 97DF
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 97E0 - 97EF
	 0,  0,  0, 15,  0,  0, 13,  0,  0,  0,  0, 15,  0,  0,  0, 27,   // 97F0 - 97FF
	27, 27, 17,  1,  0, 27, 13,  0, 13,  0, 15,  0, 13,  0,  0,  0,   // 9800 - 980F
	15, 15, 11,  5,  0,  0,  0, 25,  7,  0,  0,  0,  0,  0,  0,  0,   // 9810 - 981F
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  5,  0,  0,   // 9820 - 982F
	27,  0,  0,  0,  0,  0,  0,  0,  1, 23,  0, 11,  0,  0,  0,  0,   // 9830 - 983F
	 0,  0,  0,  0,  0,  0,  1,  0,  0,  0,  0,  0, 17, 15, 15,  0,   // 9840 - 984F
	 0,  0,  0,  0, 15,  0,  0,  0, 15,  0, 17,  0,  0,  0,  7,  0,   // 9850 - 985F
	 0,  0,  0,  0,  0, 27,  0,  1,  0,  0,  0, 17,  0,  0,  0, 27,   // 9860 - 986F
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 9870 - 987F
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 9880 - 988F
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 9890 - 989F
	 0,  0,  0,  0,  0,  0,  0,  0, 25,  0,  0,  0,  0,  0,  0, 13,   // 98A0 - 98AF
	 0, 23,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 98B0 - 98BF
	 0,  0,  0,  0, 25,  0,  0, 25,  0,  0,  0,  0,  0,  0,  0,  0,   // 98C0 - 98CF
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 11, 11,  0,  0, 13,   // 98D0 - 98DF
	 0, 13,  1,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 19, 15, 11,   // 98E0 - 98EF
	 0,  0,  0,  0, 15,  0,  0,  0,  0,  0,  0,  0, 13, 25, 13,  0,   // 98F0 - 98FF
	 0,  0,  0,  1,  0,  0,  0,  0,  0, 27, 15,  0, 15,  0,  0,  0,   // 9900 - 990F
	19,  0,  0, 15,  0,  0,  0,  0, 15,  0,  0,  0,  0,  0, 17,  0,   // 9910 - 991F
	11,  0,  0,  0,  0,  0,  0,  0,  1,  0,  0,  0,  0,  0,  0,  0,   // 9920 - 992F
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 9930 - 993F
	 0,  0,  0,  0,  0,  9,  0,  0,  0,  1,  0,  1, 19, 13,  0,  0,   // 9940 - 994F
	 0,  1, 15,  0, 15,  0,  0, 27,  0,  0,  0,  0,  0,  0,  0,  0,   // 9950 - 995F
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 9960 - 996F
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 9970 - 997F
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 9980 - 998F
	 0,  0,  0,  0,  0,  0, 13,  0,  0, 27,  0,  0,  0, 25,  0,  0,   // 9990 - 999F
	 0,  0,  0,  0,  0, 11,  0,  0, 27,  0,  0,  0,  9, 15, 25,  0,   // 99A0 - 99AF
	 0, 23,  0, 19, 13,  0,  0,  0,  0, 15,  0,  0,  0,  0,  0,  0,   // 99B0 - 99BF
	 0, 11,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 99C0 - 99CF
	17,  3,  1,  0,  0,  1,  0,  0,  0, 11,  0,  0,  0, 23,  0, 13,   // 99D0 - 99DF
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 27,  0,  0,   // 99E0 - 99EF
	 0,  7,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 17,   // 99F0 - 99FF
	 0, 11,  0,  0,  0,  0,  0,  0, 11,  0,  0,  0,  0,  0,  1,  1,   // 9A00 - 9A0F
	 0,  0,  0,  0,  0,  0,  0,  0,  0, 25,  0,  0,  0,  0,  0,  0,   // 9A10 - 9A1F
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  1,  0,  0,  0,  0,   // 9A20 - 9A2F
	 5,  0,  0,  0,  0,  0, 19, 13,  0,  0,  0,  0,  0,  0,  0,  0,   // 9A30 - 9A3F
	 9,  0,  0, 25,  0,  1,  0,  0,  0,  0,  0,  0,  0, 27,  0,  0,   // 9A40 - 9A4F
	 0,  0,  0,  0,  0,  1,  0, 27,  0,  0,  1, 15,  0,  0,  0, 19,   // 9A50 - 9A5F
	 0,  0,  7,  0,  0,  1,  0,  0,  0, 27,  7,  0,  0,  0,  0,  0,   // 9A60 - 9A6F
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 9A70 - 9A7F
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 9A80 - 9A8F
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 9A90 - 9A9F
	 0,  0,  0,  0,  0,  0,  0,  0,  1,  0,  0,  0,  0,  0,  0,  0,   // 9AA0 - 9AAF
	 0,  0,  0,  0,  0,  0,  0,  0, 27,  0,  0,  0,  0,  0,  0,  0,   // 9AB0 - 9ABF
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 9AC0 - 9ACF
	 0,  0,  0, 13, 19,  0,  0,  0,  1,  0,  0,  0,  0,  0,  0,  0,   // 9AD0 - 9ADF
	 0,  0,  0,  0,  0, 15,  0,  0,  0,  0,  0,  0,  0,  0, 11,  0,   // 9AE0 - 9AEF
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 9AF0 - 9AFF
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 9B00 - 9B0F
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 13,  0,  0,  0,  0,  0,   // 9B10 - 9B1F
	 0,  0,  0,  0,  0,  0,  0,  7,  0,  0, 23,  0,  0,  0,  0,  0,   // 9B20 - 9B2F
	 0, 15,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  1,  0,  0,  0,   // 9B30 - 9B3F
	 0,  1, 27, 11, 11,  9,  0,  0,  0,  0,  0,  0,  0,  0,  0, 15,   // 9B40 - 9B4F
	 0,  0,  0,  0,  9,  0,  0,  0,  0,  0, 15,  0,  0,  0,  0,  0,   // 9B50 - 9B5F
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  7,   // 9B60 - 9B6F
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 9B70 - 9B7F
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 17,  0,   // 9B80 - 9B8F
	 0, 25,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 15,   // 9B90 - 9B9F
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  1,  0,  0, 13,  0,   // 9BA0 - 9BAF
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 9BB0 - 9BBF
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  7,  0,  0,  0,  0,  0,  0,   // 9BC0 - 9BCF
	 0,  0,  0,  0,  0,  0, 19,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 9BD0 - 9BDF
	 0,  0,  0,  0,  1,  0,  0,  0,  1,  0,  0,  0,  0,  0,  0,  0,   // 9BE0 - 9BEF
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 9BF0 - 9BFF
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 19,  0,  0,   // 9C00 - 9C0F
	15,  0, 11,  0,  0, 27,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 9C10 - 9C1F
	 0,  0,  0,  0,  0, 27,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 9C20 - 9C2F
	 0,  0, 15,  0,  0,  0,  0,  0,  0,  0,  0,  9,  0,  0,  0,  0,   // 9C30 - 9C3F
	 0,  0,  0,  0,  0,  0,  0,  1,  0, 11,  0,  0,  0,  0,  0,  0,   // 9C40 - 9C4F
	 0,  0,  0,  0,  0,  0,  0,  7,  0,  0,  0,  0,  0,  0,  0,  0,   // 9C50 - 9C5F
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 9C60 - 9C6F
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 9C70 - 9C7F
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 9C80 - 9C8F
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 9C90 - 9C9F
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 9CA0 - 9CAF
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 9CB0 - 9CBF
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 9CC0 - 9CCF
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 9CD0 - 9CDF
	 0,  0,  0,  0,  0, 17,  0, 11,  0,  1,  0,  0,  0,  0,  0,  0,   // 9CE0 - 9CEF
	 0,  0,  0, 11,  9,  0, 15,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 9CF0 - 9CFF
	 0,  0,  0,  0,  0,  0,  0,  0,  0, 15,  0,  0,  0,  0,  0,  0,   // 9D00 - 9D0F
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 15,  0,  0,  0,  0,   // 9D10 - 9D1F
	 0,  0,  0,  0,  0,  0, 15,  0, 15,  0,  0,  0,  0,  0,  0,  0,   // 9D20 - 9D2F
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 27,  0,  0,  0,  0,   // 9D30 - 9D3F
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 9D40 - 9D4F
	 0,  1,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 15,  0,  0,   // 9D50 - 9D5F
	 1,  9,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 11,  0,  0,  0,   // 9D60 - 9D6F
	 0,  0, 17,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 9D70 - 9D7F
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 9D80 - 9D8F
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 9D90 - 9D9F
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  9,  0,  0,  0,  0,  0, 15,   // 9DA0 - 9DAF
	 0,  0,  0,  0, 27,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 9DB0 - 9DBF
	 0,  0,  0,  0,  1,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 9DC0 - 9DCF
	 0,  0,  0,  0,  0,  0,  0,  1,  0,  0,  0,  0,  0,  0,  0,  0,   // 9DD0 - 9DDF
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 9DE0 - 9DEF
	 0,  0, 19,  0,  0,  0,  0,  0, 27, 15,  7,  0,  0,  0,  0,  0,   // 9DF0 - 9DFF
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 9E00 - 9E0F
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 15,  0,  0,  0,  7,  0,   // 9E10 - 9E1F
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 9E20 - 9E2F
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 9E30 - 9E3F
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 9E40 - 9E4F
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 9E50 - 9E5F
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 9E60 - 9E6F
	 0,  0,  0,  0,  0,  7,  0,  0,  0, 27,  0,  0,  0, 15,  0,  7,   // 9E70 - 9E7F
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 9E80 - 9E8F
	 0,  0,  1,  7,  0,  0,  0,  7,  0,  0,  0,  0,  0, 13,  0,  7,   // 9E90 - 9E9F
	 0,  0,  0,  0,  0,  9,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 9EA0 - 9EAF
	 0,  0,  0,  0,  1,  9,  0,  0,  0,  0,  0,  9,  0,  0, 27,  0,   // 9EB0 - 9EBF
	 0,  0,  0, 27,  0,  0,  0,  0,  0,  0,  0,  0,  0, 13,  7,  0,   // 9EC0 - 9ECF
	 0, 27,  0,  0,  1,  0,  0,  0,  9,  0,  0,  5, 19,  0, 17,  0,   // 9ED0 - 9EDF
	 0,  0,  0,  0,  0,  0,  0,  0,  5,  0,  0,  0,  0,  0,  0,  0,   // 9EE0 - 9EEF
	 0,  0,  0,  0,  9,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 9EF0 - 9EFF
	 0,  0,  0,  0,  0,  0,  0, 15, 11,  0,  0,  0,  0,  0, 17,  0,   // 9F00 - 9F0F
	 0,  0,  0,  1,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 9F10 - 9F1F
	13,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 9F20 - 9F2F
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 11,  0,  0,  0,  0,   // 9F30 - 9F3F
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 17, 17,  0,  0, 17,  0,   // 9F40 - 9F4F
	 0,  0, 19,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 17,   // 9F50 - 9F5F
	 0,  7,  0,  0,  0,  0,  0, 13,  0,  0, 19,  0, 15,  0,  0,  0,   // 9F60 - 9F6F
	 0,  0,  0,  0,  0,  0,  0, 15,  0,  0,  0,  0,  0,  0,  0,  0,   // 9F70 - 9F7F
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  7,  0,  0,   // 9F80 - 9F8F
	11,  0,  0,  0,  0,  1,  0,  0,  0,  0,  0,  0,  1,  0,  0,  0,   // 9F90 - 9F9F
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 9FA0 - 9FAF
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 9FB0 - 9FBF
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 9FC0 - 9FCF
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 9FD0 - 9FDF
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 9FE0 - 9FEF
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 9FF0 - 9FFF
	 1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,   // AC00 - AC0F
	 1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,   // AC10 - AC1F
	 1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,   // AC20 - AC2F
	 1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,   // AC30 - AC3F
	 1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,   // AC40 - AC4F
	 1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,   // AC50 - AC5F
	 1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,   // AC60 - AC6F
	 1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,   // AC70 - AC7F
	 1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,   // AC80 - AC8F
	 1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,   // AC90 - AC9F
	 1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,   // ACA0 - ACAF
	 1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,   // ACB0 - ACBF
	 1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,   // ACC0 - ACCF
	 1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,   // ACD0 - ACDF
	 1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,   // ACE0 - ACEF
	 1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,   // ACF0 - ACFF
	 1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,   // AD00 - AD0F
	 1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,   // AD10 - AD1F
	 1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,   // AD20 - AD2F
	 1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,   // AD30 - AD3F
	 1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,   // AD40 - AD4F
	 1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,   // AD50 - AD5F
	 1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,   // AD60 - AD6F
	 1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,   // AD70 - AD7F
	 1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,   // AD80 - AD8F
	 1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,   // AD90 - AD9F
	 1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,   // ADA0 - ADAF
	 1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,   // ADB0 - ADBF
	 1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,   // ADC0 - ADCF
	 1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,   // ADD0 - ADDF
	 1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,   // ADE0 - ADEF
	 1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,   // ADF0 - ADFF
	 1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,   // AE00 - AE0F
	 1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,   // AE10 - AE1F
	 1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,   // AE20 - AE2F
	 1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,   // AE30 - AE3F
	 1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,   // AE40 - AE4F
	 1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,   // AE50 - AE5F
	 1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,   // AE60 - AE6F
	 1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,   // AE70 - AE7F
	 1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,   // AE80 - AE8F
	 1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,   // AE90 - AE9F
	 1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,   // AEA0 - AEAF
	 1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,   // AEB0 - AEBF
	 1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,   // AEC0 - AECF
	 1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,   // AED0 - AEDF
	 1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,   // AEE0 - AEEF
	 1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,   // AEF0 - AEFF
	 1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,   // AF00 - AF0F
	 1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,   // AF10 - AF1F
	 1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,   // AF20 - AF2F
	 1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,   // AF30 - AF3F
	 1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,   // AF40 - AF4F
	 1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,   // AF50 - AF5F
	 1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,   // AF60 - AF6F
	 1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,   // AF70 - AF7F
	 1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,   // AF80 - AF8F
	 1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,   // AF90 - AF9F
	 1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,   // AFA0 - AFAF
	 1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,   // AFB0 - AFBF
	 1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,   // AFC0 - AFCF
	 1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,   // AFD0 - AFDF
	 1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,   // AFE0 - AFEF
	 1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,   // AFF0 - AFFF
	 1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,   // B000 - B00F
	 1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,   // B010 - B01F
	 1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,   // B020 - B02F
	 1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,   // B030 - B03F
	 1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,   // B040 - B04F
	 1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,   // B050 - B05F
	 1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,   // B060 - B06F
	 1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,   // B070 - B07F
	 1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,   // B080 - B08F
	 1,  1,  1,  1,  1,  1,  1,  1,  3,  3,  3,  3,  3,  3,  3,  3,   // B090 - B09F
	 3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,   // B0A0 - B0AF
	 3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,   // B0B0 - B0BF
	 3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,   // B0C0 - B0CF
	 3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,   // B0D0 - B0DF
	 3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,   // B0E0 - B0EF
	 3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,   // B0F0 - B0FF
	 3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,   // B100 - B10F
	 3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,   // B110 - B11F
	 3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,   // B120 - B12F
	 3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,   // B130 - B13F
	 3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,   // B140 - B14F
	 3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,   // B150 - B15F
	 3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,   // B160 - B16F
	 3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,   // B170 - B17F
	 3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,   // B180 - B18F
	 3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,   // B190 - B19F
	 3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,   // B1A0 - B1AF
	 3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,   // B1B0 - B1BF
	 3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,   // B1C0 - B1CF
	 3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,   // B1D0 - B1DF
	 3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,   // B1E0 - B1EF
	 3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,   // B1F0 - B1FF
	 3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,   // B200 - B20F
	 3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,   // B210 - B21F
	 3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,   // B220 - B22F
	 3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,   // B230 - B23F
	 3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,   // B240 - B24F
	 3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,   // B250 - B25F
	 3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,   // B260 - B26F
	 3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,   // B270 - B27F
	 3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,   // B280 - B28F
	 3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,   // B290 - B29F
	 3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,   // B2A0 - B2AF
	 3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,   // B2B0 - B2BF
	 3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,   // B2C0 - B2CF
	 3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,   // B2D0 - B2DF
	 3,  3,  3,  3,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,   // B2E0 - B2EF
	 5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,   // B2F0 - B2FF
	 5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,   // B300 - B30F
	 5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,   // B310 - B31F
	 5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,   // B320 - B32F
	 5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,   // B330 - B33F
	 5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,   // B340 - B34F
	 5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,   // B350 - B35F
	 5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,   // B360 - B36F
	 5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,   // B370 - B37F
	 5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,   // B380 - B38F
	 5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,   // B390 - B39F
	 5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,   // B3A0 - B3AF
	 5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,   // B3B0 - B3BF
	 5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,   // B3C0 - B3CF
	 5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,   // B3D0 - B3DF
	 5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,   // B3E0 - B3EF
	 5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,   // B3F0 - B3FF
	 5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,   // B400 - B40F
	 5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,   // B410 - B41F
	 5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,   // B420 - B42F
	 5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,   // B430 - B43F
	 5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,   // B440 - B44F
	 5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,   // B450 - B45F
	 5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,   // B460 - B46F
	 5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,   // B470 - B47F
	 5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,   // B480 - B48F
	 5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,   // B490 - B49F
	 5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,   // B4A0 - B4AF
	 5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,   // B4B0 - B4BF
	 5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,   // B4C0 - B4CF
	 5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,   // B4D0 - B4DF
	 5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,   // B4E0 - B4EF
	 5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,   // B4F0 - B4FF
	 5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,   // B500 - B50F
	 5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,   // B510 - B51F
	 5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,   // B520 - B52F
	 5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,   // B530 - B53F
	 5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,   // B540 - B54F
	 5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,   // B550 - B55F
	 5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,   // B560 - B56F
	 5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,   // B570 - B57F
	 5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,   // B580 - B58F
	 5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,   // B590 - B59F
	 5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,   // B5A0 - B5AF
	 5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,   // B5B0 - B5BF
	 5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,   // B5C0 - B5CF
	 5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,   // B5D0 - B5DF
	 5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,   // B5E0 - B5EF
	 5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,   // B5F0 - B5FF
	 5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,   // B600 - B60F
	 5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,   // B610 - B61F
	 5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,   // B620 - B62F
	 5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,   // B630 - B63F
	 5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,   // B640 - B64F
	 5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,   // B650 - B65F
	 5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,   // B660 - B66F
	 5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,   // B670 - B67F
	 5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,   // B680 - B68F
	 5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,   // B690 - B69F
	 5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,   // B6A0 - B6AF
	 5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,   // B6B0 - B6BF
	 5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,   // B6C0 - B6CF
	 5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,   // B6D0 - B6DF
	 5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,   // B6E0 - B6EF
	 5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,   // B6F0 - B6FF
	 5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,   // B700 - B70F
	 5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,   // B710 - B71F
	 5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,   // B720 - B72F
	 5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,   // B730 - B73F
	 5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,   // B740 - B74F
	 5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,   // B750 - B75F
	 5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,   // B760 - B76F
	 5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  7,  7,  7,  7,   // B770 - B77F
	 7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,   // B780 - B78F
	 7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,   // B790 - B79F
	 7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,   // B7A0 - B7AF
	 7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,   // B7B0 - B7BF
	 7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,   // B7C0 - B7CF
	 7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,   // B7D0 - B7DF
	 7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,   // B7E0 - B7EF
	 7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,   // B7F0 - B7FF
	 7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,   // B800 - B80F
	 7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,   // B810 - B81F
	 7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,   // B820 - B82F
	 7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,   // B830 - B83F
	 7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,   // B840 - B84F
	 7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,   // B850 - B85F
	 7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,   // B860 - B86F
	 7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,   // B870 - B87F
	 7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,   // B880 - B88F
	 7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,   // B890 - B89F
	 7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,   // B8A0 - B8AF
	 7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,   // B8B0 - B8BF
	 7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,   // B8C0 - B8CF
	 7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,   // B8D0 - B8DF
	 7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,   // B8E0 - B8EF
	 7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,   // B8F0 - B8FF
	 7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,   // B900 - B90F
	 7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,   // B910 - B91F
	 7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,   // B920 - B92F
	 7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,   // B930 - B93F
	 7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,   // B940 - B94F
	 7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,   // B950 - B95F
	 7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,   // B960 - B96F
	 7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,   // B970 - B97F
	 7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,   // B980 - B98F
	 7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,   // B990 - B99F
	 7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,   // B9A0 - B9AF
	 7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,   // B9B0 - B9BF
	 7,  7,  7,  7,  7,  7,  7,  7,  9,  9,  9,  9,  9,  9,  9,  9,   // B9C0 - B9CF
	 9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,   // B9D0 - B9DF
	 9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,   // B9E0 - B9EF
	 9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,   // B9F0 - B9FF
	 9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,   // BA00 - BA0F
	 9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,   // BA10 - BA1F
	 9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,   // BA20 - BA2F
	 9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,   // BA30 - BA3F
	 9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,   // BA40 - BA4F
	 9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,   // BA50 - BA5F
	 9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,   // BA60 - BA6F
	 9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,   // BA70 - BA7F
	 9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,   // BA80 - BA8F
	 9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,   // BA90 - BA9F
	 9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,   // BAA0 - BAAF
	 9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,   // BAB0 - BABF
	 9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,   // BAC0 - BACF
	 9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,   // BAD0 - BADF
	 9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,   // BAE0 - BAEF
	 9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,   // BAF0 - BAFF
	 9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,   // BB00 - BB0F
	 9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,   // BB10 - BB1F
	 9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,   // BB20 - BB2F
	 9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,   // BB30 - BB3F
	 9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,   // BB40 - BB4F
	 9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,   // BB50 - BB5F
	 9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,   // BB60 - BB6F
	 9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,   // BB70 - BB7F
	 9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,   // BB80 - BB8F
	 9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,   // BB90 - BB9F
	 9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,   // BBA0 - BBAF
	 9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,   // BBB0 - BBBF
	 9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,   // BBC0 - BBCF
	 9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,   // BBD0 - BBDF
	 9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,   // BBE0 - BBEF
	 9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,   // BBF0 - BBFF
	 9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,   // BC00 - BC0F
	 9,  9,  9,  9, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11,   // BC10 - BC1F
	11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11,   // BC20 - BC2F
	11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11,   // BC30 - BC3F
	11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11,   // BC40 - BC4F
	11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11,   // BC50 - BC5F
	11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11,   // BC60 - BC6F
	11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11,   // BC70 - BC7F
	11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11,   // BC80 - BC8F
	11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11,   // BC90 - BC9F
	11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11,   // BCA0 - BCAF
	11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11,   // BCB0 - BCBF
	11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11,   // BCC0 - BCCF
	11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11,   // BCD0 - BCDF
	11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11,   // BCE0 - BCEF
	11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11,   // BCF0 - BCFF
	11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11,   // BD00 - BD0F
	11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11,   // BD10 - BD1F
	11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11,   // BD20 - BD2F
	11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11,   // BD30 - BD3F
	11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11,   // BD40 - BD4F
	11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11,   // BD50 - BD5F
	11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11,   // BD60 - BD6F
	11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11,   // BD70 - BD7F
	11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11,   // BD80 - BD8F
	11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11,   // BD90 - BD9F
	11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11,   // BDA0 - BDAF
	11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11,   // BDB0 - BDBF
	11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11,   // BDC0 - BDCF
	11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11,   // BDD0 - BDDF
	11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11,   // BDE0 - BDEF
	11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11,   // BDF0 - BDFF
	11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11,   // BE00 - BE0F
	11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11,   // BE10 - BE1F
	11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11,   // BE20 - BE2F
	11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11,   // BE30 - BE3F
	11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11,   // BE40 - BE4F
	11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11,   // BE50 - BE5F
	11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11,   // BE60 - BE6F
	11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11,   // BE70 - BE7F
	11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11,   // BE80 - BE8F
	11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11,   // BE90 - BE9F
	11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11,   // BEA0 - BEAF
	11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11,   // BEB0 - BEBF
	11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11,   // BEC0 - BECF
	11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11,   // BED0 - BEDF
	11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11,   // BEE0 - BEEF
	11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11,   // BEF0 - BEFF
	11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11,   // BF00 - BF0F
	11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11,   // BF10 - BF1F
	11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11,   // BF20 - BF2F
	11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11,   // BF30 - BF3F
	11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11,   // BF40 - BF4F
	11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11,   // BF50 - BF5F
	11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11,   // BF60 - BF6F
	11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11,   // BF70 - BF7F
	11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11,   // BF80 - BF8F
	11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11,   // BF90 - BF9F
	11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11,   // BFA0 - BFAF
	11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11,   // BFB0 - BFBF
	11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11,   // BFC0 - BFCF
	11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11,   // BFD0 - BFDF
	11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11,   // BFE0 - BFEF
	11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11,   // BFF0 - BFFF
	11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11,   // C000 - C00F
	11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11,   // C010 - C01F
	11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11,   // C020 - C02F
	11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11,   // C030 - C03F
	11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11,   // C040 - C04F
	11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11,   // C050 - C05F
	11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11,   // C060 - C06F
	11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11,   // C070 - C07F
	11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11,   // C080 - C08F
	11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11,   // C090 - C09F
	11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 13, 13, 13, 13,   // C0A0 - C0AF
	13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13,   // C0B0 - C0BF
	13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13,   // C0C0 - C0CF
	13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13,   // C0D0 - C0DF
	13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13,   // C0E0 - C0EF
	13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13,   // C0F0 - C0FF
	13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13,   // C100 - C10F
	13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13,   // C110 - C11F
	13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13,   // C120 - C12F
	13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13,   // C130 - C13F
	13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13,   // C140 - C14F
	13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13,   // C150 - C15F
	13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13,   // C160 - C16F
	13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13,   // C170 - C17F
	13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13,   // C180 - C18F
	13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13,   // C190 - C19F
	13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13,   // C1A0 - C1AF
	13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13,   // C1B0 - C1BF
	13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13,   // C1C0 - C1CF
	13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13,   // C1D0 - C1DF
	13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13,   // C1E0 - C1EF
	13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13,   // C1F0 - C1FF
	13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13,   // C200 - C20F
	13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13,   // C210 - C21F
	13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13,   // C220 - C22F
	13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13,   // C230 - C23F
	13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13,   // C240 - C24F
	13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13,   // C250 - C25F
	13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13,   // C260 - C26F
	13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13,   // C270 - C27F
	13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13,   // C280 - C28F
	13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13,   // C290 - C29F
	13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13,   // C2A0 - C2AF
	13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13,   // C2B0 - C2BF
	13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13,   // C2C0 - C2CF
	13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13,   // C2D0 - C2DF
	13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13,   // C2E0 - C2EF
	13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13,   // C2F0 - C2FF
	13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13,   // C300 - C30F
	13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13,   // C310 - C31F
	13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13,   // C320 - C32F
	13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13,   // C330 - C33F
	13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13,   // C340 - C34F
	13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13,   // C350 - C35F
	13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13,   // C360 - C36F
	13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13,   // C370 - C37F
	13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13,   // C380 - C38F
	13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13,   // C390 - C39F
	13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13,   // C3A0 - C3AF
	13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13,   // C3B0 - C3BF
	13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13,   // C3C0 - C3CF
	13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13,   // C3D0 - C3DF
	13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13,   // C3E0 - C3EF
	13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13,   // C3F0 - C3FF
	13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13,   // C400 - C40F
	13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13,   // C410 - C41F
	13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13,   // C420 - C42F
	13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13,   // C430 - C43F
	13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13,   // C440 - C44F
	13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13,   // C450 - C45F
	13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13,   // C460 - C46F
	13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13,   // C470 - C47F
	13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13,   // C480 - C48F
	13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13,   // C490 - C49F
	13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13,   // C4A0 - C4AF
	13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13,   // C4B0 - C4BF
	13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13,   // C4C0 - C4CF
	13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13,   // C4D0 - C4DF
	13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13,   // C4E0 - C4EF
	13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13,   // C4F0 - C4FF
	13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13,   // C500 - C50F
	13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13,   // C510 - C51F
	13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13,   // C520 - C52F
	13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13,   // C530 - C53F
	13, 13, 13, 13, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15,   // C540 - C54F
	15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15,   // C550 - C55F
	15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15,   // C560 - C56F
	15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15,   // C570 - C57F
	15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15,   // C580 - C58F
	15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15,   // C590 - C59F
	15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15,   // C5A0 - C5AF
	15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15,   // C5B0 - C5BF
	15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15,   // C5C0 - C5CF
	15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15,   // C5D0 - C5DF
	15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15,   // C5E0 - C5EF
	15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15,   // C5F0 - C5FF
	15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15,   // C600 - C60F
	15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15,   // C610 - C61F
	15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15,   // C620 - C62F
	15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15,   // C630 - C63F
	15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15,   // C640 - C64F
	15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15,   // C650 - C65F
	15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15,   // C660 - C66F
	15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15,   // C670 - C67F
	15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15,   // C680 - C68F
	15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15,   // C690 - C69F
	15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15,   // C6A0 - C6AF
	15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15,   // C6B0 - C6BF
	15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15,   // C6C0 - C6CF
	15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15,   // C6D0 - C6DF
	15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15,   // C6E0 - C6EF
	15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15,   // C6F0 - C6FF
	15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15,   // C700 - C70F
	15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15,   // C710 - C71F
	15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15,   // C720 - C72F
	15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15,   // C730 - C73F
	15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15,   // C740 - C74F
	15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15,   // C750 - C75F
	15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15,   // C760 - C76F
	15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15,   // C770 - C77F
	15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15,   // C780 - C78F
	17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17,   // C790 - C79F
	17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17,   // C7A0 - C7AF
	17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17,   // C7B0 - C7BF
	17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17,   // C7C0 - C7CF
	17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17,   // C7D0 - C7DF
	17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17,   // C7E0 - C7EF
	17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17,   // C7F0 - C7FF
	17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17,   // C800 - C80F
	17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17,   // C810 - C81F
	17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17,   // C820 - C82F
	17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17,   // C830 - C83F
	17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17,   // C840 - C84F
	17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17,   // C850 - C85F
	17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17,   // C860 - C86F
	17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17,   // C870 - C87F
	17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17,   // C880 - C88F
	17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17,   // C890 - C89F
	17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17,   // C8A0 - C8AF
	17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17,   // C8B0 - C8BF
	17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17,   // C8C0 - C8CF
	17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17,   // C8D0 - C8DF
	17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17,   // C8E0 - C8EF
	17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17,   // C8F0 - C8FF
	17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17,   // C900 - C90F
	17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17,   // C910 - C91F
	17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17,   // C920 - C92F
	17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17,   // C930 - C93F
	17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17,   // C940 - C94F
	17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17,   // C950 - C95F
	17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17,   // C960 - C96F
	17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17,   // C970 - C97F
	17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17,   // C980 - C98F
	17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17,   // C990 - C99F
	17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17,   // C9A0 - C9AF
	17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17,   // C9B0 - C9BF
	17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17,   // C9C0 - C9CF
	17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17,   // C9D0 - C9DF
	17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17,   // C9E0 - C9EF
	17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17,   // C9F0 - C9FF
	17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17,   // CA00 - CA0F
	17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17,   // CA10 - CA1F
	17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17,   // CA20 - CA2F
	17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17,   // CA30 - CA3F
	17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17,   // CA40 - CA4F
	17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17,   // CA50 - CA5F
	17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17,   // CA60 - CA6F
	17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17,   // CA70 - CA7F
	17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17,   // CA80 - CA8F
	17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17,   // CA90 - CA9F
	17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17,   // CAA0 - CAAF
	17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17,   // CAB0 - CABF
	17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17,   // CAC0 - CACF
	17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17,   // CAD0 - CADF
	17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17,   // CAE0 - CAEF
	17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17,   // CAF0 - CAFF
	17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17,   // CB00 - CB0F
	17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17,   // CB10 - CB1F
	17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17,   // CB20 - CB2F
	17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17,   // CB30 - CB3F
	17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17,   // CB40 - CB4F
	17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17,   // CB50 - CB5F
	17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17,   // CB60 - CB6F
	17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17,   // CB70 - CB7F
	17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17,   // CB80 - CB8F
	17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17,   // CB90 - CB9F
	17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17,   // CBA0 - CBAF
	17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17,   // CBB0 - CBBF
	17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17,   // CBC0 - CBCF
	17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17,   // CBD0 - CBDF
	17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17,   // CBE0 - CBEF
	17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17,   // CBF0 - CBFF
	17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17,   // CC00 - CC0F
	17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17,   // CC10 - CC1F
	17, 17, 17, 17, 17, 17, 17, 17, 19, 19, 19, 19, 19, 19, 19, 19,   // CC20 - CC2F
	19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19,   // CC30 - CC3F
	19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19,   // CC40 - CC4F
	19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19,   // CC50 - CC5F
	19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19,   // CC60 - CC6F
	19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19,   // CC70 - CC7F
	19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19,   // CC80 - CC8F
	19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19,   // CC90 - CC9F
	19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19,   // CCA0 - CCAF
	19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19,   // CCB0 - CCBF
	19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19,   // CCC0 - CCCF
	19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19,   // CCD0 - CCDF
	19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19,   // CCE0 - CCEF
	19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19,   // CCF0 - CCFF
	19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19,   // CD00 - CD0F
	19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19,   // CD10 - CD1F
	19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19,   // CD20 - CD2F
	19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19,   // CD30 - CD3F
	19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19,   // CD40 - CD4F
	19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19,   // CD50 - CD5F
	19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19,   // CD60 - CD6F
	19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19,   // CD70 - CD7F
	19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19,   // CD80 - CD8F
	19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19,   // CD90 - CD9F
	19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19,   // CDA0 - CDAF
	19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19,   // CDB0 - CDBF
	19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19,   // CDC0 - CDCF
	19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19,   // CDD0 - CDDF
	19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19,   // CDE0 - CDEF
	19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19,   // CDF0 - CDFF
	19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19,   // CE00 - CE0F
	19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19,   // CE10 - CE1F
	19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19,   // CE20 - CE2F
	19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19,   // CE30 - CE3F
	19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19,   // CE40 - CE4F
	19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19,   // CE50 - CE5F
	19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19,   // CE60 - CE6F
	19, 19, 19, 19, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21,   // CE70 - CE7F
	21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21,   // CE80 - CE8F
	21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21,   // CE90 - CE9F
	21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21,   // CEA0 - CEAF
	21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21,   // CEB0 - CEBF
	21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21,   // CEC0 - CECF
	21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21,   // CED0 - CEDF
	21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21,   // CEE0 - CEEF
	21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21,   // CEF0 - CEFF
	21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21,   // CF00 - CF0F
	21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21,   // CF10 - CF1F
	21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21,   // CF20 - CF2F
	21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21,   // CF30 - CF3F
	21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21,   // CF40 - CF4F
	21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21,   // CF50 - CF5F
	21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21,   // CF60 - CF6F
	21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21,   // CF70 - CF7F
	21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21,   // CF80 - CF8F
	21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21,   // CF90 - CF9F
	21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21,   // CFA0 - CFAF
	21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21,   // CFB0 - CFBF
	21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21,   // CFC0 - CFCF
	21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21,   // CFD0 - CFDF
	21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21,   // CFE0 - CFEF
	21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21,   // CFF0 - CFFF
	21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21,   // D000 - D00F
	21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21,   // D010 - D01F
	21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21,   // D020 - D02F
	21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21,   // D030 - D03F
	21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21,   // D040 - D04F
	21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21,   // D050 - D05F
	21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21,   // D060 - D06F
	21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21,   // D070 - D07F
	21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21,   // D080 - D08F
	21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21,   // D090 - D09F
	21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21,   // D0A0 - D0AF
	21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21,   // D0B0 - D0BF
	23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23,   // D0C0 - D0CF
	23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23,   // D0D0 - D0DF
	23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23,   // D0E0 - D0EF
	23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23,   // D0F0 - D0FF
	23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23,   // D100 - D10F
	23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23,   // D110 - D11F
	23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23,   // D120 - D12F
	23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23,   // D130 - D13F
	23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23,   // D140 - D14F
	23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23,   // D150 - D15F
	23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23,   // D160 - D16F
	23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23,   // D170 - D17F
	23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23,   // D180 - D18F
	23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23,   // D190 - D19F
	23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23,   // D1A0 - D1AF
	23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23,   // D1B0 - D1BF
	23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23,   // D1C0 - D1CF
	23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23,   // D1D0 - D1DF
	23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23,   // D1E0 - D1EF
	23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23,   // D1F0 - D1FF
	23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23,   // D200 - D20F
	23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23,   // D210 - D21F
	23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23,   // D220 - D22F
	23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23,   // D230 - D23F
	23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23,   // D240 - D24F
	23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23,   // D250 - D25F
	23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23,   // D260 - D26F
	23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23,   // D270 - D27F
	23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23,   // D280 - D28F
	23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23,   // D290 - D29F
	23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23,   // D2A0 - D2AF
	23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23,   // D2B0 - D2BF
	23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23,   // D2C0 - D2CF
	23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23,   // D2D0 - D2DF
	23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23,   // D2E0 - D2EF
	23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23,   // D2F0 - D2FF
	23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 25, 25, 25, 25,   // D300 - D30F
	25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25,   // D310 - D31F
	25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25,   // D320 - D32F
	25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25,   // D330 - D33F
	25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25,   // D340 - D34F
	25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25,   // D350 - D35F
	25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25,   // D360 - D36F
	25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25,   // D370 - D37F
	25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25,   // D380 - D38F
	25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25,   // D390 - D39F
	25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25,   // D3A0 - D3AF
	25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25,   // D3B0 - D3BF
	25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25,   // D3C0 - D3CF
	25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25,   // D3D0 - D3DF
	25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25,   // D3E0 - D3EF
	25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25,   // D3F0 - D3FF
	25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25,   // D400 - D40F
	25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25,   // D410 - D41F
	25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25,   // D420 - D42F
	25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25,   // D430 - D43F
	25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25,   // D440 - D44F
	25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25,   // D450 - D45F
	25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25,   // D460 - D46F
	25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25,   // D470 - D47F
	25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25,   // D480 - D48F
	25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25,   // D490 - D49F
	25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25,   // D4A0 - D4AF
	25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25,   // D4B0 - D4BF
	25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25,   // D4C0 - D4CF
	25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25,   // D4D0 - D4DF
	25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25,   // D4E0 - D4EF
	25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25,   // D4F0 - D4FF
	25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25,   // D500 - D50F
	25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25,   // D510 - D51F
	25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25,   // D520 - D52F
	25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25,   // D530 - D53F
	25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25,   // D540 - D54F
	25, 25, 25, 25, 25, 25, 25, 25, 27, 27, 27, 27, 27, 27, 27, 27,   // D550 - D55F
	27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27,   // D560 - D56F
	27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27,   // D570 - D57F
	27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27,   // D580 - D58F
	27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27,   // D590 - D59F
	27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27,   // D5A0 - D5AF
	27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27,   // D5B0 - D5BF
	27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27,   // D5C0 - D5CF
	27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27,   // D5D0 - D5DF
	27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27,   // D5E0 - D5EF
	27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27,   // D5F0 - D5FF
	27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27,   // D600 - D60F
	27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27,   // D610 - D61F
	27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27,   // D620 - D62F
	27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27,   // D630 - D63F
	27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27,   // D640 - D64F
	27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27,   // D650 - D65F
	27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27,   // D660 - D66F
	27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27,   // D670 - D67F
	27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27,   // D680 - D68F
	27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27,   // D690 - D69F
	27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27,   // D6A0 - D6AF
	27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27,   // D6B0 - D6BF
	27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27,   // D6C0 - D6CF
	27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27,   // D6D0 - D6DF
	27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27,   // D6E0 - D6EF
	27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27,   // D6F0 - D6FF
	27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27,   // D700 - D70F
	27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27,   // D710 - D71F
	27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27,   // D720 - D72F
	27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27,   // D730 - D73F
	27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27,   // D740 - D74F
	27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27,   // D750 - D75F
	27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27,   // D760 - D76F
	27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27,   // D770 - D77F
	27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27,   // D780 - D78F
	27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27,   // D790 - D79F
	27, 27, 27, 27,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // D7A0 - D7AF
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // D7B0 - D7BF
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // D7C0 - D7CF
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // D7D0 - D7DF
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // D7E0 - D7EF
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // D7F0 - D7FF
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // F700 - F70F
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // F710 - F71F
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // F720 - F72F
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // F730 - F73F
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // F740 - F74F
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 27, 27,   // F750 - F75F
	27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27,   // F760 - F76F
	27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27,   // F770 - F77F
	27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27,   // F780 - F78F
	27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27,   // F790 - F79F
	27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27,   // F7A0 - F7AF
	27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27,  0,  0,  0,  0,  0,   // F7B0 - F7BF
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // F7C0 - F7CF
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // F7D0 - F7DF
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // F7E0 - F7EF
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // F7F0 - F7FF
	 1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  3,  3,  3,  3,  3,   // F900 - F90F
	 3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,   // F910 - F91F
	 3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,   // F920 - F92F
	 3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,   // F930 - F93F
	 3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,   // F940 - F94F
	 3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  5,  7,  7,  7,  7,  7,   // F950 - F95F
	 7,  7,  7, 11, 11, 11, 11, 11, 11, 13, 13, 13, 13, 13, 13, 13,   // F960 - F96F
	13, 13, 13, 13, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15,   // F970 - F97F
	15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15,   // F980 - F98F
	15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15,   // F990 - F99F
	15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15,   // F9A0 - F9AF
	15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15,   // F9B0 - F9BF
	15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15,   // F9C0 - F9CF
	15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15,   // F9D0 - F9DF
	15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15,   // F9E0 - F9EF
	15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 17, 17, 17, 17, 19, 19,   // F9F0 - F9FF
	19, 23, 23, 23, 23, 23, 25, 25, 27, 27, 27, 27,  0,  0,  0,  0,   // FA00 - FA0F
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // FA10 - FA1F
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // FA20 - FA2F
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // FA30 - FA3F
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // FA40 - FA4F
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // FA50 - FA5F
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // FA60 - FA6F
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // FA70 - FA7F
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // FA80 - FA8F
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // FA90 - FA9F
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // FAA0 - FAAF
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // FAB0 - FABF
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // FAC0 - FACF
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // FAD0 - FADF
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // FAE0 - FAEF
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // FAF0 - FAFF
};
