/*************************************************************************
 *
 *  OpenOffice.org - a multi-platform office productivity suite
 *
 *  $RCSfile: indexdata_zh_pinyin.h,v $
 *
 *  $Revision: 1.2 $
 *
 *  last change: $Author: rt $ $Date: 2005/09/07 17:14:42 $
 *
 *  The Contents of this file are made available subject to
 *  the terms of GNU Lesser General Public License Version 2.1.
 *
 *
 *    GNU Lesser General Public License Version 2.1
 *    =============================================
 *    Copyright 2005 by Sun Microsystems, Inc.
 *    901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *    This library is free software; you can redistribute it and/or
 *    modify it under the terms of the GNU Lesser General Public
 *    License version 2.1, as published by the Free Software Foundation.
 *
 *    This library is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *    Lesser General Public License for more details.
 *
 *    You should have received a copy of the GNU Lesser General Public
 *    License along with this library; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *    MA  02111-1307  USA
 *
 ************************************************************************/
#include <sal/types.h>

static sal_Unicode idxStr[] = {
	0x0000, // 0
	0x0041, 0x0000, // 1 (1)
	0x0042, 0x0000, // 3 (2)
	0x0043, 0x0000, // 5 (3)
	0x0044, 0x0000, // 7 (4)
	0x0045, 0x0000, // 9 (5)
	0x0046, 0x0000, // 11 (6)
	0x0047, 0x0000, // 13 (7)
	0x0048, 0x0000, // 15 (8)
	0x004A, 0x0000, // 17 (9)
	0x004B, 0x0000, // 19 (10)
	0x004C, 0x0000, // 21 (11)
	0x004D, 0x0000, // 23 (12)
	0x004E, 0x0000, // 25 (13)
	0x004F, 0x0000, // 27 (14)
	0x0050, 0x0000, // 29 (15)
	0x0051, 0x0000, // 31 (16)
	0x0052, 0x0000, // 33 (17)
	0x0053, 0x0000, // 35 (18)
	0x0054, 0x0000, // 37 (19)
	0x0057, 0x0000, // 39 (20)
	0x0058, 0x0000, // 41 (21)
	0x0059, 0x0000, // 43 (22)
	0x005A, 0x0000, // 45 (23)
};

static sal_uInt16 idx1[] = {
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 0000
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 1000
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 2000
	0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 3000
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0100, 0x0200,   // 4000
	0x0300, 0x0400, 0x0500, 0x0600, 0x0700, 0x0800, 0x0900, 0x0A00, 0x0B00, 0x0C00, 0x0D00, 0x0E00, 0x0F00, 0x1000, 0x1100, 0x1200,   // 5000
	0x1300, 0x1400, 0x1500, 0x1600, 0x1700, 0x1800, 0x1900, 0x1A00, 0x1B00, 0x1C00, 0x1D00, 0x1E00, 0x1F00, 0x2000, 0x2100, 0x2200,   // 6000
	0x2300, 0x2400, 0x2500, 0x2600, 0x2700, 0x2800, 0x2900, 0x2A00, 0x2B00, 0x2C00, 0x2D00, 0x2E00, 0x2F00, 0x3000, 0x3100, 0x3200,   // 7000
	0x3300, 0x3400, 0x3500, 0x3600, 0x3700, 0x3800, 0x3900, 0x3A00, 0x3B00, 0x3C00, 0x3D00, 0x3E00, 0x3F00, 0x4000, 0x4100, 0x4200,   // 8000
	0x4300, 0x4400, 0x4500, 0x4600, 0x4700, 0x4800, 0x4900, 0x4A00, 0x4B00, 0x4C00, 0x4D00, 0x4E00, 0x4F00, 0x5000, 0x5100, 0x5200,   // 9000
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // A000
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // B000
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // C000
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // D000
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // E000
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // F000
};
static sal_uInt16 idx2[] = {
	 0,  0,  0,  0,  0,  0,  0, 21,  0,  0,  0,  0,  0,  0,  0,  0,   // 3000 - 300F
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 3010 - 301F
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 3020 - 302F
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 3030 - 303F
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 3040 - 304F
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 3050 - 305F
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 3060 - 306F
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 3070 - 307F
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 3080 - 308F
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 3090 - 309F
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 30A0 - 30AF
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 30B0 - 30BF
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 30C0 - 30CF
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 30D0 - 30DF
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 30E0 - 30EF
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 30F0 - 30FF
	43,  7, 19, 31, 35, 41, 45, 39, 45, 35, 35, 41, 17,  3, 43, 23,   // 4E00 - 4E0F
	13,  5,  5, 45, 31, 29, 35, 35, 31,  3, 43,  5,  7, 35,  5,  7,   // 4E10 - 4E1F
	31, 21,  7, 43, 21, 43,  3, 35, 35, 17, 13, 43, 31, 45, 17, 17,   // 4E20 - 4E2F
	11, 13,  5,  5, 21, 45, 45, 45, 39,  7, 39, 45, 17, 21, 17, 29,   // 4E30 - 4E3F
	11, 43, 43, 25, 45, 17, 17, 37, 23, 43, 45, 45, 39, 45, 15, 11,   // 4E40 - 4E4F
	21, 45, 29, 29, 31, 15, 13,  5,  5, 43, 43, 45, 23, 17, 31, 43,   // 4E50 - 4E5F
	41, 41, 13,  7, 45, 45, 35, 45, 35, 17, 25, 17, 45, 35, 45, 45,   // 4E60 - 4E6F
	23, 21, 45, 33, 41, 43, 11, 35, 25, 13, 45, 45, 45, 45, 31, 45,   // 4E70 - 4E7F
	13, 13, 21, 21, 43, 17, 21, 45, 43, 45, 35, 35,  9,  5, 43, 19,   // 4E80 - 4E8F
	43, 43, 15, 31, 39, 17, 35, 35, 13, 13, 43, 41, 43, 31, 43, 17,   // 4E90 - 4E9F
	37, 39, 19, 37, 17, 15, 43,  5, 15, 23, 45, 41, 17, 37, 21, 15,   // 4EA0 - 4EAF
	17, 43, 31,  3, 43, 41,  7, 21,  7, 39, 33, 33, 17, 45, 39, 43,   // 4EB0 - 4EBF
	35, 33, 21,  7, 45, 17, 29,  5,  3, 45, 17, 17,  3, 33,  5, 11,   // 4EC0 - 4ECF
	35, 21, 45,  5, 45, 35, 37, 45, 11, 41, 41,  5, 15, 37, 33, 31,   // 4ED0 - 4EDF
	13, 13,  7,  7, 21, 43,  5,  5, 35, 35, 43, 23, 23, 33, 17,  5,   // 4EE0 - 4EEF
	43, 31, 45, 29, 39, 39, 17, 17, 43, 11,  5, 33, 39, 11,  7, 11,   // 4EF0 - 4EFF
	45, 31, 29, 43,  7,  7, 39, 43, 41, 19, 43, 17,  1, 39, 17, 11,   // 4F00 - 4F0F
	11, 41, 17,  3,  5, 11, 37, 45, 43, 15, 15, 43,  5, 43, 35, 39,   // 4F10 - 4F1F
	45,  5, 43, 41, 35,  5, 21,  5, 41, 41, 39, 45,  5, 41, 25,  3,   // 4F20 - 4F2F
	13, 25, 25, 41,  3, 41, 21, 45, 35, 31, 35,  3, 35, 17, 29, 43,   // 4F30 - 4F3F
	35,  1, 45,  7, 15, 23,  7, 45,  3, 31,  3, 35,  5, 39,  7, 45,   // 4F40 - 4F4F
	45, 43, 43, 37, 45, 15,  3, 37, 35, 43, 43, 11, 45, 13, 25, 37,   // 4F50 - 4F5F
	25, 41, 17, 43, 39, 31, 45, 19, 45, 29, 15, 15, 21, 41, 13, 43,   // 4F60 - 4F6F
	 3, 11, 23, 17, 25,  3, 17, 15, 15, 13, 31, 37, 17,  5, 43, 35,   // 4F70 - 4F7F
	41, 35, 37, 19, 45, 13, 21, 43,  5, 19, 13, 21, 43, 35, 23, 45,   // 4F80 - 4F8F
	41, 43,  1, 21, 23,  9, 21,  7,  5,  5, 41, 13, 45, 43, 33, 17,   // 4F90 - 4F9F
	41, 17, 45, 21, 45, 17, 45,  5, 31, 19,  5, 25, 25, 17, 39, 15,   // 4FA0 - 4FAF
	17,  5, 45,  5,  5, 31, 21, 17, 35, 37, 35, 37,  3, 25, 15,  3,   // 4FB0 - 4FBF
	37, 43, 41,  5,  9, 31, 41, 19, 19, 39, 17, 43, 11, 21, 45, 31,   // 4FC0 - 4FCF
	21, 43, 15, 17, 41, 35, 29, 35, 11, 41, 21, 23, 29,  3, 43, 35,   // 4FD0 - 4FDF
	41, 41, 41, 43, 37,  5,  5, 45, 43, 21, 21, 21, 35, 17, 41, 11,   // 4FE0 - 4FEF
	15, 17, 41, 29, 17,  3, 37, 11, 11, 43,  1,  3, 43, 41,  3,  5,   // 4FF0 - 4FFF
	 5, 45,  3, 45, 43,  5, 21, 39, 21,  5, 45, 13, 13,  3, 37, 35,   // 5000 - 500F
	35, 23,  7, 37, 17,  5, 41, 29, 37, 15, 43, 31, 37, 13, 17, 17,   // 5010 - 501F
	41,  5, 17, 11, 45, 19, 17, 45, 17, 31, 25, 21, 45, 39, 21, 35,   // 5020 - 502F
	21, 15,  7, 45,  3, 39, 17, 25,  5, 17, 45, 43, 45, 35, 31, 45,   // 5030 - 503F
	43,  5, 31, 43, 25, 45,  5, 17, 17, 39, 43,  3, 33, 37, 39, 29,   // 5040 - 504F
	43, 11, 37, 39,  9, 41,  5, 35, 19,  7, 45,  5, 37,  3, 43, 15,   // 5050 - 505F
	43, 45, 31, 43, 43, 17, 41, 45,  5, 11,  3, 45, 45, 23, 17, 43,   // 5060 - 506F
	41, 41, 35,  7,  5, 45, 27, 37, 37,  3, 45, 21, 17, 39, 11,  5,   // 5070 - 507F
	19, 35,  5, 35, 41, 11, 43, 33, 21, 33, 43, 13, 23,  3,  7, 37,   // 5080 - 508F
	15, 17, 41, 35, 31, 17,  5,  5, 35,  3, 41, 43, 43, 37, 35, 39,   // 5090 - 509F
	11,  3, 17,  7, 45, 37, 45,  3,  5, 25, 45, 21,  5, 43, 45, 45,   // 50A0 - 50AF
	29, 35,  1,  5, 43, 45, 45, 35, 31, 31,  5, 35, 15, 45, 31, 43,   // 50B0 - 50BF
	 7, 41, 21,  3, 29, 17, 21, 21, 23, 31, 41, 31, 43,  7, 45, 41,   // 50C0 - 50CF
	35, 31, 17, 37, 45, 29, 41, 21,  5, 13, 21, 31,  7,  5, 39, 45,   // 50D0 - 50DF
	11, 15,  5, 37,  7, 17, 17, 35, 11, 41, 17,  9, 17, 17, 37, 21,   // 50E0 - 50EF
	 3, 13, 41, 35, 41, 17, 23, 43, 17, 17, 31, 29, 11, 45,  1, 35,   // 50F0 - 50FF
	43, 17, 25, 35, 43,  7, 17, 41, 19, 17,  5,  7, 17, 35, 45, 45,   // 5100 - 510F
	 3,  1, 33, 37,  5,  5, 21, 25, 17, 31, 23, 39, 25, 31, 25,  5,   // 5110 - 511F
	21, 21, 21, 19,  3,  7,  3, 45, 45, 35, 43, 15, 31,  5, 21, 37,   // 5120 - 512F
	39, 21,  5,  5, 33, 35, 15, 21, 21, 45, 25, 37, 43, 21, 25,  9,   // 5130 - 513F
	39, 43, 45, 43, 41,  5, 45, 41, 41, 13,  7, 19,  7, 23, 37,  5,   // 5140 - 514F
	 9,  7,  9, 17, 37, 35, 43, 43, 35, 35,  7, 31,  7, 11, 23, 41,   // 5150 - 515F
	 7,  3, 17, 21, 19, 33, 39, 25, 31, 21, 43,  3, 13, 21, 41, 45,   // 5160 - 516F
	21, 13, 37, 13, 41,  3, 31, 17,  7, 45, 45, 43, 17, 35, 17, 43,   // 5170 - 517F
	17,  5, 17, 23, 33, 25, 43, 23, 13, 33,  5, 17,  5, 45, 13, 17,   // 5180 - 518F
	23, 45, 23, 13, 41, 23, 23, 33, 43, 41, 19, 17, 25, 43, 23, 35,   // 5190 - 519F
	13, 23, 45, 45, 43, 23, 19, 45, 11, 41, 23,  3,  7, 37, 13, 11,   // 51A0 - 51AF
	 3, 15,  5, 17, 15, 19, 43, 21, 29, 11, 23,  7, 41, 21, 41, 17,   // 51B0 - 51BF
	17, 35, 23, 35, 31, 13, 45, 35, 17, 21, 31,  7, 21,  7, 13, 17,   // 51C0 - 51CF
	43,  5,  1, 21,  5, 23, 45,  5, 35,  7, 17, 21, 21, 25, 41,  7,   // 51D0 - 51DF
	17, 11, 11, 11, 11, 17,  5, 45, 11, 45, 45, 11, 11, 29, 11, 19,   // 51E0 - 51EF
	15, 19, 13,  7, 29, 31, 41, 19, 37,  1,  5, 17,  7, 15, 15, 45,   // 51F0 - 51FF
	 7,  7,  7, 33, 33,  5, 11, 31, 43, 17, 19, 31,  5,  5, 39, 17,   // 5200 - 520F
	 7, 41, 15, 39, 17, 21, 43, 21, 21, 45, 13,  5, 11,  5, 31, 17,   // 5210 - 521F
	35, 23, 21, 45, 29,  3, 17, 17,  3, 21, 35,  3,  5, 17, 13, 13,   // 5220 - 522F
	 7,  5, 19, 19,  7,  9, 45, 35, 31,  5,  5, 19, 17, 13,  5, 13,   // 5230 - 523F
	19,  7, 17, 37, 17, 21, 21, 45, 43,  5, 41, 19, 21, 31,  5,  5,   // 5240 - 524F
	13, 17,  5, 21, 37, 11, 29,  5, 31,  5, 45, 13, 39,  3, 17,  7,   // 5250 - 525F
	31, 43, 45, 17, 17,  3, 43, 17, 15, 35, 17,  7,  7, 39, 13, 11,   // 5260 - 526F
	35, 17, 13, 45, 19,  5, 17,  5, 37, 21, 21, 11, 35, 29, 19, 17,   // 5270 - 527F
	13, 31, 17, 15, 45, 45, 21, 17, 29, 21, 13, 17, 13, 17, 17, 37,   // 5280 - 528F
	15, 17, 17, 43, 17, 45,  5,  5, 23, 21, 45, 21, 43, 31,  3, 13,   // 5290 - 529F
	17, 39, 23, 21, 17, 19, 41, 45,  7, 45, 25, 17, 31, 35, 43, 45,   // 52A0 - 52AF
	23, 21, 17, 21, 21, 17, 19, 43, 39, 41, 23, 19, 17, 21, 15, 35,   // 52B0 - 52BF
	19, 17, 15,  3, 23,  5, 21, 43, 43, 23, 19, 41, 17, 31, 21,  3,   // 52C0 - 52CF
	23, 21, 21, 19, 23,  7, 41, 41, 19, 39, 43, 41, 39, 35, 21, 23,   // 52D0 - 52DF
	21, 29, 35, 17, 31, 31, 17, 31, 41, 43, 31, 11, 17, 37, 17,  7,   // 52E0 - 52EF
	41, 23, 41, 41, 21, 21,  5, 33, 31,  3, 35, 43, 17,  3, 13, 39,   // 52F0 - 52FF
	43, 45, 45, 13, 13,  3,  5, 45, 41, 29, 17, 37, 13, 29,  1, 29,   // 5300 - 530F
	11, 13,  7, 17, 31,  3, 15,  3, 25,  5, 11, 17, 43, 45, 17, 19,   // 5310 - 531F
	17, 19, 15, 41, 31, 11, 13, 31,  5, 19, 11, 15, 43, 13, 19, 15,   // 5320 - 532F
	 7, 19, 21, 21, 35,  7, 17, 31, 41, 29, 31, 43,  1, 43,  3, 25,   // 5330 - 533F
	31, 35, 41, 31, 25, 35, 45, 35, 39, 15,  3, 35, 41, 39, 15, 41,   // 5340 - 534F
	39,  3, 45, 45, 41,  7, 23, 25,  7, 17,  3, 35,  3, 19,  3,  3,   // 5350 - 535F
	45, 31, 21, 43, 21, 41, 13, 39, 41, 17, 17, 39,  1, 31, 45, 23,   // 5360 - 536F
	43, 39, 35, 17, 31, 21, 35, 17, 41, 41, 17, 31, 39, 17,  9, 31,   // 5370 - 537F
	41, 45,  5, 15,  9, 37, 21, 45,  1, 21, 43, 43, 43, 35, 45, 45,   // 5380 - 538F
	29, 45, 19, 43, 45,  5, 29, 37, 21, 35, 15, 37, 45,  5, 11, 43,   // 5390 - 539F
	 5, 43, 41, 43, 21, 17, 35,  7,  5, 17, 31,  1, 13, 43, 35, 21,   // 53A0 - 53AF
	 5, 21, 21, 43, 43, 43, 35, 35, 21, 31, 31, 31, 45, 21,  7, 41,   // 53B0 - 53BF
	45, 35,  5,  5, 35,  5,  1,  7, 43,  5, 17, 43, 35, 11, 35, 13,   // 53C0 - 53CF
	 3, 11, 33, 35, 35, 45, 31, 35,  3, 41, 17, 29, 35, 17, 43, 35,   // 53D0 - 53DF
	 7, 33,  5, 19, 13, 17, 21, 13, 37, 19, 45, 17, 45,  3,  7, 19,   // 53E0 - 53EF
	37,  5, 35, 43, 31, 29, 43, 15, 35, 37,  5, 21,  7, 17, 45, 15,   // 53F0 - 53FF
	23, 41, 23,  5, 13, 41, 43, 45, 15, 17,  7,  5, 37, 23, 15, 21,   // 5400 - 540F
	37, 41, 45, 41, 43, 21,  1, 23, 27, 41, 43, 17,  5, 21, 37, 43,   // 5410 - 541F
	11,  3, 31, 31, 17, 29, 11,  3,  7, 11,  9, 15, 37, 15, 35, 31,   // 5420 - 542F
	15, 45, 43, 39, 39,  5, 25,  5, 41,  5,  7, 39, 15, 27, 39, 13,   // 5430 - 543F
	43, 17, 21,  9, 13, 23,  7, 31,  5, 39, 13, 11, 17, 15,  5, 35,   // 5440 - 544F
	25, 37, 23, 43,  7, 27, 21,  3, 43, 13, 45, 31, 39,  9, 35, 31,   // 5450 - 545F
	29, 39, 25, 23, 21, 33, 43,  7, 45, 35, 45, 45, 21, 43, 31, 29,   // 5460 - 546F
	45, 13,  5, 39, 41, 15, 25, 41, 29, 43, 41, 35, 15, 23,  7, 31,   // 5470 - 547F
	17, 13, 45, 37,  7, 29, 29,  3, 11,  3, 15, 45, 15, 15, 17, 43,   // 5480 - 548F
	11,  7, 45, 39, 19, 13, 19, 45,  3, 21,  7, 25, 45, 35, 41, 15,   // 5490 - 549F
	31,  9,  9, 13, 45, 41, 43, 21, 45, 23, 23, 45, 43, 17, 45, 13,   // 54A0 - 54AF
	35, 45, 41, 19, 15, 19, 15, 37, 41,  9, 41, 41, 13, 43, 21, 43,   // 54B0 - 54BF
	 1, 29, 35, 37, 15, 41,  7, 39, 15, 45, 43,  7, 29, 41,  1, 13,   // 54C0 - 54CF
	19, 43,  7, 41,  3, 15, 45, 15, 45, 19,  7, 45, 17, 25, 23, 43,   // 54D0 - 54DF
	15, 43, 21, 29, 23, 13,  9,  5, 35, 21, 25, 45, 15, 19, 41, 41,   // 54E0 - 54EF
	21,  3, 45, 45, 21,  3, 23, 21, 35, 11,  3, 15, 15, 13, 35, 13,   // 54F0 - 54FF
	43, 43, 13, 13,  3, 15, 35,  5, 43,  1, 17, 37, 41, 13, 21, 41,   // 5500 - 550F
	37, 45, 23,  5, 39, 45, 43,  7, 31,  7, 31, 23, 45, 13,  7, 45,   // 5510 - 551F
	21, 21, 35, 45, 15, 45, 13, 17, 45, 39, 11, 43, 15, 31, 35, 39,   // 5520 - 552F
	35,  5,  9, 21, 31,  1, 17, 43, 25, 43, 37, 21, 35, 41, 37, 15,   // 5530 - 553F
	 1, 45, 25, 19, 45, 45, 35,  7, 15, 21,  1, 41, 41, 37, 39, 39,   // 5540 - 554F
	 5, 17, 15, 31, 31, 37,  7,  7, 39, 45,  3,  5,  5, 15, 43, 31,   // 5550 - 555F
	45, 11, 21, 41, 29, 35, 21, 45, 31, 13, 29, 45, 35, 45, 25, 13,   // 5560 - 556F
	21, 43,  7, 31, 37,  3,  7, 21, 41, 45, 37,  5, 37,  1, 17,  7,   // 5570 - 557F
	19, 43, 39, 25, 35, 43, 45, 21, 17, 15, 15,  7, 45,  5, 19, 33,   // 5580 - 558F
	43, 43, 45, 43, 39, 23, 15, 43,  5, 15, 15, 15, 41, 15, 17, 19,   // 5590 - 559F
	45, 39, 35, 41, 15,  7, 25, 41, 21, 43, 35,  5, 31, 43,  7, 29,   // 55A0 - 55AF
	35, 21, 43, 45, 39, 23, 43, 29, 45, 19, 41, 43, 17, 21, 19,  5,   // 55B0 - 55BF
	15, 37, 43, 15,  1, 41, 31, 35, 43, 35, 15, 41,  1, 35, 23,  5,   // 55C0 - 55CF
	15, 19,  7, 35,  5, 33, 35, 13, 17, 29, 39, 31, 35, 13, 45, 17,   // 55D0 - 55DF
	21, 39, 39, 35,  5, 15, 35, 17, 15, 35, 31, 25, 15, 45, 35, 25,   // 55E0 - 55EF
	13, 25,  7,  1, 45, 37,  3,  1,  1, 21,  5, 45, 23, 35, 35, 37,   // 55F0 - 55FF
	 7, 31, 17,  5, 17, 19, 37, 35,  5, 17, 45, 41, 29, 21, 13, 13,   // 5600 - 560F
	41, 15, 15, 13, 27, 41, 45,  5, 41, 29,  7, 23, 23, 15, 21,  7,   // 5610 - 561F
	13, 37, 43,  3, 43, 45, 17, 23, 41, 15, 23, 33, 45, 29, 21, 41,   // 5620 - 562F
	17, 45,  5, 19, 45, 41, 35, 15, 11, 21, 31, 41, 41,  5,  7, 15,   // 5630 - 563F
	41, 39, 45, 29,  5, 19,  5, 45,  5,  7, 43, 37,  5, 17, 43, 41,   // 5640 - 564F
	31, 15, 21, 41,  7, 15, 43, 29, 17, 31, 41, 25, 21, 35, 43, 43,   // 5650 - 565F
	 7, 45, 27, 45, 17, 25, 15, 15, 31,  9, 45, 43, 35, 17, 43,  1,   // 5660 - 566F
	43, 41, 19, 43, 29,  7, 13, 41,  7,  7, 45, 35, 29, 29, 43, 45,   // 5670 - 567F
	25,  7, 15, 37, 15, 33, 15, 41, 43,  7, 29,  5, 17, 17, 15, 37,   // 5680 - 568F
	 5, 45, 45,  5, 37, 21, 15,  3, 43, 25, 43, 15, 23, 15, 45, 21,   // 5690 - 569F
	21, 45, 25, 41, 23, 43, 21, 21, 21, 23,  7,  5, 29, 29, 41, 15,   // 56A0 - 56AF
	23, 41,  7, 19, 43,  5, 43, 33,  7, 21, 37, 41, 17,  5, 15, 15,   // 56B0 - 56BF
	45, 25, 41,  5, 21,  5,  5, 21, 43, 21, 25, 45, 35, 41, 45, 17,   // 56C0 - 56CF
	45, 45, 21, 25, 25, 45, 45, 39, 15, 43, 31, 35, 25, 17, 15, 41,   // 56D0 - 56DF
	43, 25, 37, 37,  7, 19, 43, 17, 29, 43,  5, 15, 15, 43,  9, 13,   // 56E0 - 56EF
	19,  5, 39, 37, 39, 21, 13, 17, 33, 21, 13, 13, 37, 13, 37, 43,   // 56F0 - 56FF
	13, 43, 15, 29, 43, 15, 43, 21, 31, 43, 31, 13,  5, 39, 43, 31,   // 5700 - 570F
	19, 29, 43, 43,  9, 37, 37, 37, 37, 21, 15, 43, 43, 21, 21, 37,   // 5710 - 571F
	43, 37, 37, 35, 43, 21, 45, 43, 45, 39, 13, 43, 39, 13, 29, 43,   // 5720 - 572F
	 7, 31, 31, 45, 45,  7, 31, 45, 45, 19,  5, 31, 25, 23, 17, 17,   // 5730 - 573F
	45, 45,  3, 41, 37, 31, 11, 17, 19,  7, 11, 11,  3, 37, 19, 15,   // 5740 - 574F
	45, 19,  3, 41,  7, 17, 17, 19,  7, 17, 17, 37, 21,  3, 39, 11,   // 5750 - 575F
	45, 29, 29, 37, 19, 31, 37, 45, 37, 13, 29,  7, 39, 25, 37, 29,   // 5760 - 576F
	17, 43, 11,  1, 21, 31, 23, 19, 13, 41,  3,  5,  5, 21, 45, 11,   // 5770 - 577F
	15, 45,  5, 21, 21, 21, 21,  1, 45, 29, 45, 41, 37, 17, 19, 21,   // 5780 - 578F
	 5,  5, 21, 13, 43, 15,  7, 45, 11, 13, 43,  7,  7, 13,  5, 43,   // 5790 - 579F
	43, 11, 13, 43,  7, 41, 19, 35, 35,  9, 45,  7, 15, 43, 19,  7,   // 57A0 - 57AF
	45,  7, 19, 45, 25,  1, 41, 41, 15,  3, 29,  3, 43, 43, 15, 41,   // 57B0 - 57BF
	 5,  5, 13,  1, 29, 11, 31, 43, 17, 17,  7, 23, 21, 41,  5, 35,   // 57C0 - 57CF
	17, 45, 21, 21,  3,  5, 45,  3, 35, 41, 13, 17, 43, 25,  7, 43,   // 57D0 - 57DF
	 3, 39, 17, 35, 29,  5, 39, 17, 21, 45, 19, 45,  7,  7, 37,  1,   // 57E0 - 57EF
	 5, 35,  3, 19, 45,  7, 43, 45, 43, 29, 17, 45, 31, 35, 17, 25,   // 57F0 - 57FF
	19, 19, 37, 19, 25, 17,  7, 17, 13, 43,  9, 29, 13, 37, 21, 45,   // 5800 - 580F
	43, 31, 45,  1,  5,  7, 25, 37,  5, 43, 15,  3, 21, 13,  7, 45,   // 5810 - 581F
	15,  3,  3, 43,  7, 23, 17, 33,  9, 13, 19, 45, 43, 15,  9, 43,   // 5820 - 582F
	43,  3, 17, 23,  5,  7, 37,  1, 11, 45, 17, 45, 15, 13,  5, 17,   // 5830 - 583F
	45, 21, 13, 15, 21,  7, 39, 41, 17, 17, 19, 43, 37,  5, 43, 19,   // 5840 - 584F
	35, 35, 35, 23, 37, 39,  5, 37, 37, 31, 45, 21, 29,  3, 35, 45,   // 5850 - 585F
	 7, 37, 39,  5, 41, 13, 45,  1, 13, 43, 19, 37, 43, 39, 41, 21,   // 5860 - 586F
	45, 21,  5, 29,  3,  5, 21, 21, 27, 31, 23, 23, 45, 35, 35, 21,   // 5870 - 587F
	 5, 23,  3, 17,  5, 35,  7, 45, 19, 43,  7,  5, 45, 17, 13, 31,   // 5880 - 588F
	17,  7, 35, 23,  5, 43, 37, 45, 31, 31, 21, 45, 45, 31, 45, 41,   // 5890 - 589F
	35, 35,  3, 29, 19,  7, 11, 31, 23,  7,  7, 45, 45, 35,  7,  7,   // 58A0 - 58AF
	37,  7, 23, 11, 15, 37,  7, 43,  5, 45,  1, 31, 17, 31, 19, 43,   // 58B0 - 58BF
	29,  3,  7, 17, 43, 43, 41, 37, 21, 17, 15,  7, 33, 31, 41, 21,   // 58C0 - 58CF
	23, 15, 19, 43,  7, 15, 33, 45, 21, 19, 21, 43, 37, 39, 15, 21,   // 58D0 - 58DF
	21, 33, 21, 21, 33,  5, 41, 43, 21,  3, 45, 35, 33, 45, 45, 45,   // 58E0 - 58EF
	35, 43, 23, 19, 45, 45, 15, 15, 19, 43, 15, 41, 19, 35, 23, 45,   // 58F0 - 58FF
	35, 43, 45, 13,  5, 41, 11,  3, 45,  3, 35, 31, 21, 11, 45, 41,   // 5900 - 590F
	41, 45, 25, 41, 19, 41, 39, 43, 23, 35,  7,  7, 43, 31, 45, 13,   // 5910 - 591F
	13, 31, 23, 23, 43, 15,  5,  7, 45, 37, 37, 11, 13, 43, 43, 15,   // 5920 - 592F
	13, 35, 37, 37, 37, 43,  3, 43, 19, 17,  7, 45, 19, 43, 17,  3,   // 5930 - 593F
	 9, 21, 15,  7, 43, 29, 17, 31, 25, 11, 41, 11,  7, 45, 19, 45,   // 5940 - 594F
	15, 31, 19, 35,  3, 43, 17, 37, 45,  3, 41, 15, 11,  7, 35,  3,   // 5950 - 595F
	 7,  1, 35, 39, 29,  1, 39,  1, 17, 21,  7, 43, 17, 35, 11, 15,   // 5960 - 596F
	 3, 21,  5, 25, 25,  7, 25, 31, 17, 37, 17, 25,  5, 15, 41, 11,   // 5970 - 597F
	17, 35, 33, 11, 39, 15, 45, 11, 23,  7, 33, 11, 17, 43, 41, 39,   // 5980 - 598F
	45, 29,  7, 17, 19, 45, 43, 17, 43, 23, 29,  5, 43, 45, 25, 43,   // 5990 - 599F
	25, 41, 11,  3, 43, 37, 11, 43, 11, 39, 43, 13,  7,  3, 25, 45,   // 59A0 - 59AF
	45, 45,  7, 25, 43, 37, 41, 45,  9, 23, 23, 31,  3, 35, 31,  9,   // 59B0 - 59BF
	15, 41, 11, 45, 25,  3, 23, 11, 21, 45, 45, 35, 33, 35, 43, 31,   // 59C0 - 59CF
	17, 13, 35, 41, 39, 45, 17, 35, 29, 33, 43, 37, 17, 35, 17, 13,   // 59D0 - 59DF
	35, 19, 17, 17, 13, 21, 17, 17, 43, 25, 45, 17, 17, 41, 15, 13,   // 59E0 - 59EF
	17, 19, 43, 23, 21, 29, 43, 43, 43,  5, 41, 43,  5, 13, 31, 45,   // 59F0 - 59FF
	35, 39, 15, 39, 21, 43, 33, 17, 21, 29, 41, 35, 21,  5, 41, 23,   // 5A00 - 5A0F
	45, 35, 23, 39, 19, 21,  5,  7, 25, 19, 25, 43, 25, 29, 35, 17,   // 5A10 - 5A1F
	35, 45, 15,  7, 45,  9, 29, 37, 41, 23, 39, 43, 39, 41, 43, 43,   // 5A20 - 5A2F
	35, 43, 39, 21, 41, 17, 31,  5, 31, 41, 45,  7,  5, 21,  1,  9,   // 5A30 - 5A3F
	 9, 21, 23,  5, 29, 17, 29,  5, 21, 39,  3, 41, 35, 31, 15, 11,   // 5A40 - 5A4F
	39, 33, 37, 11, 45, 17, 37, 25, 31, 17, 15, 17, 31,  7, 41, 15,   // 5A50 - 5A5F
	39, 21,  3, 43,  5,  5, 11, 17, 21, 43, 21, 19, 43, 43, 45, 21,   // 5A60 - 5A6F
	 7, 41, 45, 15, 43,  5, 35, 37, 43, 43, 39, 25,  5, 17, 37, 41,   // 5A70 - 5A7F
	43, 39, 37, 33, 23,  7, 33, 31, 45, 39, 31,  5, 23, 11, 17,  7,   // 5A80 - 5A8F
	41, 45, 23, 15, 23,  1, 43, 41, 45, 39, 23, 43, 45, 31, 37, 41,   // 5A90 - 5A9F
	37, 21, 23, 33, 35, 29, 39, 39, 17, 15,  1, 45,  3, 41, 37, 13,   // 5AA0 - 5AAF
	45, 43, 29, 41, 43, 43, 33, 33,  5, 21, 23, 29,  1, 23, 13, 19,   // 5AB0 - 5ABF
	31, 17, 35, 45, 43,  5, 43, 23, 43, 17, 35, 25, 41, 37, 29, 21,   // 5AC0 - 5ACF
	25,  3,  1, 29, 29, 43, 29, 43, 21, 41, 23, 43, 45, 19, 43, 25,   // 5AD0 - 5ADF
	21,  7, 13, 43, 17, 45,  5,  5, 15, 25, 21, 23, 45, 15, 15,  1,   // 5AE0 - 5AEF
	25, 31, 45,  3, 13, 39, 31, 37, 45, 23, 41, 41, 23, 21, 21, 15,   // 5AF0 - 5AFF
	13,  7, 45, 41, 45, 15, 41, 15, 33, 41, 43,  5, 17, 23, 11, 11,   // 5B00 - 5B0F
	41, 43, 39,  5, 11, 35,  3, 35, 35, 31, 21, 15, 45, 25,  7, 43,   // 5B10 - 5B1F
	 5,  1, 25, 25, 23, 37,  5, 17,  5, 43, 29, 45, 41, 25, 43, 37,   // 5B20 - 5B2F
	43,  5, 25, 45, 43, 23, 45, 23, 35, 41, 25,  7, 21, 43, 21, 43,   // 5B30 - 5B3F
	35, 21, 17, 25, 21, 41, 43, 35, 35, 31, 23, 21, 21, 43, 45, 21,   // 5B40 - 5B4F
	45, 17, 17, 17, 19, 43, 45, 45,  5, 35, 11,  3, 45, 41, 41, 23,   // 5B50 - 5B5F
	35, 37,  3, 17, 13, 25, 41, 45,  5, 15, 21, 35, 25, 23,  5, 17,   // 5B60 - 5B6F
	35,  5, 43, 45, 25, 11, 45, 21, 41,  3, 33, 25, 25, 25, 43, 21,   // 5B70 - 5B7F
	23, 25, 33, 37, 13, 45, 31, 43, 35,  1, 37, 35, 39, 33, 43, 15,   // 5B80 - 5B8F
	43, 17, 45, 23, 13,  7, 15, 45, 13, 45,  7, 39, 43,  3, 35, 35,   // 5B90 - 5B9F
	 5, 35, 19, 41, 35, 43, 15, 43, 37, 35, 41, 13,  5, 31, 13, 41,   // 5BA0 - 5BAF
	45, 45,  3, 15, 43, 41, 17, 35,  5, 33, 15, 23, 19, 19,  3, 35,   // 5BB0 - 5BBF
	 5, 45, 17, 43, 17, 43, 23, 19, 31, 15, 45, 17, 11, 25,  3, 15,   // 5BC0 - 5BCF
	23, 31, 15, 43, 35, 25, 17, 25, 45, 43,  3, 19, 25, 31, 23,  5,   // 5BD0 - 5BDF
	17, 13, 31, 15, 39, 21, 35, 25, 45, 35, 39, 41, 19, 15, 21, 17,   // 5BE0 - 5BEF
	15, 43, 43,  3, 31,  5,  3, 11,  5,  7, 35, 41,  7, 21,  7, 35,   // 5BF0 - 5BFF
	29, 11, 45, 11, 35, 19, 17, 17, 45, 39, 45, 41, 35,  7,  7, 41,   // 5C00 - 5C0F
	17, 35,  9,  9,  9, 13, 17, 35,  5, 35, 35, 43, 13,  5, 21, 41,   // 5C10 - 5C1F
	41, 45, 39, 39, 43, 21, 21, 43, 23, 39, 39, 39, 13, 43,  7, 19,   // 5C20 - 5C2F
	45, 17, 13, 13, 13, 13, 13, 13, 35, 43,  5, 19, 25, 17, 39, 25,   // 5C30 - 5C3F
	17, 29,  5, 41,  3, 17, 17, 37, 31, 37, 17, 39,  7, 35, 35, 29,   // 5C40 - 5C4F
	17, 41,  5, 41, 25, 45, 41, 45, 23,  9, 21, 29, 37, 11, 35, 41,   // 5C50 - 5C5F
	37, 21, 21, 41,  5, 21, 17, 41, 17, 17, 21, 17, 35, 41,  5, 37,   // 5C60 - 5C6F
	25, 35, 39, 41, 21,  9, 45, 45, 21, 43, 31, 33, 39, 15, 35, 43,   // 5C70 - 5C7F
	 5, 35, 31, 45, 43,  3, 43,  1, 43, 39, 17,  9, 17, 31, 11, 39,   // 5C80 - 5C8F
	31,  5, 31, 31,  5, 17, 31, 13, 41,  1, 21,  7,  3, 45, 45, 43,   // 5C90 - 5C9F
	17, 13, 19, 13, 41,  3, 21, 37, 31, 43, 11, 41, 17, 21, 37, 29,   // 5CA0 - 5CAF
	43,  7, 19, 43, 31, 15, 29, 23,  1, 37, 21,  5, 45,  7, 45, 19,   // 5CB0 - 5CBF
	41, 23, 37, 41, 43, 45, 15, 19, 21,  9, 11, 41,  7, 21, 21,  9,   // 5CC0 - 5CCF
	13, 31, 37, 43, 23, 35,  1, 39, 15, 45, 23, 21, 17, 37, 19, 43,   // 5CD0 - 5CDF
	45, 41, 21, 43, 17, 45, 21, 17,  9,  9, 43, 43,  3, 31, 31, 11,   // 5CE0 - 5CEF
	11, 25, 21, 43, 41, 15,  7, 35,  5, 37, 13, 17, 15, 41, 43, 39,   // 5CF0 - 5CFF
	21, 19, 21, 21, 41, 31, 19,  5,  5, 37, 45, 15, 17, 21, 31, 23,   // 5D00 - 5D0F
	19, 19, 45, 13,  5, 43, 43, 13, 21, 21, 21, 17,  7,  5, 13, 43,   // 5D10 - 5D1F
	 7, 15, 45, 39, 43, 29, 43, 35, 17,  3, 45, 17,  7, 45, 13, 43,   // 5D20 - 5D2F
	45, 45, 15, 43, 39, 43, 11, 31,  7, 37, 43, 45, 35, 45, 43,  9,   // 5D30 - 5D3F
	45, 19, 21, 43, 23, 13, 17, 17, 15, 37, 35, 23, 31, 39, 43, 45,   // 5D40 - 5D4F
	21, 17, 43, 43, 39, 45,  5, 35, 33, 19, 31, 43, 31, 21, 37,  7,   // 5D50 - 5D5F
	41, 39,  5,  7, 33, 17,  1, 21, 39, 35, 31, 45, 39,  3,  7,  5,   // 5D60 - 5D6F
	31, 43, 25,  5, 17, 45, 45, 35, 45, 17, 21, 45,  5,  7,  5,  7,   // 5D70 - 5D7F
	37, 21, 45, 45, 45,  1,  5, 31, 31, 45, 45,  7,  7, 41, 43,  3,   // 5D80 - 5D8F
	21, 41,  5,  3, 31, 17, 43, 21, 45, 21, 21, 21, 17,  7,  7, 45,   // 5D90 - 5D9F
	17, 13, 43, 31, 43, 17, 45, 43, 41, 25, 43, 43, 43,  9, 41, 17,   // 5DA0 - 5DAF
	41, 19, 35,  7,  1, 45, 45, 43, 33,  7, 21, 45, 43, 43, 43, 45,   // 5DB0 - 5DBF
	17, 21, 35, 21, 21,  7, 43, 41, 17,  5, 43, 19, 43, 39, 25, 31,   // 5DC0 - 5DCF
	 5,  5, 21,  7,  7, 25, 43, 43, 43, 25, 43,  5, 13,  5, 45, 15,   // 5DD0 - 5DDF
	17, 41,  5,  5, 21, 13, 45, 31, 17, 13, 45, 39, 45, 45,  5, 31,   // 5DE0 - 5DEF
	31, 17, 43, 35,  3, 45, 45, 41, 43, 17, 41, 17, 45, 41, 17, 11,   // 5DF0 - 5DFF
	45,  3, 35,  3,  7, 35, 11, 25, 35, 11, 29, 45, 41, 15,  7, 39,   // 5E00 - 5E0F
	45, 37,  7, 23, 29, 29, 37, 11, 21, 45, 45,  3, 45,  7, 23, 43,   // 5E10 - 5E1F
	43, 29, 31, 17, 33, 35,  7, 45, 35, 31, 45, 35, 31, 41,  3,  7,   // 5E20 - 5E2F
	13,  5, 29, 45, 35, 39,  7, 39,  5, 35, 31, 45, 13, 23,  7, 15,   // 5E30 - 5E3F
	45, 41, 23, 39, 39, 11, 43,  3, 29, 45, 13, 29, 15,  7, 23, 17,   // 5E40 - 5E4F
	37, 15, 45, 35, 23, 23,  3, 13, 45, 23,  3, 45, 17,  5, 11, 45,   // 5E50 - 5E5F
	15, 11,  5,  3,  3, 45, 23, 31,  7, 11, 23,  3,  5, 23,  5, 17,   // 5E60 - 5E6F
	41, 21, 13, 29, 25, 17,  3,  3, 41, 13, 43, 15, 43, 43, 17, 13,   // 5E70 - 5E7F
	29, 37, 45, 13, 45, 23, 31,  3, 31,  7,  5, 13, 43,  3, 17, 41,   // 5E80 - 5E8F
	21, 39, 45, 19, 43,  7, 29,  7, 43, 23, 13,  5, 11, 37, 29, 11,   // 5E90 - 5E9F
	41, 43, 45, 37, 45, 41,  7, 45, 41, 37, 13, 19, 29, 37, 43,  3,   // 5EA0 - 5EAF
	 3,  5, 21,  3, 17,  1, 35, 19, 43, 37, 35, 35, 31, 43, 43, 23,   // 5EB0 - 5EBF
	35,  5, 41, 11, 17, 15, 15, 21, 35, 21, 21, 35, 17, 29, 31, 17,   // 5EC0 - 5ECF
	17, 31,  1, 19, 21, 43, 21,  7, 21, 43,  5,  5, 37, 35, 41, 23,   // 5ED0 - 5EDF
	 5, 39, 11, 13, 45, 13,  3, 31, 41, 21, 21, 21, 21, 45, 43, 41,   // 5EE0 - 5EEF
	37, 43, 21, 37, 43, 41, 43, 37,  7, 29, 17, 15, 25, 15, 13, 25,   // 5EF0 - 5EFF
	19,  3, 43, 31, 25, 11, 17, 43, 43, 45,  3, 43, 43,  9, 35, 35,   // 5F00 - 5F0F
	 9, 35, 35, 13,  7, 43, 15, 11, 15, 39, 37,  5, 31,  3, 35,  7,   // 5F10 - 5F1F
	45, 17, 37, 11,  7, 23, 41, 15,  5, 25, 17, 45, 43, 23, 31, 39,   // 5F20 - 5F2F
	35, 33, 41, 17,  7, 45, 17, 31,  3,  7, 31,  3,  3, 35,  7, 17,   // 5F30 - 5F3F
	13, 45, 11,  3, 19, 45,  3, 41,  7, 19, 31, 15, 23, 19, 39, 17,   // 5F40 - 5F4F
	17, 17, 13,  7, 21, 21, 37, 15, 45, 15, 15, 43, 43, 43, 43, 15,   // 5F50 - 5F5F
	15, 35, 41, 45, 37, 43, 43, 43,  5,  5,  3,  7,  3, 29, 43, 29,   // 5F60 - 5F6F
	45, 43,  5,  5, 45, 37, 17, 29, 45, 43, 39,  5,  3,  7, 21, 11,   // 5F70 - 5F7F
	39, 45,  5, 39, 17,  7, 41, 41, 15, 43, 15, 21, 15, 39,  5, 45,   // 5F80 - 5F8F
	41, 17, 37,  5, 45, 21,  5,  7, 29, 41, 45, 31,  5, 45,  5, 45,   // 5F90 - 5F9F
	21, 43, 41, 17, 17,  5, 17,  3, 15, 11, 41, 39, 29, 43, 39, 41,   // 5FA0 - 5FAF
	45, 29,  5,  7, 45, 45,  3,  7,  5,  5, 17, 39, 17, 15, 23, 21,   // 5FB0 - 5FBF
	41,  3, 31, 41, 41,  3, 43, 21, 33,  7,  7, 13, 17, 33, 33,  5,   // 5FC0 - 5FCF
	37, 37, 37, 13, 31,  7,  5, 45, 39, 23, 41, 11, 43, 37, 23, 23,   // 5FD0 - 5FDF
	45,  5, 39, 17, 39, 41, 43, 43, 39, 45, 45, 19, 43,  3, 45,  5,   // 5FE0 - 5FEF
	 5,  5, 37, 37, 31, 25, 15, 41, 25, 39, 41, 41, 19, 15, 19, 11,   // 5FF0 - 5FFF
	15, 37, 35, 39, 27,  5,  5, 17, 43,  3,  5, 23, 29, 45, 45, 43,   // 6000 - 600F
	19,  3, 25, 25, 45, 29,  3, 37, 15, 15, 17,  7, 21, 35, 45,  7,   // 6010 - 601F
	 7, 43, 37, 43, 11, 17, 29, 41, 43, 25, 13, 11, 41,  3, 43, 31,   // 6020 - 602F
	41, 45,  3, 15, 41,  5, 29, 41, 41, 37, 45, 45,  7, 45, 45, 43,   // 6030 - 603F
	 5, 25, 41, 35, 41, 21, 15, 19, 23, 45, 41, 21, 37, 15,  7, 15,   // 6040 - 604F
	19, 13, 15, 41, 41, 35, 35, 15, 31, 43, 15, 15,  5, 17, 43, 41,   // 6050 - 605F
	13, 21, 15, 45, 41,  5, 41, 25, 15,  9, 19,  7, 37, 13, 31, 41,   // 6060 - 606F
	31, 43, 29, 19,  7, 15,  9, 45, 37, 43, 19,  5, 25, 43, 23, 43,   // 6070 - 607F
	43, 17, 23, 19, 31, 43, 43, 43, 17, 41, 45, 21, 37, 15, 15, 31,   // 6080 - 608F
	37,  3, 43, 31, 15, 41,  3, 23, 43, 15, 35, 31,  5, 19, 39, 39,   // 6090 - 609F
	43, 21, 21, 15,  5, 43, 43, 21, 25, 25,  9, 31, 41, 31, 39, 23,   // 60A0 - 60AF
	 5, 11,  3,  7,  5,  5, 23, 21, 17, 13, 13, 41,  7, 31, 19, 37,   // 60B0 - 60BF
	21, 41, 19, 19, 25, 31,  5,  7, 13,  5, 17, 39, 43, 17, 17, 21,   // 60C0 - 60CF
	43, 15, 15, 31, 43, 37, 37, 25, 39,  5, 15, 15, 41,  5, 41, 39,   // 60D0 - 60DF
	15,  9, 33, 45, 17, 43,  7, 17,  5,  5,  7,  3, 31,  5,  7, 13,   // 60E0 - 60EF
	 7, 25, 43, 41, 45,  7, 15,  5, 31, 33, 41,  5,  3, 15, 45, 37,   // 60F0 - 60FF
	31,  5,  3, 41, 39, 13, 31, 39, 43, 43,  3, 41, 15, 23,  3, 43,   // 6100 - 610F
	23, 43, 19,  7, 43,  9,  5, 23, 31, 19, 43,  1, 31, 43, 25, 13,   // 6110 - 611F
	43, 45, 35, 21, 11, 45, 19, 19, 31, 13, 43, 35, 35, 31, 43, 35,   // 6120 - 612F
	15, 45, 13, 17,  5, 37, 41, 19, 45, 43,  5, 35, 35,  3, 19, 43,   // 6130 - 613F
	41, 15, 43, 43, 21, 35, 37, 43,  5, 41, 31, 37, 15, 43, 35, 23,   // 6140 - 614F
	45, 35,  5, 29, 23, 23, 13,  5,  5,  5,  5,  5, 23, 25, 45, 37,   // 6150 - 615F
	 1, 35, 23, 13, 31, 45, 17, 15, 19, 21, 27, 35, 17, 43, 21, 35,   // 6160 - 616F
	39, 37, 23, 31, 45, 43, 31, 19,  7, 45, 21, 17, 31, 31, 43, 29,   // 6170 - 617F
	21, 45, 43,  5, 45, 37,  5, 31, 31, 29,  3,  3,  5, 17, 45,  5,   // 6180 - 618F
	21, 29, 19, 15, 31,  5, 43, 43, 41, 41,  7, 37,  7,  7,  7, 35,   // 6190 - 619F
	17,  5, 41, 11, 11, 21, 21,  5, 15, 31, 41, 23, 17, 21, 39,  5,   // 61A0 - 61AF
	17,  5, 41, 37, 35, 29, 43,  5, 41, 25,  7, 37, 17, 35, 15, 17,   // 61B0 - 61BF
	39, 15,  7, 31, 31, 31,  5, 19, 41, 43,  1, 23, 43, 21, 35, 17,   // 61C0 - 61CF
	15, 23, 21,  1, 21, 43, 13, 41,  5, 43, 43,  7, 23,  1, 23,  7,   // 61D0 - 61DF
	31, 23, 21, 23,  5, 45, 25, 25, 43, 43,  3, 45, 41, 19, 43, 11,   // 61E0 - 61EF
	21, 23,  5, 45,  5, 23, 21, 15, 41, 33,  5, 17, 17, 15, 35, 43,   // 61F0 - 61FF
	21, 25, 23, 37, 17, 13, 13, 45, 13, 43, 39, 17, 41, 35, 33, 41,   // 6200 - 620F
	 5, 39, 17, 13, 17, 31, 15, 31, 45,  7, 31, 17,  7,  5, 17, 17,   // 6210 - 621F
	35, 19, 17, 19, 13,  7, 45,  5, 13, 17, 17, 43, 17, 43, 21, 41,   // 6220 - 622F
	45, 41, 41,  5,  7, 31, 15, 15, 15,  9, 35, 21, 23, 15, 21, 11,   // 6230 - 623F
	35,  3,  7, 17, 35, 43, 43, 35, 15, 11, 43, 35, 35,  5, 45, 31,   // 6240 - 624F
	21, 29,  3,  7, 33, 11, 45, 45, 37, 45,  7, 19, 43, 19, 15, 35,   // 6250 - 625F
	 5,  5, 13, 19, 39, 37, 31, 45,  5, 19, 23, 35, 43, 25,  3,  5,   // 6260 - 626F
	33, 41, 31,  3, 17, 43, 11,  1, 41, 29, 45, 45,  9,  7, 45,  5,   // 6270 - 627F
	17, 43, 19,  3,  5, 17, 39, 15, 43, 17,  3, 31, 45, 45, 43, 39,   // 6280 - 628F
	25, 43, 35, 45, 29, 37,  7, 19, 45, 29, 11, 29,  3,  1, 45, 37,   // 6290 - 629F
	19, 21, 31, 45, 15,  3,  3, 45, 29, 37, 29, 29, 37, 43, 45, 45,   // 62A0 - 62AF
	43,  3, 15, 25, 43,  7,  5, 29, 45, 23, 23,  5, 43,  5, 31, 23,   // 62B0 - 62BF
	 5, 17, 11, 45, 45,  7,  5, 23, 25, 21, 11, 29,  3, 29, 21, 25,   // 62C0 - 62CF
	13, 31, 17, 37,  3, 37, 37,  1, 17, 45, 29, 45,  3,  3,  7, 25,   // 62D0 - 62DF
	17, 19, 21, 17, 31, 43, 21, 25,  3, 45, 31, 15, 19, 35, 17, 45,   // 62E0 - 62EF
	25, 13, 13, 31, 35, 37, 45, 19,  5, 41,  5, 15, 29, 45, 35, 25,   // 62F0 - 62FF
	 3,  5, 13, 45, 19,  7,  7, 45, 31,  1, 25, 45, 13, 17, 19,  7,   // 6300 - 630F
	33, 37, 21, 45, 21,  7, 39, 17, 45, 17, 45, 21, 43, 45, 37, 41,   // 6310 - 631F
	25,  7, 17, 45, 17, 15, 41, 45,  1, 37, 25,  5,  3, 13, 37, 45,   // 6320 - 632F
	 5, 35, 35, 19, 23, 21, 17, 29, 17, 43, 37, 35, 25, 39, 41,  5,   // 6330 - 633F
	11, 17, 39, 17, 17, 37, 19, 15, 37, 45, 29, 21,  3, 15, 35, 25,   // 6340 - 634F
	17, 35, 35, 43, 17,  3, 15,  3, 17, 43, 45, 21, 35, 37, 21, 35,   // 6350 - 635F
	 3, 17, 15,  7, 45, 39, 31, 29, 35, 21, 23, 23, 11,  3, 17,  7,   // 6360 - 636F
	39,  1, 17, 43, 45,  5,  5, 17, 37,  3, 25, 25, 25, 45, 39, 41,   // 6370 - 637F
	41,  5,  7, 35, 21, 31, 13,  7, 35,  7, 29,  7, 45, 13, 17, 37,   // 6380 - 638F
	31, 31, 29, 35, 31, 21, 43, 43, 17, 45, 21, 13, 43, 15, 35,  7,   // 6390 - 639F
	21,  5, 37,  5,  3, 17, 37, 19, 37, 43,  5, 45, 17, 37, 31, 19,   // 63A0 - 63AF
	 3, 35, 17, 21, 13, 45, 45, 45,  7, 45,  5, 35, 13, 29, 43, 25,   // 63B0 - 63BF
	17, 45, 17, 17, 43, 43, 19, 25, 15, 33, 29, 39, 35, 45, 41, 23,   // 63C0 - 63CF
	37, 25,  5, 35, 45, 45, 43, 35, 15,  3, 43, 15, 43, 45,  1, 41,   // 63D0 - 63DF
	43, 39, 19,  5, 17, 37, 21, 21,  5, 19, 17, 17, 37, 17, 15, 13,   // 63E0 - 63EF
	 5, 35, 35, 41, 43, 31, 43,  5, 45,  3, 43, 45, 45, 21, 39, 31,   // 63F0 - 63FF
	 5, 13, 21, 45, 13, 17, 13, 31, 43, 31,  5,  5, 45, 35, 35,  3,   // 6400 - 640F
	 5, 33,  3,  5, 35, 19, 43,  7, 45, 25, 41, 17, 35, 31, 13, 41,   // 6410 - 641F
	35, 35, 17, 23,  9,  5, 25, 35, 37, 17, 37, 29,  3,  7, 21, 37,   // 6420 - 642F
	15, 45, 39, 41, 31, 39, 31,  5, 45,  9, 41, 25, 31,  5, 45, 13,   // 6430 - 643F
	39,  9, 35, 13, 35, 35,  3, 43,  3, 35, 37, 35,  5, 35, 21,  5,   // 6440 - 644F
	 5, 13,  3, 11, 35,  7, 31, 45, 45, 21,  5,  5, 13, 21, 21, 21,   // 6450 - 645F
	45, 13, 15, 45,  5, 37, 15,  5, 25, 23, 17, 13, 43, 45,  1, 45,   // 6460 - 646F
	 5, 23, 35, 19, 35, 35, 37, 45, 23, 23, 45,  5, 19,  3, 17, 43,   // 6470 - 647F
	13, 31, 21, 17, 43, 17, 29, 29, 21,  7, 41, 33, 19, 45, 43, 41,   // 6480 - 648F
	 5,  5, 35, 25, 15, 35, 15, 15,  7, 45, 25, 21, 45, 15, 45, 17,   // 6490 - 649F
	17,  5,  7,  7,  5,  3,  5, 17, 41, 21,  3, 11, 31,  3,  5, 45,   // 64A0 - 64AF
	45, 37, 29, 31,  7, 25, 45, 41, 21, 17,  5, 37, 15, 31, 45, 17,   // 64B0 - 64BF
	13, 43, 21, 19, 21, 35, 45, 45, 29,  5, 17,  7, 35,  5, 31, 17,   // 64C0 - 64CF
	15, 17, 31, 19,  7, 41, 13, 29,  3,  1, 17, 43, 45, 45, 35, 23,   // 64D0 - 64DF
	17, 37, 45,  7, 41, 21,  5, 17, 43, 33, 43, 43, 25, 15, 17,  3,   // 64E0 - 64EF
	25, 13, 45, 17, 19, 23, 17, 41, 21, 37,  3, 35, 21, 21, 33, 45,   // 64F0 - 64FF
	29, 43, 21, 35, 35, 45, 25, 41, 17, 15, 21, 21, 15, 43, 21, 21,   // 6500 - 650F
	31, 31, 45, 31, 21, 35, 43, 23, 33,  5, 45,  5, 41, 35, 21, 17,   // 6510 - 651F
	23, 21, 45, 21, 37, 45, 21,  7, 39,  7, 17, 17, 21, 21, 25, 45,   // 6520 - 652F
	13, 13, 31, 41, 29, 29, 35, 19, 43, 13, 13, 13, 13,  3, 11, 45,   // 6530 - 653F
	 3,  7, 19, 23, 39, 13, 13,  5, 41, 23,  5, 13,  7, 41, 17, 23,   // 6540 - 654F
	 5, 17, 35,  7, 43,  5,  1,  3, 41, 17,  7, 21, 25,  3,  5,  7,   // 6550 - 655F
	 7, 43, 13, 35, 19, 43,  7, 31,  7, 41,  7, 17, 17, 43, 41, 15,   // 6560 - 656F
	35,  1, 31,  1, 45,  7, 45, 11, 35, 21, 31, 41, 41, 17, 45, 31,   // 6570 - 657F
	45, 43, 21,  3, 21, 41, 41, 39, 41, 31, 31, 45,  3, 17, 45, 21,   // 6580 - 658F
	11,  3,  3, 21, 43, 21, 39,  7, 35, 21, 17, 15, 41, 17, 43, 45,   // 6590 - 659F
	17, 39, 37,  7, 17,  5, 43, 11, 31, 45, 31, 45, 45,  7, 45, 35,   // 65A0 - 65AF
	41, 45, 45, 31, 21, 45,  5,  7, 45, 11, 41, 15, 39, 35, 29, 43,   // 65B0 - 65BF
	45, 29, 31, 45, 23, 21, 29, 29, 21, 11, 11, 41, 17, 17, 25, 45,   // 65C0 - 65CF
	45, 43, 21, 35, 17, 45, 43, 31, 45, 11, 29, 11, 45, 13, 35, 43,   // 65D0 - 65DF
	39, 17, 17, 17, 15, 33,  7, 17, 45, 45, 41, 37, 41, 41, 13, 21,   // 65E0 - 65EF
	13, 15, 37,  7, 41,  5, 35, 19, 43, 35, 39, 23, 23, 37,  5, 39,   // 65F0 - 65FF
	43,  3,  1, 45,  3, 17, 19, 35, 15, 11, 15, 13,  5, 41, 23, 15,   // 6600 - 660F
	11, 31, 15, 43, 41, 41, 43, 45, 11, 37, 35, 17, 43, 45,  3, 41,   // 6610 - 661F
	43, 41, 29, 45, 21,  5, 15, 23, 45, 23,  3, 41, 15, 45, 45, 35,   // 6620 - 662F
	35, 43, 11,  7, 23, 25,  5, 39,  7,  1,  3,  1, 45, 21, 41, 19,   // 6630 - 663F
	37,  5, 35, 15, 15, 41, 19, 41, 17, 17, 45, 17, 35, 37, 15, 43,   // 6640 - 664F
	13, 41, 35, 41, 43, 43, 15, 15, 15, 17, 39, 41, 19, 45, 41, 35,   // 6650 - 665F
	35,  3, 45, 45, 39, 15, 15, 15,  5, 39, 37, 45, 45, 45, 29, 17,   // 6660 - 666F
	41, 35, 43, 41, 31, 31, 17, 13, 45, 43, 45,  1, 39, 21, 21,  5,   // 6670 - 667F
	39, 41, 45, 45, 41, 13, 43, 41, 43, 15, 11, 23, 19, 15, 43,  7,   // 6680 - 668F
	39, 35, 31, 23, 25, 17, 25,  1, 43,  5, 43, 35, 29, 23, 17, 19,   // 6690 - 669F
	13, 39,  5, 31, 15, 43, 21,  1, 17, 13, 23, 45, 41, 15, 23, 23,   // 66A0 - 66AF
	 5, 25, 45, 15,  3, 15, 41,  5, 21, 41,  7, 17, 29, 21, 37, 41,   // 66B0 - 66BF
	43, 17, 19,  7, 43, 43, 21, 37, 37, 41, 11, 31, 45, 15, 43, 41,   // 66C0 - 66CF
	41, 35, 17,  3, 17, 45,  1, 43, 33, 35, 23, 41, 43, 29, 21,  5,   // 66D0 - 66DF
	19,  7, 45, 43, 15, 21, 41, 33, 21, 25, 21, 21, 35, 37, 43,  5,   // 66E0 - 66EF
	43, 43, 31, 43, 13, 45, 15, 15, 35,  5,  5, 35, 23,  5,  5, 37,   // 66F0 - 66FF
	45,  5, 41, 15, 43, 31, 11, 29, 43, 43, 33, 29,  3, 11, 21, 11,   // 6700 - 670F
	31, 45, 25, 37, 35, 45, 21, 21, 17, 23, 15, 39, 37, 45, 17, 31,   // 6710 - 671F
	43, 45, 39, 37, 21, 45, 23, 21, 23,  7, 39, 23,  3, 45, 45, 45,   // 6720 - 672F
	45, 45, 33,  3, 29,  7,  7,  7, 21, 31, 17, 17,  3, 41, 37,  5,   // 6730 - 673F
	35, 45, 45, 31, 31, 43, 13, 39,  5, 35, 41, 11, 39, 45, 21, 41,   // 6740 - 674F
	 5,  5, 33, 35, 45,  7, 45, 23,  5, 43, 13, 13,  7, 43, 31, 35,   // 6750 - 675F
	13, 37, 45, 45, 45, 21, 35, 23, 43, 23, 23, 35, 43, 15, 11,  3,   // 6760 - 676F
	17,  7, 13, 43, 41,  5,  5, 29, 35, 15, 41,  5, 45,  5, 35,  3,   // 6770 - 677F
	35, 17, 43, 43, 13, 17, 23, 29,  3, 39,  1, 11, 11, 43, 11, 25,   // 6780 - 678F
	41, 15, 43,  7, 41, 45, 43, 21, 33,  9, 23, 45, 13, 45, 45, 43,   // 6790 - 679F
	45,  7, 35, 45, 45, 21, 21, 17,  5, 35, 31, 11, 25, 41, 41, 19,   // 67A0 - 67AF
	29, 37, 41, 45, 13, 41, 17, 17, 13,  3, 23, 43, 43, 35, 35, 25,   // 67B0 - 67BF
	 3, 37, 43, 21,  3, 25, 21, 15,  3, 11, 45,  7,  5, 43, 11,  3,   // 67C0 - 67CF
	23, 13, 31, 33, 33, 23, 45, 35, 45, 41, 43, 35, 17, 37, 45, 25,   // 67D0 - 67DF
	25, 43,  7, 45, 45,  5,  7, 13, 45, 17,  1, 11, 17,  3,  7, 19,   // 67E0 - 67EF
	25, 45,  3, 21,  5, 45, 35, 45, 29, 35, 13,  5, 43,  5, 17, 35,   // 67F0 - 67FF
	45, 21, 23, 45, 33, 45, 45,  3, 45, 45, 21,  7, 21, 45, 21, 21,   // 6800 - 680F
	43, 35, 41, 35, 31, 45, 31, 21,  5, 41, 45, 21, 35, 13, 19,  3,   // 6810 - 681F
	33, 41,  3, 33,  3, 45,  5, 43,  5, 41, 45, 17, 45,  9,  9, 43,   // 6820 - 682F
	11, 13, 19, 21, 45, 21, 45, 43, 15, 13, 45,  5, 13, 45, 21, 11,   // 6830 - 683F
	17, 15, 13, 37, 13, 39, 19, 33,  1,  1, 17, 43, 45, 19, 45, 31,   // 6840 - 684F
	37, 35, 35, 15, 17, 17, 41,  7, 45, 43, 45, 45, 43, 45, 45, 45,   // 6850 - 685F
	43, 33, 45,  7, 31, 31, 15, 13, 17, 45, 41, 35, 35, 45,  3, 37,   // 6860 - 686F
	19, 17,  3,  3, 11, 33, 37, 17, 41, 21, 21, 11, 31, 39, 17, 13,   // 6870 - 687F
	 5, 21, 31, 37, 43, 23,  3, 21, 29, 45,  7, 41, 37, 45,  1, 13,   // 6880 - 688F
	 3,  7, 15, 45, 45, 33,  3, 13, 17, 15, 39, 25, 17, 37, 17, 41,   // 6890 - 689F
	21, 19, 35,  5, 11, 35, 23, 39, 21, 21,  7,  5, 43, 35, 17, 37,   // 68A0 - 68AF
	41, 19, 45, 35,  5, 11, 39, 17, 21,  3, 45, 45, 37, 45, 21, 21,   // 68B0 - 68BF
	17, 45, 21, 21, 31,  3, 21,  5, 31, 23, 31, 31,  5, 13,  5,  7,   // 68C0 - 68CF
	11, 29,  3, 29, 15, 45,  5, 45, 17, 21, 29, 43, 43, 13, 15,  7,   // 68D0 - 68DF
	37, 13, 39,  7, 41, 11,  5, 45, 31, 43, 43, 43, 31, 43, 35, 33,   // 68E0 - 68EF
	 5, 21, 31, 45, 11, 19, 21, 45, 45, 45, 13, 11, 11,  5, 31, 25,   // 68F0 - 68FF
	39, 13, 21, 15, 17, 43,  5, 17, 17,  5, 45, 21, 31, 45, 45, 43,   // 6900 - 690F
	17,  3, 17, 45, 45,  3, 29,  7,  5, 35, 45, 45, 17, 13, 41,  7,   // 6910 - 691F
	31, 45, 19, 45, 21, 45, 45, 45, 45, 45, 29, 35, 45, 37, 35,  7,   // 6920 - 692F
	43, 11, 39, 39,  7, 17, 45, 17, 43, 35, 41, 43, 43,  5, 45,  5,   // 6930 - 693F
	43, 15, 45, 39,  3,  3, 43, 15, 41, 33, 43, 21, 43,  3, 15, 19,   // 6940 - 694F
	17, 19, 35, 11, 41, 37, 17, 17, 23, 23,  5, 15, 15, 21, 21, 37,   // 6950 - 695F
	25, 43, 43, 23, 35, 41, 41, 43, 45, 29,  7, 17, 17, 43,  5, 35,   // 6960 - 696F
	43,  5, 39, 23,  7, 17, 17, 19, 31, 43, 33, 15, 21, 21, 45, 13,   // 6970 - 697F
	29, 45, 13, 37, 21, 43, 43,  5, 21, 17, 45, 45, 45, 41, 17, 43,   // 6980 - 698F
	45, 11, 25, 23, 21, 33, 13, 17, 17, 37, 43, 45,  3, 35, 43, 45,   // 6990 - 699F
	23, 35, 17, 43, 17, 15, 13, 11, 45, 31, 23, 35, 43, 41, 33, 35,   // 69A0 - 69AF
	45,  5, 43, 37, 21, 33, 37, 31, 45, 35, 35, 37, 19, 41, 13, 31,   // 69B0 - 69BF
	19, 13, 35, 29, 37, 13, 41,  7, 25, 17, 35, 13,  5, 31,  5, 31,   // 69C0 - 69CF
	15, 23, 41, 13, 13, 45, 37, 31, 43,  7, 17, 17, 45, 45, 21,  3,   // 69D0 - 69DF
	45, 45, 41, 31, 21, 15, 43, 31, 13, 13, 13, 37, 15, 31, 35,  5,   // 69E0 - 69EF
	 3, 43, 15, 17, 15, 15, 19, 43, 43, 13, 19, 13, 13,  5, 23, 17,   // 69F0 - 69FF
	 7, 45, 21, 21,  5,  5, 21, 41, 31, 35, 11, 37, 13, 17, 35, 21,   // 6A00 - 6A0F
	21, 21, 23, 21,  5, 35, 19,  5, 37,  3, 21, 17, 35, 45, 35, 45,   // 6A10 - 6A1F
	23, 23, 25, 43, 37, 29, 45, 35, 41, 31, 15, 17,  5, 45, 45, 31,   // 6A20 - 6A2F
	45, 43,  9, 41, 45, 31, 45,  5, 29, 35, 15, 19, 45, 45, 43, 45,   // 6A30 - 6A3F
	41, 41,  7, 11, 13, 23, 39, 31, 33, 21, 21, 31, 41, 33, 11, 45,   // 6A40 - 6A4F
	37, 21, 43, 35, 37,  5, 37, 23, 17,  5, 35, 17, 17, 37, 15, 17,   // 6A50 - 6A5F
	25, 41, 37, 25, 33, 45, 37, 45, 11, 31, 33, 15,  5, 13, 21, 21,   // 6A60 - 6A6F
	13,  5, 45, 45, 45, 45, 17,  7, 45, 21, 45, 45, 43, 37, 35, 17,   // 6A70 - 6A7F
	37, 21, 25, 43, 41, 35, 35, 45, 41,  5, 13, 17, 45, 43, 31, 29,   // 6A80 - 6A8F
	43, 21, 11, 15,  7, 17, 35,  3,  3,  7,  5, 45, 13, 17, 17, 17,   // 6A90 - 6A9F
	31, 45, 17, 31,  7, 43,  3, 35, 35, 21, 21,  5, 23, 43, 37, 37,   // 6AA0 - 6AAF
	23, 31, 45,  3, 15, 17, 31, 23, 25, 43, 13, 17, 43,  9, 31, 43,   // 6AB0 - 6ABF
	31, 23, 45, 13,  5, 17, 19, 29,  7,  5, 45, 23, 43, 45, 13, 31,   // 6AC0 - 6ACF
	21, 21, 35, 21, 45,  5, 21, 23, 15, 27, 21, 45, 13,  7, 43, 21,   // 6AD0 - 6ADF
	11, 45, 35, 21, 45,  5, 45, 45, 21, 43, 21, 45,  5, 17,  9, 35,   // 6AE0 - 6AEF
	15, 25, 43, 21, 21, 45, 41, 45, 17, 41, 21, 43, 17, 43, 43, 43,   // 6AF0 - 6AFF
	41, 25,  3,  5, 21, 17, 35, 35, 39,  5, 31, 31, 45, 45, 43, 21,   // 6B00 - 6B0F
	21, 45, 21,  7, 17, 45, 21, 21, 45, 21, 21,  3, 25, 43, 21, 45,   // 6B10 - 6B1F
	31,  5, 15, 41, 43, 43, 31, 27, 41,  5,  5, 31, 19, 43, 17, 41,   // 6B20 - 6B2F
	41, 41, 43, 19, 21, 19, 35, 41,  9, 43, 31, 15,  5, 31, 19, 19,   // 6B30 - 6B3F
	19, 19,  5, 35, 45, 43, 41, 41, 43, 31, 41, 43, 13, 39, 37, 17,   // 6B40 - 6B4F
	27, 15, 37, 15, 41, 29, 41, 41, 15, 35, 45, 21,  5, 43, 19, 43,   // 6B50 - 6B5F
	 5, 15, 45, 45,  5,  3, 39, 31,  3,  3, 39, 17, 31,  5, 35,  5,   // 6B60 - 6B6F
	35, 45, 35, 35, 21,  5, 43, 21, 13,  7,  7, 35, 17, 45, 23, 23,   // 6B70 - 6B7F
	43, 23,  5, 43, 37, 35,  7, 35, 41, 41, 35,  5, 17, 29, 31, 31,   // 6B80 - 6B8F
	35, 31, 43, 21, 43, 11, 45, 43,  5, 15,  7, 17, 43, 45, 43, 39,   // 6B90 - 6B9F
	 5,  3, 37, 17, 35, 43,  7,  5, 15,  5, 43,  7,  7, 17, 21,  3,   // 6BA0 - 6BAF
	 7, 17, 17, 35, 27,  7, 45, 43, 31, 43, 35, 19, 19, 43, 41,  7,   // 6BB0 - 6BBF
	15, 15, 13, 31, 17, 43, 27, 15,  7, 43, 41, 39, 13, 23, 23, 23,   // 6BC0 - 6BCF
	 1, 45,  7, 43,  3,  3,  3, 29, 29,  3,  5, 23, 45, 45, 29, 45,   // 6BD0 - 6BDF
	17, 45, 35, 23, 37, 41,  9, 33, 41, 17, 23, 15, 31,  7, 45, 37,   // 6BE0 - 6BEF
	29, 17,  7,  5,  3, 35, 45, 23, 35, 35, 43, 37, 15, 17, 37, 35,   // 6BF0 - 6BFF
	21, 23, 21, 37, 33,  5, 29, 21, 45, 35, 45, 23, 21, 31,  7, 35,   // 6C00 - 6C0F
	 7, 23, 17, 23, 31, 29, 25, 31,  7, 41,  5, 11, 33, 25, 45, 11,   // 6C10 - 6C1F
	35,  7, 31, 31, 43, 41, 15, 43,  1, 43, 19, 31, 43,  7,  7, 21,   // 6C20 - 6C2F
	31, 43, 43, 43, 35, 35, 45,  3, 43,  7, 35, 21, 25, 37, 11, 13,   // 6C30 - 6C3F
	37, 45, 31,  3, 45, 23,  5, 15,  7, 15,  5, 45,  5, 39, 11,  7,   // 6C40 - 6C4F
	41, 37, 23, 31, 31, 35, 29, 15, 31, 39, 39, 41, 35, 33, 13, 17,   // 6C50 - 6C5F
	 5, 39, 45, 45, 37, 45,  5, 31, 23, 13, 39, 31, 17, 33, 17, 15,   // 6C60 - 6C6F
	37, 31, 17,  3,  3, 13, 39, 45, 11, 41, 17, 15, 45, 31, 11, 41,   // 6C70 - 6C7F
	41, 31, 43, 39, 43, 43, 15, 43, 35,  5,  7, 43,  7, 15, 15, 31,   // 6C80 - 6C8F
	23, 33, 23, 37, 23, 39,  5, 37,  3, 35, 45, 29, 29, 45, 45, 13,   // 6C90 - 6C9F
	21, 23, 45, 11, 27, 21, 21,  5, 11, 39, 15, 23, 23, 35, 17, 45,   // 6CA0 - 6CAF
	37, 37,  7, 15, 21, 23, 43, 11, 11, 43, 37, 45, 45, 13, 45, 43,   // 6CB0 - 6CBF
	35, 19, 17, 17, 41, 31, 43, 17, 45, 31,  3, 15, 23,  3, 45,  5,   // 6CC0 - 6CCF
	21, 43, 13, 15, 13, 11, 23, 35, 15, 29,  5, 11, 45, 35, 25,  5,   // 6CD0 - 6CDF
	21, 29,  3, 31, 35, 25, 17, 43, 45, 35, 21, 41, 41, 11, 29, 23,   // 6CE0 - 6CEF
	37, 43, 17, 43, 13,  3, 41, 21, 21,  7, 21, 41, 29, 45, 17, 43,   // 6CF0 - 6CFF
	45, 17, 43, 15, 15, 45,  5, 43, 39, 15, 17, 43, 21, 35, 17,  9,   // 6D00 - 6D0F
	41, 11, 35, 45, 45, 43, 39, 41, 19, 45, 17, 21, 45,  1,  7, 43,   // 6D10 - 6D1F
	23, 21, 43, 23, 31, 17, 29, 39, 41, 41, 15, 41, 35, 19, 37, 31,   // 6D20 - 6D2F
	17,  9, 45, 33, 29, 41, 41, 45, 13, 15, 23, 15, 39, 31, 29, 39,   // 6D30 - 6D3F
	31, 21, 43, 17, 17, 31, 17, 17, 45, 35, 45,  5, 45, 15, 17, 21,   // 6D40 - 6D4F
	 5, 15, 15, 25, 41, 17, 21, 31, 39, 45, 17, 15,  3, 23, 45, 43,   // 6D50 - 6D5F
	41,  3,  7, 15, 15, 43, 29, 43, 21, 15, 21, 15, 21, 13, 11, 39,   // 6D60 - 6D6F
	21,  5, 11, 43, 43, 37, 21, 15, 17, 17,  5, 39, 23, 35,  5, 29,   // 6D70 - 6D7F
	41, 35, 37, 19, 29, 25, 15, 17, 41, 35, 25, 37, 43, 41, 41, 37,   // 6D80 - 6D8F
	 9, 35, 37, 17,  5, 37, 21, 35, 35, 21, 35, 37,  7, 21, 21, 21,   // 6D90 - 6D9F
	39, 39, 43, 15,  7, 45, 33, 17, 45, 35, 11, 13, 41, 35, 35, 43,   // 6DA0 - 6DAF
	 5, 45, 43, 19, 39, 15, 37,  7, 15, 39, 17, 13, 21, 15, 37, 45,   // 6DB0 - 6DBF
	 7, 31,  7, 17, 45, 41, 41, 31, 13, 13, 15, 21, 37, 45, 29, 15,   // 6DC0 - 6DCF
	 5, 35, 31, 11,  5, 21, 25, 17, 37,  5, 21, 45, 29, 11, 35, 37,   // 6DD0 - 6DDF
	29,  7, 43, 25, 43, 21, 13, 23, 17, 21, 21, 43,  5, 31, 15, 43,   // 6DE0 - 6DEF
	25, 35, 29,  5, 15, 43, 21, 15, 31, 43, 31, 37, 23, 45, 43, 23,   // 6DF0 - 6DFF
	 3, 43, 39, 33, 11, 31, 43, 19, 17, 35, 43, 35, 21, 45,  7, 45,   // 6E00 - 6E0F
	17, 23, 29, 41, 43, 43, 35, 35, 33, 15, 45, 17, 25, 43, 31, 37,   // 6E10 - 6E1F
	31,  7, 11, 45,  3, 39, 39,  7, 39, 39, 33, 41,  5, 39, 13, 13,   // 6E20 - 6E2F
	43, 15, 41, 23, 19, 23, 43, 43, 43, 15, 23, 41, 23, 45, 15, 25,   // 6E30 - 6E3F
	19, 35,  9, 29, 23, 21, 31, 31, 23, 37,  5, 39,  5, 37, 23, 41,   // 6E40 - 6E4F
	23, 41, 17, 29, 17, 17, 15, 11, 41, 43, 43, 45, 35, 17, 45, 15,   // 6E50 - 6E5F
	37, 43,  3, 23, 35, 37, 35, 43, 17, 45, 45, 31, 17, 45, 43, 37,   // 6E60 - 6E6F
	21, 15, 43, 25,  3, 43, 31,  5, 21,  5, 43,  5, 25, 45, 39, 35,   // 6E70 - 6E7F
	23, 43, 21, 19, 45, 17, 41, 21, 13, 13, 45, 45, 29, 17, 13, 37,   // 6E80 - 6E8F
	43, 35, 43, 21, 43, 23, 45, 35, 19, 37, 37, 39, 21, 13, 35, 23,   // 6E90 - 6E9F
	45, 35, 43, 21, 23, 29, 39, 21,  5, 39, 41, 39, 31,  5, 35, 35,   // 6EA0 - 6EAF
	43, 45, 35, 43, 41, 43, 33, 15, 35, 35, 25, 37, 35, 33, 39, 29,   // 6EB0 - 6EBF
	 5,  5, 29, 39,  5, 23, 15,  7, 15, 15, 41, 45,  7, 45, 43, 11,   // 6EC0 - 6ECF
	17, 15, 13, 45, 37, 37, 35,  3, 17, 15, 13, 43, 13, 21, 45, 43,   // 6ED0 - 6EDF
	35, 23, 43,  5, 21, 21, 21, 41,  3, 37, 43, 41, 15,  3,  3, 45,   // 6EE0 - 6EEF
	17, 19, 35, 35,  7, 23,  1, 21, 15, 15, 43,  5, 11, 43, 13, 23,   // 6EF0 - 6EFF
	31, 43, 29, 17, 43, 17, 31, 41, 17, 21, 21, 21, 17, 13,  5, 21,   // 6F00 - 6F0F
	45, 13, 31, 21, 43,  5, 17,  5,  5, 37, 27, 37, 43, 41, 23, 37,   // 6F10 - 6F1F
	23, 35, 15, 21, 21, 39, 21, 31, 11, 41, 43, 23, 45, 23, 19, 21,   // 6F20 - 6F2F
	29, 35, 45, 45,  5, 41, 15, 19, 17, 43,  5, 21,  5, 37, 43, 17,   // 6F30 - 6F3F
	 5, 43, 15, 41, 35, 13, 43, 41, 45, 45, 41, 21, 45, 39, 29, 43,   // 6F40 - 6F4F
	17, 29, 41, 15, 17, 39, 29, 17, 29, 39, 41, 31, 31, 41, 21, 41,   // 6F50 - 6F5F
	35,  7, 15, 23, 33, 35, 21, 45, 45, 43,  7, 39,  7, 37,  5, 41,   // 6F60 - 6F6F
	19, 45, 35, 37, 45, 35, 15,  3, 35,  5,  5, 35, 37, 29, 21, 39,   // 6F70 - 6F7F
	35, 35,  5, 17,  5, 15, 17, 21,  5, 13,  5, 15, 35, 35, 29, 15,   // 6F80 - 6F8F
	43, 21, 15, 11, 15, 15, 41, 17, 35, 41,  1, 21, 21, 45, 43, 21,   // 6F90 - 6F9F
	23, 45,  7, 15, 45, 41, 43, 21, 35, 41, 21, 23, 45, 43, 19,  5,   // 6FA0 - 6FAF
	21,  7, 43,  1, 15, 21,  5, 23,  7,  7, 43, 35, 29, 17, 37, 31,   // 6FB0 - 6FBF
	17, 45, 21, 25, 13, 17, 11, 35, 17, 35, 15,  5, 37, 35,  7, 35,   // 6FC0 - 6FCF
	45, 21,  3, 21, 23, 35, 35, 23, 25, 43, 43, 23, 17, 31,  3, 17,   // 6FD0 - 6FDF
	15, 33, 45, 39, 37, 43, 43,  7,  5, 15, 17, 21, 17,  1, 29, 45,   // 6FE0 - 6FEF
	39,  3, 13, 31, 41,  3, 19, 11, 45,  3, 17,  7, 21, 21, 21, 21,   // 6FF0 - 6FFF
	43, 43, 21, 35, 17, 43,  7, 39, 15, 41, 29, 35,  3,  5, 23, 21,   // 7000 - 700F
	17, 29, 35,  5, 13,  3, 15, 41, 21, 31, 15, 43, 33, 21, 17, 41,   // 7010 - 701F
	43, 35, 39, 41, 15, 15, 45, 21, 21,  7, 11, 15, 21, 45, 45, 43,   // 7020 - 702F
	23, 17, 21, 17, 43, 11, 21, 43, 17, 43,  5,  7, 33, 17, 21, 11,   // 7030 - 703F
	35, 43, 45, 11, 35, 21, 21,  5, 31, 43, 31, 11, 13, 31, 43, 15,   // 7040 - 704F
	45, 35, 45, 21, 43, 21, 23,  7, 37,  7, 17,  5, 45, 15,  3, 45,   // 7050 - 705F
	21, 21, 25, 39, 21, 31, 41, 43, 13, 43, 43, 15,  3, 23, 13,  7,   // 7060 - 706F
	15, 41, 41, 45, 15, 21, 45, 45, 17, 45, 41,  5, 45, 45, 45,  5,   // 7070 - 707F
	43, 31, 45, 11, 25, 13, 39, 29, 43, 21,  5, 29, 19, 29, 43, 19,   // 7080 - 708F
	29, 23,  5, 21, 13, 19,  7, 13, 41, 45, 13, 41, 39, 31,  3,  7,   // 7090 - 709F
	41, 45, 45, 19, 45, 11,  3,  7,  7, 21, 45, 41, 17, 37, 29, 17,   // 70A0 - 70AF
	29, 37, 37,  3, 43, 37, 15, 45, 45,  7, 39, 35, 21,  5, 29, 45,   // 70B0 - 70BF
	15, 35, 21, 37, 17, 41, 41, 31, 21, 15, 43, 41, 41, 41, 43, 39,   // 70C0 - 70CF
	45, 43, 35, 39, 37, 37, 45, 19, 15, 21, 41, 45, 41, 45, 29, 43,   // 70D0 - 70DF
	15, 13, 45, 15, 19, 45, 11, 35, 43, 15, 45, 37, 17, 33, 45, 41,   // 70E0 - 70EF
	11, 17,  5, 29, 17, 45, 37, 39, 15, 29, 21, 35, 15, 11,  5, 33,   // 70F0 - 70FF
	15, 45, 35, 21, 41, 41, 17, 41, 41, 43, 15, 45, 31,  7, 41, 31,   // 7100 - 710F
	39, 45, 45, 15, 43, 15, 23, 17,  7,  3, 11, 21, 19, 15,  5, 41,   // 7110 - 711F
	 5, 39, 15, 17, 11, 43, 17,  5, 11, 29, 31,  5, 41, 31, 41, 45,   // 7120 - 712F
	43, 43, 43, 17, 43, 13, 33, 29, 43, 45, 35,  5, 35, 45, 45, 45,   // 7130 - 713F
	45,  5, 15, 19, 45,  7, 43, 15, 11, 21, 41, 41, 15, 17, 17,  3,   // 7140 - 714F
	43, 45, 39, 37, 37, 41, 25, 25,  5, 43, 17, 17, 43, 23, 35, 39,   // 7150 - 715F
	43, 41, 31, 33, 23, 15, 41, 45, 39, 11, 31, 35, 43, 21, 45, 45,   // 7160 - 716F
	13, 13,  3, 15, 43, 41, 45, 45,  3, 39, 37, 37,  5, 35, 43,  3,   // 7170 - 717F
	15, 41, 41, 39, 41, 43, 15, 15, 41, 43, 41, 25, 19, 45, 43, 41,   // 7180 - 718F
	23, 21, 43, 39, 33, 45, 45, 31, 21, 41,  3,  3,  5, 21, 17, 35,   // 7190 - 719F
	43, 21, 11, 35, 43, 37, 17, 45, 43, 15, 43, 45,  1, 39, 21, 15,   // 71A0 - 71AF
	27, 33, 17, 23, 45, 35,  5, 45, 17, 41, 41, 41, 43, 41,  5, 15,   // 71B0 - 71BF
	 5, 43, 31, 33, 43, 41, 31, 45,  7,  7, 35, 17, 11, 35, 21, 43,   // 71C0 - 71CF
	21, 37, 35, 11, 11, 43, 41, 21, 23, 37, 43, 17, 23, 45, 45, 43,   // 71D0 - 71DF
	43, 43, 41, 21, 37, 45,  5, 35, 41, 31,  5, 21, 15, 45, 41, 21,   // 71E0 - 71EF
	39, 43, 41, 45, 15, 45, 45, 21, 33, 41, 19, 41, 17,  5,  7, 43,   // 71F0 - 71FF
	15, 21,  3, 33, 21, 23,  3, 33,  7, 21,  1, 41, 19, 35, 45, 21,   // 7200 - 720F
	21, 17, 21, 43, 41, 41, 21, 43, 45, 33, 43, 21,  5, 17, 37, 13,   // 7210 - 721F
	45,  5, 23, 37, 21, 45, 21, 21,  5, 43, 45, 21, 29, 45, 29, 45,   // 7220 - 722F
	43,  1, 39, 45, 17, 17, 11, 43,  3,  7, 43, 43, 45, 35,  9, 29,   // 7230 - 723F
	 5, 19, 45, 45, 31,  7, 31, 29,  3, 29, 35, 17, 29,  7, 43, 37,   // 7240 - 724F
	37,  3,  7,  3,  3,  3, 43, 45,  7, 43,  5, 25,  5, 29, 17, 23,   // 7250 - 725F
	37, 23, 21, 33, 23, 11, 23, 23, 33, 39, 43, 11,  3, 35, 17, 13,   // 7260 - 726F
	43, 13, 35, 23,  7, 31, 31, 31, 45, 37, 41, 23, 19, 31, 39, 13,   // 7270 - 727F
	41, 21, 21, 29, 17, 13, 45,  3, 31, 33,  7, 17, 17, 17, 11, 29,   // 7280 - 728F
	19, 17, 19,  5, 41,  3, 21, 17, 23, 35, 39, 21,  7, 37, 35, 17,   // 7290 - 729F
	41, 21,  7, 21, 29, 29,  3, 41,  5, 39, 19,  5, 31, 31,  3, 11,   // 72A0 - 72AF
	31,  3,  5,  5,  1, 17, 45, 13, 23, 43, 19,  3, 15, 43, 15, 15,   // 72B0 - 72BF
	45, 43, 19, 25,  7, 31, 45, 43,  3, 29, 17, 25, 35, 29, 41, 37,   // 72C0 - 72CF
	15, 21, 11, 29, 25, 35, 43, 13, 43, 17,  7,  3, 13, 41, 25, 15,   // 72D0 - 72DF
	15, 17, 15, 45, 17, 15, 35, 37, 33, 35, 37, 21,  7, 41, 35, 19,   // 72E0 - 72EF
	45, 43, 35, 43,  3, 23, 41, 17, 21, 41, 43, 35, 21,  3, 45, 43,   // 72F0 - 72FF
	35, 21, 45, 41, 17, 15, 11, 43,  3, 31, 25,  3, 43, 21, 21, 17,   // 7300 - 730F
	31, 19, 43, 13, 45, 23,  5, 43, 45, 45, 43, 23,  5,  5, 35, 21,   // 7310 - 731F
	45, 21, 15, 45, 15, 39, 11, 39, 43, 41, 45, 23, 39, 43, 41, 37,   // 7320 - 732F
	43, 25, 41, 17, 15,  3, 43, 43, 23,  5, 43, 35,  3, 23, 15, 43,   // 7330 - 733F
	35, 23, 43,  7, 43, 35, 15, 45, 43, 45,  5, 15, 23, 17, 17, 23,   // 7340 - 734F
	45,  5,  1,  1, 15,  5,  3, 17,  3,  3, 15,  3, 21, 43, 37, 43,   // 7350 - 735F
	21, 35, 41, 35, 45, 41, 13, 17,  7, 15, 19, 41, 41, 37, 41, 41,   // 7360 - 736F
	25,  3, 15, 25, 23, 21, 25, 13, 35, 21, 37, 41, 23, 33, 15, 25,   // 7370 - 737F
	21, 41, 31, 31, 41, 23, 45, 21, 21, 43, 35, 39, 31, 13,  7, 21,   // 7380 - 738F
	 3, 17, 15,  7,  5, 13, 17, 43, 31, 43, 43, 23, 15, 39, 11, 39,   // 7390 - 739F
	17, 43,  3,  3,  3, 43, 17, 43, 17, 39, 17, 23,  7, 29, 39, 15,   // 73A0 - 73AF
	41, 31, 21,  7, 43,  1, 29,  7, 11, 41, 41,  3,  5, 13, 17, 35,   // 73B0 - 73BF
	29,  5, 19, 33, 35, 35, 43, 45, 17, 23, 35, 21,  3, 45, 45, 17,   // 73C0 - 73CF
	11, 21, 17, 17, 17, 21, 13, 41, 45, 13, 43, 41, 43, 41, 21, 35,   // 73D0 - 73DF
	45, 31, 19, 41,  3,  9, 41, 43, 41, 15, 13,  5, 41,  3, 29, 45,   // 73E0 - 73EF
	 7, 43, 15, 39,  9,  5, 37, 39, 39,  5, 17, 23,  3, 37, 41,  5,   // 73F0 - 73FF
	15, 41, 43, 31, 31, 21, 21, 41, 11, 21, 43, 41, 21, 21, 17, 21,   // 7400 - 740F
	35, 35, 45, 39,  7,  3, 45,  5, 23, 43, 17,  5, 21, 39, 35, 39,   // 7410 - 741F
	 7,  5, 45, 29,  5, 15, 31,  9, 19,  5, 31,  3, 39, 21,  5, 13,   // 7420 - 742F
	43,  7,  3, 21, 31, 29, 29, 31, 45, 31, 11, 45, 31,  7, 17, 15,   // 7430 - 743F
	43, 23, 23,  5, 41, 37, 41,  7, 33, 23, 45, 39, 33, 15, 41,  5,   // 7440 - 744F
	17, 45, 43, 21, 31, 41,  7, 43, 43, 25, 15, 43, 43, 15, 33, 35,   // 7450 - 745F
	21, 45, 33, 35, 43, 39, 39, 17, 17, 43, 23, 37, 21, 37, 21, 21,   // 7460 - 746F
	13, 37, 31,  5, 17, 45, 43,  1,  3, 37,  5, 19, 45,  5, 17, 43,   // 7470 - 747F
	 5,  5, 31, 21, 43, 35, 31, 41,  1, 21, 23, 45, 43, 45, 43, 39,   // 7480 - 748F
	21, 39,  7, 45, 45, 41, 31,  7, 21, 21, 31, 35, 15, 13, 29, 17,   // 7490 - 749F
	11, 17, 21, 17, 45, 17,  1,  3,  5, 31, 45,  7, 17, 13, 37, 15,   // 74A0 - 74AF
	15, 35, 35, 37, 45, 43, 17, 11,  3, 35, 39, 45, 21, 41, 17, 41,   // 74B0 - 74BF
	33, 15, 13, 21,  7, 21, 45, 33, 21, 45, 31, 45, 13, 35, 21, 21,   // 74C0 - 74CF
	21, 21, 45, 21, 43, 23, 41, 41, 13,  7, 45, 15, 13,  3,  7, 29,   // 74D0 - 74DF
	15, 45, 29,  3, 33, 21, 39, 45, 17, 31,  3, 29, 11,  7, 39, 27,   // 74E0 - 74EF
	45, 45, 45, 15, 21, 43, 29,  5, 45, 17,  5,  5, 45,  7, 23,  3,   // 74F0 - 74FF
	 5, 29,  3, 45, 45, 45,  5, 43, 31, 41, 21,  7, 27, 23, 45,  3,   // 7500 - 750F
	21, 45, 39, 29,  7, 39, 43, 43, 13,  7, 35, 37, 37, 15,  5, 35,   // 7510 - 751F
	31, 35,  5,  5, 33, 35, 35, 35, 43, 35, 21, 11, 43,  3, 45, 25,   // 7520 - 752F
	37, 43, 17, 35, 45,  7, 11, 25,  7, 29,  7, 15, 37, 31, 45, 23,   // 7530 - 753F
	 3, 31, 21, 41, 21,  5, 23, 43, 11, 11, 13, 37, 17, 17, 31, 39,   // 7540 - 754F
	11, 37, 23, 45, 29, 17, 39,  7, 25, 21,  3, 45,  5, 23, 23,  5,   // 7550 - 755F
	45, 13,  3,  7, 45, 21, 31, 21, 29, 45, 11, 15, 43, 43, 23, 17,   // 7560 - 756F
	43, 21, 35,  7,  5, 15,  7,  5, 17, 39, 17,  5,  5, 37, 21, 17,   // 7570 - 757F
	 5, 21,  7, 37, 21, 17, 17,  5,  3,  7,  7, 29, 25,  7, 35, 35,   // 7580 - 758F
	45, 43,  5, 25,  7,  3, 17, 21, 13, 13, 17, 45, 41, 35, 41, 25,   // 7590 - 759F
	21, 43,  5, 43,  3, 17, 17, 41, 41,  5,  3, 43, 21, 45,  5, 11,   // 75A0 - 75AF
	45, 29, 29, 13, 19,  5, 41, 31,  7, 45, 11, 45, 37, 17, 17, 11,   // 75B0 - 75BF
	17,  7, 17, 41, 45,  3, 25, 45, 43, 17, 31,  5, 37, 43, 17, 39,   // 75C0 - 75CF
	15,  7, 43,  5, 45, 15, 43, 23,  7, 17, 41, 37, 37, 23, 29, 41,   // 75D0 - 75DF
	35, 29, 21, 45,  5,  7, 39, 35, 21, 35, 15, 41, 43, 29, 45, 13,   // 75E0 - 75EF
	37, 11, 23, 21,  5, 17, 37,  1,  5,  3,  3, 23, 13,  7,  9, 39,   // 75F0 - 75FF
	43,  5, 43, 45, 41,  7, 35, 45, 17, 43, 15, 11, 21, 43, 35, 37,   // 7600 - 760F
	43, 13, 39, 15, 19, 17, 43, 43, 21, 35, 17,  5, 41, 13, 43, 39,   // 7610 - 761F
	17,  5,  3, 21, 21,  5, 35, 25,  7,  7,  3, 37, 45,  3, 35,  5,   // 7620 - 762F
	21, 43, 45,  5, 45, 45, 35, 35, 31,  7, 21, 21, 23, 17, 43, 43,   // 7630 - 763F
	15, 11, 21, 21, 31, 21, 21, 41, 11,  7, 43, 15,  1,  3, 41, 13,   // 7640 - 764F
	13, 25, 43, 39, 43, 43, 29, 21, 21, 35,  7, 21,  7, 21, 21,  3,   // 7650 - 765F
	17,  5, 43, 41, 17, 45, 45, 21, 15, 21, 17,  7, 41, 43, 43, 31,   // 7660 - 766F
	43, 37,  7, 21, 21, 21,  3, 45, 13, 29, 11,  7, 11,  3,  3, 31,   // 7670 - 767F
	 3, 45, 45, 23,  7, 29, 17, 15, 13,  5, 21, 13, 23, 17, 17, 29,   // 7680 - 768F
	13,  1,  9, 15, 15,  3, 39,  5, 31, 41,  1, 17, 15, 15, 15, 45,   // 7690 - 769F
	 5, 15, 41, 43, 29, 15, 17,  1, 41, 15, 21, 29, 15, 17, 29, 13,   // 76A0 - 76AF
	29, 45, 17, 31,  5, 31, 45, 13, 17, 17, 45, 45, 13, 45,  7, 23,   // 76B0 - 76BF
	31, 43, 43,  3, 45, 45, 29, 15, 43, 15, 43,  3, 39, 15,  1, 45,   // 76C0 - 76CF
	43, 17, 15, 43, 19, 11, 13,  7, 29, 11, 31, 35,  7, 21, 45, 23,   // 76D0 - 76DF
	21, 17, 41, 17, 29, 13,  1, 21, 41, 45,  7,  1, 13, 21, 23,  7,   // 76E0 - 76EF
	13, 41, 23, 23, 45, 31, 39, 37, 41,  7, 41, 41, 29, 11,  7, 23,   // 76F0 - 76FF
	23, 35, 35, 43, 23, 29, 11, 23,  7, 23, 23, 19, 41, 19, 35, 43,   // 7700 - 770F
	45, 43, 35, 15,  7, 45, 19, 17, 35, 43, 35, 23, 23, 45, 45, 45,   // 7710 - 771F
	23,  7, 43,  7, 43, 45, 45,  5, 45, 41,  3, 23, 21, 35, 37, 23,   // 7720 - 772F
	 7, 43,  9, 23, 41,  5, 19, 17, 23, 45, 37, 43, 43, 23, 45, 23,   // 7730 - 773F
	45, 45, 23, 35, 35, 15, 15,  7,  5,  5, 17,  9, 39, 41, 41, 19,   // 7740 - 774F
	21, 17, 35, 37, 15, 39, 21, 35, 31, 21, 43, 17, 45, 21, 21, 35,   // 7750 - 775F
	17, 35, 35,  7, 29, 29, 23, 15, 25, 21, 13, 17,  5, 45, 43, 15,   // 7760 - 776F
	23, 41, 41, 15, 13, 45,  5, 17, 23,  7, 15, 41, 37, 19, 13, 33,   // 7770 - 777F
	23, 41, 11, 39, 23,  5, 19, 23, 39, 19,  7,  5, 19, 35, 41, 31,   // 7780 - 778F
	23, 23, 23, 35, 45, 45, 43,  7, 19, 23, 35,  5, 21,  5, 23, 29,   // 7790 - 779F
	 5, 17, 23, 15, 33, 29, 41, 31, 29, 45,  7, 35, 35, 21,  5, 41,   // 77A0 - 77AF
	19, 43, 41, 37, 39, 21, 19, 17, 43,  1, 15, 45, 17, 13, 45, 17,   // 77B0 - 77BF
	39,  5, 17, 25, 41, 43, 15, 23, 23,  3, 23, 21, 13, 17, 41, 23,   // 77C0 - 77CF
	15, 21, 23, 21, 13, 23, 41,  5, 37, 19, 45, 23, 17, 21, 43, 35,   // 77D0 - 77DF
	 5, 17, 35, 43, 35, 45, 15, 35, 43, 17, 45, 17,  5,  7,  1, 17,   // 77E0 - 77EF
	45, 15,  3, 35,  7, 31, 17, 45, 13, 39, 37, 19, 31, 41, 11, 19,   // 77F0 - 77FF
	 7, 23, 35,  7, 17, 21, 11, 23, 25, 15, 19, 45, 31, 19, 17, 11,   // 7800 - 780F
	 9, 43, 29, 45, 43, 35, 45,  5,  7, 29, 43, 45, 11, 11, 23, 45,   // 7810 - 781F
	31, 43, 19, 37, 37,  7, 45, 45,  9, 11, 23, 45, 21,  3, 25, 29,   // 7820 - 782F
	29, 21, 29, 21, 29,  3, 29, 35, 45,  1, 21, 21, 37, 45, 21, 19,   // 7830 - 783F
	 5, 19, 31, 45, 19, 13,  9, 25, 17, 21, 39,  1, 21, 19, 41, 43,   // 7840 - 784F
	 7, 29, 41, 45, 15, 35, 41, 31, 45, 39, 31, 45, 19, 41, 31,  5,   // 7850 - 785F
	21, 15, 43, 41, 41, 23, 21, 45,  5,  5, 39, 21, 43, 23, 31, 43,   // 7860 - 786F
	 5, 19, 43, 45, 45, 21,  5, 17, 45, 35, 45, 19, 29, 43, 45, 19,   // 7870 - 787F
	 5, 31, 45, 31, 21, 17,  3,  7, 23,  7, 17, 15, 21,  1, 35, 31,   // 7880 - 788F
	21,  3, 43,  7, 39, 31, 21, 39,  7, 13,  3, 31,  5, 33, 43,  7,   // 7890 - 789F
	 7, 45, 37, 17, 43,  3, 19,  3, 39, 35, 45,  7, 41,  7, 37, 25,   // 78A0 - 78AF
	29, 17,  7, 37,  5, 45, 31, 45, 11, 41, 31, 31, 23, 13, 25, 35,   // 78B0 - 78BF
	 9,  5, 21, 35, 37,  3, 15, 29, 39, 35, 21,  5, 37, 41, 41, 21,   // 78C0 - 78CF
	29, 39, 43,  7, 45, 19, 21, 45, 31, 13, 45,  5, 31,  1, 29, 21,   // 78D0 - 78DF
	21, 19, 31,  5, 43, 21,  3, 31, 23, 31,  5, 45, 31,  5, 45, 17,   // 78E0 - 78EF
	35, 21, 31, 45,  7, 17, 41, 21,  7,  7, 15, 29, 45, 31,  7, 21,   // 78F0 - 78FF
	17, 17, 41, 45, 31,  7, 17, 43, 45, 15, 15, 45, 21, 19,  5, 17,   // 7900 - 790F
	31,  7, 39, 17, 29, 29, 43, 29, 31,  1, 19, 17, 43, 33, 23, 29,   // 7910 - 791F
	45,  3, 45, 23,  5, 41, 19, 21, 21, 45, 21, 21, 11, 31, 29, 43,   // 7920 - 792F
	21, 21, 21, 23,  3, 35, 13, 21, 45, 43, 35, 35, 21, 33, 35, 43,   // 7930 - 793F
	35, 31, 37, 23, 41, 43, 41, 45, 31, 45,  3, 35,  5, 45, 43, 35,   // 7940 - 794F
	43, 45, 37, 11, 11, 23, 45, 45, 35, 23, 45, 31, 15, 45, 35, 35,   // 7950 - 795F
	 5,  5, 23, 21, 43, 41, 39, 37, 29, 45, 13, 41, 45, 17, 13, 45,   // 7960 - 796F
	13, 35, 17, 45, 13, 19,  7,  7, 15, 37, 31, 13, 13, 45, 21, 21,   // 7970 - 797F
	 3, 17,  7, 45, 21, 35,  3, 45, 15, 43, 41, 43, 45, 15, 45, 11,   // 7980 - 798F
	43, 39, 41, 43, 37, 43, 23, 35,  7, 45, 45, 45, 43, 17, 13, 37,   // 7990 - 799F
	 5, 23, 37, 45, 41, 31, 43, 41, 17, 35,  5, 41, 15, 35, 21, 25,   // 79A0 - 79AF
	25,  7, 21, 33, 43, 37, 45, 21, 33, 43, 43, 21, 41, 31, 15, 37,   // 79B0 - 79BF
	41, 35, 33, 37, 45,  5, 13, 43, 41,  3, 25, 31, 31,  5, 11, 15,   // 79C0 - 79CF
	43, 19, 23, 45, 17,  3, 45, 43, 23, 19,  3, 29, 25, 21, 43, 45,   // 79D0 - 79DF
	29,  3, 21, 23,  5, 25, 31, 43, 45, 45, 45, 35, 17, 45, 37, 17,   // 79E0 - 79EF
	 5, 37, 45, 15, 15, 43, 45, 45, 17, 33,  7, 43, 45, 15, 25, 11,   // 79F0 - 79FF
	41, 19, 21, 11, 45, 35, 21, 19, 13, 17, 37,  5, 37, 35, 35, 43,   // 7A00 - 7A0F
	21, 21, 13, 45, 33, 45,  3,  3, 17, 45, 45, 19, 21, 29, 19,  3,   // 7A10 - 7A1F
	 5, 45, 43, 35, 45, 45, 43, 41,  3, 17, 11,  3, 25, 17, 45, 45,   // 7A20 - 7A2F
	41,  5,  7, 39, 21, 45, 43, 17, 41, 45, 45,  7, 17, 17, 13, 13,   // 7A30 - 7A3F
	13, 33, 35, 45, 17, 19, 23, 35, 23, 45, 17, 21, 35, 17, 43, 39,   // 7A40 - 7A4F
	31, 35, 45, 43, 15, 31, 17, 35, 41, 29, 17, 45, 37, 45, 21, 35,   // 7A50 - 7A5F
	25, 35, 15, 33, 25, 43, 45, 17, 37, 39,  5, 15, 13, 21,  3, 45,   // 7A60 - 7A6F
	33, 17, 21, 45, 41, 39, 17, 31, 41, 31, 19, 43, 35, 17, 43,  5,   // 7A70 - 7A7F
	45, 37, 21, 31, 45, 43,  3,  3, 43,  3, 43, 45, 17, 31,  7, 39,   // 7A80 - 7A8F
	13, 43, 45,  5, 43, 37, 17,  5, 17, 41,  5, 19,  5, 39,  7, 19,   // 7A90 - 7A9F
	19, 45, 41, 35, 45, 19,  7, 45, 43, 39, 39, 43, 43, 17, 31, 43,   // 7AA0 - 7AAF
	43, 37, 21, 43, 37,  7, 17, 21, 41, 39, 19,  5, 17, 45, 19, 21,   // 7AB0 - 7ABF
	 5,  5, 29, 45,  5, 31, 31,  7, 45, 45, 31, 21,  5, 35, 11, 31,   // 7AC0 - 7ACF
	 5, 15, 31, 31, 13, 35, 35, 23, 17, 45, 45, 21, 21,  3, 17, 17,   // 7AD0 - 7ADF
	45, 43, 35, 17, 15, 37, 35, 17,  7, 43, 35, 17, 31, 17, 29,  7,   // 7AE0 - 7AEF
	35, 45,  5,  7,  5, 15, 17, 19, 17, 45, 45, 21, 29, 43,  5, 13,   // 7AF0 - 7AFF
	23, 45, 45,  7, 17, 41,  3, 35, 17, 45, 45, 35, 43, 45, 43, 15,   // 7B00 - 7B0F
	13, 41,  5, 29,  3, 17, 43,  7, 35, 35, 41,  7, 45, 25,  5, 13,   // 7B10 - 7B1F
	21, 31, 23,  3, 37, 35, 11,  5,  3, 11,  7, 45,  7, 21, 45, 25,   // 7B20 - 7B2F
	11, 13, 11, 17, 13, 11, 35, 23, 29, 45, 17, 31, 21, 45,  3, 21,   // 7B30 - 7B3F
	13, 31,  5, 43, 43, 41,  3, 31, 13,  7, 17, 17, 31, 35, 33, 11,   // 7B40 - 7B4F
	19, 45, 37, 17,  7, 15,  5, 45, 19, 21,  3, 35,  7, 45,  5, 11,   // 7B50 - 7B5F
	43, 37, 29, 21, 21, 17, 13, 17, 15, 37, 41, 45,  5, 35, 35, 45,   // 7B60 - 7B6F
	45, 41, 35, 37, 17, 43, 13, 19, 13,  5, 19, 13, 43, 45, 31, 41,   // 7B70 - 7B7F
	17, 29, 21, 45,  3,  3,  3, 13,  5, 13, 43, 17, 45, 13,  5, 45,   // 7B80 - 7B8F
	31, 35, 45, 21,  3, 17, 21, 35, 17, 11, 45, 13, 19, 31, 31, 17,   // 7B90 - 7B9F
	 5, 13, 43,  5, 17,  3, 45, 31, 37, 21,  7, 41, 33, 17, 45,  3,   // 7BA0 - 7BAF
	35, 41, 41, 29, 45, 35, 15, 35, 45, 43,  5, 11, 39,  7, 35, 17,   // 7BB0 - 7BBF
	17, 15, 41, 23, 11,  5, 45, 29, 11, 45, 15, 31, 15, 31, 23, 31,   // 7BC0 - 7BCF
	45, 19, 45, 21, 43, 15, 37, 43,  5, 13, 11, 33, 45, 13, 25, 31,   // 7BD0 - 7BDF
	41,  5, 13, 29,  7, 21,  3, 45,  5, 35,  5, 45, 31, 21, 21, 17,   // 7BE0 - 7BEF
	 3, 21, 15,  3,  7,  5, 43, 29, 35,  5, 29, 29,  7, 43, 23, 45,   // 7BF0 - 7BFF
	45, 41, 13, 43, 15,  5, 19,  5, 29, 45, 17, 13, 35, 21, 45, 21,   // 7C00 - 7C0F
	25, 35,  5, 45, 35, 21,  7, 21, 41,  3, 23, 35,  7, 21,  7,  7,   // 7C10 - 7C1F
	11, 17, 23, 19,  7, 31,  7, 15, 35, 21, 45, 41, 21, 35, 45, 45,   // 7C20 - 7C2F
	29, 31, 29, 13, 17,  7, 21, 43,  3,  7, 35, 19, 13, 31, 21,  3,   // 7C30 - 7C3F
	45, 21, 45, 21, 19, 43, 43, 15, 45, 37, 37, 23,  5, 17, 45, 31,   // 7C40 - 7C4F
	37, 45, 45, 11, 35, 45, 31, 19, 37, 21, 21, 17, 37, 43, 43, 21,   // 7C50 - 7C5F
	21, 45, 21, 21, 31, 43, 45, 31, 21,  3,  7, 45, 21, 35, 21, 43,   // 7C60 - 7C6F
	43, 45, 41, 23,  7, 11, 35, 45, 35, 25, 41, 21, 41, 45, 25,  5,   // 7C70 - 7C7F
	45, 31, 45,  3,  3, 39, 35, 19, 33, 11,  3,  5, 43, 21,  5, 37,   // 7C80 - 7C8F
	45,  3, 21, 13, 17, 29, 23,  5, 45, 45, 21, 35, 37, 21, 41, 35,   // 7C90 - 7C9F
	15, 37, 45,  5, 43, 45, 21, 45,  3, 45, 11, 23, 31, 45, 21, 41,   // 7CA0 - 7CAF
	11, 21,  5, 17, 21, 43, 21, 17, 31,  5,  3,  5, 21, 45, 17, 13,   // 7CB0 - 7CBF
	45, 35, 35, 37,  3, 33, 23, 15, 41, 45, 15, 17, 45,  5, 21, 41,   // 7CC0 - 7CCF
	11, 25,  3, 13, 41, 13, 37, 31, 45,  5, 45, 37, 23, 35, 11, 45,   // 7CD0 - 7CDF
	19, 17, 23, 35, 35, 25,  5, 21, 17, 19,  3, 15, 35, 45, 17, 25,   // 7CE0 - 7CEF
	37, 25, 21, 45,  7, 25, 37, 21, 23, 23, 17, 41, 13, 45, 17, 43,   // 7CF0 - 7CFF
	17,  5, 45, 41, 43, 15, 43, 15, 39, 33, 39, 39, 31, 25, 45, 37,   // 7D00 - 7D0F
	25, 11, 17, 35,  5, 29, 43, 35, 15, 45, 17, 11, 43, 33,  7, 17,   // 7D10 - 7D1F
	35, 11, 35,  5, 17, 45,  3, 17, 11, 45, 31, 45,  5, 15, 45, 21,   // 7D20 - 7D2F
	41, 11, 41, 35,  3, 45, 31, 21, 45, 35, 13, 43, 11, 37, 45,  7,   // 7D30 - 7D3F
	 5, 35, 45, 41, 45, 17,  3, 17, 29, 35, 45, 19, 17, 33, 15, 41,   // 7D40 - 7D4F
	17, 45,  5, 13,  3, 17, 19, 15,  5, 13, 13, 37, 41, 19, 17, 31,   // 7D50 - 7D5F
	13, 21, 41,  3, 41, 11, 13, 37, 33, 37, 43, 21, 41, 31, 41, 15,   // 7D60 - 7D6F
	 7, 37, 35, 17, 41, 15, 17, 45, 17, 17,  5, 23, 45, 21,  5, 31,   // 7D70 - 7D7F
	35,  3, 37, 41, 39, 31, 13, 41, 37, 41, 41, 15, 41, 11, 37, 35,   // 7D80 - 7D8F
	 7, 19, 11, 17, 15, 45, 43, 17, 11, 17, 41, 45, 45, 21,  7, 21,   // 7D90 - 7D9F
	21, 21,  5, 31, 35, 31, 31, 45, 31, 39, 31, 41, 35, 39, 31, 37,   // 7DA0 - 7DAF
	39, 13, 39,  3, 45,  5, 13,  5, 21, 21, 31, 45,  3,  5, 21, 23,   // 7DB0 - 7DBF
	31, 17, 37, 45, 13, 45, 43, 45, 41, 21, 17, 11, 33, 23, 43, 45,   // 7DC0 - 7DCF
	11, 21, 41, 45, 35, 45, 41, 41, 17, 19, 41, 33, 23, 17,  7, 45,   // 7DD0 - 7DDF
	 7, 23, 23, 43, 41,  3, 35, 31,  3, 15, 13, 45, 23, 39, 11, 39,   // 7DE0 - 7DEF
	43, 13, 23, 17, 21, 45,  3, 43, 43, 37, 13, 45, 43,  5,  5,  7,   // 7DF0 - 7DFF
	17, 43, 45, 41, 35, 45, 13, 45, 43, 17, 43, 45, 25,  3, 13, 29,   // 7E00 - 7E0F
	45, 17,  5, 31, 35, 43, 41, 35, 41, 33, 37, 11, 43, 45, 13, 33,   // 7E10 - 7E1F
	15, 45, 37, 41, 35, 45, 45, 37, 15,  5,  3, 11,  5, 21, 35, 43,   // 7E20 - 7E2F
	41, 45, 21, 45, 31, 23, 45, 21, 23, 29, 21, 23, 41, 45, 17, 35,   // 7E30 - 7E3F
	35, 11, 35,  3, 43, 35, 23, 45, 31, 15, 41, 41, 45, 41, 33, 41,   // 7E40 - 7E4F
	15, 31, 45, 45, 45, 35, 35, 21, 43, 11, 21,  5, 45, 17, 33,  5,   // 7E50 - 7E5F
	33, 41, 15, 15, 45, 41, 31, 45,  7, 35, 15, 41, 35, 17, 17, 15,   // 7E60 - 7E6F
	31,  5, 17, 17,  3,  5, 43, 25, 35, 43, 35, 41, 17,  3, 31, 17,   // 7E70 - 7E7F
	29, 41, 45, 31, 29, 21, 23, 21, 41, 45, 19, 43, 41, 21, 41,  5,   // 7E80 - 7E8F
	45, 21,  5, 43,  5, 41, 41, 45, 45, 21, 41,  7, 21, 21, 21, 23,   // 7E90 - 7E9F
	17, 43, 15, 45, 41, 15, 43, 17, 39, 19, 17, 33, 39, 43, 15,  5,   // 7EA0 - 7EAF
	29, 35, 13, 25, 33, 45, 21, 11, 45, 39, 11, 45, 45, 25, 35, 41,   // 7EB0 - 7EBF
	13, 41, 11, 21, 45, 35, 41, 45, 45, 45,  3, 11,  5, 35, 43, 17,   // 7EC0 - 7ECF
	 7,  3, 33, 17, 19, 33,  7, 15, 15, 13, 41, 17, 21, 17, 17, 37,   // 7ED0 - 7EDF
	13, 41, 17, 41, 41, 35, 37, 17, 37, 17, 41, 21, 43, 41, 31, 11,   // 7EE0 - 7EEF
	 5, 35, 13, 35, 39, 23, 35,  3,  5, 37, 21, 31, 45, 45, 39, 21,   // 7EF0 - 7EFF
	45, 45, 19, 41, 17, 23, 21, 37, 23, 17, 43, 15, 35,  7,  7,  3,   // 7F00 - 7F0F
	41, 13, 45, 15,  7, 21,  3, 23, 43, 17, 11, 33, 45, 11,  5, 13,   // 7F10 - 7F1F
	 5, 21, 43, 17,  3, 29, 23, 21, 43, 35, 23, 35, 41, 21, 35, 45,   // 7F20 - 7F2F
	17, 31, 31, 15, 17, 45, 11, 41, 13, 11, 31, 11, 31,  3, 29, 15,   // 7F30 - 7F3F
	45, 13, 43, 43, 31, 41, 13, 45, 37, 45, 31, 39, 43, 21, 37, 21,   // 7F40 - 7F4F
	13, 39, 13, 39, 39, 15, 45, 21, 11, 23, 11, 13, 45, 17, 23, 13,   // 7F50 - 7F5F
	23, 13,  3, 13, 37, 17, 11, 21, 43, 45, 45, 13, 45, 43, 45,  1,   // 7F60 - 7F6F
	11, 21, 35, 35, 29, 23, 21,  3, 11, 21,  5, 39,  3, 17, 45, 37,   // 7F70 - 7F7F
	21, 17, 17, 23, 45, 21, 29, 17, 17, 21, 43, 23, 31, 37, 23, 43,   // 7F80 - 7F8F
	43, 43, 11,  3, 13, 43, 13, 31, 45, 13, 21, 43, 45,  7, 41, 31,   // 7F90 - 7F9F
	43, 41, 33, 31, 31, 31, 15, 35, 41, 43, 43, 31, 41, 43, 13, 17,   // 7FA0 - 7FAF
	37, 43, 41, 11, 35, 11, 35, 21, 21, 13, 25, 31,  5, 43, 13, 43,   // 7FB0 - 7FBF
	 5, 39, 11, 15,  5,  5,  5, 11, 41, 29, 43, 21, 43, 29, 21, 21,   // 7FC0 - 7FCF
	45, 31, 41, 41, 41, 41, 41, 31, 31, 15, 15, 35, 35, 15, 17,  7,   // 7FD0 - 7FDF
	 5, 11, 37, 35,  5, 45, 17, 41, 35, 29, 45, 39, 15, 15, 15, 15,   // 7FE0 - 7FEF
	15,  1, 29, 43, 21, 31, 45, 21, 29, 31,  1, 11, 43, 15, 41,  7,   // 7FF0 - 7FFF
	43, 21, 45, 19, 23, 45, 31, 13, 13, 13,  7,  7,  9, 35, 33,  9,   // 8000 - 800F
	25, 45, 21, 37, 45, 13,  5, 15, 43, 29, 29,  5, 35, 31, 17, 17,   // 8010 - 801F
	15,  5, 21, 21, 17, 37, 27, 21, 25, 17, 29, 45, 21, 17, 21, 15,   // 8020 - 802F
	43, 23, 15,  9, 45,  7, 43,  7, 35, 31, 43,  5,  7,  7, 15, 13,   // 8030 - 803F
	45, 45, 25,  7, 45,  5, 21, 45, 43, 39, 21, 21, 45, 25, 37,  9,   // 8040 - 804F
	43,  7, 13, 45, 21, 15, 35, 21, 29, 17, 17,  3,  7, 13, 39, 41,   // 8050 - 805F
	29,  5, 45, 45, 37, 43,  5, 19, 21, 19,  5, 21, 39, 19, 21, 21,   // 8060 - 806F
	 5,  1, 35, 35, 37, 19, 25, 45,  7, 25, 45, 17, 37, 37, 21, 43,   // 8070 - 807F
	43, 45, 35, 35, 43, 35, 35, 45, 45, 33, 43, 21, 17, 31, 19,  5,   // 8080 - 808F
	13,  7, 15, 15, 43, 33, 41, 33, 45, 43,  7, 13, 33, 13,  5, 39,   // 8090 - 809F
	 5, 13, 45, 31, 11, 11,  3, 29, 29, 17, 11, 45, 43, 25,  1, 19,   // 80A0 - 80AF
	33, 13, 43, 39, 43, 17, 29, 31, 41, 41, 11, 19, 17, 37, 35, 45,   // 80B0 - 80BF
	45, 41, 35, 39, 45,  7,  7, 11,  3,  3, 31, 37,  3, 13, 37, 45,   // 80C0 - 80CF
	19, 45, 25, 29, 45, 11, 29, 45, 41, 45, 29, 17, 35, 45,  3, 23,   // 80D0 - 80DF
	31, 15, 19, 43, 43, 41, 43, 21,  7, 19, 21, 17, 25, 43, 29, 19,   // 80E0 - 80EF
	43, 13, 15, 13,  7, 45, 17, 41, 41,  9,  1, 41, 29, 25, 45, 45,   // 80F0 - 80FF
	 5, 37, 45,  5, 23, 41,  5, 41, 23, 23, 17, 41, 45, 19, 35, 45,   // 8100 - 810F
	31, 25, 23, 25, 21, 39,  3, 39, 39, 31, 17, 17, 43, 15,  5, 21,   // 8110 - 811F
	35, 37, 23,  5, 35, 41, 45, 17,  5, 41, 41, 37, 29,  5, 25, 11,   // 8120 - 812F
	 7, 37, 25, 25, 29, 13, 21, 21, 21, 45,  5, 17, 21, 35, 29,  3,   // 8130 - 813F
	21, 29, 13, 17,  5,  7, 37, 25, 17, 17, 21, 43,  1, 33, 35,  5,   // 8140 - 814F
	11, 11, 17, 11, 31, 39,  7, 29, 13, 45,  7, 39, 23, 33, 45, 45,   // 8150 - 815F
	 5, 13, 27,  7,  1, 41, 25, 35, 35, 25, 43, 45, 33,  9, 35, 37,   // 8160 - 816F
	43, 17, 39, 17, 43, 17,  7,  3,  5, 11, 41, 25, 23, 39, 37, 37,   // 8170 - 817F
	 3, 31, 21, 39, 35, 37, 35, 45, 13, 43,  3, 21, 17, 29, 41, 13,   // 8180 - 818F
	21,  3, 45,  5, 21, 13, 29,  5,  3, 17, 11, 37, 23, 41, 45, 21,   // 8190 - 819F
	17, 43, 21, 45, 41,  5, 21, 37, 29, 25,  5, 21,  5, 13, 41, 37,   // 81A0 - 81AF
	11, 45, 17, 35, 15,  5, 33, 41, 35, 11, 43, 35, 13,  7, 19, 25,   // 81B0 - 81BF
	37, 21,  3, 43, 17,  5, 43, 17, 21, 21, 35, 37, 13, 31,  5,  3,   // 81C0 - 81CF
	41, 25, 15, 45, 41,  3, 41, 19, 21, 43, 21, 15, 45, 21, 31, 45,   // 81D0 - 81DF
	21, 25, 45,  5, 31, 39, 13, 45, 21, 13, 45, 17, 25,  5, 17, 13,   // 81E0 - 81EF
	 5, 23, 25, 45, 45, 13, 17,  7, 45, 41, 37, 45, 17, 41, 43,  5,   // 81F0 - 81FF
	43, 43,  5, 41, 41, 17, 43, 43, 41, 17, 17, 41, 35, 35, 35, 17,   // 8200 - 820F
	35, 37, 35, 35, 37,  7, 29, 29, 13, 15, 37,  5, 35, 41, 39, 45,   // 8210 - 821F
	 7,  5, 35, 43, 45, 29, 37, 11,  3,  5, 15, 11,  3,  3, 21, 45,   // 8220 - 822F
	17,  5, 21, 45, 45,  7,  3, 41, 13,  5, 17, 21, 15, 29, 41, 45,   // 8230 - 823F
	11, 45, 11, 21, 35, 43, 21, 37, 45, 39,  3, 23, 25, 17, 15, 35,   // 8240 - 824F
	45,  3, 23,  7, 45,  3,  5, 43, 35,  5,  5, 21,  7, 45, 43,  5,   // 8250 - 825F
	45,  7, 31, 21, 43, 17, 17, 15, 23, 31, 21, 21,  5, 35, 13, 21,   // 8260 - 826F
	17, 17, 35, 43, 11, 29, 43, 43,  5,  5, 43, 21, 37, 17,  1, 25,   // 8270 - 827F
	37, 17, 17, 29, 39, 43,  5, 23, 23, 13, 31, 43, 43, 35, 41,  7,   // 8280 - 828F
	41, 31, 23, 45, 15, 35, 45, 41,  3, 11, 37, 39, 39, 45, 31, 35,   // 8290 - 829F
	39, 31, 33, 11, 19, 17, 21, 45, 17, 31, 31, 43, 11,  3, 33, 41,   // 82A0 - 82AF
	17, 15, 15, 11, 39, 17, 13, 45, 43, 31,  1,  5, 23, 43, 11, 33,   // 82B0 - 82BF
	15,  5, 43, 43,  3, 43, 45, 39, 21, 29,  9, 41,  5,  5, 45, 35,   // 82C0 - 82CF
	43, 43, 33, 21, 37, 37,  7, 23, 31, 21, 33, 19, 23, 29,  3, 13,   // 82D0 - 82DF
	23, 43, 43, 17, 29, 33, 19, 45, 25,  3,  3, 35, 31, 43, 41,  3,   // 82E0 - 82EF
	15, 43, 45,  7, 17,  7, 25, 13, 15, 29, 23, 11, 35, 13,  3, 39,   // 82F0 - 82FF
	11, 45, 23, 11, 31, 23, 23,  3, 45, 23, 45,  7,  5, 13, 17, 21,   // 8300 - 830F
	45, 25, 45, 41, 43, 31, 13, 23, 21, 33, 43, 13, 31,  5,  5, 43,   // 8310 - 831F
	41, 45, 21, 39,  7, 19,  5, 17,  5, 13, 13, 23,  5, 17, 17, 11,   // 8320 - 832F
	43, 45, 45, 17, 15, 43,  5, 11, 33, 33,  5, 23, 37, 45, 45, 45,   // 8330 - 833F
	41, 15, 19, 31, 13,  7, 17, 41,  5,  5, 17,  9,  1, 35,  5, 33,   // 8340 - 834F
	17, 37, 15, 29, 21, 17, 21, 33, 45,  7, 17, 33,  3,  5, 31, 15,   // 8350 - 835F
	31,  7, 45, 33, 15, 43, 21, 43, 31, 17, 35, 43, 23, 15, 45, 43,   // 8360 - 836F
	 7, 39,  5,  7, 11, 33, 43, 15,  3,  3, 43,  7, 37, 35, 35,  5,   // 8370 - 837F
	 5, 39,  3, 41, 13, 21, 29, 45, 23, 21, 45, 17,  7, 31, 35, 35,   // 8380 - 838F
	 5, 11, 17, 23, 23, 41, 17,  5, 41, 17, 43, 37, 43,  5, 13, 15,   // 8390 - 839F
	43,  5, 17, 39, 43, 25, 35, 41, 21, 11,  9, 23, 39, 17, 25, 23,   // 83A0 - 83AF
	19, 21, 21, 35, 39, 37, 41, 15, 43, 43, 43, 45,  5, 23, 23,  5,   // 83B0 - 83BF
	43, 17,  7, 31,  7, 17, 45, 13, 21, 21, 17, 39, 17, 25, 19, 15,   // 83C0 - 83CF
	29, 45, 13, 13, 11, 21,  5,  5, 35,  5, 45, 23,  5,  3, 21, 37,   // 83D0 - 83DF
	 3, 15,  3, 31, 17, 41, 31,  7, 17, 29,  7, 17, 45, 37, 13, 15,   // 83E0 - 83EF
	13, 21, 11, 17,  1, 39,  3, 45, 43, 45, 17, 21, 37, 35, 37,  7,   // 83F0 - 83FF
	15, 17, 15,  5, 37,  5,  3,  5, 15, 11, 21, 31, 23, 29, 39,  7,   // 8400 - 840F
	35, 15, 43, 43, 37, 31, 39,  5, 25, 45, 37, 17, 37, 21, 45, 45,   // 8410 - 841F
	23, 45, 45,  7, 43, 43, 43, 41, 35, 31, 19, 41, 39, 43, 43, 11,   // 8420 - 842F
	21, 41, 41, 25, 45, 39,  5, 41, 43, 29, 23,  1,  9, 21, 43, 15,   // 8430 - 843F
	13, 17, 39, 45, 45, 17,  3, 33, 41, 41,  1, 31, 17, 11, 21, 21,   // 8440 - 844F
	29, 11, 15, 15, 15, 43, 37, 45, 45, 41, 35, 13, 31, 17, 23, 15,   // 8450 - 845F
	35, 29, 13,  7, 45, 31, 39,  3, 39, 29, 17, 15, 45, 17,  7, 43,   // 8460 - 846F
	17,  5, 31, 39, 41, 19, 37, 15, 41, 35, 31, 21, 45, 43, 43, 23,   // 8470 - 847F
	43, 35,  7, 45, 13, 45, 31,  5, 19, 19, 45, 17, 21, 39, 29, 45,   // 8480 - 848F
	35, 43, 35,  5, 35, 43, 45, 21, 25, 23, 15, 31, 35, 43, 21, 17,   // 8490 - 849F
	41,  3,  5, 41, 37, 21, 15, 45, 31, 45, 29,  5, 43,  5, 43, 19,   // 84A0 - 84AF
	29, 29, 29, 25, 35, 41, 11, 43, 45, 17, 17, 33,  5,  9, 23, 15,   // 84B0 - 84BF
	35, 45, 23, 45, 41, 21, 41, 13, 21, 33, 39, 13,  5, 35, 37, 21,   // 84C0 - 84CF
	33, 35, 41,  3, 43, 13,  3, 45, 13, 45, 41,  5, 45, 21, 45, 17,   // 84D0 - 84DF
	21,  5, 21, 43, 45, 43, 23,  7, 41, 39, 37, 45, 29,  1, 21,  5,   // 84E0 - 84EF
	41, 29, 31, 17,  5, 17, 39, 37,  5, 43, 43, 17, 21,  3, 21, 41,   // 84F0 - 84FF
	 3, 45, 21, 31, 23, 43, 21, 17,  3, 13, 15,  7, 35, 21, 35, 35,   // 8500 - 850F
	 7, 23, 41, 23,  3,  7,  5, 45, 35, 41, 43, 15,  1, 23, 21,  5,   // 8510 - 851F
	45,  5, 29, 17, 23,  5, 25, 15, 17, 43, 17, 25, 35, 43, 19,  5,   // 8520 - 852F
	15, 35, 19, 31, 23,  5, 45, 31,  7, 21, 21, 19,  1,  3, 21, 39,   // 8530 - 853F
	17, 31, 35, 11, 23, 27,  5,  7, 41, 17, 33, 33, 21, 43, 31,  5,   // 8540 - 854F
	15, 17, 23, 43,  3, 43, 31, 21, 33, 15,  9, 37, 11, 17, 45, 11,   // 8550 - 855F
	33, 11, 19, 35, 33, 43, 41, 11, 17,  7, 39, 37, 35, 41, 41, 43,   // 8560 - 856F
	39, 35, 31, 17, 43, 35, 21, 43, 41, 39, 17, 15, 35,  7, 21, 41,   // 8570 - 857F
	43, 43, 41, 15,  3, 15,  1, 39, 15, 39, 17,  5, 41, 21, 23, 43,   // 8580 - 858F
	21, 17,  5, 35, 31, 21, 19, 43,  7, 37, 37, 41,  3, 45, 35, 21,   // 8590 - 859F
	11,  7, 41, 13, 41, 35, 17, 19, 15, 35, 41, 41, 43,  3, 35, 35,   // 85A0 - 85AF
	41,  7, 29, 39, 25,  5, 23, 33, 29, 37, 31, 45,  5, 45,  9, 25,   // 85B0 - 85BF
	43, 13,  5, 41, 31, 11, 17, 41, 19, 17,  3,  7, 23, 21, 17,  5,   // 85C0 - 85CF
	23, 31, 31, 41, 45, 27, 41, 35, 21, 43, 41, 41, 21, 43, 21, 21,   // 85D0 - 85DF
	17,  7, 45, 29, 37, 43, 23, 15,  3, 11, 35, 37, 37, 31, 31, 39,   // 85E0 - 85EF
	21, 15, 35, 13, 43, 45, 21, 45, 45,  1, 21, 45, 41,  5, 21, 15,   // 85F0 - 85FF
	37, 39, 33, 33, 31, 15, 21, 35, 37, 23, 43, 29, 43, 41, 17, 17,   // 8600 - 860F
	41, 23, 45, 35, 17, 45, 25,  3, 33, 43, 41, 43, 17, 21, 21, 43,   // 8610 - 861F
	31, 43, 21, 37, 39, 43, 21, 31, 43, 11, 23, 21, 19, 21, 17,  7,   // 8620 - 862F
	45, 21, 21, 37, 11, 45, 39, 19, 45, 15, 21, 17, 23, 21, 15, 21,   // 8630 - 863F
	17, 25, 21, 17, 45, 45, 21, 31, 41, 43, 21, 23,  3, 15, 15, 21,   // 8640 - 864F
	25, 21, 45, 41, 31,  5, 15, 41,  5, 11, 41, 41, 21, 15, 43, 15,   // 8650 - 865F
	17, 17, 13,  3, 43, 45, 45, 19,  3, 41, 35,  5, 31,  7, 17, 31,   // 8660 - 866F
	 7, 35, 45,  7, 45, 35, 43, 13, 45, 15, 15, 23, 13, 35, 41,  5,   // 8670 - 867F
	35, 43, 23, 41, 11,  9, 29,  5, 31, 39, 39, 33,  3, 29, 43, 43,   // 8680 - 868F
	17, 31, 33, 43, 31,  5, 43, 17, 15, 31, 31, 45, 43, 15, 23, 39,   // 8690 - 869F
	11, 11, 15, 13, 45, 11, 33, 17, 11,  5,  7,  3, 41, 25, 37, 31,   // 86A0 - 86AF
	43, 45, 29,  5, 43, 15, 15, 17, 21, 11, 33, 45, 13, 29,  3, 41,   // 86B0 - 86BF
	45,  7,  3,  3, 13, 33, 31, 35, 37, 21, 13,  7, 13, 43, 21,  5,   // 86C0 - 86CF
	31, 23, 13,  5, 15, 15, 23, 11, 43, 39, 21, 45, 43, 41, 19, 17,   // 86D0 - 86DF
	21, 43, 29, 17, 15, 35, 43, 39, 23, 31, 31, 13, 13, 45, 23, 45,   // 86E0 - 86EF
	45, 17, 25, 35, 31, 41, 21, 31, 35, 43, 17, 37,  5,  3,  9, 15,   // 86F0 - 86FF
	35, 41, 11, 35, 45, 11, 41, 45, 39, 11, 21, 21,  3,  5, 43, 43,   // 8700 - 870F
	17,  7, 43, 37,  7, 37, 15, 39, 45, 35, 11, 17, 23, 31, 31, 43,   // 8710 - 871F
	17, 21, 23, 31, 35, 41, 21, 21,  7, 37, 37, 19, 13, 15, 43,  3,   // 8720 - 872F
	11, 29, 39,  7, 43, 43, 35, 31, 31, 33, 25, 31, 39, 21, 13, 39,   // 8730 - 873F
	 7,  9,  3, 45, 39,  5, 43, 43, 13,  5, 45, 21, 19, 17, 41, 37,   // 8740 - 874F
	23, 41, 23, 43, 17, 35, 41, 15, 43,  3, 33, 39, 11, 43, 23, 39,   // 8750 - 875F
	11, 33, 41, 43, 43, 23, 41, 43, 35,  5, 37, 45, 45, 37, 11, 43,   // 8760 - 876F
	19, 23, 21,  7, 15, 31,  7, 21, 13, 43, 17, 25, 21,  5, 33, 43,   // 8770 - 877F
	17, 37, 21, 29, 35, 41, 41, 41, 43, 39, 21, 35,  3, 33, 33, 17,   // 8780 - 878F
	39, 41, 15, 31, 43,  3, 15, 37, 43,  7, 25, 15, 15, 41, 23, 23,   // 8790 - 879F
	43, 39, 43, 37, 43,  5, 45, 45, 23, 45, 35, 35,  5,  5,  7,  1,   // 87A0 - 87AF
	21, 39, 45, 37,  5, 29, 31, 29, 43, 17, 21, 21, 31, 45, 43, 17,   // 87B0 - 87BF
	35, 39, 17, 39, 45, 45, 23, 23, 13, 21, 23, 41,  5, 21, 23, 41,   // 87C0 - 87CF
	45, 45, 23, 41, 23, 45, 35, 31, 37, 45, 29, 29, 17, 31,  3, 21,   // 87D0 - 87DF
	29, 13, 41, 17, 45, 15, 11, 21, 17, 17, 15, 43,  5, 17, 35, 33,   // 87E0 - 87EF
	41, 39,  5, 41, 35, 45,  5,  7, 21, 41, 35, 43, 17,  7,  5, 31,   // 87F0 - 87FF
	45, 41, 35, 21, 31, 43,  5, 21, 45, 41, 21, 45, 45, 41, 23, 41,   // 8800 - 880F
	31, 33, 17, 23, 15, 33, 15, 45, 17,  3, 15, 23, 11, 21, 17, 21,   // 8810 - 881F
	23, 21,  5, 21, 31, 25, 21,  7, 41, 45, 21, 21, 21, 11, 43, 29,   // 8820 - 882F
	33, 13, 17, 43, 45, 41,  5, 31, 31,  7,  5, 23, 31, 17, 45, 45,   // 8830 - 883F
	41, 15, 25, 29, 25, 41, 45, 23,  9, 23, 23, 35, 41, 43, 19, 43,   // 8840 - 884F
	45, 21, 41, 35, 41, 37, 21, 17, 41, 43, 15, 39,  7,  5, 39,  7,   // 8850 - 885F
	45, 15, 31, 43, 43,  3, 13, 43,  3,  5, 43, 35,  5, 11, 13, 11,   // 8860 - 886F
	35, 17, 25, 45,  7, 33, 45, 45, 41, 31, 41, 33, 45, 33, 31, 17,   // 8870 - 887F
	17, 43, 23,  5,  1, 25, 15, 33, 17, 37, 21,  7,  3, 29, 43, 45,   // 8880 - 888F
	 3, 35, 37, 17, 15, 41, 41, 45, 43, 29,  3,  7, 39, 11, 13, 45,   // 8890 - 889F
	45, 33, 29, 43, 23, 45, 25, 19, 41,  5, 31,  3, 43, 41, 45,  3,   // 88A0 - 88AF
	45, 11, 43,  5, 19, 33, 17, 17,  5, 23, 17,  9, 13, 33, 45, 13,   // 88B0 - 88BF
	43,  5, 21, 45, 45, 45,  7, 45, 19, 19, 25, 35, 17, 19,  5, 21,   // 88C0 - 88CF
	17, 35, 29, 13, 43, 43,  5, 21, 31, 31, 17, 43,  3, 45, 35, 35,   // 88D0 - 88DF
	31, 21, 21, 21, 19, 17, 11, 37,  3, 13, 37, 43, 21,  5,  5,  5,   // 88E0 - 88EF
	 7,  3, 21, 35, 29, 29, 11, 43, 21, 13, 43,  7, 37, 45, 17, 31,   // 88F0 - 88FF
	17, 45, 13, 19, 45, 37, 35, 11,  5, 41,  3,  7, 19,  7, 41, 41,   // 8900 - 890F
	15, 43,  3,  3, 11, 43, 37, 43, 15,  3,  5, 21, 45, 45, 43, 37,   // 8910 - 891F
	13,  7, 15, 33, 43, 33, 25, 17, 35,  3, 37,  5, 35, 25, 43, 17,   // 8920 - 892F
	31, 15, 19, 21, 21, 21, 45, 35, 21, 43,  7, 41, 41, 39,  3,  5,   // 8930 - 893F
	17, 31, 35,  3, 41, 45, 29, 17, 45, 17, 45, 17,  7, 45, 11,  3,   // 8940 - 894F
	41, 41,  3, 33, 23, 21,  1,  7, 15,  5, 35, 25,  5, 21,  3, 17,   // 8950 - 895F
	 7, 35, 37,  3, 21, 29, 33, 45, 45, 35, 39, 35,  3, 41,  3,  5,   // 8960 - 896F
	21, 21, 41, 41, 21, 45,  7, 45, 45, 35, 17, 29, 43, 45, 43, 41,   // 8970 - 897F
	41, 43, 11, 37, 45, 45, 11,  3, 15, 17, 17, 17, 13,  3, 43, 13,   // 8980 - 898F
	17, 29, 23, 23, 23, 23, 35, 35, 45, 21, 17, 23, 37, 21, 43, 45,   // 8990 - 899F
	17, 41, 35, 39, 41, 37, 43, 21,  9,  7, 31, 29, 17, 23, 29, 13,   // 89A0 - 89AF
	31, 45, 17, 13,  7, 17, 21, 31, 17, 39, 17, 31, 21, 21, 35,  7,   // 89B0 - 89BF
	13, 17, 13, 43, 13, 23, 35,  5, 21, 17, 17, 41,  7, 37, 43, 13,   // 89C0 - 89CF
	17, 31, 17, 17, 17,  5, 17, 45,  5, 17, 13,  7, 45,  7, 35, 15,   // 89D0 - 89DF
	31, 13, 45, 17, 13, 13,  5, 17, 15, 31, 41, 35, 25, 17, 21, 45,   // 89E0 - 89EF
	45,  3, 41, 15, 35, 13, 45, 41,  5, 41, 43, 21, 17, 41, 43, 41,   // 89F0 - 89FF
	43, 43,  7, 11, 31, 31, 17, 15, 17, 11, 41,  7, 15,  5, 37, 41,   // 8A00 - 8A0F
	17, 43, 33, 41, 43, 35, 31, 37, 17, 41, 43,  9, 11, 43, 43, 35,   // 8A10 - 8A1F
	35, 43, 41, 17, 41, 25,  5, 43, 45, 41, 11, 41,  5, 35, 41, 35,   // 8A20 - 8A2F
	45, 41, 43, 43, 35,  5, 15, 35, 15, 41, 45, 45, 45, 13, 45, 45,   // 8A30 - 8A3F
	45, 13, 11, 17,  7, 21,  7, 43, 21, 25, 29, 45, 13, 35, 17,  1,   // 8A40 - 8A4F
	45, 37, 43, 31, 45, 29,  3, 41,  5,  3,  7, 45, 37, 45,  5, 45,   // 8A50 - 8A5F
	43, 41, 41, 43, 15, 15, 35,  5, 17, 35, 15,  5, 13, 13, 31, 15,   // 8A60 - 8A6F
	17, 15, 13, 41, 15, 35,  5, 37, 23, 45, 23,  9, 15, 43, 41, 13,   // 8A70 - 8A7F
	 9,  3, 37,  5, 21, 45, 19, 19, 39, 43, 37, 17, 45, 33, 35, 21,   // 8A80 - 8A8F
	 9, 19,  9, 35, 37,  7,  3,  5, 43, 15, 31, 31, 35,  1, 43, 41,   // 8A90 - 8A9F
	 5, 17, 41, 39, 39, 13, 35, 29, 15, 17, 35, 45, 35,  7, 45,  5,   // 8AA0 - 8AAF
	35, 17, 19, 31,  5, 41, 35, 39, 41, 11,  5, 37, 43, 25, 43,  7,   // 8AB0 - 8ABF
	29,  5,  5,  5, 45, 17, 31, 37,  5, 39, 17, 31, 17, 45, 45, 45,   // 8AC0 - 8ACF
	31, 45, 21, 17, 45, 15, 21, 35,  3, 15, 29, 43,  7, 41, 29, 35,   // 8AD0 - 8ADF
	41, 35, 15, 15,  9, 45,  7, 41, 11, 29, 37, 17, 31, 43, 45,  5,   // 8AE0 - 8AEF
	41, 15, 43,  1, 41, 25,  5, 11, 45, 43, 43, 15, 41, 13, 25, 31,   // 8AF0 - 8AFF
	23, 43, 39, 45, 37, 45, 35, 17,  3, 45, 15, 15, 13, 43, 23, 41,   // 8B00 - 8B0F
	23, 41, 31,  5, 25, 35, 35,  3,  5, 31, 35, 17, 43, 41, 41, 37,   // 8B10 - 8B1F
	43, 43, 15, 43,  3,  5, 31, 21, 23, 23, 35, 45, 23, 17, 45, 45,   // 8B20 - 8B2F
	21, 21,  5, 27, 13, 41, 45,  1,  1, 17, 45, 43, 15, 17, 23,  5,   // 8B30 - 8B3F
	15, 15,  5, 41, 45, 35, 41, 35,  7, 45, 25, 21,  9, 43, 17, 17,   // 8B40 - 8B4F
	45, 17,  3, 15, 45, 39, 17, 45, 35, 31, 37, 45, 29, 35, 41, 45,   // 8B50 - 8B5F
	45,  7, 35, 31, 17, 17, 17, 21, 25, 43,  1, 45, 29, 15, 15, 43,   // 8B60 - 8B6F
	43, 35, 33, 25, 31, 45, 37, 15, 45, 15, 25, 43, 17, 43, 17, 15,   // 8B70 - 8B7F
	 7, 45, 41, 45, 21, 35, 39,  5, 21, 43,  3, 45, 43,  9,  5, 39,   // 8B80 - 8B8F
	 5, 43,  5, 33, 43, 21,  5, 15, 45, 15, 45, 43,  7, 45, 43,  7,   // 8B90 - 8B9F
	43, 17,  7, 11, 33, 17, 17, 15, 37, 33, 35, 31, 37, 41, 43, 41,   // 8BA0 - 8BAF
	17, 33, 17, 15, 27, 17, 43, 25, 41,  9, 21, 41, 35, 11, 35, 11,   // 8BB0 - 8BBF
	17, 45, 13, 15, 29, 45, 45, 41, 45, 35, 45,  7, 45,  5, 31, 45,   // 8BC0 - 8BCF
	 3, 43, 43, 19, 21, 35, 13, 35, 17, 15,  5, 45, 35, 15,  7, 13,   // 8BD0 - 8BDF
	31, 13, 41, 43, 45, 13, 41,  5, 15, 41, 45, 17, 39, 43, 31, 39,   // 8BE0 - 8BEF
	13, 43, 15, 19, 35, 35,  9, 31, 45, 45, 25,  7, 45, 11, 19, 39,   // 8BF0 - 8BFF
	43, 35, 35,  7,  5, 21, 45, 35, 37, 35, 43, 23,  5,  7, 15, 17,   // 8C00 - 8C0F
	41, 41, 43, 39,  9, 43, 41,  5, 45,  1, 43,  7, 23, 29, 41, 23,   // 8C10 - 8C1F
	 7, 35, 41, 43,  3, 35, 31, 23, 17, 23, 45, 17, 23, 37, 17, 31,   // 8C20 - 8C2F
	21, 29, 17, 43, 31, 45,  5, 13, 31, 15, 43, 17, 15, 15, 15, 31,   // 8C30 - 8C3F
	41, 15, 21, 15,  7, 21,  7, 17, 31,  5, 11,  7, 39,  3, 35, 41,   // 8C40 - 8C4F
	11, 45, 45, 43, 43, 35,  5, 15, 37, 43, 37, 43, 17,  3, 15,  9,   // 8C50 - 8C5F
	 5, 41, 15, 17, 19, 13, 31, 11, 41,  3, 15, 43, 45, 17, 11, 41,   // 8C60 - 8C6F
	15, 39, 15,  3,  7, 45, 11, 43, 45,  3,  5, 15, 29, 25, 29, 13,   // 8C70 - 8C7F
	 7, 43,  7, 23, 35, 41, 15, 19, 15, 15, 23,  1, 23, 21, 25,  3,   // 8C80 - 8C8F
	43, 17, 37, 23, 29, 41,  9, 17, 23,  5, 37, 15, 31,  3, 45, 43,   // 8C90 - 8C9F
	11,  5, 13, 37, 43, 15, 39, 29, 15, 11, 37, 13, 45, 45,  9, 45,   // 8CA0 - 8CAF
	35,  3, 45,  9, 13, 29,  3, 23,  7, 35, 19, 11, 37, 43,  5, 23,   // 8CB0 - 8CBF
	15,  3, 21, 21, 15, 13, 29, 45, 17, 41, 45, 17, 13, 45, 17, 43,   // 8CC0 - 8CCF
	41, 45, 35,  3,  3, 31, 35,  5, 45, 45, 21, 45, 35,  5, 35, 37,   // 8CD0 - 8CDF
	29, 13, 41, 23, 17, 35, 11,  7,  5,  5, 45, 17, 45,  7, 17, 41,   // 8CE0 - 8CEF
	35, 43,  3, 45, 21, 11,  5, 17, 35,  1, 45, 11, 13, 35, 45, 21,   // 8CF0 - 8CFF
	39,  3,  5, 45, 45, 45,  3, 43, 45, 37, 45, 43, 45, 35, 39, 43,   // 8D00 - 8D0F
	17, 13, 41, 45,  3,  7, 35, 43, 45, 41, 21, 13, 45,  3, 45, 11,   // 8D10 - 8D1F
	43, 13,  5, 45, 41,  3, 45, 15, 45, 11, 37, 29,  3, 13, 45, 13,   // 8D20 - 8D2F
	 9, 17,  3, 35, 37, 13, 19,  7, 23, 11, 15, 43, 45, 45, 17, 15,   // 8D30 - 8D3F
	45, 21, 21, 45, 45, 13, 17, 31, 45, 21, 35, 11,  7, 17, 35, 35,   // 8D40 - 8D4F
	 5,  3, 45, 13, 29,  7, 21, 11, 45, 11, 45, 35, 45, 43, 45, 43,   // 8D50 - 8D5F
	45, 35, 43, 13,  5, 41, 35, 25, 41, 41,  5, 15,  5, 45, 41, 37,   // 8D60 - 8D6F
	45, 45, 21, 17, 11, 45, 13, 31, 35, 31, 31, 41,  5, 17, 31,  5,   // 8D70 - 8D7F
	 5,  5,  5,  7, 17,  5,  7, 35, 45, 45, 43, 31, 17,  5,  5, 13,   // 8D80 - 8D8F
	41, 45, 37,  7, 21, 13, 35,  5, 41, 45, 35, 43, 17, 17, 31, 37,   // 8D90 - 8D9F
	 5,  5, 21, 31,  7, 31, 45, 37, 31,  5, 15, 31, 31, 43, 45, 43,   // 8DA0 - 8DAF
	45, 45, 45, 45, 29,  3, 19, 15,  7, 17, 11,  5, 17, 11, 45, 37,   // 8DB0 - 8DBF
	43, 29, 31, 43, 31, 37, 37, 43, 25, 21, 23,  3,  7, 19, 37, 17,   // 8DC0 - 8DCF
	 5, 29, 31, 45, 17,  7, 45, 11, 29, 17, 35,  3, 25, 17, 21, 13,   // 8DD0 - 8DDF
	43, 17,  7, 41, 17,  7,  5, 31, 19, 45, 13, 31, 19, 41,  5, 21,   // 8DE0 - 8DEF
	 3, 45, 17, 37,  5, 17,  7, 31,  3, 41,  7, 17, 17, 17, 35, 37,   // 8DF0 - 8DFF
	 5, 41, 25, 41,  3, 41, 31, 23, 35, 21, 43, 17,  5, 41, 45, 37,   // 8E00 - 8E0F
	17, 31, 39, 39,  5, 17, 17, 25, 17, 17, 21, 21, 21, 15, 17,  5,   // 8E10 - 8E1F
	39, 31, 37,  3, 45, 31, 31,  5, 45,  5, 45, 29, 45, 45,  7, 45,   // 8E20 - 8E2F
	43,  7,  7,  5, 43, 45,  7, 45,  5,  5, 17, 13, 37, 17, 11, 45,   // 8E30 - 8E3F
	 7, 29, 33, 25, 37,  5, 37, 17,  7,  5, 41, 37, 31, 45,  7, 37,   // 8E40 - 8E4F
	17, 25, 29, 21, 45,  3,  5, 21, 21,  5, 37,  7, 35, 41, 19, 17,   // 8E50 - 8E5F
	45, 31,  7, 23, 45, 21,  3, 45, 25,  3, 37, 17,  7,  5, 41, 11,   // 8E60 - 8E6F
	 5, 45,  7,  3,  5, 45, 17, 17, 21, 37, 31, 31, 29, 21,  7,  5,   // 8E70 - 8E7F
	19, 45, 37,  3,  3, 45, 17,  5, 31,  7,  5, 17, 39, 43, 25, 21,   // 8E80 - 8E8F
	21, 45, 21, 45,  5,  5,  7, 39, 21, 21, 41, 39, 45, 21, 41, 33,   // 8E90 - 8E9F
	41, 25, 37, 31, 17,  5, 45, 41, 19, 17, 21, 35, 13,  7, 45, 31,   // 8EA0 - 8EAF
	37,  7,  7, 13, 21, 45, 21,  1, 17, 17, 37, 45, 45, 43, 45, 19,   // 8EB0 - 8EBF
	31, 21, 21,  7, 45, 45, 37,  7, 45, 43,  5, 43, 13, 17, 39, 43,   // 8EC0 - 8ECF
	41,  7, 41, 11, 33, 35, 31, 35, 37,  5,  7,  9, 25, 31, 23, 33,   // 8ED0 - 8EDF
	33, 31, 45, 15, 15, 31, 15,  7, 21,  7,  1, 45, 11, 19,  1, 29,   // 8EE0 - 8EEF
	 3, 13, 13, 29, 45, 33,  9,  3, 45, 45, 43, 19, 43, 31, 35, 29,   // 8EF0 - 8EFF
	 9, 31, 17, 17, 13, 21, 19, 31, 45, 45, 45, 17, 21, 43, 35, 43,   // 8F00 - 8F0F
	15, 43, 45, 39, 11, 31, 45, 25, 21, 45, 45, 21, 45, 15, 39,  5,   // 8F10 - 8F1F
	13, 19, 43, 29, 31, 13, 25, 29, 13,  3, 21, 29, 21, 33, 33, 17,   // 8F20 - 8F2F
	43, 41,  5,  5,  5, 13, 43, 15, 35, 11, 45, 11, 39,  3, 45, 43,   // 8F30 - 8F3F
	39, 37, 13, 45, 41, 43, 21, 17,  5, 45, 39, 15, 45,  5, 17, 45,   // 8F40 - 8F4F
	29, 21, 11, 11, 21, 13, 35, 19, 15, 43, 17,  7,  9, 43, 41, 15,   // 8F50 - 8F5F
	21, 29, 21, 21, 21, 21,  5, 43, 13, 41,  7, 33, 45,  9, 21, 33,   // 8F60 - 8F6F
	15, 13, 19, 21, 45, 45, 43, 15, 45, 21, 43, 31, 35, 45, 45, 17,   // 8F70 - 8F7F
	45, 31, 21, 17, 45, 11, 21, 25,  3, 15, 13, 39, 21,  5, 45,  5,   // 8F80 - 8F8F
	11, 17, 39, 35, 29, 43, 41, 45, 21, 45, 21, 41, 13,  5,  5, 29,   // 8F90 - 8F9F
	45,  3, 21, 21,  5, 41,  3,  3,  3,  3, 45,  3,  3,  5,  3,  3,   // 8FA0 - 8FAF
	 5, 33, 25, 25, 45,  5,  5, 45, 33,  3,  3, 45, 45, 21,  7,  5,   // 8FB0 - 8FBF
	13, 31, 43, 43, 31, 41, 43, 13, 23, 31, 45, 39, 45, 45, 43, 37,   // 8FC0 - 8FCF
	43, 17, 15, 43, 11, 39, 37,  9, 15, 45, 45, 17, 43, 39, 21,  5,   // 8FD0 - 8FDF
	 5, 25, 37, 45, 43, 17, 17,  5,  7,  9,  7, 29, 39,  7, 45, 37,   // 8FE0 - 8FEF
	35, 37, 45, 17, 15, 37, 43, 23,  3, 17, 25, 43, 17, 45, 21, 41,   // 8FF0 - 8FFF
	37, 35, 35, 37, 29, 15, 25,  7, 17, 41, 41,  3, 43, 41, 31, 37,   // 9000 - 900F
	45, 31,  7,  7, 37, 17, 37,  7, 43, 45, 37, 13, 39, 35,  5, 35,   // 9010 - 901F
	45, 31, 11, 21, 35, 15, 21, 45, 45,  3,  5, 17,  3, 15,  7, 21,   // 9020 - 902F
	43, 45, 17, 43,  5, 19, 39, 37, 43,  7, 43, 21,  3, 25, 43,  7,   // 9030 - 903F
	35,  7, 35, 43,  5,  5, 37, 43, 35, 45, 43, 43,  9,  3, 13,  9,   // 9040 - 904F
	41, 15, 31,  7,  7, 39, 45, 43, 13, 43,  5, 21, 41, 37,  7,  5,   // 9050 - 905F
	43, 35, 37, 31, 45, 43, 13, 45,  1, 35,  5, 35, 35, 45, 45,  7,   // 9060 - 906F
	45, 21,  5,  5, 21, 45, 33, 31, 41, 43, 43, 39, 21, 17, 35,  3,   // 9070 - 907F
	43, 23, 41, 35, 15, 45,  7,  9, 23,  3,  3, 21, 21, 43, 43, 21,   // 9080 - 908F
	21, 43, 37,  7, 31, 43, 35, 15, 43, 23, 33, 31, 45, 19, 11, 19,   // 9090 - 909F
	 3, 11, 41, 25, 45, 35,  3, 43,  5, 15, 41,  3, 39, 17, 43, 15,   // 90A0 - 90AF
	37, 31,  3, 29,  3, 35,  3, 39,  7, 45, 43, 21, 19, 13, 45, 35,   // 90B0 - 90BF
	19, 43, 13, 15, 31, 45, 17, 41, 15, 41, 17, 41, 13, 25, 21, 17,   // 90C0 - 90CF
	19, 45, 21, 43, 43,  5,  7, 41, 21, 11, 39, 11, 13, 15, 21, 17,   // 90D0 - 90DF
	13, 17, 43,  3, 41,  3, 21, 43,  3, 41, 31, 29, 31, 13, 45, 37,   // 90E0 - 90EF
	45, 29, 21, 25,  5, 43,  3, 41,  7, 17, 43, 31, 43,  7, 43, 23,   // 90F0 - 90FF
	33,  3,  9, 43, 17, 43, 43, 15, 19, 41, 41, 35, 37, 23, 41, 33,   // 9100 - 910F
	 5, 45, 45, 17, 39, 41, 43, 15, 43,  3, 23,  5, 11, 21, 43, 45,   // 9110 - 911F
	15, 31, 43, 45, 11, 39, 41,  7,  3, 41,  3,  5, 39, 45, 23, 35,   // 9120 - 912F
	21, 29,  7, 23, 43,  5, 19, 11, 23, 45, 19, 21, 45,  5, 43, 31,   // 9130 - 913F
	43,  5,  5, 21, 15, 41, 11, 45, 21, 43,  7, 31, 45, 29, 45, 43,   // 9140 - 914F
	13, 43, 17, 43, 45, 23,  7, 41, 37, 45, 11, 45, 45, 43, 37, 37,   // 9150 - 915F
	31, 37, 45, 15, 13, 35, 11,  5,  7, 23, 21,  5,  5, 43, 37, 45,   // 9160 - 916F
	41, 17,  5, 43, 37, 17, 23, 19, 35, 21, 29, 45, 15, 43, 35, 25,   // 9170 - 917F
	39, 21, 21, 43, 37, 29, 45,  5, 37, 45,  5,  5, 19, 37, 41,  7,   // 9180 - 918F
	15, 41, 41, 37, 31,  5, 43, 11, 19, 35, 23, 31,  5,  5, 43, 43,   // 9190 - 919F
	 1, 45, 15, 37, 17, 29, 21, 43, 21, 45, 21, 43, 17,  3, 17, 41,   // 91A0 - 91AF
	37, 11, 25, 43, 21, 17, 43, 43, 25, 33, 41,  5, 43, 21, 23, 23,   // 91B0 - 91BF
	25, 41, 17, 35, 23, 43,  3,  5, 35, 43, 35, 35, 21, 45, 43, 21,   // 91C0 - 91CF
	21, 17, 17, 13, 43, 21,  7, 45,  7, 21, 31, 15, 11, 45, 45,  3,   // 91D0 - 91DF
	21, 11, 25,  7, 35, 31, 19,  5, 45, 11, 43, 15, 15, 13, 31, 23,   // 91E0 - 91EF
	17,  7, 35, 41, 43,  5, 37, 37, 41, 25, 31, 45, 17, 29, 43, 43,   // 91F0 - 91FF
	 3, 11,  5, 17, 37, 43, 43, 11,  3, 25, 41,  9, 17,  7, 13, 43,   // 9200 - 920F
	31,  3, 17, 33,  5, 25, 11, 43, 43, 31, 29, 13, 15, 43, 17, 35,   // 9210 - 921F
	43, 45, 25, 13, 33, 15, 37, 19, 45, 21, 45, 45,  7, 45, 25, 37,   // 9220 - 922F
	35, 23, 13, 19, 21,  3, 43, 13,  3, 29, 43, 35, 45,  3, 43,  7,   // 9230 - 923F
	17, 45, 35, 35, 37, 17, 45, 37, 37, 41, 45,  3, 15,  3, 35,  5,   // 9240 - 924F
	35,  3, 45,  5, 45, 29, 37, 31, 11, 45, 21, 31, 11, 21, 43, 29,   // 9250 - 925F
	43,  3,  3, 17, 13, 35, 45, 23, 25, 41,  7, 17, 23, 37, 35, 43,   // 9260 - 926F
	35, 19, 19,  3, 17, 37, 41, 15, 17,  5,  9, 13,  3, 35, 23, 17,   // 9270 - 927F
	43, 17, 45,  5, 35, 37, 23, 21, 17, 43, 41, 33,  5, 45, 31, 35,   // 9280 - 928F
	 5, 41, 41, 31, 29, 43, 45, 15, 23, 19, 43, 41, 41, 41, 17,  5,   // 9290 - 929F
	21, 17, 43, 33, 23, 43, 43, 13,  1,  7, 43, 35, 19, 31, 21, 45,   // 92A0 - 92AF
	 1,  7, 15, 33, 35, 19, 31, 41, 45, 41, 45, 37,  5, 13, 13, 45,   // 92B0 - 92BF
	 7, 21, 23, 21, 39, 41, 43,  3, 39, 35, 43,  5, 37,  3, 15, 17,   // 92C0 - 92CF
	15,  5, 11,  5, 39, 45, 35, 41, 39, 39, 37, 13, 45, 21, 41, 31,   // 92D0 - 92DF
	35, 15, 45, 43,  5, 45, 17, 41,  9, 23, 29, 21, 35, 33,  5, 13,   // 92E0 - 92EF
	21, 37, 45, 45, 45, 37, 21, 45, 17,  5, 43, 17, 13,  7, 37,  5,   // 92F0 - 92FF
	21, 13, 21,  3, 21, 21, 31, 29, 17, 23, 45, 29,  1, 29, 41, 43,   // 9300 - 930F
	45, 21,  1, 19, 37, 19,  7, 39,  5, 45, 45,  3, 25,  5,  5, 37,   // 9310 - 931F
	 7, 31, 31, 45, 31, 43, 17, 13, 23,  5,  7, 41, 21, 37, 13,  5,   // 9320 - 932F
	35, 45, 21, 23, 21, 15,  3, 13, 21, 19, 45, 45, 25, 39, 45, 45,   // 9330 - 933F
	 7, 41, 45, 15, 21, 45, 23, 19, 43,  7, 21, 13, 41,  7, 37, 39,   // 9340 - 934F
	 5, 11, 33, 17,  9, 33,  5, 37, 45, 15, 43,  7, 41, 43, 19, 41,   // 9350 - 935F
	15, 39, 11, 45,  5, 31, 35, 15, 19, 25, 23, 31, 31, 15, 45, 15,   // 9360 - 936F
	15, 43, 23, 17,  7, 17, 35, 19, 15, 41, 45, 17, 45,  3, 45, 45,   // 9370 - 937F
	41, 43, 23, 29,  1, 17, 45, 23,  5, 37,  3, 41, 21, 35, 41, 21,   // 9380 - 938F
	45, 43, 25, 39, 33, 37, 35, 31, 13, 35,  5,  3, 29, 37,  3, 35,   // 9390 - 939F
	13, 45, 39, 43, 15, 37, 21, 19, 35, 35, 35, 39, 15, 45, 45, 21,   // 93A0 - 93AF
	43, 43, 37, 25, 41, 17, 13, 23, 17, 33, 45, 35, 45, 45, 45, 25,   // 93B0 - 93BF
	21, 35, 19, 45, 37, 41, 13, 41, 21, 35,  1, 23, 23, 21,  3, 39,   // 93C0 - 93CF
	21,  7, 31, 15, 43, 21,  1, 19, 31,  5, 31,  5, 37, 23, 43,  5,   // 93D0 - 93DF
	11, 17,  3, 35, 21, 41,  5, 21, 45, 17,  5, 21, 41, 41, 19, 45,   // 93E0 - 93EF
	 3, 45, 45, 45, 21, 15, 17, 29, 15, 31, 29, 21, 35, 41, 35,  5,   // 93F0 - 93FF
	19, 35, 21, 25, 15, 29, 35, 11, 31,  5, 43, 37, 41, 17, 17, 45,   // 9400 - 940F
	21, 17, 21,  7, 37, 45, 17, 17, 45,  7, 21, 43,  7, 17, 25, 37,   // 9410 - 941F
	29, 37, 45, 45,  7, 35, 19, 17, 11, 35, 21, 17, 15, 43, 21, 45,   // 9420 - 942F
	31, 31, 45, 21,  3, 37, 15, 43,  7, 13,  7, 17, 11,  7,  3, 43,   // 9430 - 943F
	 1,  7, 41,  7, 45, 15, 45, 17, 25, 37, 15, 31,  3, 43, 19, 25,   // 9440 - 944F
	41, 17, 17, 31,  5, 45, 23, 21, 21, 17, 45, 19, 35, 29, 21,  7,   // 9450 - 945F
	35,  5, 21,  3,  3, 21, 45, 45, 21,  9, 21, 41, 17, 21,  3, 17,   // 9460 - 946F
	43,  5, 41, 17, 41, 13,  5, 25, 21,  5, 31, 29, 21, 45, 21, 45,   // 9470 - 947F
	25, 17, 37, 35, 21, 17, 13, 43, 45,  7, 45, 29, 21, 37, 31,  5,   // 9480 - 948F
	35, 35, 11,  7, 23, 25, 43,  5, 41, 13,  3, 37, 17,  7,  5, 45,   // 9490 - 949F
	25,  3, 13,  3, 31, 43, 31, 17, 39, 13, 19, 11, 15, 37, 25,  3,   // 94A0 - 94AF
	43, 31, 45, 31, 13,  3, 19, 29,  3,  3, 43, 45, 23, 37, 17,  7,   // 94B0 - 94BF
	43, 37,  3, 21, 35, 31, 23,  3, 35, 41, 37,  3, 25, 29,  7, 41,   // 94C0 - 94CF
	19, 21,  9, 23, 43, 43,  5, 17, 43, 25, 45,  7, 37, 21,  7, 43,   // 94D0 - 94DF
	19, 45, 45, 41, 37,  7, 41, 15, 31, 35, 15, 43, 13, 23, 45, 35,   // 94E0 - 94EF
	17, 43,  5,  5, 37,  1, 43, 33, 45, 21, 29, 39, 21, 37, 21, 19,   // 94F0 - 94FF
	41, 35, 21, 45,  5, 13, 13,  9, 41,  5, 21, 11, 41, 21, 19, 17,   // 9500 - 950F
	33, 37, 21, 31, 17,  1, 31, 45, 25,  5, 23,  3, 31,  7, 19, 19,   // 9510 - 951F
	 5, 41, 13, 21,  5, 45, 17, 45, 41, 17, 15, 29, 37,  7, 17, 17,   // 9520 - 952F
	23, 45, 31, 43, 19, 31, 35,  9,  5, 31, 45,  7, 35, 15, 15,  1,   // 9530 - 953F
	 7, 23, 21, 45, 11, 23, 23, 45,  3, 13, 25, 37, 17, 25, 25, 21,   // 9540 - 954F
	15,  3, 43, 17,  3, 33,  3, 37, 23, 21,  3, 43, 17,  7, 45, 41,   // 9550 - 955F
	21,  5, 17, 21, 29, 21,  7, 21, 29,  5, 31,  7, 15, 21, 15, 45,   // 9560 - 956F
	21, 43,  5,  3, 21,  5, 41,  5,  5, 17,  1,  7, 31, 21, 23,  5,   // 9570 - 957F
	23, 23, 35, 35, 15, 23, 43,  3, 15,  3, 45, 19, 19,  3, 15, 33,   // 9580 - 958F
	35, 41, 41, 17, 23, 41, 23,  7, 45, 25, 45, 29, 19, 21,  3,  3,   // 9590 - 959F
	33, 15, 13, 13, 15, 11,  5, 15, 13, 23, 45, 19, 21, 21, 37, 35,   // 95A0 - 95AF
	43, 43, 43,  5, 31, 21,  5, 35, 19, 43, 23, 43,  9, 15, 43, 39,   // 95B0 - 95BF
	41, 45, 41, 31, 43, 39,  3,  1, 39, 43, 19, 31, 21,  7, 45, 45,   // 95C0 - 95CF
	37, 25,  7, 19, 15, 31,  5, 13,  7, 31, 19, 37, 13, 29, 19, 41,   // 95D0 - 95DF
	15,  5, 29,  7, 15, 37, 39, 45, 23, 35, 35, 43, 15,  3, 39,  5,   // 95E0 - 95EF
	33, 39, 41, 15, 17, 23, 19, 23, 45, 25, 13, 39, 37, 23, 21, 19,   // 95F0 - 95FF
	11, 13, 15, 19, 17, 43, 21,  7, 43, 43,  5, 41, 39, 15, 43, 43,   // 9600 - 960F
	 5, 21, 31, 15, 19, 31, 15, 37,  7, 31, 19, 15, 11, 11, 21,  7,   // 9610 - 961F
	41, 31, 39, 43, 37, 43, 43,  7,  9, 35,  3, 29, 19, 43, 33, 45,   // 9620 - 962F
	29, 17, 11, 43, 43, 45, 17,  5,  9, 31,  7, 45, 45,  7, 21,  1,   // 9630 - 963F
	37, 37, 29,  3, 11, 17, 21, 21,  5, 41,  7, 21, 23, 17, 35,  7,   // 9640 - 964F
	41,  9, 13, 39, 13, 35, 17, 31, 41,  5, 11,  3, 35, 35, 35, 45,   // 9650 - 965F
	29,  7, 43, 45,  5, 41, 45, 25, 43, 41, 29, 29, 45, 43,  7, 21,   // 9660 - 966F
	43, 17,  5,  5, 29, 21, 37, 41, 21, 45, 41, 43, 45, 43, 33, 35,   // 9670 - 967F
	 5, 43, 43, 43, 37, 43, 21, 39, 39, 25,  7, 35,  1, 15, 17, 35,   // 9680 - 968F
	43, 13, 43, 15, 13, 43, 39, 39,  1, 41, 37, 17, 45,  7,  1, 41,   // 9690 - 969F
	43, 35, 33, 21, 37,  7, 29, 35, 35, 43, 41, 11, 25,  9, 17,  7,   // 96A0 - 96AF
	41, 43, 45, 15, 21, 41, 21, 21, 21, 45, 15, 45, 35, 17, 25, 43,   // 96B0 - 96BF
	31, 43, 31, 43, 41, 43, 17, 13, 15, 45, 13, 17,  5, 43, 17,  5,   // 96C0 - 96CF
	15, 45, 21, 43,  5,  7, 35, 15, 15, 35, 13,  5, 45, 43, 17, 35,   // 96D0 - 96DF
	 5, 21, 21, 25, 41, 45, 17, 17, 43, 43, 41, 25, 11, 35, 23, 39,   // 96E0 - 96EF
	11, 29, 43, 21, 21, 43, 21, 21,  1,  3, 23,  7,  7, 15, 39, 45,   // 96F0 - 96FF
	41, 17, 23,  5, 41, 45, 37, 45, 29, 23, 21, 31,  5, 15, 35, 11,   // 9700 - 970F
	39, 45, 43, 25,  5, 37, 21, 45,  7, 43, 39, 21, 35, 21, 41, 15,   // 9710 - 971F
	43, 23, 23, 43, 21, 23,  3, 39, 39, 19, 43, 41, 43,  1,  7,  7,   // 9720 - 972F
	41, 43, 21, 21,  7, 17, 29, 43,  3, 29, 39, 45, 41, 17, 23, 23,   // 9730 - 973F
	23, 21, 21, 15,  1, 11,  7, 21, 21,  1, 11, 21,  3, 45, 15, 15,   // 9740 - 974F
	 3, 31, 31, 17, 31, 45, 17,  5, 31, 17, 17,  7, 17, 37, 11, 11,   // 9750 - 975F
	19, 23, 23, 23, 29, 43, 37, 15, 43, 13,  7, 33, 17, 33,  7,  7,   // 9760 - 976F
	39, 33, 31, 17, 41, 25,  3, 43, 35, 33, 23, 45,  7,  3, 43, 43,   // 9770 - 977F
	37,  3, 17, 15, 29, 43, 23, 43, 17, 37, 17, 41,  1,  1, 15, 13,   // 9780 - 978F
	13,  7, 31, 37, 39, 43, 35, 37, 31, 41, 19,  3, 37, 45,  3, 19,   // 9790 - 979F
	17, 21, 41, 33,  3, 43, 31, 31, 15, 41, 23, 17, 17,  3,  7, 17,   // 97A0 - 97AF
	45, 37, 13, 37,  3, 41, 29, 13,  3, 19, 37, 21, 13, 31, 41, 17,   // 97B0 - 97BF
	17, 17,  5,  7, 15, 41, 31,  7, 39, 17, 21, 39, 33, 11, 23, 17,   // 97C0 - 97CF
	13, 39, 31, 15,  5, 45, 33, 41, 35, 39, 13,  3, 37, 13, 43, 13,   // 97D0 - 97DF
	 3, 39, 15, 35, 39,  7, 39, 33, 11, 15, 39, 43, 37, 17, 17, 41,   // 97E0 - 97EF
	41, 41, 17, 43, 45, 43, 35, 21, 29, 15, 43, 43, 29, 43, 43, 41,   // 97F0 - 97FF
	15, 43,  7, 31, 29, 41, 35, 15, 41, 43, 41, 13, 35, 19, 31, 15,   // 9800 - 980F
	43, 39,  3,  7,  7,  7, 29, 29, 21,  5, 17, 21, 15, 31,  9,  9,   // 9810 - 981F
	39, 17, 13, 35, 43, 43, 19,  7, 29, 29, 21, 11, 17, 37, 15, 19,   // 9820 - 982F
	17, 21, 37,  5, 43, 17, 15, 15, 17, 37, 37, 29, 21, 37, 45, 45,   // 9830 - 983F
	 5,  7, 21, 43, 15, 31, 19,  5, 17, 31, 43, 35, 37,  9,  9, 43,   // 9840 - 984F
	15, 19, 43, 45, 43, 41, 41, 43, 43, 35,  7,  7, 17, 19, 21, 21,   // 9850 - 985F
	29, 43, 23, 31, 43, 15, 31, 13, 41, 31, 15, 45, 33, 15,  3, 41,   // 9860 - 986F
	29, 21, 21, 25, 31, 43,  7, 31, 15, 41, 35, 41, 41, 39, 13,  7,   // 9870 - 987F
	31,  3, 35, 15, 43, 21, 21, 29, 17, 17, 17, 37, 15, 43, 17, 19,   // 9880 - 988F
	43, 29, 15, 37, 15, 43, 43, 19, 37, 43,  9, 45, 43,  9, 25, 23,   // 9890 - 989F
	 7, 35, 15, 21, 45, 33, 29, 31, 11,  3, 45, 11, 41, 45,  3, 35,   // 98A0 - 98AF
	11, 37, 21, 13, 41, 35, 17,  3, 35, 39, 43, 43, 35, 19, 35, 11,   // 98B0 - 98BF
	21, 41, 21, 29, 29, 21,  3,  3,  3, 21, 45, 35, 11,  3, 11, 43,   // 98C0 - 98CF
	45,  3, 35, 17, 35, 35, 43, 21, 29,  3,  3, 11, 11, 11, 11, 35,   // 98D0 - 98DF
	35,  5, 17,  7, 35, 37, 17, 35, 41, 37, 33, 43, 17,  5, 43, 11,   // 98E0 - 98EF
	11, 35, 43, 45, 43, 45,  3, 17, 37, 21,  5, 37, 35,  3, 35,  7,   // 98F0 - 98FF
	15, 33, 37, 17, 17,  3, 43, 37,  5, 41, 43, 43,  9, 43, 21, 43,   // 9900 - 990F
	 5,  3, 25,  9,  3, 17,  7, 35, 43, 35, 43, 15, 13, 35, 17, 45,   // 9910 - 991F
	 3, 41,  3, 43, 37, 11, 45, 39, 13,  9, 25, 15, 15, 15, 37, 15,   // 9920 - 992F
	17, 15, 15, 41, 11, 39, 13,  5, 35, 37,  3, 13, 41, 19, 21, 35,   // 9930 - 993F
	37, 43, 43, 23, 37, 23,  3, 43, 41, 17, 35, 19, 45, 35,  5,  7,   // 9940 - 994F
	43, 17, 33,  5, 43, 37, 15, 41, 45, 11, 15, 23, 43, 23,  5, 41,   // 9950 - 995F
	21, 45, 25, 35,  7, 17, 37, 41, 37, 41, 33, 43,  5, 11, 43, 17,   // 9960 - 996F
	35,  3, 35,  7, 43,  9, 33, 41, 15, 21, 17, 41,  3,  3,  7,  9,   // 9970 - 997F
	43, 25, 17, 13, 15, 41, 13,  5, 19, 13, 35,  5, 43, 23,  3, 21,   // 9980 - 998F
	41, 17, 23, 35, 45, 25, 35, 19, 13, 41, 11,  3, 25,  3,  3, 37,   // 9990 - 999F
	15, 11, 17, 43,  1, 11, 41, 39, 41, 11,  3, 41, 23, 43, 11, 15,   // 99A0 - 99AF
	 7, 37, 37,  5, 41, 45, 45, 29, 41, 33, 35, 43, 39, 45,  7, 21,   // 99B0 - 99BF
	43,  3,  3, 19, 37, 43, 31, 39, 31, 17,  3, 45, 43, 29, 45, 17,   // 99C0 - 99CF
	45, 25, 17, 29, 45, 17, 21, 45, 37, 11, 43, 35,  3, 37, 37, 35,   // 99D0 - 99DF
	21, 23, 29, 37, 45, 33, 37,  7, 41, 31, 35, 17,  9, 15,  3, 45,   // 99E0 - 99EF
	43, 21, 45,  7, 41, 21, 17, 35, 31, 23, 21, 15, 37, 41, 37, 17,   // 99F0 - 99FF
	 9,  5, 41,  1, 21, 45, 45, 35, 29, 19, 37, 21, 45, 19, 31, 31,   // 9A00 - 9A0F
	43, 11, 35, 43, 17, 43, 39, 29,  5, 29, 31, 11, 15, 17, 15, 43,   // 9A10 - 9A1F
	37, 31, 41, 45, 19, 33, 35, 13, 37, 19, 35, 31,  5, 45, 21, 29,   // 9A20 - 9A2F
	37, 41,  5,  7, 43, 43, 45, 35, 35, 21, 45, 35, 21, 41, 21, 45,   // 9A30 - 9A3F
	23,  1,  5, 29,  5, 31,  3, 45, 43, 41, 15,  3, 35, 41, 21, 45,   // 9A40 - 9A4F
	 7, 21, 37, 45, 37, 17, 37, 43, 21, 45, 17, 43, 43, 37,  3, 45,   // 9A50 - 9A5F
	43, 29, 21, 37, 41, 17, 35, 17, 41, 15, 21,  3, 23, 43, 37, 41,   // 9A60 - 9A6F
	 5, 31, 33,  3, 21, 45, 35, 35, 11, 17, 45, 45, 37, 25, 17, 43,   // 9A70 - 9A7F
	37, 41, 23, 43, 17, 15, 21, 15, 29,  3, 21,  5, 43, 41, 31, 17,   // 9A80 - 9A8F
	31, 31, 19, 45, 45, 35,  5, 29, 45, 19, 35, 39,  1, 21, 31, 35,   // 9A90 - 9A9F
	29, 21,  5, 45, 45, 17, 35, 41, 13, 39, 39, 39, 43, 13, 43,  1,   // 9AA0 - 9AAF
	37, 41,  3,  3,  5, 37,  7, 19, 15, 31, 15, 19, 13, 37, 13, 29,   // 9AB0 - 9ABF
	 3, 19, 31, 43, 35, 21,  3, 41,  3,  3,  5, 19,  3, 23, 21, 21,   // 9AC0 - 9ACF
	25,  7, 45, 35, 37,  3, 19, 21, 13, 13, 31, 19, 31, 21, 45,  3,   // 9AD0 - 9ADF
	19, 19, 37, 11, 41, 33, 23,  7, 19,  3, 11, 37, 29, 45, 11, 33,   // 9AE0 - 9AEF
	37, 29, 29, 23, 11,  9, 33, 31, 45, 41, 13, 17, 29, 45, 35, 35,   // 9AF0 - 9AFF
	37, 21,  3, 45, 37, 29, 35, 45, 31, 45, 35, 17,  7, 15, 21, 17,   // 9B00 - 9B0F
	31, 21, 45,  3, 29, 23, 35, 23, 23, 35, 41, 21, 31, 31, 25, 15,   // 9B10 - 9B1F
	19, 25,  3, 21, 33,  7,  7, 25, 15, 41,  7, 19,  7,  7, 17,  5,   // 9B20 - 9B2F
	43, 43, 21, 17, 11, 31, 13, 45, 21, 13, 35, 43, 13, 23, 17, 31,   // 9B30 - 9B3F
	17, 19, 15,  3, 29, 23, 41, 43, 41, 21, 43, 37, 31, 39, 21, 39,   // 9B40 - 9B4F
	17,  5, 29,  3, 23, 17, 41,  5, 43, 45, 43,  7, 33, 17,  3, 15,   // 9B50 - 9B5F
	37,  7, 17, 43,  9, 31, 35, 15, 37, 23, 13, 35, 11, 43, 29, 21,   // 9B60 - 9B6F
	39, 15, 21, 45, 11, 11, 25, 43, 45, 45, 15, 41, 31, 15, 29, 21,   // 9B70 - 9B7F
	37,  3, 31, 29, 11,  3, 17, 39, 17,  7,  3, 43, 13, 29, 25, 41,   // 9B80 - 9B8F
	37,  3, 11, 45, 17, 13, 45, 45, 45, 37, 17, 35, 15, 41,  9,  1,   // 9B90 - 9B9F
	39, 37, 45, 43, 21, 21, 37, 43, 31,  3, 39, 17, 29, 13, 41, 13,   // 9BA0 - 9BAF
	15, 45, 45, 19, 45,  7, 17, 37, 23, 35, 45, 35, 31, 43, 25, 45,   // 9BB0 - 9BBF
	13, 13, 45, 39, 31, 37, 11, 15,  5, 21, 35, 35, 13, 23, 45, 45,   // 9BC0 - 9BCF
	45, 45, 43, 25, 45, 31, 31, 41, 25,  5, 17,  7, 31, 13, 45,  7,   // 9BD0 - 9BDF
	21, 11, 25, 43, 19, 21, 17,  5, 17, 21, 21, 45, 21, 23, 45, 45,   // 9BE0 - 9BEF
	25, 45, 45, 45, 35, 35, 15, 37, 15, 41, 17, 21, 45, 17,  3,  3,   // 9BF0 - 9BFF
	15, 31, 17, 39, 39, 43,  5, 33,  7, 15, 21, 43, 31, 31, 17,  3,   // 9C00 - 9C0F
	 9, 43, 11, 35, 17, 15, 37, 15, 45, 33, 45, 39, 17, 15, 39, 29,   // 9C10 - 9C1F
	35, 21, 23, 35, 35, 13, 45, 37, 37, 43, 13, 33, 31, 31, 39, 33,   // 9C20 - 9C2F
	45, 21,  1, 21, 15, 23, 17, 37, 31, 17, 35, 23, 41, 31,  3, 17,   // 9C30 - 9C3F
	17, 45, 17, 31, 45, 43, 45, 19, 41,  3, 17, 31, 41,  3, 17, 41,   // 9C40 - 9C4F
	35, 15, 45, 35, 35, 11, 13, 21, 41, 23, 41, 45, 41, 11, 13, 15,   // 9C50 - 9C5F
	19, 45, 35, 45, 13, 13, 35, 21,  5, 45, 45,  1, 33, 17, 41, 15,   // 9C60 - 9C6F
	45, 21, 21, 21, 23, 45, 41,  9, 21, 13, 21, 41, 43,  7, 17, 43,   // 9C70 - 9C7F
	37, 21, 11,  3, 19,  3, 29, 25, 21, 43, 45, 11,  3,  3, 15, 29,   // 9C80 - 9C8F
	37, 13, 17, 19, 39,  9, 37, 45, 15, 19, 17, 17, 41, 45, 41, 41,   // 9C90 - 9C9F
	13, 21, 21, 17, 21, 35, 37, 13, 35, 15, 17, 17, 43, 31, 21, 31,   // 9CA0 - 9CAF
	45, 11, 19,  5, 13, 25, 25,  7, 17, 35, 35, 45, 11,  7,  3,  5,   // 9CB0 - 9CBF
	37, 39, 39, 35,  9, 31, 11, 15, 31, 17,  3, 35,  1, 31, 37, 13,   // 9CC0 - 9CCF
	43, 29, 17, 21,  3, 41,  3, 23, 23, 43, 39, 41, 13, 35, 21, 45,   // 9CD0 - 9CDF
	15, 13, 21, 35, 13, 25, 43, 11, 21, 17,  3, 43, 11,  7, 17, 11,   // 9CE0 - 9CEF
	45, 13, 35, 11, 23,  3, 43, 45, 15, 31, 11, 11, 39, 17, 35, 43,   // 9CF0 - 9CFF
	11, 43, 17, 17, 29, 15, 45,  3, 43, 43, 45, 11, 11, 39, 27, 37,   // 9D00 - 9D0F
	17, 25, 21, 23, 11, 37, 39, 21,  3, 45, 13, 43, 45, 31, 41,  5,   // 9D10 - 9D1F
	 7, 17, 43, 13, 45, 43, 43, 33, 43, 45, 43, 45, 43, 45, 39,  9,   // 9D20 - 9D2F
	13,  1, 45, 43, 15, 17, 17, 21, 45, 33, 37, 15, 21, 33, 23, 13,   // 9D30 - 9D3F
	33, 17, 41, 45,  5, 21, 45, 45, 45, 21, 17, 17, 43, 15, 37,  3,   // 9D40 - 9D4F
	39, 17, 43,  3, 41, 41,  3, 41, 17, 17, 37, 17, 37,  9,  9, 19,   // 9D50 - 9D5F
	15, 39, 35, 21, 45, 45, 21,  3, 35, 11,  1, 45, 29, 31, 31,  3,   // 9D60 - 9D6F
	 7, 21, 31, 17, 17, 37, 43, 43, 31, 21, 43, 45, 19,  7, 19, 35,   // 9D70 - 9D7F
	31, 17, 25,  9, 17, 45, 21,  7, 31,  5, 13, 17, 31, 45, 45, 17,   // 9D80 - 9D8F
	35, 45,  5, 23, 33, 11, 31, 37, 15, 37,  9, 17, 23, 11,  5, 37,   // 9D90 - 9D9F
	43, 15, 43, 29, 43, 23, 15, 43,  7, 23, 17, 45,  5, 11, 13, 43,   // 9DA0 - 9DAF
	43, 41, 39, 35, 15,  5, 37, 41, 33, 21, 17, 13, 17, 45, 15, 45,   // 9DB0 - 9DBF
	 5, 43, 43, 43, 17, 21, 37, 19, 37, 37, 25, 37, 23, 17, 21, 45,   // 9DC0 - 9DCF
	 5, 21, 45, 45,  1, 43, 43, 27,  5, 45, 21, 33, 21,  3, 35, 45,   // 9DD0 - 9DDF
	43, 39, 17, 43, 37, 35, 17, 43, 15,  3, 43, 35, 15, 11, 17, 21,   // 9DE0 - 9DEF
	43, 19, 17, 41, 41, 37, 23, 45, 43, 43, 21, 37, 41, 41, 43, 29,   // 9DF0 - 9DFF
	35, 21, 31, 43, 17, 45, 43, 45, 43, 43, 29, 25, 15, 23, 43, 23,   // 9E00 - 9E0F
	 7, 43, 43, 21,  3, 21, 15, 21, 35, 43, 43, 13, 31, 21, 21, 25,   // 9E10 - 9E1F
	17, 17, 43, 23, 35, 27, 43,  5,  3, 45, 13,  7, 21, 43, 41, 43,   // 9E20 - 9E2F
	21,  5, 31, 43, 41, 37, 35, 45,  9, 13, 41, 15, 45, 13, 21, 15,   // 9E30 - 9E3F
	39,  3, 21, 17, 15,  9, 43, 41, 37, 39, 31, 23,  1, 19,  3, 29,   // 9E40 - 9E4F
	31,  5, 13, 43, 35, 15, 15,  9, 13, 31,  5, 23, 39, 43, 43, 39,   // 9E50 - 9E5F
	21, 17, 43, 17, 15, 43, 43, 45, 21, 21, 17, 17, 43, 21, 15, 45,   // 9E60 - 9E6F
	43, 15, 23, 13, 35, 21, 17, 21, 17, 41,  5, 17, 17, 43,  5, 21,   // 9E70 - 9E7F
	43,  5, 17,  3,  5, 29, 45, 17, 45, 17, 23, 23, 39, 21,  5, 17,   // 9E80 - 9E8F
	21, 25, 31, 21, 17, 17, 17, 21, 41, 43, 17, 23, 21, 35, 45, 21,   // 9E90 - 9E9F
	17, 31, 21, 43,  5, 23, 23, 13,  5, 11, 23, 23, 11, 29, 31, 31,   // 9EA0 - 9EAF
	23, 11, 41, 21, 31, 23,  5, 11, 11, 31, 23, 23, 23, 23, 15, 45,   // 9EB0 - 9EBF
	45, 25, 11, 15, 15, 17, 13, 37, 37, 15, 41, 19, 15, 35, 21, 25,   // 9EC0 - 9ECF
	 5, 15, 15, 43, 31, 45, 41, 37, 23, 23, 31,  7,  5, 43,  7, 43,   // 9ED0 - 9EDF
	41, 43, 31, 23, 43, 31, 43, 21,  7,  7,  5, 43,  1, 43, 37,  1,   // 9EE0 - 9EEF
	45,  7,  5, 43, 23,  7, 43,  7, 21, 45, 11, 11, 11, 23, 23, 43,   // 9EF0 - 9EFF
	 5, 31,  5, 39, 45, 45, 23,  1,  3, 37,  3, 43,  5, 37,  7, 23,   // 9F00 - 9F0F
	25,  7, 45, 13, 13,  7, 11, 37, 43, 29,  5, 13, 31, 43, 37, 37,   // 9F10 - 9F1F
	35, 35, 11, 11, 39,  3,  7, 37, 37, 31, 35, 35, 43, 35, 37, 39,   // 9F20 - 9F2F
	25, 17, 15, 17, 43, 37, 35, 41, 41, 43, 21,  3, 43, 43, 15, 15,   // 9F30 - 9F3F
	39, 15, 41, 13, 45, 41, 39, 45, 25, 25, 31, 45, 17, 45, 17, 17,   // 9F40 - 9F4F
	31, 17,  5,  5,  5, 15, 43, 19, 41,  3, 45, 35, 45,  5, 25, 17,   // 9F50 - 9F5F
	37, 21, 21,  5, 31, 41, 43, 25, 17, 25,  5, 19, 43,  5, 43, 25,   // 9F60 - 9F6F
	 5,  5, 31, 25, 41, 43,  9, 39, 43,  5, 45,  7,  5, 17, 43,  5,   // 9F70 - 9F7F
	 5, 15, 43, 17, 21,  3, 37, 45, 43, 43,  5, 31, 39, 21, 29, 13,   // 9F80 - 9F8F
	29, 43, 21, 21, 13, 19, 37, 21, 37, 21, 13, 19, 13, 31,  3, 13,   // 9F90 - 9F9F
	43,  5, 15, 17, 41, 43,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 9FA0 - 9FAF
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 9FB0 - 9FBF
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 9FC0 - 9FCF
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 9FD0 - 9FDF
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 9FE0 - 9FEF
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 9FF0 - 9FFF
};
