/*************************************************************************
 *
 *  OpenOffice.org - a multi-platform office productivity suite
 *
 *  $RCSfile: indexdata_zh_stroke.h,v $
 *
 *  $Revision: 1.2 $
 *
 *  last change: $Author: rt $ $Date: 2005/09/07 17:15:30 $
 *
 *  The Contents of this file are made available subject to
 *  the terms of GNU Lesser General Public License Version 2.1.
 *
 *
 *    GNU Lesser General Public License Version 2.1
 *    =============================================
 *    Copyright 2005 by Sun Microsystems, Inc.
 *    901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *    This library is free software; you can redistribute it and/or
 *    modify it under the terms of the GNU Lesser General Public
 *    License version 2.1, as published by the Free Software Foundation.
 *
 *    This library is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *    Lesser General Public License for more details.
 *
 *    You should have received a copy of the GNU Lesser General Public
 *    License along with this library; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *    MA  02111-1307  USA
 *
 ************************************************************************/
#include <sal/types.h>

static sal_Unicode idxStr[] = {
	0x0000, // 0 (0)
	0x2488, 0x753B, 0x0000, // 1 (1)
	0x2489, 0x753B, 0x0000, // 4 (2)
	0x248A, 0x753B, 0x0000, // 7 (3)
	0x248B, 0x753B, 0x0000, // 10 (4)
	0x248C, 0x753B, 0x0000, // 13 (5)
	0x248D, 0x753B, 0x0000, // 16 (6)
	0x248E, 0x753B, 0x0000, // 19 (7)
	0x248F, 0x753B, 0x0000, // 22 (8)
	0x2490, 0x753B, 0x0000, // 25 (9)
	0x2491, 0x753B, 0x0000, // 28 (10)
	0x2492, 0x753B, 0x0000, // 31 (11)
	0x2493, 0x753B, 0x0000, // 34 (12)
	0x2494, 0x753B, 0x0000, // 37 (13)
	0x2495, 0x753B, 0x0000, // 40 (14)
	0x2496, 0x753B, 0x0000, // 43 (15)
	0x2497, 0x753B, 0x0000, // 46 (16)
	0x2498, 0x753B, 0x0000, // 49 (17)
	0x2499, 0x753B, 0x0000, // 52 (18)
	0x249A, 0x753B, 0x0000, // 55 (19)
	0x249B, 0x753B, 0x0000, // 58 (20)
	0x249B, 0x753B, 0x4EE5, 0x4E0A, 0x0000, // 61 (21)
};

static sal_uInt16 idx1[] = {
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 0000
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 1000
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 2000
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 3000
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0x0100,   // 4000
	0x0200, 0x0300, 0x0400, 0x0500, 0x0600, 0x0700, 0x0800, 0x0900, 0x0A00, 0x0B00, 0x0C00, 0x0D00, 0x0E00, 0x0F00, 0x1000, 0x1100,   // 5000
	0x1200, 0x1300, 0x1400, 0x1500, 0x1600, 0x1700, 0x1800, 0x1900, 0x1A00, 0x1B00, 0x1C00, 0x1D00, 0x1E00, 0x1F00, 0x2000, 0x2100,   // 6000
	0x2200, 0x2300, 0x2400, 0x2500, 0x2600, 0x2700, 0x2800, 0x2900, 0x2A00, 0x2B00, 0x2C00, 0x2D00, 0x2E00, 0x2F00, 0x3000, 0x3100,   // 7000
	0x3200, 0x3300, 0x3400, 0x3500, 0x3600, 0x3700, 0x3800, 0x3900, 0x3A00, 0x3B00, 0x3C00, 0x3D00, 0x3E00, 0x3F00, 0x4000, 0x4100,   // 8000
	0x4200, 0x4300, 0x4400, 0x4500, 0x4600, 0x4700, 0x4800, 0x4900, 0x4A00, 0x4B00, 0x4C00, 0x4D00, 0x4E00, 0x4F00, 0x5000, 0x5100,   // 9000
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // A000
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // B000
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // C000
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // D000
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // E000
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x5200, 0x5300, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // F000
};
static sal_uInt16 idx2[] = {
	 1,  4,  4,  4,  4,  4,  4,  7,  7,  7,  7,  7,  7, 10,  7, 10,   // 4E00 - 4E0F
	10, 10, 10, 10, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 16, 16,   // 4E10 - 4E1F
	16, 16, 16, 19, 19, 19, 22, 22,  1,  4,  7,  7,  7, 10, 10, 10,   // 4E20 - 4E2F
	10, 13, 19, 22, 25, 28,  1,  4,  7, 10, 10, 13, 13, 19, 25,  1,   // 4E30 - 4E3F
	 1,  1,  4,  4,  4,  7,  7,  7,  7,  7,  7,  7, 10, 13, 13, 10,   // 4E40 - 4E4F
	13, 16, 16, 16, 16, 19, 22, 25, 28,  1,  1,  1,  4,  4,  7,  7,   // 4E50 - 4E5F
	 7,  7, 10, 10, 10, 10, 10, 13, 16, 16, 16, 16, 16, 16, 16, 16,   // 4E60 - 4E6F
	16, 19, 19, 22, 22, 22, 22, 22, 22, 25, 25, 25, 25, 25, 31, 31,   // 4E70 - 4E7F
	31, 34, 37, 37, 37,  1,  4,  7, 10, 16, 19, 22,  4,  7,  7,  7,   // 4E80 - 4E8F
	 7, 10, 10, 10, 10, 10, 10, 13, 16, 16, 16, 22, 19, 22, 22, 22,   // 4E90 - 4E9F
	 4,  7, 10, 10, 16, 16, 16, 16, 19, 19, 19, 22, 22, 25, 25, 25,   // 4EA0 - 4EAF
	25, 25, 25, 28, 34, 34, 37, 37, 46, 61,  4,  4,  7,  7,  7,  7,   // 4EB0 - 4EBF
	10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10,   // 4EC0 - 4ECF
	10, 10, 10, 10, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13,   // 4ED0 - 4EDF
	13, 13, 13, 13, 13, 10, 13, 13, 13, 13, 13, 13, 13, 13, 16, 16,   // 4EE0 - 4EEF
	16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16,   // 4EF0 - 4EFF
	16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16,   // 4F00 - 4F0F
	16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16,   // 4F10 - 4F1F
	16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 19, 19, 19,   // 4F20 - 4F2F
	19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 16, 19, 19, 19,   // 4F30 - 4F3F
	19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 22, 19, 19, 19,   // 4F40 - 4F4F
	19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19,   // 4F50 - 4F5F
	19, 19, 16, 19, 16, 19, 19, 19, 19, 22, 22, 22, 22, 22, 22, 22,   // 4F60 - 4F6F
	22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22,   // 4F70 - 4F7F
	22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22,   // 4F80 - 4F8F
	22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22,   // 4F90 - 4F9F
	22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 25, 25,   // 4FA0 - 4FAF
	25, 25, 25, 25, 25, 25, 25, 25, 25, 22, 25, 25, 25, 25, 25, 25,   // 4FB0 - 4FBF
	25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25,   // 4FC0 - 4FCF
	25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25,   // 4FD0 - 4FDF
	25, 25, 22, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 28,   // 4FE0 - 4FEF
	28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28,   // 4FF0 - 4FFF
	28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28,   // 5000 - 500F
	28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28,   // 5010 - 501F
	28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28,   // 5020 - 502F
	28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28,   // 5030 - 503F
	28, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 28, 31, 31, 31,   // 5040 - 504F
	31, 31, 31, 31, 31, 31, 28, 31, 31, 31, 31, 31, 31, 31, 31, 31,   // 5050 - 505F
	31, 31, 31, 31, 31, 28, 31, 31, 34, 31, 31, 31, 31, 31, 31, 31,   // 5060 - 506F
	31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31,   // 5070 - 507F
	31, 31, 34, 34, 34, 34, 34, 31, 34, 34, 34, 34, 34, 34, 34, 34,   // 5080 - 508F
	34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 31, 34,   // 5090 - 509F
	34, 34, 34, 34, 34, 34, 31, 34, 34, 34, 37, 37, 37, 37, 37, 37,   // 50A0 - 50AF
	37, 37, 34, 37, 37, 37, 37, 37, 37, 37, 37, 37, 37, 37, 37, 37,   // 50B0 - 50BF
	37, 37, 37, 34, 37, 37, 34, 37, 37, 37, 40, 37, 37, 37, 40, 37,   // 50C0 - 50CF
	40, 40, 40, 40, 40, 40, 40, 40, 40, 37, 40, 40, 40, 40, 40, 40,   // 50D0 - 50DF
	40, 40, 40, 40, 40, 40, 40, 40, 40, 40, 40, 40, 40, 40, 40, 40,   // 50E0 - 50EF
	40, 40, 43, 40, 40, 43, 43, 40, 43, 43, 43, 43, 43, 43, 43, 43,   // 50F0 - 50FF
	43, 40, 43, 43, 43, 43, 40, 43, 43, 43, 43, 43, 43, 43, 43, 43,   // 5100 - 510F
	46, 46, 46, 46, 46, 46, 46, 46, 46, 43, 43, 46, 46, 46, 46, 49,   // 5110 - 511F
	49, 49, 49, 46, 49, 49, 49, 49, 49, 49, 49, 46, 49, 52, 52, 52,   // 5120 - 512F
	49, 52, 49, 55, 55, 52, 58, 61, 61, 61, 61, 61, 61, 61, 61,  4,   // 5130 - 513F
	 7, 10, 10, 10, 13, 16, 16, 16, 16, 16, 16, 19, 19, 19, 19, 19,   // 5140 - 514F
	19, 19, 22, 22, 22, 19, 22, 25, 25, 25, 28, 28, 31, 31, 31, 34,   // 5150 - 515F
	34, 37, 40, 46, 58,  4,  7, 10, 16, 22, 25,  4, 10, 10, 10, 10,   // 5160 - 516F
	13, 16, 16, 16, 16, 19, 22, 22, 22, 25, 25, 25, 28, 31, 37, 37,   // 5170 - 517F
	46, 52,  4, 10, 10, 10, 10, 10, 10, 13, 13, 13, 13, 16, 13, 19,   // 5180 - 518F
	22, 25, 25, 28, 28, 31,  4, 10, 10, 13, 13, 16, 16, 19, 22, 25,   // 5190 - 519F
	25, 28, 28, 28, 28, 28, 28, 28, 31, 40, 43,  4, 13, 13, 13, 13,   // 51A0 - 51AF
	16, 16, 16, 16, 16, 19, 19, 19, 19, 19, 19, 19, 22, 22, 22, 22,   // 51B0 - 51BF
	22, 25, 25, 25, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 31,   // 51C0 - 51CF
	31, 31, 34, 34, 34, 34, 34, 37, 40, 43, 43, 43, 43, 46, 46, 49,   // 51D0 - 51DF
	 4,  7,  7,  7, 10, 13, 13, 13, 16, 16, 16, 16, 19, 22, 22, 22,   // 51E0 - 51EF
	31, 34, 34, 40, 40,  4, 10, 13, 13, 13, 13, 13, 16, 22, 25, 34,   // 51F0 - 51FF
	 4,  4,  4,  7,  7, 10, 10, 10, 10, 13, 13, 13, 13, 13, 16, 16,   // 5200 - 520F
	16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 19, 19, 19, 19,   // 5210 - 521F
	19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 22, 22,   // 5220 - 522F
	22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22,   // 5230 - 523F
	22, 22, 22, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25,   // 5240 - 524F
	25, 25, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28,   // 5250 - 525F
	28, 28, 28, 28, 28, 28, 28, 28, 31, 34, 31, 31, 31, 31, 28, 31,   // 5260 - 526F
	31, 31, 34, 31, 34, 34, 31, 37, 37, 37, 37, 37, 37, 37, 37, 37,   // 5270 - 527F
	40, 40, 40, 40, 40, 43, 43, 43, 43, 43, 43, 43, 43, 43, 43, 43,   // 5280 - 528F
	43, 46, 46, 46, 46, 49, 55, 61, 61, 61, 61,  4,  7, 10, 10, 13,   // 5290 - 529F
	13, 13, 13, 16, 16, 16, 16, 16, 16, 19, 19, 19, 19, 19, 19, 19,   // 52A0 - 52AF
	19, 19, 19, 19, 19, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22,   // 52B0 - 52BF
	25, 25, 25, 25, 25, 25, 22, 25, 25, 25, 25, 25, 28, 28, 28, 28,   // 52C0 - 52CF
	28, 28, 31, 31, 31, 31, 31, 31, 31, 28, 31, 34, 34, 34, 34, 34,   // 52D0 - 52DF
	37, 37, 37, 37, 37, 40, 37, 37, 37, 40, 40, 40, 40, 40, 43, 43,   // 52E0 - 52EF
	43, 40, 43, 46, 49, 46, 49, 55, 55,  4,  7, 10, 10, 10, 10, 10,   // 52F0 - 52FF
	10, 10, 10, 13, 13, 13, 13, 13, 16, 19, 22, 22, 22, 25, 28, 31,   // 5300 - 530F
	31, 34, 31, 31, 43,  4, 10, 13, 31, 31,  4, 13, 13, 13, 13, 16,   // 5310 - 531F
	16, 16, 16, 19, 19, 19, 22, 25, 25, 25, 28, 28, 31, 31, 31, 37,   // 5320 - 532F
	40, 40, 40, 43, 46, 49, 55, 58,  4, 10, 10, 19, 22, 25, 31, 28,   // 5330 - 533F
	31,  4,  7,  7,  7, 10, 10, 10, 10, 13, 13, 16, 13, 10, 16, 16,   // 5340 - 534F
	10, 22, 22, 22, 22, 22, 22, 25, 25, 31, 34, 61,  4, 10, 10, 13,   // 5350 - 535F
	13, 13, 13, 19, 19, 22, 22, 22, 28,  4,  7,  7, 10, 13, 13, 13,   // 5360 - 536F
	13, 16, 19, 19, 19, 19, 22, 22, 25, 22, 22, 25, 25, 25, 31, 28,   // 5370 - 537F
	37, 37,  4, 10, 10, 10, 10, 13, 13, 13, 16, 16, 16, 16, 19, 19,   // 5380 - 538F
	19, 19, 22, 22, 22, 22, 25, 25, 25, 25, 25, 25, 28, 28, 28, 28,   // 5390 - 539F
	31, 31, 31, 31, 34, 34, 34, 34, 34, 31, 37, 34, 40, 40, 40, 37,   // 53A0 - 53AF
	40, 43, 40, 46, 55, 61,  4, 10, 10, 10, 13, 13, 13, 16, 16, 19,   // 53B0 - 53BF
	22, 22, 22, 31, 31, 34, 40, 43,  4,  7,  7, 10, 10, 10, 10, 13,   // 53C0 - 53CF
	13, 13, 16, 19, 22, 22, 22, 22, 22, 25, 25, 25, 25, 25, 28, 25,   // 53D0 - 53DF
	37, 46, 52,  7, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13,   // 53E0 - 53EF
	13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 16,   // 53F0 - 53FF
	16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16,   // 5400 - 540F
	16, 16, 16, 16, 16, 16, 16, 16, 19, 19, 19, 19, 19, 19, 19, 19,   // 5410 - 541F
	19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19,   // 5420 - 542F
	19, 19, 19, 19, 19, 19, 19, 19, 16, 19, 19, 19, 19, 19, 19, 19,   // 5430 - 543F
	19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19,   // 5440 - 544F
	19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 22, 22, 22,   // 5450 - 545F
	22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22,   // 5460 - 546F
	25, 22, 25, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22,   // 5470 - 547F
	22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22,   // 5480 - 548F
	22, 22, 22, 19, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 19, 25,   // 5490 - 549F
	25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25,   // 54A0 - 54AF
	25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 22, 25, 25, 25,   // 54B0 - 54BF
	25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 22, 25,   // 54C0 - 54CF
	25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25,   // 54D0 - 54DF
	28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 25, 28, 28, 28, 28, 28,   // 54E0 - 54EF
	28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28,   // 54F0 - 54FF
	28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 25, 28, 28, 28,   // 5500 - 550F
	28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28,   // 5510 - 551F
	28, 28, 28, 28, 28, 28, 28, 28, 28, 31, 31, 31, 31, 31, 31, 31,   // 5520 - 552F
	31, 31, 31, 31, 28, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31,   // 5530 - 553F
	31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 28, 31, 31, 31, 31, 31,   // 5540 - 554F
	31, 31, 31, 31, 31, 31, 31, 31, 31, 34, 31, 31, 31, 31, 31, 31,   // 5550 - 555F
	31, 31, 31, 34, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31,   // 5560 - 556F
	31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 34, 34, 34, 34, 34, 34,   // 5570 - 557F
	34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 37, 31, 31,   // 5580 - 558F
	31, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34,   // 5590 - 559F
	34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 31,   // 55A0 - 55AF
	34, 34, 34, 34, 34, 31, 31, 34, 34, 34, 34, 34, 34, 34, 34, 37,   // 55B0 - 55BF
	37, 37, 37, 37, 37, 37, 37, 37, 37, 37, 37, 37, 37, 37, 37, 34,   // 55C0 - 55CF
	37, 37, 34, 37, 37, 37, 34, 34, 37, 37, 37, 37, 37, 37, 34, 34,   // 55D0 - 55DF
	37, 37, 34, 37, 37, 37, 37, 37, 37, 37, 37, 37, 37, 37, 37, 37,   // 55E0 - 55EF
	37, 37, 37, 37, 34, 37, 37, 37, 37, 37, 40, 40, 37, 40, 40, 40,   // 55F0 - 55FF
	40, 40, 40, 40, 40, 34, 40, 40, 40, 40, 40, 40, 40, 40, 40, 40,   // 5600 - 560F
	40, 40, 40, 40, 40, 40, 40, 40, 40, 40, 40, 40, 40, 40, 40, 37,   // 5610 - 561F
	43, 40, 40, 40, 40, 40, 40, 40, 40, 37, 43, 43, 43, 43, 43, 46,   // 5620 - 562F
	43, 43, 43, 43, 46, 43, 43, 43, 43, 43, 43, 43, 43, 43, 43, 43,   // 5630 - 563F
	43, 43, 43, 43, 43, 43, 43, 43, 43, 40, 43, 43, 43, 43, 43, 43,   // 5640 - 564F
	43, 40, 43, 40, 43, 43, 43, 43, 43, 43, 43, 43, 43, 43, 46, 46,   // 5650 - 565F
	43, 46, 43, 46, 46, 46, 46, 43, 46, 46, 46, 46, 46, 46, 46, 46,   // 5660 - 566F
	46, 46, 46, 46, 43, 43, 43, 46, 46, 46, 46, 46, 46, 49, 49, 49,   // 5670 - 567F
	49, 49, 49, 46, 46, 49, 46, 49, 49, 49, 49, 49, 49, 49, 49, 49,   // 5680 - 568F
	49, 49, 49, 49, 52, 52, 52, 52, 52, 52, 52, 52, 52, 49, 52, 52,   // 5690 - 569F
	52, 52, 52, 52, 52, 55, 55, 55, 55, 55, 55, 55, 55, 55, 49, 55,   // 56A0 - 56AF
	55, 58, 58, 58, 55, 58, 58, 58, 58, 58, 58, 61, 58, 58, 58, 58,   // 56B0 - 56BF
	61, 61, 61, 61, 61, 61, 61, 61, 61, 61, 61, 61, 61, 61, 61, 61,   // 56C0 - 56CF
	61, 61, 61, 61, 61, 61, 61,  7, 13, 13, 13, 13, 13, 16, 16, 16,   // 56D0 - 56DF
	16, 16, 16, 16, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19,   // 56E0 - 56EF
	19, 19, 19, 19, 19, 19, 22, 22, 22, 22, 22, 22, 22, 22, 22, 25,   // 56F0 - 56FF
	25, 28, 28, 28, 28, 28, 28, 31, 31, 31, 31, 31, 34, 34, 34, 34,   // 5700 - 570F
	34, 37, 37, 37, 37, 37, 40, 40, 40, 40, 43, 46, 46, 61, 61,  7,   // 5710 - 571F
	10, 10, 13, 13, 13, 13, 13, 13, 16, 16, 16, 16, 16, 16, 16, 16,   // 5720 - 572F
	16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 19, 19, 19, 16, 19,   // 5730 - 573F
	19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19,   // 5740 - 574F
	19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19,   // 5750 - 575F
	19, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22,   // 5760 - 576F
	22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22,   // 5770 - 577F
	22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 25, 25, 25, 25, 25,   // 5780 - 578F
	25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25,   // 5790 - 579F
	25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25,   // 57A0 - 57AF
	25, 25, 25, 25, 25, 25, 28, 28, 28, 25, 28, 28, 28, 28, 28, 28,   // 57B0 - 57BF
	28, 28, 28, 28, 28, 25, 28, 28, 28, 28, 28, 28, 28, 28, 25, 25,   // 57C0 - 57CF
	28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 31, 31, 31, 31,   // 57D0 - 57DF
	31, 31, 31, 31, 31, 31, 31, 31, 31, 25, 31, 31, 31, 31, 31, 31,   // 57E0 - 57EF
	31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31,   // 57F0 - 57FF
	31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31,   // 5800 - 580F
	31, 31, 31, 31, 31, 31, 34, 34, 34, 34, 34, 34, 34, 31, 34, 34,   // 5810 - 581F
	34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34,   // 5820 - 582F
	34, 34, 28, 34, 34, 31, 34, 34, 34, 34, 34, 34, 34, 37, 34, 34,   // 5830 - 583F
	34, 34, 34, 34, 34, 34, 34, 34, 34, 37, 34, 37, 37, 37, 37, 37,   // 5840 - 584F
	37, 37, 37, 37, 34, 37, 37, 37, 37, 37, 37, 37, 37, 37, 37, 34,   // 5850 - 585F
	34, 37, 37, 37, 37, 37, 34, 37, 37, 37, 37, 37, 37, 34, 37, 37,   // 5860 - 586F
	37, 37, 40, 37, 40, 40, 40, 40, 40, 40, 40, 37, 40, 40, 40, 40,   // 5870 - 587F
	43, 40, 40, 40, 40, 40, 40, 40, 40, 40, 40, 40, 40, 40, 37, 40,   // 5880 - 588F
	40, 40, 40, 37, 40, 40, 40, 40, 40, 40, 40, 40, 40, 43, 43, 40,   // 5890 - 589F
	43, 43, 43, 43, 43, 43, 43, 43, 43, 43, 43, 43, 40, 40, 40, 43,   // 58A0 - 58AF
	43, 43, 43, 43, 40, 43, 43, 37, 40, 43, 43, 46, 46, 46, 46, 46,   // 58B0 - 58BF
	46, 46, 46, 46, 46, 46, 46, 46, 46, 46, 46, 46, 46, 49, 49, 49,   // 58C0 - 58CF
	49, 49, 46, 49, 49, 49, 49, 49, 52, 49, 55, 55, 55, 52, 55, 55,   // 58D0 - 58DF
	55, 55, 55, 58, 58, 58, 58, 61, 61, 61, 61,  7, 10, 13, 16, 19,   // 58E0 - 58EF
	19, 19, 19, 19, 25, 25, 28, 31, 31, 34, 34, 34, 37, 40, 37, 43,   // 58F0 - 58FF
	40, 46,  7, 10, 13, 16, 19, 22, 25, 25,  7, 19, 22, 25, 28, 28,   // 5900 - 590F
	40, 52, 55, 55, 61,  7, 13, 13, 13, 16, 16, 16, 22, 22, 28, 31,   // 5910 - 591F
	31, 34, 37, 40, 40, 40, 43,  7,  7, 10, 10, 10, 10, 10, 13, 13,   // 5920 - 592F
	13, 13, 13, 13, 13, 16, 16, 16, 16, 16, 16, 16, 16, 19, 19, 19,   // 5930 - 593F
	19, 19, 19, 22, 22, 22, 19, 22, 22, 22, 25, 22, 22, 22, 25, 25,   // 5940 - 594F
	25, 25, 25, 25, 22, 25, 25, 28, 28, 28, 28, 31, 31, 31, 31, 31,   // 5950 - 595F
	34, 34, 31, 34, 34, 34, 37, 37, 37, 40, 40, 43, 40, 43, 46, 46,   // 5960 - 596F
	52, 61, 61,  7, 13, 13, 13, 16, 16, 16, 16, 16, 16, 16, 16, 16,   // 5970 - 597F
	16, 16, 16, 16, 16, 16, 16, 16, 16, 19, 19, 19, 19, 19, 19, 19,   // 5980 - 598F
	19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19,   // 5990 - 599F
	19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 22, 22, 22, 22,   // 59A0 - 59AF
	22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22,   // 59B0 - 59BF
	22, 22, 19, 22, 22, 22, 22, 22, 22, 19, 19, 22, 22, 22, 22, 22,   // 59C0 - 59CF
	22, 22, 19, 22, 22, 25, 19, 22, 25, 25, 25, 25, 25, 25, 25, 25,   // 59D0 - 59DF
	25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 28, 25, 25, 25,   // 59E0 - 59EF
	25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25,   // 59F0 - 59FF
	25, 25, 25, 25, 25, 25, 25, 25, 25, 28, 28, 28, 28, 25, 28, 28,   // 5A00 - 5A0F
	28, 28, 28, 28, 28, 28, 28, 25, 28, 28, 28, 28, 25, 28, 28, 28,   // 5A10 - 5A1F
	28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 25, 31, 28, 28, 28,   // 5A20 - 5A2F
	25, 28, 28, 28, 28, 31, 31, 31, 31, 31, 31, 31, 31, 28, 31, 28,   // 5A30 - 5A3F
	28, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31,   // 5A40 - 5A4F
	31, 31, 31, 31, 31, 31, 31, 31, 31, 25, 31, 31, 31, 31, 31, 31,   // 5A50 - 5A5F
	31, 31, 31, 34, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31,   // 5A60 - 5A6F
	31, 31, 28, 31, 31, 31, 31, 34, 34, 34, 34, 34, 31, 34, 34, 34,   // 5A70 - 5A7F
	34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 31, 34, 31, 34,   // 5A80 - 5A8F
	37, 34, 34, 34, 34, 34, 31, 34, 34, 34, 34, 34, 34, 34, 34, 34,   // 5A90 - 5A9F
	34, 34, 34, 34, 34, 34, 34, 31, 34, 34, 34, 34, 34, 34, 34, 34,   // 5AA0 - 5AAF
	37, 37, 37, 37, 37, 37, 34, 37, 37, 37, 37, 37, 37, 37, 37, 34,   // 5AB0 - 5ABF
	37, 37, 34, 37, 37, 34, 37, 37, 37, 37, 37, 37, 37, 37, 37, 31,   // 5AC0 - 5ACF
	37, 37, 37, 37, 37, 40, 40, 40, 40, 40, 40, 40, 40, 40, 40, 37,   // 5AD0 - 5ADF
	40, 40, 40, 40, 40, 40, 40, 40, 40, 40, 40, 37, 40, 40, 40, 37,   // 5AE0 - 5AEF
	40, 40, 40, 40, 43, 43, 43, 40, 43, 40, 43, 43, 43, 43, 43, 43,   // 5AF0 - 5AFF
	43, 43, 43, 43, 43, 43, 43, 43, 43, 43, 43, 43, 43, 43, 43, 43,   // 5B00 - 5B0F
	46, 46, 46, 46, 46, 46, 46, 46, 43, 46, 46, 46, 46, 46, 43, 46,   // 5B10 - 5B1F
	46, 46, 46, 49, 49, 49, 49, 49, 46, 46, 49, 49, 49, 49, 49, 49,   // 5B20 - 5B2F
	49, 49, 49, 46, 46, 49, 49, 49, 52, 55, 49, 52, 52, 55, 55, 55,   // 5B30 - 5B3F
	58, 58, 58, 58, 58, 58, 58, 61, 61, 58, 61, 61, 61, 61, 61, 61,   // 5B40 - 5B4F
	 7,  7,  7,  7, 10, 13, 16, 16, 16, 16, 19, 19, 19, 19, 19, 22,   // 5B50 - 5B5F
	22, 22, 22, 22, 22, 22, 22, 22, 25, 25, 25, 28, 28, 28, 31, 31,   // 5B60 - 5B6F
	31, 34, 31, 34, 37, 40, 34, 40, 46, 46, 49, 49, 55, 55, 58, 61,   // 5B70 - 5B7F
	 7, 13, 13, 13, 13, 16, 16, 16, 16, 16, 19, 19, 19, 19, 19, 19,   // 5B80 - 5B8F
	19, 19, 19, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22,   // 5B90 - 5B9F
	22, 22, 25, 25, 25, 25, 25, 28, 25, 25, 25, 25, 25, 28, 28, 28,   // 5BA0 - 5BAF
	28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 31,   // 5BB0 - 5BBF
	31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 34, 34, 34, 34, 34, 34,   // 5BC0 - 5BCF
	34, 34, 34, 34, 34, 34, 37, 37, 37, 37, 37, 37, 37, 37, 37, 40,   // 5BD0 - 5BDF
	40, 40, 40, 40, 40, 40, 40, 40, 40, 43, 43, 43, 40, 43, 43, 43,   // 5BE0 - 5BEF
	46, 49, 49, 55, 55, 55, 58, 61,  7, 13, 16, 16, 16, 19, 19, 19,   // 5BF0 - 5BFF
	22, 25, 25, 28, 28, 28, 25, 31, 31, 31, 34, 34, 34, 40, 43,  7,   // 5C00 - 5C0F
	10, 10, 13, 13, 13, 13, 16, 16, 16, 22, 22, 25, 25, 25, 34, 37,   // 5C10 - 5C1F
	37, 40,  7, 10, 10, 16, 19, 16, 19, 22, 19, 19, 19, 22, 25, 25,   // 5C20 - 5C2F
	34, 34, 37, 34, 37, 43, 49, 49,  7, 10, 10, 13, 13, 16, 19, 19,   // 5C30 - 5C3F
	19, 19, 19, 19, 22, 22, 22, 22, 22, 22, 22, 25, 25, 25, 25, 25,   // 5C40 - 5C4F
	28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 31, 31, 31, 31, 34, 34,   // 5C50 - 5C5F
	31, 34, 40, 40, 43, 43, 43, 43, 49, 52, 52, 55, 61, 61,  7, 10,   // 5C60 - 5C6F
	16,  7, 10, 13, 13, 13, 13, 13, 16, 16, 16, 16, 16, 16, 16, 16,   // 5C70 - 5C7F
	16, 16, 16, 16, 19, 19, 19, 19, 19, 19, 19, 16, 16, 19, 19, 19,   // 5C80 - 5C8F
	19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 22, 22, 22,   // 5C90 - 5C9F
	19, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22,   // 5CA0 - 5CAF
	22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22,   // 5CB0 - 5CBF
	22, 22, 22, 22, 22, 22, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25,   // 5CC0 - 5CCF
	25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25,   // 5CD0 - 5CDF
	25, 25, 25, 25, 25, 25, 25, 25, 28, 28, 28, 25, 28, 28, 28, 28,   // 5CE0 - 5CEF
	28, 28, 28, 28, 28, 28, 28, 28, 25, 28, 28, 28, 28, 28, 28, 28,   // 5CF0 - 5CFF
	28, 28, 28, 28, 28, 28, 31, 31, 31, 31, 31, 28, 31, 31, 31, 31,   // 5D00 - 5D0F
	31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31,   // 5D10 - 5D1F
	31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31,   // 5D20 - 5D2F
	31, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34,   // 5D30 - 5D3F
	34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 37, 34, 34, 34, 34, 34,   // 5D40 - 5D4F
	34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 37, 37,   // 5D50 - 5D5F
	37, 37, 37, 37, 37, 37, 37, 37, 37, 37, 37, 34, 34, 37, 37, 34,   // 5D60 - 5D6F
	37, 37, 37, 34, 37, 37, 37, 40, 40, 43, 40, 40, 40, 40, 40, 40,   // 5D70 - 5D7F
	40, 40, 40, 40, 40, 37, 40, 40, 40, 40, 40, 40, 40, 40, 40, 43,   // 5D80 - 5D8F
	40, 40, 43, 43, 43, 43, 43, 43, 43, 43, 43, 43, 43, 43, 40, 43,   // 5D90 - 5D9F
	43, 43, 43, 43, 43, 43, 46, 46, 46, 46, 46, 46, 46, 46, 46, 43,   // 5DA0 - 5DAF
	46, 46, 43, 46, 43, 46, 46, 49, 49, 49, 49, 49, 46, 49, 49, 49,   // 5DB0 - 5DBF
	52, 49, 52, 55, 55, 55, 55, 58, 58, 58, 58, 61, 55, 58, 61, 58,   // 5DC0 - 5DCF
	61, 61, 61, 61, 61, 61, 61, 61, 61, 61, 61,  7,  4,  7, 16, 16,   // 5DD0 - 5DDF
	19, 16, 31, 31, 43,  7, 13, 13, 10, 16, 13, 19, 25, 25, 25, 34,   // 5DE0 - 5DEF
	40,  7,  7,  7, 10, 19, 22, 25, 28, 25, 25, 25, 25, 34,  7, 10,   // 5DF0 - 5DFF
	10, 10, 13, 13, 13, 13, 16, 16, 16, 19, 19, 19, 19, 19, 19, 19,   // 5E00 - 5E0F
	19, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 25, 25, 25,   // 5E10 - 5E1F
	25, 25, 25, 25, 25, 25, 25, 25, 28, 28, 28, 28, 28, 28, 25, 28,   // 5E20 - 5E2F
	28, 28, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 34, 31, 34,   // 5E30 - 5E3F
	34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 37, 37, 37, 37, 37, 37,   // 5E40 - 5E4F
	37, 40, 40, 40, 40, 37, 40, 40, 40, 37, 43, 40, 43, 43, 43, 43,   // 5E50 - 5E5F
	43, 43, 43, 40, 43, 43, 46, 46, 46, 43, 46, 49, 49, 49, 52, 46,   // 5E60 - 5E6F
	55, 58,  7, 13, 16, 16, 16, 22, 22, 37,  7, 10, 13, 25, 34,  7,   // 5E70 - 5E7F
	13, 13, 13, 13, 16, 16, 16, 19, 19, 19, 19, 19, 19, 19, 19, 19,   // 5E80 - 5E8F
	19, 19, 19, 19, 19, 22, 22, 22, 22, 22, 22, 25, 22, 22, 22, 22,   // 5E90 - 5E9F
	25, 25, 25, 25, 25, 25, 25, 28, 28, 28, 28, 28, 28, 25, 28, 28,   // 5EA0 - 5EAF
	25, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 34, 31, 31,   // 5EB0 - 5EBF
	34, 34, 34, 34, 34, 37, 34, 37, 37, 37, 31, 34, 37, 37, 40, 40,   // 5EC0 - 5ECF
	34, 40, 37, 37, 40, 37, 40, 40, 40, 40, 43, 43, 40, 43, 43, 43,   // 5ED0 - 5EDF
	43, 43, 43, 40, 43, 46, 46, 46, 46, 46, 46, 52, 55, 55, 58, 58,   // 5EE0 - 5EEF
	58, 61, 61, 61,  4, 13, 16, 16, 19, 19, 22, 22, 22, 25,  7, 10,   // 5EF0 - 5EFF
	10, 13, 16, 19, 19, 19, 22, 25, 25, 28, 40,  7, 10, 13, 16, 16,   // 5F00 - 5F0F
	16, 34, 37,  7, 10, 10, 10, 13, 13, 16, 16, 16, 16, 19, 19, 19,   // 5F10 - 5F1F
	19, 19, 22, 22, 22, 22, 22, 22, 22, 22, 22, 25, 28, 25, 25, 25,   // 5F20 - 5F2F
	28, 28, 28, 28, 31, 31, 31, 31, 31, 31, 34, 34, 34, 34, 34, 37,   // 5F30 - 5F3F
	37, 37, 37, 37, 40, 40, 40, 46, 43, 40, 46, 46, 49, 49, 61, 61,   // 5F40 - 5F4F
	 7,  7, 13, 16, 22, 22, 25, 31, 34, 37, 37, 46, 46, 52, 52, 55,   // 5F50 - 5F5F
	61,  7, 19, 19, 19, 25, 25, 28, 28, 31, 31, 31, 31, 34, 37, 40,   // 5F60 - 5F6F
	40, 43, 61,  7, 16, 16, 16, 19, 19, 19, 19, 19, 22, 22, 22, 22,   // 5F70 - 5F7F
	22, 22, 22, 22, 22, 25, 25, 25, 25, 25, 25, 25, 25, 25, 28, 28,   // 5F80 - 5F8F
	28, 28, 28, 28, 25, 28, 31, 31, 31, 31, 34, 31, 31, 31, 31, 31,   // 5F90 - 5F9F
	31, 34, 31, 31, 31, 34, 34, 34, 34, 34, 34, 34, 37, 37, 37, 37,   // 5FA0 - 5FAF
	37, 40, 43, 40, 40, 43, 40, 43, 43, 43, 43, 46, 46, 49, 49, 55,   // 5FB0 - 5FBF
	58, 58, 61, 10,  7, 13, 10, 13, 16, 13, 13, 16, 19, 19, 19, 16,   // 5FC0 - 5FCF
	19, 19, 19, 16, 16, 16, 16, 19, 19, 16, 16, 16, 19, 22, 22, 19,   // 5FD0 - 5FDF
	22, 19, 22, 16, 19, 22, 19, 19, 19, 22, 19, 19, 19, 19, 19, 19,   // 5FE0 - 5FEF
	19, 19, 19, 19, 19, 22, 19, 19, 19, 19, 19, 19, 19, 22, 19, 22,   // 5FF0 - 5FFF
	19, 22, 22, 19, 19, 19, 19, 19, 22, 22, 22, 22, 22, 22, 25, 22,   // 6000 - 600F
	22, 22, 25, 22, 22, 22, 22, 22, 25, 22, 22, 22, 22, 25, 22, 22,   // 6010 - 601F
	25, 22, 22, 25, 25, 25, 22, 22, 25, 22, 22, 22, 22, 22, 22, 22,   // 6020 - 602F
	22, 25, 22, 22, 22, 22, 22, 25, 25, 25, 22, 25, 25, 22, 22, 22,   // 6030 - 603F
	25, 28, 25, 25, 25, 25, 25, 25, 25, 25, 25, 28, 25, 25, 25, 28,   // 6040 - 604F
	28, 25, 25, 25, 25, 28, 28, 25, 25, 28, 28, 25, 25, 28, 25, 25,   // 6050 - 605F
	25, 25, 25, 28, 25, 28, 25, 28, 25, 28, 25, 25, 25, 28, 25, 28,   // 6060 - 606F
	25, 25, 25, 28, 28, 28, 28, 28, 25, 25, 25, 25, 25, 25, 25, 31,   // 6070 - 607F
	28, 28, 28, 28, 28, 28, 31, 28, 28, 31, 31, 28, 28, 28, 28, 28,   // 6080 - 608F
	31, 28, 28, 28, 28, 28, 28, 28, 31, 28, 28, 28, 28, 28, 28, 28,   // 6090 - 609F
	31, 31, 28, 31, 31, 31, 28, 28, 31, 28, 31, 31, 31, 28, 28, 28,   // 60A0 - 60AF
	31, 31, 34, 34, 31, 31, 34, 31, 31, 34, 31, 31, 31, 31, 31, 31,   // 60B0 - 60BF
	31, 34, 31, 31, 34, 31, 31, 31, 31, 34, 31, 31, 34, 31, 34, 31,   // 60C0 - 60CF
	31, 34, 34, 31, 31, 31, 34, 31, 31, 31, 31, 31, 31, 31, 31, 31,   // 60D0 - 60DF
	34, 34, 34, 34, 31, 34, 31, 31, 31, 34, 34, 34, 31, 31, 31, 31,   // 60E0 - 60EF
	34, 34, 34, 37, 34, 34, 34, 37, 34, 34, 34, 34, 34, 34, 34, 34,   // 60F0 - 60FF
	34, 37, 37, 34, 34, 34, 37, 34, 37, 34, 34, 34, 34, 37, 34, 37,   // 6100 - 610F
	34, 34, 34, 34, 34, 34, 34, 37, 34, 37, 37, 37, 34, 34, 34, 37,   // 6110 - 611F
	34, 34, 34, 34, 34, 31, 34, 34, 40, 37, 37, 37, 40, 37, 37, 37,   // 6120 - 612F
	37, 37, 34, 40, 37, 37, 37, 37, 40, 37, 34, 40, 37, 37, 37, 40,   // 6130 - 613F
	37, 40, 40, 37, 37, 34, 37, 40, 37, 37, 37, 40, 34, 37, 37, 37,   // 6140 - 614F
	40, 37, 40, 40, 37, 40, 40, 43, 40, 43, 40, 40, 43, 40, 40, 40,   // 6150 - 615F
	37, 40, 40, 40, 43, 37, 43, 43, 34, 37, 40, 43, 40, 43, 43, 40,   // 6160 - 616F
	43, 40, 40, 40, 40, 40, 43, 40, 43, 43, 40, 40, 43, 40, 43, 43,   // 6170 - 617F
	40, 40, 43, 43, 43, 43, 40, 43, 40, 43, 46, 43, 46, 43, 43, 40,   // 6180 - 618F
	43, 46, 43, 43, 43, 43, 46, 46, 43, 46, 43, 43, 40, 46, 43, 43,   // 6190 - 619F
	46, 43, 43, 43, 43, 46, 43, 43, 43, 46, 43, 43, 43, 43, 43, 43,   // 61A0 - 61AF
	43, 43, 46, 43, 46, 49, 46, 46, 46, 46, 46, 46, 46, 43, 46, 46,   // 61B0 - 61BF
	46, 46, 43, 49, 46, 46, 46, 49, 46, 49, 43, 49, 46, 46, 46, 43,   // 61C0 - 61CF
	46, 49, 46, 46, 46, 52, 52, 49, 52, 46, 49, 49, 46, 49, 46, 52,   // 61D0 - 61DF
	49, 49, 49, 52, 49, 49, 49, 49, 49, 49, 52, 52, 52, 49, 52, 55,   // 61E0 - 61EF
	52, 49, 55, 52, 52, 52, 55, 55, 58, 58, 58, 55, 61, 58, 61, 61,   // 61F0 - 61FF
	61, 61, 61, 61, 61, 61, 61, 61, 10, 13, 13, 13, 16, 16, 16, 16,   // 6200 - 620F
	16, 19, 19, 19, 22, 22, 22, 22, 25, 28, 31, 31, 31, 31, 34, 34,   // 6210 - 621F
	34, 37, 34, 37, 37, 37, 37, 40, 40, 40, 40, 40, 40, 43, 43, 43,   // 6220 - 622F
	46, 46, 49, 52, 49, 61, 10, 10, 10, 13, 19, 19, 19, 22, 22, 22,   // 6230 - 623F
	22, 25, 25, 25, 28, 28, 28, 28, 31, 34, 34, 10,  7,  7, 10, 13,   // 6240 - 624F
	13, 13, 13, 13, 13, 13, 13, 16, 16, 16, 16, 16, 16, 16, 16, 16,   // 6250 - 625F
	16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 19, 19, 19,   // 6260 - 626F
	19, 16, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 22,   // 6270 - 627F
	19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19,   // 6280 - 628F
	19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19,   // 6290 - 629F
	19, 19, 19, 19, 19, 19, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22,   // 62A0 - 62AF
	22, 22, 22, 22, 22, 22, 22, 22, 19, 22, 22, 22, 22, 22, 22, 22,   // 62B0 - 62BF
	22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22,   // 62C0 - 62CF
	22, 22, 19, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 19,   // 62D0 - 62DF
	22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 25, 25, 25, 25, 25, 25,   // 62E0 - 62EF
	25, 25, 28, 28, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 28,   // 62F0 - 62FF
	25, 25, 25, 25, 25, 25, 25, 25, 28, 25, 25, 25, 25, 25, 25, 25,   // 6300 - 630F
	28, 25, 25, 25, 25, 25, 25, 25, 25, 28, 28, 28, 25, 25, 25, 25,   // 6310 - 631F
	25, 25, 25, 25, 25, 25, 25, 25, 28, 28, 25, 28, 28, 28, 28, 28,   // 6320 - 632F
	28, 28, 31, 28, 28, 28, 28, 25, 28, 28, 25, 25, 28, 28, 28, 28,   // 6330 - 633F
	28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28,   // 6340 - 634F
	28, 28, 28, 25, 28, 28, 28, 28, 28, 28, 28, 25, 28, 28, 28, 28,   // 6350 - 635F
	28, 28, 28, 28, 28, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31,   // 6360 - 636F
	31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31,   // 6370 - 637F
	31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 34, 31, 31, 31,   // 6380 - 638F
	31, 31, 31, 31, 34, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31,   // 6390 - 639F
	31, 31, 31, 34, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31,   // 63A0 - 63AF
	34, 34, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 34, 34,   // 63B0 - 63BF
	34, 34, 34, 34, 34, 37, 34, 34, 34, 34, 34, 34, 34, 34, 34, 31,   // 63C0 - 63CF
	34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34,   // 63D0 - 63DF
	34, 34, 34, 34, 28, 34, 34, 37, 34, 34, 34, 37, 34, 34, 34, 34,   // 63E0 - 63EF
	34, 37, 34, 34, 34, 31, 31, 34, 34, 34, 34, 34, 34, 34, 34, 34,   // 63F0 - 63FF
	34, 34, 34, 34, 34, 34, 37, 37, 37, 37, 37, 37, 37, 37, 37, 37,   // 6400 - 640F
	37, 34, 37, 34, 34, 37, 37, 37, 37, 37, 37, 37, 34, 37, 37, 37,   // 6410 - 641F
	37, 37, 37, 37, 37, 34, 37, 37, 37, 37, 37, 40, 37, 34, 37, 37,   // 6420 - 642F
	34, 37, 37, 37, 40, 37, 37, 37, 37, 37, 37, 40, 37, 34, 37, 40,   // 6430 - 643F
	37, 37, 37, 37, 37, 37, 37, 37, 37, 37, 37, 37, 40, 40, 40, 40,   // 6440 - 644F
	40, 40, 34, 37, 40, 40, 40, 40, 40, 37, 40, 37, 40, 40, 40, 40,   // 6450 - 645F
	40, 40, 34, 40, 40, 40, 40, 40, 43, 43, 40, 40, 40, 40, 40, 43,   // 6460 - 646F
	43, 40, 40, 40, 40, 40, 40, 40, 37, 40, 40, 40, 40, 40, 43, 40,   // 6470 - 647F
	43, 40, 40, 43, 40, 43, 43, 40, 43, 46, 43, 43, 43, 43, 43, 43,   // 6480 - 648F
	43, 43, 43, 43, 43, 43, 40, 40, 43, 43, 43, 43, 43, 43, 43, 43,   // 6490 - 649F
	43, 43, 43, 43, 43, 43, 40, 43, 43, 43, 43, 43, 43, 43, 43, 40,   // 64A0 - 64AF
	43, 40, 43, 43, 43, 43, 37, 43, 43, 43, 43, 43, 46, 46, 40, 46,   // 64B0 - 64BF
	46, 46, 46, 46, 46, 46, 40, 46, 46, 46, 49, 46, 46, 46, 46, 43,   // 64C0 - 64CF
	46, 43, 43, 46, 46, 43, 43, 46, 49, 43, 46, 43, 46, 46, 46, 49,   // 64D0 - 64DF
	49, 49, 49, 49, 49, 52, 49, 49, 49, 49, 52, 49, 49, 46, 49, 49,   // 64E0 - 64EF
	49, 49, 49, 46, 49, 52, 52, 52, 52, 52, 52, 52, 52, 52, 52, 49,   // 64F0 - 64FF
	55, 49, 52, 49, 52, 52, 52, 55, 55, 55, 55, 55, 55, 55, 55, 55,   // 6500 - 650F
	55, 55, 55, 58, 58, 58, 58, 58, 58, 58, 55, 61, 61, 61, 61, 61,   // 6510 - 651F
	61, 61, 61, 61, 61, 61, 61, 61, 61, 61, 61, 61, 61, 61, 61, 10,   // 6520 - 652F
	16, 25, 34, 46, 10, 10, 16, 16, 19, 19, 19, 19, 19, 22, 22, 25,   // 6530 - 653F
	25, 25, 25, 25, 25, 25, 28, 28, 28, 28, 28, 28, 28, 31, 31, 31,   // 6540 - 654F
	31, 31, 31, 31, 31, 31, 28, 31, 31, 31, 31, 31, 34, 31, 34, 34,   // 6550 - 655F
	34, 34, 31, 34, 34, 34, 34, 34, 34, 34, 34, 37, 34, 34, 37, 37,   // 6560 - 656F
	37, 40, 40, 40, 46, 43, 40, 43, 43, 43, 43, 43, 46, 46, 46, 46,   // 6570 - 657F
	49, 49, 49, 49, 55, 58, 58, 10, 19, 22, 28, 28, 34, 31, 31, 31,   // 6580 - 658F
	34, 34, 37, 46, 52, 61, 61, 10, 19, 28, 28, 31, 31, 34, 34, 37,   // 6590 - 659F
	40, 40, 43, 49, 10, 13, 22, 22, 22, 22, 25, 25, 31, 31, 34, 34,   // 65A0 - 65AF
	37, 34, 40, 43, 46, 49, 49, 52, 61, 10, 22, 22, 22, 25, 25, 25,   // 65B0 - 65BF
	25, 28, 28, 28, 28, 28, 28, 31, 31, 31, 28, 31, 31, 31, 31, 31,   // 65C0 - 65CF
	34, 34, 37, 37, 34, 37, 40, 40, 46, 46, 49, 52, 55, 55, 52, 55,   // 65D0 - 65DF
	10, 10, 25, 31, 34, 10, 13, 13, 16, 16, 16, 16, 16, 16, 16, 16,   // 65E0 - 65EF
	19, 19, 19, 19, 19, 19, 19, 19, 19, 22, 22, 22, 22, 22, 22, 22,   // 65F0 - 65FF
	22, 22, 22, 22, 22, 19, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22,   // 6600 - 660F
	22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 25, 22, 25, 25, 25, 25,   // 6610 - 661F
	25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25,   // 6620 - 662F
	25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25,   // 6630 - 663F
	28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28,   // 6640 - 664F
	28, 28, 28, 28, 28, 28, 28, 31, 31, 31, 31, 31, 31, 31, 31, 28,   // 6650 - 665F
	28, 31, 31, 31, 31, 31, 31, 31, 31, 34, 34, 34, 34, 34, 34, 34,   // 6660 - 666F
	34, 34, 34, 34, 34, 34, 34, 34, 37, 34, 34, 34, 34, 34, 34, 34,   // 6670 - 667F
	34, 34, 34, 34, 37, 37, 37, 37, 37, 37, 37, 37, 37, 37, 34, 34,   // 6680 - 668F
	37, 34, 37, 37, 37, 37, 37, 37, 37, 37, 40, 37, 40, 40, 40, 40,   // 6690 - 669F
	40, 40, 40, 40, 40, 40, 40, 40, 40, 43, 43, 43, 43, 43, 40, 40,   // 66A0 - 66AF
	43, 40, 43, 43, 43, 43, 43, 43, 46, 43, 46, 46, 43, 46, 46, 46,   // 66B0 - 66BF
	46, 46, 43, 43, 40, 40, 46, 46, 46, 46, 46, 46, 46, 46, 49, 43,   // 66C0 - 66CF
	49, 49, 49, 49, 46, 49, 49, 49, 52, 49, 49, 52, 52, 55, 52, 55,   // 66D0 - 66DF
	52, 55, 55, 58, 58, 58, 58, 58, 58, 61, 61, 61, 61, 61, 61, 61,   // 66E0 - 66EF
	10, 13, 16, 16, 19, 19, 22, 25, 28, 31, 28, 28, 31, 31, 34, 34,   // 66F0 - 66FF
	34, 34, 34, 37, 40, 40, 46, 61, 10, 16, 22, 22, 22, 22, 25, 25,   // 6700 - 670F
	25, 25, 28, 28, 28, 28, 31, 28, 31, 31, 31, 31, 34, 34, 34, 34,   // 6710 - 671F
	34, 37, 40, 46, 46, 46, 49, 58, 10, 10, 13, 13, 13, 13, 13, 13,   // 6720 - 672F
	13, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16,   // 6730 - 673F
	16, 16, 16, 16, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19,   // 6740 - 674F
	19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19,   // 6750 - 675F
	19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 22, 22, 22, 22, 22, 22,   // 6760 - 676F
	22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22,   // 6770 - 677F
	22, 19, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22,   // 6780 - 678F
	22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22,   // 6790 - 679F
	22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 25, 25,   // 67A0 - 67AF
	25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 28, 25, 25,   // 67B0 - 67BF
	25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25,   // 67C0 - 67CF
	25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 22, 25, 25, 25,   // 67D0 - 67DF
	25, 28, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25,   // 67E0 - 67EF
	25, 25, 25, 25, 28, 25, 25, 25, 25, 22, 25, 25, 25, 25, 25, 25,   // 67F0 - 67FF
	25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25,   // 6800 - 680F
	25, 25, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28,   // 6810 - 681F
	28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28,   // 6820 - 682F
	28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28,   // 6830 - 683F
	28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 25,   // 6840 - 684F
	28, 28, 25, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 25, 28,   // 6850 - 685F
	28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 31, 31, 31, 31, 31,   // 6860 - 686F
	31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31,   // 6870 - 687F
	31, 31, 31, 28, 31, 31, 28, 31, 31, 31, 31, 31, 31, 31, 31, 31,   // 6880 - 688F
	31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 28, 31, 28, 31, 31,   // 6890 - 689F
	28, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31,   // 68A0 - 68AF
	31, 31, 31, 31, 28, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31,   // 68B0 - 68BF
	31, 31, 31, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34,   // 68C0 - 68CF
	34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34,   // 68D0 - 68DF
	34, 34, 34, 34, 34, 34, 28, 34, 34, 37, 34, 34, 34, 34, 34, 34,   // 68E0 - 68EF
	34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 31, 34, 34, 34, 34,   // 68F0 - 68FF
	34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34,   // 6900 - 690F
	34, 34, 34, 34, 34, 34, 34, 34, 31, 34, 34, 31, 34, 34, 34, 34,   // 6910 - 691F
	34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 37,   // 6920 - 692F
	34, 37, 37, 37, 37, 37, 37, 37, 37, 37, 37, 37, 37, 37, 37, 37,   // 6930 - 693F
	37, 37, 37, 37, 37, 37, 37, 37, 37, 34, 37, 37, 37, 37, 37, 37,   // 6940 - 694F
	37, 37, 37, 37, 37, 37, 31, 34, 37, 37, 37, 34, 37, 37, 37, 37,   // 6950 - 695F
	37, 37, 37, 37, 37, 37, 37, 34, 37, 37, 37, 37, 37, 37, 34, 37,   // 6960 - 696F
	34, 37, 37, 37, 37, 34, 37, 37, 37, 37, 37, 37, 37, 37, 37, 37,   // 6970 - 697F
	37, 37, 37, 37, 37, 37, 37, 37, 37, 37, 37, 37, 37, 40, 40, 40,   // 6980 - 698F
	40, 40, 40, 40, 34, 40, 40, 40, 37, 37, 40, 40, 40, 40, 40, 40,   // 6990 - 699F
	40, 40, 40, 40, 40, 40, 40, 40, 40, 40, 40, 40, 40, 40, 40, 40,   // 69A0 - 69AF
	40, 40, 40, 37, 40, 37, 40, 40, 40, 40, 40, 40, 40, 40, 37, 40,   // 69B0 - 69BF
	40, 40, 40, 40, 40, 40, 37, 40, 40, 40, 40, 40, 37, 40, 37, 40,   // 69C0 - 69CF
	37, 40, 40, 40, 40, 40, 40, 40, 40, 40, 40, 40, 40, 40, 40, 40,   // 69D0 - 69DF
	40, 40, 43, 43, 40, 43, 43, 43, 40, 37, 43, 43, 43, 43, 43, 43,   // 69E0 - 69EF
	40, 43, 43, 43, 43, 43, 43, 43, 43, 43, 43, 43, 43, 43, 43, 43,   // 69F0 - 69FF
	43, 43, 43, 40, 40, 43, 40, 40, 43, 43, 43, 40, 43, 43, 43, 43,   // 6A00 - 6A0F
	43, 43, 43, 43, 43, 43, 43, 43, 43, 43, 43, 43, 43, 43, 43, 43,   // 6A10 - 6A1F
	43, 40, 43, 43, 40, 40, 43, 43, 46, 43, 43, 43, 43, 43, 40, 43,   // 6A20 - 6A2F
	43, 43, 46, 46, 46, 46, 46, 46, 46, 46, 40, 46, 46, 46, 46, 46,   // 6A30 - 6A3F
	46, 46, 46, 46, 43, 46, 46, 46, 46, 46, 46, 46, 46, 46, 46, 46,   // 6A40 - 6A4F
	46, 46, 46, 46, 46, 46, 46, 43, 46, 46, 49, 46, 46, 46, 46, 46,   // 6A50 - 6A5F
	46, 43, 43, 46, 46, 43, 46, 46, 46, 46, 46, 46, 46, 46, 46, 46,   // 6A60 - 6A6F
	46, 46, 46, 46, 46, 46, 46, 46, 46, 46, 46, 46, 46, 46, 49, 49,   // 6A70 - 6A7F
	49, 49, 49, 46, 49, 49, 49, 46, 49, 49, 49, 49, 49, 49, 46, 49,   // 6A80 - 6A8F
	49, 49, 49, 49, 49, 49, 46, 49, 49, 46, 49, 43, 49, 46, 49, 49,   // 6A90 - 6A9F
	46, 49, 49, 49, 46, 49, 49, 46, 46, 49, 49, 52, 49, 52, 52, 52,   // 6AA0 - 6AAF
	52, 52, 52, 52, 49, 52, 52, 52, 52, 52, 52, 52, 52, 52, 52, 52,   // 6AB0 - 6ABF
	52, 52, 52, 52, 52, 52, 49, 52, 52, 52, 52, 55, 55, 55, 52, 55,   // 6AC0 - 6ACF
	55, 55, 52, 55, 52, 55, 55, 52, 55, 52, 52, 49, 55, 55, 55, 55,   // 6AD0 - 6ADF
	55, 52, 55, 49, 55, 55, 55, 55, 58, 58, 58, 55, 58, 52, 58, 58,   // 6AE0 - 6AEF
	58, 58, 55, 58, 58, 55, 58, 61, 58, 58, 61, 61, 61, 58, 61, 58,   // 6AF0 - 6AFF
	61, 61, 58, 61, 61, 61, 61, 61, 61, 61, 61, 61, 61, 61, 61, 61,   // 6B00 - 6B0F
	61, 61, 61, 61, 61, 61, 61, 61, 61, 61, 61, 61, 61, 61, 61, 61,   // 6B10 - 6B1F
	10, 16, 16, 22, 19, 22, 22, 22, 25, 25, 25, 31, 28, 28, 28, 28,   // 6B20 - 6B2F
	28, 28, 31, 31, 28, 31, 31, 31, 31, 34, 34, 34, 34, 34, 34, 34,   // 6B30 - 6B3F
	37, 37, 37, 37, 34, 37, 37, 37, 37, 40, 40, 40, 40, 40, 43, 43,   // 6B40 - 6B4F
	43, 43, 43, 43, 43, 46, 46, 49, 46, 46, 46, 49, 49, 49, 52, 49,   // 6B50 - 6B5F
	55, 61, 10, 13, 16, 19, 22, 22, 22, 22, 25, 22, 28, 28, 34, 34,   // 6B60 - 6B6F
	40, 37, 37, 37, 40, 43, 43, 46, 52, 10, 13, 16, 19, 22, 22, 22,   // 6B70 - 6B7F
	22, 22, 25, 25, 25, 25, 25, 25, 28, 28, 28, 25, 31, 31, 31, 31,   // 6B80 - 6B8F
	31, 31, 31, 31, 34, 34, 34, 34, 34, 34, 34, 34, 37, 40, 40, 37,   // 6B90 - 6B9F
	40, 40, 43, 43, 43, 43, 43, 46, 46, 46, 46, 46, 49, 49, 49, 52,   // 6BA0 - 6BAF
	55, 55, 61, 10, 22, 25, 25, 28, 31, 31, 28, 31, 34, 34, 34, 37,   // 6BB0 - 6BBF
	37, 37, 37, 40, 40, 43, 43, 46, 46, 52, 61, 10, 10, 13, 16, 19,   // 6BC0 - 6BCF
	19, 22, 25, 40, 10, 16, 25, 25, 25, 28, 49, 10, 19, 19, 22, 22,   // 6BD0 - 6BDF
	25, 25, 28, 28, 28, 28, 28, 28, 28, 28, 28, 31, 31, 31, 31, 34,   // 6BE0 - 6BEF
	34, 34, 34, 34, 34, 34, 34, 37, 37, 37, 37, 37, 37, 34, 40, 43,   // 6BF0 - 6BFF
	43, 40, 43, 46, 46, 46, 46, 46, 49, 49, 49, 49, 55, 61, 61, 10,   // 6C00 - 6C0F
	13, 13, 16, 22, 10, 13, 16, 16, 16, 19, 19, 22, 22, 22, 25, 25,   // 6C10 - 6C1F
	25, 25, 25, 28, 28, 28, 28, 28, 28, 28, 31, 31, 34, 34, 34, 34,   // 6C20 - 6C2F
	34, 37, 37, 40, 10,  7, 13, 13, 13, 13, 13, 13, 16, 16, 13, 13,   // 6C30 - 6C3F
	13, 13, 19, 13, 13, 13, 16, 13, 13, 13, 16, 16, 16, 16, 16, 16,   // 6C40 - 6C4F
	16, 16, 16, 16, 16, 16, 19, 16, 16, 16, 16, 16, 16, 16, 19, 16,   // 6C50 - 6C5F
	16, 16, 16, 16, 16, 19, 19, 19, 19, 19, 19, 19, 22, 19, 19, 19,   // 6C60 - 6C6F
	19, 19, 16, 19, 19, 19, 19, 16, 19, 19, 19, 19, 19, 19, 19, 19,   // 6C70 - 6C7F
	22, 19, 19, 19, 19, 19, 19, 19, 19, 19, 22, 19, 19, 19, 19, 19,   // 6C80 - 6C8F
	19, 19, 19, 22, 19, 19, 19, 25, 19, 19, 19, 19, 19, 22, 19, 19,   // 6C90 - 6C9F
	19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 22, 22, 22, 22, 25,   // 6CA0 - 6CAF
	22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22,   // 6CB0 - 6CBF
	22, 22, 22, 22, 22, 22, 22, 22, 22, 25, 22, 22, 22, 22, 22, 22,   // 6CC0 - 6CCF
	19, 22, 22, 22, 22, 22, 22, 22, 22, 22, 25, 19, 22, 22, 22, 22,   // 6CD0 - 6CDF
	22, 22, 22, 22, 19, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22,   // 6CE0 - 6CEF
	28, 22, 19, 22, 25, 25, 25, 22, 22, 22, 22, 22, 22, 22, 22, 25,   // 6CF0 - 6CFF
	25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 28, 25, 25,   // 6D00 - 6D0F
	25, 25, 25, 25, 25, 25, 28, 25, 25, 25, 25, 25, 28, 25, 25, 25,   // 6D10 - 6D1F
	25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 28,   // 6D20 - 6D2F
	19, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25,   // 6D30 - 6D3F
	25, 28, 25, 25, 25, 22, 28, 25, 25, 25, 25, 25, 25, 25, 25, 25,   // 6D40 - 6D4F
	25, 25, 25, 25, 25, 25, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28,   // 6D50 - 6D5F
	28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28,   // 6D60 - 6D6F
	28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28,   // 6D70 - 6D7F
	28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 25, 25,   // 6D80 - 6D8F
	28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28,   // 6D90 - 6D9F
	28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 31, 31, 31, 31, 31, 31,   // 6DA0 - 6DAF
	31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31,   // 6DB0 - 6DBF
	31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31,   // 6DC0 - 6DCF
	31, 31, 31, 28, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31,   // 6DD0 - 6DDF
	31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31,   // 6DE0 - 6DEF
	31, 31, 31, 31, 31, 34, 31, 31, 31, 31, 31, 31, 34, 28, 34, 31,   // 6DF0 - 6DFF
	31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31,   // 6E00 - 6E0F
	31, 31, 31, 31, 31, 31, 31, 31, 34, 34, 31, 34, 34, 34, 34, 34,   // 6E10 - 6E1F
	31, 34, 34, 34, 34, 34, 31, 34, 34, 34, 34, 34, 34, 34, 31, 34,   // 6E20 - 6E2F
	34, 34, 34, 34, 34, 31, 31, 34, 34, 34, 34, 34, 34, 34, 34, 34,   // 6E30 - 6E3F
	34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34,   // 6E40 - 6E4F
	34, 34, 34, 34, 34, 31, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34,   // 6E50 - 6E5F
	34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 37, 34, 34, 34,   // 6E60 - 6E6F
	34, 34, 34, 34, 31, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34,   // 6E70 - 6E7F
	34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 37, 37, 37,   // 6E80 - 6E8F
	37, 37, 37, 37, 37, 37, 37, 37, 37, 37, 34, 37, 37, 37, 34, 37,   // 6E90 - 6E9F
	34, 37, 37, 37, 37, 37, 37, 37, 37, 37, 37, 37, 34, 37, 37, 37,   // 6EA0 - 6EAF
	37, 37, 34, 37, 37, 37, 37, 37, 37, 37, 37, 37, 37, 37, 34, 37,   // 6EB0 - 6EBF
	37, 34, 37, 37, 37, 37, 37, 37, 37, 37, 37, 34, 37, 37, 40, 37,   // 6EC0 - 6ECF
	37, 34, 37, 37, 37, 43, 37, 37, 37, 37, 37, 37, 37, 37, 34, 37,   // 6ED0 - 6EDF
	37, 37, 37, 37, 37, 37, 37, 37, 37, 37, 37, 37, 40, 37, 40, 40,   // 6EE0 - 6EEF
	40, 40, 40, 40, 40, 40, 37, 40, 40, 40, 40, 40, 40, 40, 40, 40,   // 6EF0 - 6EFF
	43, 40, 40, 40, 40, 40, 40, 40, 40, 40, 40, 40, 40, 40, 40, 40,   // 6F00 - 6F0F
	43, 40, 43, 37, 40, 40, 40, 40, 40, 40, 40, 40, 40, 40, 40, 40,   // 6F10 - 6F1F
	37, 40, 40, 37, 40, 40, 43, 40, 37, 40, 40, 40, 40, 37, 40, 40,   // 6F20 - 6F2F
	40, 40, 40, 40, 40, 40, 40, 37, 40, 40, 40, 40, 40, 43, 40, 43,   // 6F30 - 6F3F
	40, 43, 40, 37, 40, 40, 40, 40, 40, 40, 40, 40, 40, 40, 40, 43,   // 6F40 - 6F4F
	43, 43, 40, 43, 43, 43, 43, 43, 43, 43, 46, 43, 43, 43, 46, 43,   // 6F50 - 6F5F
	43, 43, 40, 43, 43, 43, 43, 43, 43, 40, 43, 43, 43, 43, 43, 43,   // 6F60 - 6F6F
	43, 43, 43, 40, 40, 43, 43, 43, 43, 43, 43, 43, 43, 43, 43, 43,   // 6F70 - 6F7F
	49, 43, 43, 46, 43, 43, 43, 43, 43, 40, 43, 43, 43, 43, 43, 43,   // 6F80 - 6F8F
	43, 43, 43, 37, 43, 43, 43, 43, 43, 43, 40, 43, 43, 43, 46, 46,   // 6F90 - 6F9F
	46, 46, 46, 46, 46, 46, 46, 46, 46, 49, 46, 43, 46, 46, 46, 46,   // 6FA0 - 6FAF
	46, 46, 46, 43, 46, 46, 46, 46, 46, 46, 46, 43, 46, 46, 43, 46,   // 6FB0 - 6FBF
	46, 46, 46, 46, 40, 46, 43, 46, 43, 46, 46, 46, 49, 43, 43, 46,   // 6FC0 - 6FCF
	43, 46, 46, 46, 49, 49, 46, 46, 49, 49, 49, 46, 49, 49, 49, 49,   // 6FD0 - 6FDF
	49, 49, 49, 49, 49, 49, 49, 49, 46, 46, 49, 49, 49, 46, 49, 49,   // 6FE0 - 6FEF
	49, 49, 49, 55, 49, 49, 49, 52, 46, 49, 52, 49, 52, 52, 52, 49,   // 6FF0 - 6FFF
	52, 49, 52, 52, 46, 52, 52, 49, 52, 52, 52, 52, 52, 52, 49, 52,   // 7000 - 700F
	52, 52, 52, 52, 52, 55, 55, 55, 55, 55, 55, 55, 55, 55, 49, 55,   // 7010 - 701F
	55, 49, 52, 55, 55, 55, 52, 55, 55, 55, 58, 55, 55, 55, 55, 55,   // 7020 - 702F
	58, 58, 58, 55, 58, 58, 58, 58, 58, 58, 58, 58, 58, 58, 58, 58,   // 7030 - 703F
	58, 58, 58, 61, 61, 61, 58, 61, 61, 61, 61, 61, 58, 61, 61, 61,   // 7040 - 704F
	61, 61, 61, 61, 61, 61, 61, 61, 61, 61, 61, 61, 61, 61, 61, 61,   // 7050 - 705F
	61, 61, 61, 61, 61, 61, 61, 61, 61, 61, 61, 10, 10, 13, 16, 16,   // 7060 - 706F
	16, 16, 16, 16, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19,   // 7070 - 707F
	19, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22,   // 7080 - 708F
	22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 25,   // 7090 - 709F
	25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 22, 25, 25, 25,   // 70A0 - 70AF
	25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25,   // 70B0 - 70BF
	25, 25, 25, 25, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 22, 28,   // 70C0 - 70CF
	28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28,   // 70D0 - 70DF
	28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 31,   // 70E0 - 70EF
	31, 31, 31, 31, 31, 28, 28, 31, 31, 31, 31, 28, 31, 31, 31, 31,   // 70F0 - 70FF
	31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31,   // 7100 - 710F
	31, 31, 28, 31, 34, 31, 31, 31, 31, 34, 34, 34, 34, 34, 34, 34,   // 7110 - 711F
	34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 31, 34, 34, 34, 34,   // 7120 - 712F
	34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34,   // 7130 - 713F
	34, 37, 37, 37, 37, 37, 37, 37, 37, 37, 37, 37, 37, 37, 37, 37,   // 7140 - 714F
	34, 34, 37, 37, 37, 40, 37, 37, 37, 37, 34, 40, 37, 37, 37, 37,   // 7150 - 715F
	37, 34, 37, 37, 37, 37, 37, 37, 37, 37, 37, 37, 37, 37, 34, 37,   // 7160 - 716F
	37, 34, 37, 37, 37, 37, 37, 37, 37, 40, 37, 40, 40, 40, 40, 40,   // 7170 - 717F
	40, 40, 40, 40, 40, 40, 40, 40, 40, 40, 40, 40, 40, 37, 40, 40,   // 7180 - 718F
	40, 40, 40, 40, 40, 40, 40, 40, 40, 40, 40, 43, 43, 43, 43, 43,   // 7190 - 719F
	43, 43, 40, 43, 43, 40, 43, 43, 43, 43, 43, 43, 40, 43, 43, 43,   // 71A0 - 71AF
	43, 43, 43, 43, 43, 43, 46, 46, 46, 46, 46, 46, 43, 49, 46, 43,   // 71B0 - 71BF
	46, 40, 46, 46, 46, 46, 46, 46, 46, 46, 46, 46, 46, 46, 46, 46,   // 71C0 - 71CF
	46, 46, 46, 46, 46, 46, 46, 46, 46, 46, 46, 46, 46, 46, 46, 46,   // 71D0 - 71DF
	46, 49, 49, 49, 46, 49, 49, 46, 49, 49, 46, 49, 49, 49, 49, 49,   // 71E0 - 71EF
	49, 49, 49, 49, 49, 46, 49, 49, 52, 52, 52, 52, 52, 52, 52, 52,   // 71F0 - 71FF
	52, 52, 55, 52, 52, 55, 55, 52, 55, 55, 55, 58, 52, 55, 55, 58,   // 7200 - 720F
	58, 55, 58, 58, 58, 55, 58, 52, 58, 61, 61, 61, 61, 61, 61, 61,   // 7210 - 721F
	61, 61, 61, 61, 61, 61, 61, 61, 61, 61, 10, 10, 22, 22, 25, 25,   // 7220 - 722F
	25, 28, 34, 40, 43, 49, 10, 16, 22, 28, 34, 10, 25, 31, 40, 10,   // 7230 - 723F
	22, 25, 28, 37, 40, 43, 49, 10, 22, 25, 25, 34, 34, 34, 37, 37,   // 7240 - 724F
	37, 37, 37, 40, 40, 43, 43, 43, 55, 10, 34, 10, 10, 16, 16, 16,   // 7250 - 725F
	19, 19, 19, 19, 19, 22, 22, 22, 22, 22, 22, 22, 22, 25, 25, 25,   // 7260 - 726F
	25, 25, 25, 25, 25, 25, 28, 28, 28, 28, 28, 31, 31, 31, 31, 31,   // 7270 - 727F
	34, 31, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 37, 34, 37, 37,   // 7280 - 728F
	37, 37, 40, 40, 40, 40, 40, 40, 43, 43, 43, 43, 46, 46, 46, 46,   // 7290 - 729F
	49, 52, 55, 55, 55, 55, 55, 58, 58, 61, 61, 61, 10,  7, 13, 13,   // 72A0 - 72AF
	13, 16, 16, 16, 16, 16, 19, 16, 16, 19, 19, 19, 19, 19, 19, 19,   // 72B0 - 72BF
	22, 19, 19, 19, 19, 19, 19, 19, 19, 22, 25, 22, 22, 22, 22, 22,   // 72C0 - 72CF
	22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 25,   // 72D0 - 72DF
	25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25,   // 72E0 - 72EF
	25, 25, 25, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 25,   // 72F0 - 72FF
	28, 28, 28, 28, 31, 31, 34, 31, 31, 31, 31, 34, 34, 31, 31, 31,   // 7300 - 730F
	28, 31, 34, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31,   // 7310 - 731F
	31, 31, 34, 34, 34, 34, 34, 31, 34, 34, 31, 31, 34, 34, 37, 34,   // 7320 - 732F
	34, 34, 34, 34, 34, 34, 34, 37, 34, 34, 37, 37, 37, 37, 34, 37,   // 7330 - 733F
	34, 37, 37, 40, 40, 37, 37, 34, 37, 37, 37, 43, 40, 40, 43, 37,   // 7340 - 734F
	40, 40, 40, 37, 40, 40, 43, 43, 43, 40, 40, 43, 43, 43, 43, 43,   // 7350 - 735F
	43, 43, 43, 46, 43, 46, 43, 46, 46, 46, 46, 46, 46, 46, 49, 49,   // 7360 - 736F
	49, 49, 46, 49, 46, 52, 52, 49, 55, 55, 55, 58, 58, 58, 58, 61,   // 7370 - 737F
	61, 61, 61, 61, 13, 25, 28, 31, 31, 13, 13, 10, 13, 13, 16, 16,   // 7380 - 738F
	16, 16, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 22, 22, 22, 22,   // 7390 - 739F
	22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22,   // 73A0 - 73AF
	22, 22, 25, 25, 25, 25, 25, 25, 25, 25, 28, 25, 28, 25, 25, 25,   // 73B0 - 73BF
	25, 22, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25,   // 73C0 - 73CF
	25, 25, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28,   // 73D0 - 73DF
	28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28,   // 73E0 - 73EF
	28, 28, 28, 31, 31, 31, 31, 34, 31, 28, 31, 31, 31, 28, 31, 31,   // 73F0 - 73FF
	31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 28, 31, 31, 31, 31, 31,   // 7400 - 740F
	31, 31, 31, 31, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 37, 34,   // 7410 - 741F
	34, 34, 34, 34, 28, 34, 34, 37, 34, 34, 34, 34, 34, 34, 34, 34,   // 7420 - 742F
	34, 34, 34, 34, 34, 34, 34, 31, 34, 34, 34, 34, 34, 34, 37, 37,   // 7430 - 743F
	37, 37, 37, 37, 37, 37, 37, 37, 37, 37, 37, 37, 37, 37, 37, 37,   // 7440 - 744F
	37, 37, 37, 37, 37, 37, 37, 37, 34, 37, 37, 34, 37, 37, 37, 37,   // 7450 - 745F
	40, 40, 40, 40, 40, 37, 40, 40, 40, 43, 40, 40, 43, 40, 40, 34,   // 7460 - 746F
	37, 40, 40, 37, 40, 37, 40, 40, 40, 40, 43, 43, 43, 43, 43, 46,   // 7470 - 747F
	43, 43, 43, 40, 43, 43, 43, 43, 40, 40, 43, 43, 43, 40, 43, 46,   // 7480 - 748F
	49, 46, 46, 40, 46, 46, 43, 49, 46, 46, 46, 49, 43, 46, 46, 46,   // 7490 - 749F
	46, 43, 46, 46, 46, 46, 49, 52, 49, 49, 49, 49, 49, 46, 49, 49,   // 74A0 - 74AF
	49, 49, 46, 49, 49, 49, 52, 55, 52, 52, 58, 52, 52, 55, 52, 52,   // 74B0 - 74BF
	52, 49, 49, 55, 55, 55, 55, 55, 55, 55, 52, 52, 58, 52, 58, 58,   // 74C0 - 74CF
	58, 58, 58, 61, 61, 61, 61, 61, 61, 61, 61, 61, 13, 22, 28, 28,   // 74D0 - 74DF
	31, 37, 46, 55, 61, 61, 10, 16, 19, 19, 22, 22, 22, 22, 22, 22,   // 74E0 - 74EF
	22, 22, 22, 25, 25, 25, 28, 28, 28, 31, 31, 31, 31, 34, 34, 34,   // 74F0 - 74FF
	34, 34, 37, 37, 37, 37, 37, 40, 40, 40, 43, 43, 43, 40, 43, 46,   // 7500 - 750F
	46, 46, 46, 49, 49, 49, 52, 58, 13, 22, 25, 31, 31, 37, 37, 13,   // 7510 - 751F
	25, 28, 31, 31, 34, 34, 34, 40, 13, 13, 16, 19, 19, 25, 25, 34,   // 7520 - 752F
	13, 13, 13, 13, 13, 13, 16, 19, 19, 19, 19, 22, 19, 22, 22, 22,   // 7530 - 753F
	22, 22, 22, 22, 22, 22, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25,   // 7540 - 754F
	25, 25, 25, 25, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28,   // 7550 - 755F
	28, 31, 28, 31, 31, 31, 31, 31, 31, 31, 34, 34, 34, 34, 34, 34,   // 7560 - 756F
	31, 34, 34, 34, 34, 37, 37, 37, 37, 37, 37, 40, 40, 40, 43, 43,   // 7570 - 757F
	46, 46, 46, 49, 49, 52, 55, 55, 58, 58, 61, 13, 22, 28, 34, 34,   // 7580 - 758F
	40, 40, 13, 19, 19, 19, 19, 19, 22, 22, 22, 22, 22, 22, 22, 22,   // 7590 - 759F
	22, 22, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25,   // 75A0 - 75AF
	28, 28, 28, 28, 28, 31, 28, 28, 28, 28, 25, 28, 28, 28, 28, 28,   // 75B0 - 75BF
	28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 31, 31, 31, 31, 31, 31,   // 75C0 - 75CF
	31, 31, 31, 31, 31, 31, 31, 34, 34, 34, 34, 34, 34, 34, 34, 34,   // 75D0 - 75DF
	34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 37, 37, 37, 37,   // 75E0 - 75EF
	37, 37, 37, 37, 37, 37, 37, 37, 37, 37, 37, 37, 37, 37, 34, 37,   // 75F0 - 75FF
	37, 37, 37, 37, 37, 37, 37, 40, 40, 40, 40, 40, 40, 40, 40, 37,   // 7600 - 760F
	37, 37, 40, 40, 37, 40, 40, 40, 40, 40, 43, 43, 43, 43, 43, 40,   // 7610 - 761F
	43, 43, 43, 40, 43, 40, 40, 40, 43, 40, 43, 43, 46, 46, 46, 46,   // 7620 - 762F
	46, 46, 46, 46, 46, 46, 46, 46, 46, 46, 46, 46, 43, 46, 46, 46,   // 7630 - 763F
	46, 49, 49, 46, 49, 49, 49, 49, 49, 49, 43, 49, 49, 49, 49, 52,   // 7640 - 764F
	52, 52, 52, 52, 52, 52, 52, 52, 49, 52, 52, 52, 52, 52, 52, 55,   // 7650 - 765F
	55, 55, 55, 55, 52, 58, 58, 61, 61, 61, 61, 61, 61, 61, 61, 61,   // 7660 - 766F
	61, 61, 61, 61, 61, 61, 13, 22, 25, 25, 25, 34, 34, 13, 16, 16,   // 7670 - 767F
	19, 19, 19, 19, 22, 25, 25, 25, 25, 31, 28, 28, 28, 25, 31, 31,   // 7680 - 768F
	31, 31, 34, 34, 34, 34, 34, 37, 37, 37, 43, 43, 43, 43, 43, 46,   // 7690 - 769F
	46, 46, 49, 43, 49, 49, 52, 52, 52, 55, 58, 58, 61, 61, 13, 22,   // 76A0 - 76AF
	28, 28, 31, 34, 34, 37, 40, 40, 40, 40, 43, 46, 49, 52, 58, 13,   // 76B0 - 76BF
	19, 19, 22, 25, 25, 25, 25, 25, 25, 28, 28, 28, 28, 28, 28, 28,   // 76C0 - 76CF
	28, 28, 31, 31, 31, 31, 31, 31, 31, 34, 34, 31, 34, 37, 37, 37,   // 76D0 - 76DF
	40, 40, 40, 40, 43, 46, 46, 46, 49, 49, 49, 52, 52, 58, 13, 19,   // 76E0 - 76EF
	22, 22, 22, 22, 22, 22, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25,   // 76F0 - 76FF
	25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 28, 28,   // 7700 - 770F
	28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28,   // 7710 - 771F
	28, 28, 28, 28, 28, 31, 31, 28, 25, 28, 28, 28, 28, 31, 31, 31,   // 7720 - 772F
	31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 28,   // 7730 - 773F
	31, 31, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34,   // 7740 - 774F
	34, 34, 37, 37, 37, 37, 37, 37, 37, 37, 37, 37, 37, 37, 37, 37,   // 7750 - 775F
	37, 37, 37, 37, 37, 37, 37, 37, 37, 37, 37, 37, 37, 37, 40, 40,   // 7760 - 776F
	37, 40, 40, 40, 40, 40, 40, 37, 40, 37, 40, 40, 40, 40, 40, 40,   // 7770 - 777F
	40, 40, 40, 40, 37, 40, 40, 43, 43, 43, 43, 43, 43, 40, 43, 43,   // 7780 - 778F
	43, 43, 43, 43, 46, 46, 46, 46, 46, 43, 46, 46, 46, 43, 46, 46,   // 7790 - 779F
	46, 46, 43, 46, 49, 46, 49, 49, 49, 49, 49, 49, 49, 49, 49, 49,   // 77A0 - 77AF
	46, 43, 49, 49, 49, 49, 49, 49, 49, 52, 52, 52, 52, 52, 52, 52,   // 77B0 - 77BF
	52, 52, 52, 55, 55, 55, 52, 52, 55, 55, 55, 55, 55, 58, 55, 58,   // 77C0 - 77CF
	61, 61, 58, 61, 61, 61, 61, 61, 61, 61, 61, 13, 25, 28, 34, 34,   // 77D0 - 77DF
	37, 61, 13, 19, 22, 22, 25, 25, 25, 25, 31, 31, 34, 34, 37, 49,   // 77E0 - 77EF
	49, 52, 58, 13, 19, 19, 19, 22, 22, 22, 22, 22, 22, 22, 22, 22,   // 77F0 - 77FF
	22, 22, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25,   // 7800 - 780F
	22, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 28, 28, 28,   // 7810 - 781F
	28, 28, 28, 28, 28, 28, 31, 28, 28, 28, 28, 28, 28, 25, 28, 28,   // 7820 - 782F
	28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28,   // 7830 - 783F
	28, 28, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31,   // 7840 - 784F
	31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 34, 34, 34, 31,   // 7850 - 785F
	34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 31, 34, 34,   // 7860 - 786F
	34, 34, 34, 34, 34, 34, 34, 34, 37, 37, 37, 37, 37, 37, 40, 37,   // 7870 - 787F
	31, 37, 37, 37, 37, 37, 37, 37, 37, 37, 37, 37, 37, 37, 37, 37,   // 7880 - 788F
	37, 37, 37, 37, 37, 37, 37, 37, 37, 37, 37, 37, 37, 40, 40, 40,   // 7890 - 789F
	40, 40, 37, 40, 37, 40, 40, 40, 40, 40, 40, 40, 40, 40, 40, 40,   // 78A0 - 78AF
	37, 40, 40, 40, 40, 40, 40, 40, 40, 40, 43, 43, 43, 43, 43, 43,   // 78B0 - 78BF
	40, 40, 43, 43, 43, 43, 40, 43, 40, 43, 43, 40, 43, 43, 43, 43,   // 78C0 - 78CF
	43, 43, 43, 40, 43, 43, 46, 43, 43, 43, 46, 46, 46, 43, 46, 46,   // 78D0 - 78DF
	46, 46, 46, 46, 43, 46, 46, 46, 46, 46, 46, 46, 46, 46, 46, 49,   // 78E0 - 78EF
	49, 49, 46, 49, 49, 49, 49, 49, 49, 49, 46, 49, 49, 49, 49, 49,   // 78F0 - 78FF
	49, 49, 49, 49, 49, 49, 52, 49, 49, 52, 52, 52, 52, 49, 52, 52,   // 7900 - 790F
	52, 52, 52, 52, 52, 52, 52, 55, 55, 55, 52, 55, 52, 55, 52, 55,   // 7910 - 791F
	52, 52, 55, 55, 55, 58, 55, 58, 58, 58, 55, 58, 58, 61, 61, 61,   // 7920 - 792F
	61, 61, 61, 61, 61, 61, 61, 61, 61, 61, 13, 10, 13, 16, 19, 19,   // 7930 - 793F
	19, 16, 19, 19, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 25,   // 7940 - 794F
	25, 25, 25, 25, 25, 25, 25, 25, 28, 25, 25, 25, 25, 25, 25, 28,   // 7950 - 795F
	25, 28, 25, 28, 28, 28, 31, 28, 31, 28, 28, 28, 28, 31, 28, 28,   // 7960 - 796F
	31, 31, 31, 31, 31, 31, 31, 31, 31, 34, 34, 34, 34, 34, 34, 34,   // 7970 - 797F
	37, 37, 34, 34, 34, 34, 34, 34, 37, 37, 37, 37, 37, 34, 37, 37,   // 7980 - 798F
	37, 37, 37, 37, 37, 37, 37, 37, 37, 37, 40, 40, 43, 40, 40, 40,   // 7990 - 799F
	40, 40, 40, 40, 43, 43, 49, 46, 46, 43, 46, 46, 49, 46, 49, 49,   // 79A0 - 79AF
	52, 52, 52, 61, 61, 61, 61, 61, 10, 25, 25, 28, 31, 34, 13, 19,   // 79B0 - 79BF
	19, 19, 19, 19, 22, 22, 22, 22, 22, 22, 22, 25, 25, 25, 25, 25,   // 79C0 - 79CF
	25, 25, 25, 25, 25, 25, 25, 25, 28, 28, 28, 28, 28, 28, 28, 28,   // 79D0 - 79DF
	28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 25, 25, 28, 28,   // 79E0 - 79EF
	28, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 34,   // 79F0 - 79FF
	34, 34, 34, 34, 34, 34, 31, 34, 34, 34, 34, 34, 34, 34, 34, 37,   // 7A00 - 7A0F
	37, 37, 37, 37, 37, 37, 37, 37, 37, 37, 37, 37, 37, 37, 37, 37,   // 7A10 - 7A1F
	37, 37, 37, 37, 37, 37, 40, 40, 40, 40, 40, 40, 40, 40, 40, 40,   // 7A20 - 7A2F
	40, 40, 40, 40, 43, 40, 43, 43, 43, 43, 43, 43, 43, 43, 43, 43,   // 7A30 - 7A3F
	43, 40, 43, 43, 46, 46, 46, 46, 46, 49, 40, 46, 46, 46, 46, 46,   // 7A40 - 7A4F
	46, 46, 46, 46, 46, 49, 49, 49, 49, 49, 49, 49, 49, 49, 49, 49,   // 7A50 - 7A5F
	52, 52, 52, 52, 55, 52, 55, 55, 55, 55, 55, 52, 55, 58, 58, 58,   // 7A60 - 7A6F
	61, 61, 61, 61, 13, 16, 19, 19, 22, 22, 22, 22, 25, 25, 25, 25,   // 7A70 - 7A7F
	25, 25, 25, 25, 28, 28, 25, 28, 28, 28, 28, 28, 28, 28, 28, 31,   // 7A80 - 7A8F
	31, 31, 31, 31, 31, 31, 34, 34, 34, 34, 31, 34, 34, 34, 37, 37,   // 7A90 - 7A9F
	37, 37, 37, 37, 37, 37, 37, 37, 40, 37, 40, 40, 40, 40, 43, 43,   // 7AA0 - 7AAF
	43, 43, 43, 43, 43, 46, 46, 46, 46, 46, 46, 46, 46, 46, 49, 46,   // 7AB0 - 7ABF
	49, 49, 49, 61, 52, 52, 52, 58, 61, 61, 61, 13, 19, 19, 22, 22,   // 7AC0 - 7ACF
	25, 25, 25, 25, 25, 25, 25, 25, 28, 28, 28, 28, 28, 28, 28, 31,   // 7AD0 - 7ADF
	31, 31, 34, 34, 34, 34, 34, 34, 37, 37, 37, 31, 40, 40, 40, 40,   // 7AE0 - 7AEF
	40, 46, 49, 49, 49, 52, 58, 58, 61, 16, 22, 22, 25, 25, 25, 25,   // 7AF0 - 7AFF
	25, 25, 25, 25, 28, 28, 28, 28, 25, 28, 28, 28, 28, 28, 28, 28,   // 7B00 - 7B0F
	28, 28, 28, 28, 28, 28, 28, 31, 31, 31, 31, 31, 31, 31, 31, 31,   // 7B10 - 7B1F
	31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 28, 31, 31, 31, 31,   // 7B20 - 7B2F
	31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 34,   // 7B30 - 7B3F
	34, 34, 34, 34, 34, 34, 34, 31, 34, 34, 34, 34, 34, 34, 34, 34,   // 7B40 - 7B4F
	34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 37, 37,   // 7B50 - 7B5F
	37, 37, 37, 37, 37, 34, 37, 37, 37, 37, 37, 37, 34, 37, 37, 37,   // 7B60 - 7B6F
	37, 37, 37, 34, 37, 34, 37, 37, 37, 37, 37, 37, 37, 37, 37, 37,   // 7B70 - 7B7F
	37, 40, 40, 40, 40, 40, 40, 40, 40, 40, 40, 40, 40, 40, 40, 40,   // 7B80 - 7B8F
	40, 40, 40, 40, 40, 40, 40, 40, 40, 40, 40, 40, 40, 40, 40, 40,   // 7B90 - 7B9F
	40, 40, 40, 40, 40, 40, 40, 40, 40, 40, 40, 40, 40, 43, 43, 43,   // 7BA0 - 7BAF
	43, 43, 43, 43, 43, 43, 43, 43, 40, 43, 43, 43, 43, 43, 43, 43,   // 7BB0 - 7BBF
	37, 43, 43, 43, 43, 43, 43, 43, 43, 46, 43, 43, 43, 43, 43, 43,   // 7BC0 - 7BCF
	43, 43, 43, 43, 46, 46, 46, 46, 46, 46, 46, 46, 46, 46, 46, 46,   // 7BD0 - 7BDF
	46, 46, 46, 46, 46, 46, 46, 46, 43, 46, 46, 46, 46, 46, 46, 46,   // 7BE0 - 7BEF
	46, 46, 49, 46, 46, 49, 49, 46, 49, 46, 49, 49, 49, 52, 49, 49,   // 7BF0 - 7BFF
	49, 49, 49, 49, 49, 49, 49, 49, 49, 46, 49, 49, 49, 49, 49, 49,   // 7C00 - 7C0F
	49, 46, 49, 49, 49, 46, 49, 49, 49, 52, 52, 52, 52, 52, 52, 52,   // 7C10 - 7C1F
	52, 52, 52, 52, 52, 52, 52, 49, 52, 52, 52, 55, 55, 52, 52, 52,   // 7C20 - 7C2F
	52, 52, 52, 55, 55, 55, 52, 55, 55, 55, 55, 49, 55, 55, 55, 55,   // 7C30 - 7C3F
	55, 55, 55, 58, 58, 55, 55, 58, 55, 58, 58, 58, 58, 58, 58, 58,   // 7C40 - 7C4F
	61, 61, 61, 61, 61, 58, 61, 61, 61, 61, 61, 61, 61, 61, 61, 61,   // 7C50 - 7C5F
	61, 61, 61, 61, 61, 61, 61, 61, 61, 61, 61, 61, 61, 61, 61, 61,   // 7C60 - 7C6F
	61, 61, 61, 16, 22, 22, 22, 25, 25, 25, 25, 25, 25, 25, 25, 25,   // 7C70 - 7C7F
	25, 25, 25, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28,   // 7C80 - 7C8F
	28, 28, 31, 31, 28, 31, 31, 31, 31, 31, 31, 31, 31, 31, 34, 34,   // 7C90 - 7C9F
	34, 34, 34, 31, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 37, 37,   // 7CA0 - 7CAF
	37, 37, 37, 37, 37, 37, 40, 40, 40, 40, 40, 40, 40, 40, 40, 40,   // 7CB0 - 7CBF
	37, 40, 43, 43, 43, 43, 43, 43, 43, 43, 43, 43, 43, 43, 43, 46,   // 7CC0 - 7CCF
	46, 46, 46, 46, 43, 46, 46, 46, 46, 46, 46, 49, 49, 49, 49, 49,   // 7CD0 - 7CDF
	49, 49, 46, 52, 52, 52, 52, 52, 52, 55, 55, 55, 55, 55, 58, 58,   // 7CE0 - 7CEF
	58, 61, 58, 61, 61, 61, 61, 61, 16, 16, 19, 19, 22, 22, 22, 22,   // 7CF0 - 7CFF
	25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 28, 28, 28, 28, 28, 28,   // 7D00 - 7D0F
	28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 25, 28, 28, 28, 28, 28,   // 7D10 - 7D1F
	28, 28, 28, 28, 28, 28, 28, 28, 31, 31, 34, 34, 31, 31, 31, 31,   // 7D20 - 7D2F
	31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31,   // 7D30 - 7D3F
	31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 34, 34, 34,   // 7D40 - 7D4F
	34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34,   // 7D50 - 7D5F
	34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34,   // 7D60 - 7D6F
	34, 34, 34, 34, 34, 34, 34, 34, 37, 37, 37, 37, 37, 34, 34, 37,   // 7D70 - 7D7F
	37, 34, 37, 37, 37, 37, 37, 37, 37, 37, 37, 37, 37, 37, 34, 37,   // 7D80 - 7D8F
	37, 37, 37, 37, 37, 37, 34, 37, 37, 37, 37, 37, 40, 40, 40, 40,   // 7D90 - 7D9F
	40, 40, 40, 40, 37, 40, 40, 40, 40, 40, 40, 40, 40, 40, 40, 40,   // 7DA0 - 7DAF
	40, 40, 40, 40, 40, 40, 40, 40, 40, 40, 40, 40, 40, 40, 40, 40,   // 7DB0 - 7DBF
	40, 40, 40, 40, 40, 40, 40, 40, 40, 40, 40, 40, 40, 40, 40, 40,   // 7DC0 - 7DCF
	40, 40, 40, 40, 40, 40, 43, 43, 43, 43, 43, 43, 43, 43, 43, 43,   // 7DD0 - 7DDF
	43, 43, 40, 43, 43, 43, 43, 43, 43, 43, 43, 43, 43, 43, 43, 43,   // 7DE0 - 7DEF
	43, 43, 43, 43, 43, 43, 43, 43, 43, 43, 40, 46, 43, 43, 43, 43,   // 7DF0 - 7DFF
	43, 43, 43, 43, 43, 43, 43, 43, 46, 46, 46, 43, 43, 46, 43, 46,   // 7E00 - 7E0F
	46, 46, 43, 46, 46, 46, 46, 46, 46, 43, 46, 46, 46, 46, 46, 46,   // 7E10 - 7E1F
	46, 46, 46, 46, 46, 46, 46, 46, 46, 49, 46, 46, 49, 46, 49, 49,   // 7E20 - 7E2F
	49, 49, 49, 49, 49, 49, 49, 49, 46, 49, 46, 49, 49, 49, 49, 49,   // 7E30 - 7E3F
	49, 49, 49, 49, 49, 49, 49, 49, 49, 49, 49, 49, 49, 49, 52, 52,   // 7E40 - 7E4F
	52, 52, 52, 52, 52, 52, 52, 52, 52, 52, 52, 52, 52, 52, 52, 52,   // 7E50 - 7E5F
	52, 55, 52, 52, 49, 52, 55, 52, 52, 55, 55, 55, 55, 52, 55, 55,   // 7E60 - 7E6F
	55, 52, 55, 55, 55, 55, 55, 55, 52, 55, 55, 58, 58, 58, 55, 58,   // 7E70 - 7E7F
	58, 58, 58, 58, 55, 61, 61, 61, 61, 61, 58, 61, 61, 61, 61, 61,   // 7E80 - 7E8F
	61, 61, 61, 61, 61, 61, 61, 61, 61, 61, 61, 61, 61, 61, 61,  7,   // 7E90 - 7E9F
	13, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 19, 19, 19, 19,   // 7EA0 - 7EAF
	19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 22,   // 7EB0 - 7EBF
	22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22,   // 7EC0 - 7ECF
	22, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25,   // 7ED0 - 7EDF
	28, 28, 28, 28, 28, 28, 28, 28, 28, 31, 31, 31, 31, 31, 31, 31,   // 7EE0 - 7EEF
	31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31,   // 7EF0 - 7EFF
	31, 31, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 31, 34, 34,   // 7F00 - 7F0F
	34, 34, 34, 34, 34, 34, 34, 34, 34, 37, 37, 37, 37, 37, 37, 37,   // 7F10 - 7F1F
	37, 37, 37, 37, 37, 40, 40, 40, 40, 40, 40, 40, 43, 43, 43, 43,   // 7F20 - 7F2F
	46, 46, 46, 46, 46, 55, 16, 22, 25, 28, 28, 28, 28, 31, 34, 34,   // 7F30 - 7F3F
	34, 40, 40, 46, 49, 49, 49, 52, 52, 52, 55, 55, 58, 61, 61, 61,   // 7F40 - 7F4F
	61, 16, 13, 10, 22, 19, 22, 22, 25, 22, 25, 28, 28, 28, 28, 28,   // 7F50 - 7F5F
	28, 28, 28, 31, 34, 34, 34, 37, 37, 37, 37, 37, 37, 37, 37, 40,   // 7F60 - 7F6F
	40, 40, 37, 40, 40, 43, 43, 43, 43, 46, 46, 46, 43, 49, 49, 49,   // 7F70 - 7F7F
	52, 49, 52, 52, 55, 55, 55, 61, 61, 61, 16, 22, 19, 25, 25, 25,   // 7F80 - 7F8F
	25, 25, 28, 28, 28, 31, 28, 25, 28, 28, 31, 31, 31, 31, 28, 31,   // 7F90 - 7F9F
	34, 34, 34, 37, 37, 37, 37, 37, 37, 37, 37, 40, 43, 43, 43, 43,   // 7FA0 - 7FAF
	43, 46, 46, 52, 52, 52, 55, 55, 55, 55, 58, 61, 61, 16, 25, 25,   // 7FB0 - 7FBF
	28, 28, 28, 28, 28, 28, 28, 31, 31, 31, 31, 31, 31, 31, 31, 31,   // 7FC0 - 7FCF
	31, 31, 31, 34, 34, 34, 34, 34, 34, 34, 34, 34, 37, 37, 40, 40,   // 7FD0 - 7FDF
	40, 40, 40, 40, 40, 40, 43, 43, 43, 43, 43, 43, 43, 43, 46, 46,   // 7FE0 - 7FEF
	46, 46, 49, 49, 46, 49, 49, 52, 52, 52, 52, 52, 49, 55, 55, 58,   // 7FF0 - 7FFF
	58, 16, 10, 16, 28, 22, 28, 25, 31, 25, 28, 34, 16, 25, 25, 25,   // 8000 - 800F
	25, 25, 16, 22, 25, 28, 28, 28, 28, 28, 31, 31, 31, 31, 31, 28,   // 8010 - 801F
	34, 37, 37, 40, 40, 40, 43, 43, 46, 46, 46, 49, 49, 52, 52, 55,   // 8020 - 802F
	61, 61, 61, 16, 19, 22, 22, 25, 28, 28, 28, 28, 28, 28, 28, 28,   // 8030 - 803F
	28, 28, 28, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 34, 34,   // 8040 - 804F
	34, 34, 34, 34, 34, 37, 37, 37, 37, 40, 40, 40, 40, 40, 40, 40,   // 8050 - 805F
	34, 40, 40, 40, 43, 43, 43, 43, 43, 43, 43, 43, 46, 43, 46, 49,   // 8060 - 806F
	49, 46, 49, 49, 49, 52, 52, 52, 55, 58, 58, 58, 55, 61, 61, 16,   // 8070 - 807F
	10, 28, 28, 22, 37, 37, 37, 40, 40, 16, 13, 16, 16, 16, 16, 22,   // 8080 - 808F
	19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19,   // 8090 - 809F
	19, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22,   // 80A0 - 80AF
	22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22,   // 80B0 - 80BF
	22, 22, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 22,   // 80C0 - 80CF
	25, 25, 25, 25, 34, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25,   // 80D0 - 80DF
	25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 31, 28, 28, 28,   // 80E0 - 80EF
	28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 34, 28,   // 80F0 - 80FF
	28, 28, 28, 28, 28, 28, 28, 28, 28, 25, 28, 28, 28, 28, 28, 28,   // 8100 - 810F
	28, 28, 28, 28, 34, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31,   // 8110 - 811F
	28, 28, 31, 31, 31, 31, 31, 31, 31, 28, 31, 31, 31, 31, 31, 31,   // 8120 - 812F
	31, 31, 31, 31, 31, 31, 31, 31, 31, 34, 34, 34, 34, 34, 34, 34,   // 8130 - 813F
	34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34,   // 8140 - 814F
	40, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 37, 37, 37, 37, 37,   // 8150 - 815F
	37, 34, 37, 37, 37, 37, 37, 37, 37, 37, 37, 37, 37, 37, 37, 37,   // 8160 - 816F
	37, 34, 37, 37, 34, 37, 37, 37, 37, 37, 37, 37, 37, 37, 37, 37,   // 8170 - 817F
	40, 40, 40, 40, 37, 40, 40, 37, 40, 40, 40, 40, 40, 40, 40, 40,   // 8180 - 818F
	46, 40, 43, 43, 43, 43, 40, 43, 43, 46, 43, 43, 40, 43, 43, 43,   // 8190 - 819F
	43, 43, 43, 43, 43, 49, 46, 46, 46, 46, 46, 46, 46, 46, 46, 46,   // 81A0 - 81AF
	46, 46, 46, 46, 46, 43, 46, 43, 46, 46, 49, 49, 43, 49, 49, 49,   // 81B0 - 81BF
	49, 49, 49, 49, 49, 49, 49, 46, 46, 49, 49, 55, 49, 52, 52, 52,   // 81C0 - 81CF
	52, 52, 49, 52, 55, 55, 58, 52, 55, 58, 58, 58, 58, 61, 61, 61,   // 81D0 - 81DF
	61, 61, 61, 16, 22, 22, 37, 40, 49, 52, 16, 19, 28, 28, 34, 34,   // 81E0 - 81EF
	34, 43, 46, 16, 28, 34, 34, 34, 34, 34, 40, 46, 16, 22, 22, 25,   // 81F0 - 81FF
	28, 25, 31, 34, 34, 37, 40, 37, 46, 46, 49, 58, 16, 22, 22, 22,   // 8200 - 820F
	28, 31, 34, 40, 40, 40, 43, 43, 46, 52, 55, 16, 34, 37, 40, 16,   // 8210 - 821F
	22, 25, 25, 25, 25, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28,   // 8220 - 822F
	28, 28, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 34, 34, 34, 34,   // 8230 - 823F
	37, 37, 37, 37, 37, 37, 37, 34, 37, 37, 40, 40, 40, 40, 43, 43,   // 8240 - 824F
	43, 43, 43, 43, 43, 46, 43, 46, 43, 46, 49, 49, 49, 49, 52, 52,   // 8250 - 825F
	52, 55, 55, 55, 55, 52, 58, 55, 55, 58, 61, 61, 61, 61, 16, 19,   // 8260 - 826F
	22, 49, 16, 28, 31, 34, 55, 61, 16,  7, 10, 13, 13, 13, 13, 13,   // 8270 - 827F
	13, 13, 13, 16, 16, 16, 16, 16, 19, 16, 16, 16, 16, 16, 16, 16,   // 8280 - 828F
	16, 16, 16, 16, 25, 16, 16, 16, 19, 19, 19, 19, 19, 16, 19, 19,   // 8290 - 829F
	19, 19, 19, 19, 19, 19, 19, 19, 16, 19, 19, 19, 19, 19, 19, 19,   // 82A0 - 82AF
	19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 28, 19, 19, 19, 19,   // 82B0 - 82BF
	19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19,   // 82C0 - 82CF
	22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22,   // 82D0 - 82DF
	22, 19, 22, 19, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22,   // 82E0 - 82EF
	22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22,   // 82F0 - 82FF
	22, 22, 22, 22, 22, 22, 22, 22, 25, 22, 22, 22, 22, 25, 22, 22,   // 8300 - 830F
	22, 22, 22, 22, 22, 22, 25, 25, 25, 25, 22, 25, 25, 28, 25, 25,   // 8310 - 831F
	25, 25, 25, 28, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25,   // 8320 - 832F
	25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 34, 25, 25, 19, 25,   // 8330 - 833F
	25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25,   // 8340 - 834F
	25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25,   // 8350 - 835F
	25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25,   // 8360 - 836F
	28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 25,   // 8370 - 837F
	28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28,   // 8380 - 838F
	28, 28, 25, 28, 28, 28, 28, 28, 28, 28, 25, 25, 28, 28, 28, 28,   // 8390 - 839F
	28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28,   // 83A0 - 83AF
	28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 31, 31,   // 83B0 - 83BF
	31, 31, 31, 28, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31,   // 83C0 - 83CF
	34, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31,   // 83D0 - 83DF
	31, 31, 31, 31, 31, 31, 28, 31, 31, 31, 31, 31, 31, 31, 31, 28,   // 83E0 - 83EF
	31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31,   // 83F0 - 83FF
	31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31,   // 8400 - 840F
	31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31,   // 8410 - 841F
	31, 31, 31, 31, 31, 31, 31, 31, 31, 34, 34, 34, 34, 34, 34, 34,   // 8420 - 842F
	34, 34, 34, 34, 34, 31, 34, 34, 31, 34, 34, 34, 34, 34, 34, 34,   // 8430 - 843F
	34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34,   // 8440 - 844F
	34, 34, 34, 34, 34, 34, 34, 31, 34, 34, 34, 34, 34, 34, 34, 34,   // 8450 - 845F
	34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34,   // 8460 - 846F
	34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34,   // 8470 - 847F
	34, 31, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34,   // 8480 - 848F
	34, 37, 37, 37, 37, 37, 37, 37, 37, 37, 37, 37, 37, 37, 37, 37,   // 8490 - 849F
	37, 37, 34, 37, 37, 37, 37, 37, 37, 37, 37, 34, 37, 37, 37, 37,   // 84A0 - 84AF
	37, 37, 37, 37, 37, 37, 37, 37, 37, 37, 37, 37, 37, 37, 34, 37,   // 84B0 - 84BF
	37, 37, 37, 34, 37, 37, 37, 34, 31, 37, 37, 37, 37, 37, 37, 37,   // 84C0 - 84CF
	37, 37, 37, 37, 37, 37, 37, 37, 37, 37, 34, 37, 37, 37, 37, 37,   // 84D0 - 84DF
	37, 37, 37, 37, 37, 37, 37, 37, 37, 37, 37, 37, 37, 40, 37, 40,   // 84E0 - 84EF
	40, 34, 40, 40, 40, 40, 40, 40, 40, 43, 40, 40, 40, 37, 40, 40,   // 84F0 - 84FF
	37, 40, 40, 43, 40, 40, 40, 34, 40, 40, 40, 40, 40, 40, 40, 40,   // 8500 - 850F
	40, 40, 40, 40, 40, 40, 40, 40, 40, 40, 40, 40, 37, 40, 40, 40,   // 8510 - 851F
	40, 40, 40, 40, 40, 40, 40, 40, 40, 40, 40, 40, 43, 37, 40, 37,   // 8520 - 852F
	40, 37, 40, 40, 40, 40, 40, 40, 40, 40, 40, 40, 40, 40, 43, 43,   // 8530 - 853F
	43, 43, 43, 43, 43, 43, 43, 43, 43, 43, 43, 43, 43, 43, 43, 40,   // 8540 - 854F
	43, 43, 43, 43, 43, 43, 40, 46, 43, 43, 43, 43, 43, 43, 43, 43,   // 8550 - 855F
	43, 43, 43, 43, 43, 43, 43, 43, 43, 43, 43, 43, 43, 46, 43, 40,   // 8560 - 856F
	43, 43, 43, 43, 43, 43, 46, 46, 43, 46, 43, 46, 46, 46, 46, 46,   // 8570 - 857F
	46, 43, 46, 46, 46, 46, 46, 46, 46, 46, 46, 46, 40, 46, 46, 46,   // 8580 - 858F
	46, 46, 46, 46, 46, 46, 40, 46, 43, 46, 46, 46, 46, 46, 46, 46,   // 8590 - 859F
	46, 43, 46, 46, 46, 46, 46, 46, 46, 46, 46, 46, 46, 46, 46, 46,   // 85A0 - 85AF
	49, 49, 49, 46, 49, 49, 49, 49, 49, 49, 49, 49, 49, 46, 49, 49,   // 85B0 - 85BF
	49, 49, 49, 49, 49, 49, 49, 46, 49, 49, 49, 49, 49, 49, 49, 49,   // 85C0 - 85CF
	49, 49, 49, 49, 52, 52, 52, 49, 52, 52, 52, 52, 52, 52, 52, 52,   // 85D0 - 85DF
	52, 49, 52, 52, 52, 52, 52, 52, 52, 52, 52, 52, 49, 52, 55, 52,   // 85E0 - 85EF
	52, 49, 52, 52, 52, 52, 55, 52, 52, 55, 55, 55, 55, 55, 55, 55,   // 85F0 - 85FF
	55, 55, 55, 55, 55, 55, 55, 55, 55, 55, 55, 55, 58, 55, 55, 55,   // 8600 - 860F
	55, 55, 55, 55, 55, 55, 58, 58, 58, 58, 58, 58, 58, 58, 58, 55,   // 8610 - 861F
	58, 58, 55, 58, 58, 58, 58, 55, 58, 58, 58, 58, 61, 58, 58, 58,   // 8620 - 862F
	58, 61, 61, 58, 61, 61, 58, 61, 61, 61, 61, 61, 61, 61, 61, 61,   // 8630 - 863F
	61, 61, 61, 61, 61, 61, 61, 61, 61, 61, 61, 61, 61, 16, 22, 22,   // 8640 - 864F
	25, 28, 28, 28, 28, 31, 31, 31, 31, 31, 31, 34, 37, 34, 37, 37,   // 8650 - 865F
	40, 37, 43, 46, 46, 46, 46, 49, 49, 52, 61, 16, 19, 22, 22, 22,   // 8660 - 866F
	22, 22, 22, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25,   // 8670 - 867F
	25, 25, 25, 25, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28,   // 8680 - 868F
	28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28,   // 8690 - 869F
	28, 28, 28, 28, 25, 28, 28, 28, 28, 28, 28, 31, 28, 31, 31, 31,   // 86A0 - 86AF
	31, 31, 31, 31, 31, 31, 31, 28, 31, 31, 31, 31, 31, 31, 31, 31,   // 86B0 - 86BF
	31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31,   // 86C0 - 86CF
	34, 34, 34, 34, 34, 34, 37, 34, 34, 34, 34, 34, 34, 34, 34, 34,   // 86D0 - 86DF
	34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34,   // 86E0 - 86EF
	34, 34, 34, 34, 34, 37, 37, 37, 37, 37, 37, 37, 37, 37, 37, 37,   // 86F0 - 86FF
	37, 37, 37, 37, 37, 37, 37, 37, 37, 37, 37, 37, 37, 37, 37, 37,   // 8700 - 870F
	37, 34, 34, 34, 37, 37, 37, 37, 40, 40, 40, 40, 40, 40, 40, 40,   // 8710 - 871F
	40, 40, 40, 37, 40, 40, 40, 40, 40, 40, 40, 40, 40, 40, 40, 40,   // 8720 - 872F
	40, 40, 40, 40, 40, 43, 40, 40, 40, 37, 40, 40, 40, 40, 40, 40,   // 8730 - 873F
	40, 40, 40, 40, 40, 40, 37, 40, 40, 40, 40, 40, 43, 37, 43, 43,   // 8740 - 874F
	43, 43, 43, 43, 43, 40, 43, 43, 43, 43, 43, 43, 43, 43, 43, 43,   // 8750 - 875F
	43, 43, 43, 43, 43, 43, 43, 40, 43, 43, 43, 40, 43, 43, 43, 43,   // 8760 - 876F
	43, 43, 43, 43, 43, 43, 43, 43, 40, 43, 43, 43, 43, 43, 43, 43,   // 8770 - 877F
	43, 43, 40, 46, 46, 46, 43, 46, 46, 46, 46, 43, 46, 46, 46, 46,   // 8780 - 878F
	46, 46, 46, 46, 46, 46, 43, 46, 46, 46, 46, 46, 46, 43, 46, 46,   // 8790 - 879F
	46, 46, 46, 46, 46, 46, 46, 46, 46, 46, 49, 49, 49, 46, 49, 46,   // 87A0 - 87AF
	49, 49, 49, 49, 46, 49, 46, 49, 49, 49, 49, 49, 49, 49, 49, 49,   // 87B0 - 87BF
	49, 49, 49, 49, 49, 49, 46, 46, 49, 49, 49, 49, 49, 49, 49, 49,   // 87C0 - 87CF
	49, 49, 46, 49, 52, 55, 52, 52, 52, 52, 52, 52, 52, 49, 49, 52,   // 87D0 - 87DF
	52, 52, 52, 52, 52, 49, 52, 52, 52, 52, 52, 52, 52, 52, 52, 52,   // 87E0 - 87EF
	55, 52, 52, 52, 52, 52, 55, 55, 55, 55, 55, 55, 52, 52, 55, 55,   // 87F0 - 87FF
	55, 49, 52, 55, 52, 55, 52, 52, 55, 55, 55, 55, 55, 55, 49, 55,   // 8800 - 880F
	58, 58, 58, 55, 58, 58, 55, 58, 58, 58, 58, 58, 61, 61, 55, 61,   // 8810 - 881F
	61, 61, 61, 58, 61, 61, 61, 61, 61, 61, 61, 61, 61, 61, 61, 61,   // 8820 - 882F
	61, 61, 61, 61, 61, 61, 61, 61, 61, 61, 61, 61, 61, 61, 61, 61,   // 8830 - 883F
	16, 25, 25, 28, 28, 31, 34, 34, 34, 34, 58, 61, 16, 25, 25, 28,   // 8840 - 884F
	31, 31, 31, 31, 31, 34, 34, 34, 37, 37, 43, 43, 43, 43, 46, 46,   // 8850 - 885F
	46, 46, 61, 16, 13, 19, 22, 22, 22, 22, 22, 22, 22, 25, 28, 25,   // 8860 - 886F
	28, 22, 25, 25, 25, 25, 25, 28, 25, 25, 28, 25, 25, 25, 28, 25,   // 8870 - 887F
	25, 28, 25, 28, 25, 28, 25, 25, 31, 28, 28, 31, 31, 28, 28, 28,   // 8880 - 888F
	28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 31, 28,   // 8890 - 889F
	31, 28, 28, 28, 31, 28, 28, 28, 28, 28, 28, 28, 31, 31, 28, 28,   // 88A0 - 88AF
	31, 31, 34, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31,   // 88B0 - 88BF
	31, 34, 34, 31, 31, 34, 31, 31, 31, 31, 37, 34, 34, 34, 34, 37,   // 88C0 - 88CF
	34, 34, 34, 34, 37, 34, 34, 34, 37, 34, 37, 37, 34, 37, 34, 37,   // 88D0 - 88DF
	37, 34, 34, 34, 34, 34, 40, 37, 37, 37, 37, 40, 37, 37, 37, 37,   // 88E0 - 88EF
	37, 37, 37, 40, 40, 40, 37, 37, 37, 40, 37, 40, 37, 40, 37, 37,   // 88F0 - 88FF
	37, 34, 37, 37, 37, 40, 40, 40, 40, 40, 40, 40, 40, 40, 40, 40,   // 8900 - 890F
	40, 40, 43, 40, 40, 40, 40, 40, 40, 40, 37, 40, 43, 40, 40, 43,   // 8910 - 891F
	43, 40, 43, 43, 43, 43, 43, 46, 40, 46, 40, 43, 43, 46, 46, 43,   // 8920 - 892F
	46, 46, 43, 43, 43, 43, 46, 46, 46, 46, 49, 49, 49, 49, 46, 46,   // 8930 - 893F
	46, 49, 46, 46, 49, 43, 49, 49, 49, 49, 49, 49, 49, 49, 49, 49,   // 8940 - 894F
	46, 49, 46, 49, 46, 49, 49, 52, 52, 52, 49, 52, 52, 52, 55, 52,   // 8950 - 895F
	52, 52, 52, 55, 55, 55, 55, 55, 55, 58, 55, 58, 58, 58, 58, 61,   // 8960 - 896F
	61, 61, 61, 61, 61, 61, 61, 61, 61, 61, 61, 61, 61, 61, 16, 16,   // 8970 - 897F
	16, 25, 28, 34, 34, 37, 52, 55, 55, 61, 61, 19, 25, 28, 28, 31,   // 8980 - 898F
	31, 31, 31, 31, 31, 34, 31, 34, 34, 34, 34, 37, 37, 40, 40, 40,   // 8990 - 899F
	40, 40, 43, 43, 43, 43, 46, 46, 46, 43, 46, 49, 49, 49, 49, 49,   // 89A0 - 89AF
	52, 52, 52, 52, 55, 55, 55, 52, 55, 58, 58, 58, 61, 61, 61, 61,   // 89B0 - 89BF
	61, 10, 16, 19, 22, 22, 22, 25, 25, 25, 28, 31, 34, 34, 37, 40,   // 89C0 - 89CF
	43, 43, 19, 25, 25, 31, 31, 31, 31, 28, 34, 34, 37, 34, 34, 37,   // 89D0 - 89DF
	37, 37, 37, 37, 37, 37, 37, 37, 40, 40, 40, 40, 43, 43, 43, 43,   // 89E0 - 89EF
	43, 46, 49, 49, 52, 52, 55, 58, 58, 55, 61, 61, 61, 61, 61, 61,   // 89F0 - 89FF
	19, 19, 25, 25, 25, 25, 25, 25, 25, 28, 28, 28, 28, 28, 28, 28,   // 8A00 - 8A0F
	28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 31, 31, 31, 31, 31,   // 8A10 - 8A1F
	31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 28,   // 8A20 - 8A2F
	31, 31, 31, 31, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 37, 37,   // 8A30 - 8A3F
	34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 31, 34,   // 8A40 - 8A4F
	34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34,   // 8A50 - 8A5F
	34, 37, 37, 37, 37, 37, 37, 37, 37, 37, 37, 37, 37, 37, 37, 37,   // 8A60 - 8A6F
	37, 37, 37, 37, 37, 37, 37, 37, 37, 37, 37, 37, 37, 37, 37, 37,   // 8A70 - 8A7F
	37, 37, 37, 37, 37, 37, 37, 37, 37, 37, 37, 40, 40, 40, 40, 40,   // 8A80 - 8A8F
	40, 40, 40, 40, 37, 37, 40, 40, 40, 40, 40, 40, 40, 40, 40, 40,   // 8A90 - 8A9F
	37, 40, 40, 40, 40, 40, 40, 40, 40, 40, 40, 40, 40, 40, 40, 43,   // 8AA0 - 8AAF
	43, 43, 43, 43, 43, 43, 43, 43, 43, 43, 43, 43, 43, 43, 43, 43,   // 8AB0 - 8ABF
	43, 43, 43, 43, 43, 43, 43, 43, 43, 43, 43, 43, 43, 37, 43, 43,   // 8AC0 - 8ACF
	43, 43, 43, 43, 43, 43, 43, 43, 43, 43, 43, 43, 46, 46, 46, 46,   // 8AD0 - 8ADF
	46, 46, 46, 43, 46, 46, 46, 46, 46, 43, 46, 46, 46, 46, 46, 46,   // 8AE0 - 8AEF
	46, 46, 46, 46, 46, 46, 46, 46, 46, 46, 46, 46, 46, 46, 43, 46,   // 8AF0 - 8AFF
	46, 46, 46, 46, 49, 49, 49, 49, 49, 46, 46, 49, 49, 49, 46, 46,   // 8B00 - 8B0F
	49, 49, 49, 49, 46, 49, 49, 49, 49, 49, 49, 49, 49, 49, 49, 49,   // 8B10 - 8B1F
	49, 49, 49, 52, 52, 52, 52, 49, 49, 49, 52, 52, 52, 52, 52, 52,   // 8B20 - 8B2F
	49, 52, 52, 52, 52, 52, 52, 49, 49, 52, 52, 52, 52, 55, 52, 55,   // 8B30 - 8B3F
	52, 49, 55, 52, 55, 61, 55, 52, 55, 55, 55, 55, 55, 58, 55, 55,   // 8B40 - 8B4F
	55, 55, 55, 55, 55, 55, 55, 55, 55, 55, 55, 55, 55, 58, 58, 58,   // 8B50 - 8B5F
	58, 58, 55, 58, 58, 58, 55, 58, 58, 58, 55, 58, 58, 58, 58, 58,   // 8B60 - 8B6F
	58, 58, 58, 61, 58, 61, 61, 58, 61, 61, 61, 61, 61, 58, 61, 61,   // 8B70 - 8B7F
	61, 61, 61, 61, 61, 61, 61, 61, 61, 61, 61, 61, 61, 61, 61, 61,   // 8B80 - 8B8F
	61, 61, 61, 61, 61, 61, 61, 61, 61, 61, 61, 61, 61, 61, 61, 61,   // 8B90 - 8B9F
	 4, 10, 10, 10, 10, 10, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13,   // 8BA0 - 8BAF
	13, 13, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16,   // 8BB0 - 8BBF
	16, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19,   // 8BC0 - 8BCF
	19, 19, 19, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22,   // 8BD0 - 8BDF
	22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 25, 25, 25, 25, 25, 25,   // 8BE0 - 8BEF
	25, 25, 25, 25, 25, 25, 25, 28, 28, 28, 28, 28, 28, 28, 28, 28,   // 8BF0 - 8BFF
	28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 31, 31, 31, 31, 31,   // 8C00 - 8C0F
	31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 34,   // 8C10 - 8C1F
	34, 34, 34, 34, 34, 34, 34, 34, 37, 37, 37, 37, 37, 40, 40, 40,   // 8C20 - 8C2F
	40, 40, 40, 43, 43, 43, 55, 19, 28, 31, 31, 31, 37, 40, 43, 49,   // 8C30 - 8C3F
	49, 49, 52, 52, 61, 61, 19, 28, 28, 31, 37, 37, 43, 43, 43, 49,   // 8C40 - 8C4F
	52, 58, 61, 61, 61, 19, 22, 28, 31, 31, 31, 31, 31, 31, 34, 34,   // 8C50 - 8C5F
	34, 31, 37, 37, 37, 37, 37, 40, 40, 40, 40, 43, 43, 46, 46, 49,   // 8C60 - 8C6F
	49, 46, 49, 49, 52, 52, 55, 55, 19, 28, 28, 28, 31, 31, 34, 34,   // 8C70 - 8C7F
	34, 34, 34, 34, 37, 37, 37, 37, 37, 37, 37, 40, 40, 40, 43, 43,   // 8C80 - 8C8F
	46, 46, 46, 43, 49, 49, 49, 52, 49, 52, 55, 61, 61, 19, 25, 25,   // 8C90 - 8C9F
	25, 28, 28, 28, 28, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 34,   // 8CA0 - 8CAF
	34, 34, 37, 34, 34, 34, 31, 34, 34, 34, 34, 34, 34, 34, 34, 34,   // 8CB0 - 8CBF
	34, 34, 37, 37, 37, 37, 37, 37, 37, 37, 37, 37, 37, 37, 37, 40,   // 8CC0 - 8CCF
	40, 40, 40, 40, 40, 40, 40, 40, 40, 43, 43, 43, 43, 43, 43, 43,   // 8CD0 - 8CDF
	43, 43, 43, 43, 43, 43, 43, 43, 43, 43, 43, 43, 43, 43, 46, 46,   // 8CE0 - 8CEF
	46, 46, 46, 46, 46, 46, 49, 49, 49, 49, 49, 49, 49, 49, 52, 52,   // 8CF0 - 8CFF
	52, 52, 52, 52, 52, 49, 55, 55, 55, 55, 55, 55, 55, 58, 55, 58,   // 8D00 - 8D0F
	61, 61, 61, 61, 61, 61, 61, 61, 61, 61, 61, 61, 61, 10, 16, 16,   // 8D10 - 8D1F
	16, 19, 19, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22,   // 8D20 - 8D2F
	25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 28, 28, 28, 28,   // 8D30 - 8D3F
	28, 28, 28, 28, 28, 28, 28, 31, 31, 31, 31, 34, 34, 34, 34, 34,   // 8D40 - 8D4F
	34, 34, 34, 34, 34, 34, 37, 37, 40, 40, 40, 40, 43, 46, 46, 46,   // 8D50 - 8D5F
	46, 49, 49, 61, 19, 31, 31, 31, 37, 37, 37, 40, 46, 43, 46, 49,   // 8D60 - 8D6F
	19, 16, 25, 25, 25, 25, 28, 28, 28, 31, 31, 31, 31, 31, 31, 31,   // 8D70 - 8D7F
	34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 37, 37, 37, 37,   // 8D80 - 8D8F
	37, 37, 37, 37, 37, 40, 40, 40, 40, 40, 40, 43, 43, 43, 43, 43,   // 8D90 - 8D9F
	43, 43, 43, 43, 43, 46, 46, 46, 49, 52, 52, 55, 55, 55, 58, 61,   // 8DA0 - 8DAF
	61, 61, 61, 19, 25, 28, 28, 28, 28, 31, 31, 31, 31, 31, 31, 28,   // 8DB0 - 8DBF
	31, 31, 31, 31, 31, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34,   // 8DC0 - 8DCF
	37, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 31, 34, 37,   // 8DD0 - 8DDF
	37, 37, 37, 37, 37, 37, 37, 37, 37, 37, 37, 37, 37, 37, 37, 37,   // 8DE0 - 8DEF
	37, 37, 37, 37, 37, 34, 37, 37, 37, 37, 37, 37, 40, 40, 40, 40,   // 8DF0 - 8DFF
	40, 40, 40, 40, 40, 40, 40, 40, 40, 40, 40, 40, 40, 40, 40, 43,   // 8E00 - 8E0F
	43, 43, 43, 43, 43, 43, 43, 43, 43, 43, 43, 43, 43, 43, 43, 43,   // 8E10 - 8E1F
	43, 43, 43, 43, 43, 43, 43, 43, 43, 43, 43, 43, 43, 37, 43, 43,   // 8E20 - 8E2F
	46, 46, 46, 46, 46, 46, 46, 43, 46, 46, 43, 46, 46, 46, 46, 46,   // 8E30 - 8E3F
	46, 46, 46, 43, 46, 46, 46, 49, 49, 46, 49, 49, 49, 49, 49, 49,   // 8E40 - 8E4F
	49, 49, 49, 49, 52, 49, 52, 52, 52, 52, 52, 52, 52, 52, 52, 52,   // 8E50 - 8E5F
	52, 52, 52, 52, 52, 49, 52, 52, 55, 52, 55, 55, 55, 55, 52, 55,   // 8E60 - 8E6F
	55, 55, 55, 55, 55, 55, 55, 55, 55, 55, 55, 55, 55, 55, 55, 55,   // 8E70 - 8E7F
	52, 58, 55, 58, 58, 58, 58, 52, 58, 55, 61, 61, 61, 61, 61, 61,   // 8E80 - 8E8F
	61, 61, 61, 61, 61, 61, 61, 61, 61, 61, 61, 61, 61, 61, 61, 61,   // 8E90 - 8E9F
	61, 61, 61, 61, 61, 61, 61, 61, 61, 61, 61, 19, 28, 31, 31, 31,   // 8EA0 - 8EAF
	34, 37, 37, 37, 40, 40, 43, 43, 43, 43, 43, 43, 43, 46, 46, 52,   // 8EB0 - 8EBF
	52, 52, 55, 55, 55, 55, 58, 61, 61, 61, 19, 22, 25, 25, 28, 28,   // 8EC0 - 8ECF
	28, 28, 28, 28, 28, 28, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31,   // 8ED0 - 8EDF
	31, 31, 31, 31, 34, 34, 34, 34, 34, 34, 34, 34, 34, 37, 34, 34,   // 8EE0 - 8EEF
	34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 37, 37,   // 8EF0 - 8EFF
	37, 37, 37, 37, 37, 37, 37, 37, 37, 37, 37, 37, 37, 40, 40, 40,   // 8F00 - 8F0F
	40, 40, 40, 40, 40, 40, 43, 43, 43, 43, 43, 43, 43, 43, 43, 43,   // 8F10 - 8F1F
	43, 43, 43, 43, 43, 43, 43, 43, 43, 43, 43, 43, 43, 46, 46, 46,   // 8F20 - 8F2F
	46, 46, 46, 46, 46, 46, 46, 46, 46, 46, 46, 46, 46, 49, 49, 49,   // 8F30 - 8F3F
	49, 49, 49, 49, 49, 49, 52, 52, 52, 52, 52, 49, 52, 55, 55, 55,   // 8F40 - 8F4F
	55, 55, 55, 55, 55, 55, 58, 58, 58, 58, 58, 61, 61, 58, 61, 61,   // 8F50 - 8F5F
	61, 61, 61, 61, 61, 61, 10, 13, 16, 19, 19, 19, 22, 22, 22, 22,   // 8F60 - 8F6F
	22, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 28, 28, 28, 28,   // 8F70 - 8F7F
	28, 28, 28, 28, 31, 31, 31, 34, 34, 34, 34, 34, 34, 34, 34, 37,   // 8F80 - 8F8F
	37, 37, 37, 37, 37, 40, 40, 40, 43, 46, 46, 19, 34, 34, 37, 37,   // 8F90 - 8F9F
	37, 40, 40, 40, 43, 46, 46, 46, 46, 46, 49, 49, 52, 55, 58, 61,   // 8FA0 - 8FAF
	19, 28, 37, 43, 55, 19,  7, 10, 13, 13, 13, 13, 13, 13, 16, 16,   // 8FB0 - 8FBF
	16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 19, 19, 19, 19, 19, 19,   // 8FC0 - 8FCF
	19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19,   // 8FD0 - 8FDF
	22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22,   // 8FE0 - 8FEF
	22, 22, 22, 22, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25,   // 8FF0 - 8FFF
	25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 28, 28, 28, 28, 28,   // 9000 - 900F
	28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28,   // 9010 - 901F
	28, 28, 28, 28, 28, 28, 28, 28, 31, 31, 31, 31, 31, 31, 31, 31,   // 9020 - 902F
	31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 34, 31, 34, 34,   // 9030 - 903F
	34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 31, 34,   // 9040 - 904F
	34, 34, 34, 34, 34, 34, 34, 34, 37, 37, 34, 37, 37, 37, 37, 37,   // 9050 - 905F
	37, 37, 37, 37, 37, 37, 40, 40, 37, 40, 40, 40, 40, 40, 40, 40,   // 9060 - 906F
	40, 40, 43, 37, 43, 43, 43, 43, 43, 43, 43, 43, 43, 46, 46, 46,   // 9070 - 907F
	46, 43, 46, 49, 46, 46, 43, 49, 49, 49, 52, 52, 52, 55, 61, 61,   // 9080 - 908F
	61, 19, 10, 10, 13, 28, 13, 13, 13, 13, 13, 13, 13, 13, 16, 16,   // 9090 - 909F
	16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 31, 16, 19, 19, 19,   // 90A0 - 90AF
	19, 19, 19, 19, 19, 19, 19, 16, 19, 19, 19, 19, 22, 22, 22, 22,   // 90B0 - 90BF
	22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 37, 22, 22, 22,   // 90C0 - 90CF
	22, 22, 37, 22, 22, 22, 25, 25, 22, 25, 25, 25, 25, 25, 25, 25,   // 90D0 - 90DF
	25, 25, 25, 25, 25, 25, 25, 25, 28, 28, 28, 28, 28, 28, 28, 28,   // 90E0 - 90EF
	28, 22, 28, 28, 28, 28, 43, 28, 28, 31, 46, 31, 31, 28, 31, 31,   // 90F0 - 90FF
	28, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 34, 34, 34, 34,   // 9100 - 910F
	34, 34, 34, 34, 34, 34, 34, 34, 37, 37, 34, 37, 37, 37, 37, 37,   // 9110 - 911F
	37, 37, 37, 37, 37, 37, 40, 40, 52, 40, 40, 40, 40, 40, 40, 40,   // 9120 - 912F
	40, 40, 40, 43, 43, 43, 43, 43, 43, 46, 46, 49, 49, 49, 49, 49,   // 9130 - 913F
	52, 55, 52, 55, 55, 58, 58, 61, 61, 19, 25, 25, 28, 28, 28, 28,   // 9140 - 914F
	28, 28, 28, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 34,   // 9150 - 915F
	34, 34, 34, 34, 34, 34, 34, 37, 37, 37, 37, 37, 37, 37, 37, 37,   // 9160 - 916F
	37, 37, 40, 40, 40, 40, 40, 40, 40, 40, 40, 40, 40, 40, 40, 40,   // 9170 - 917F
	43, 43, 43, 43, 43, 43, 43, 43, 43, 43, 43, 43, 43, 46, 46, 43,   // 9180 - 918F
	46, 46, 46, 46, 46, 46, 46, 46, 49, 46, 46, 46, 46, 46, 49, 49,   // 9190 - 919F
	49, 49, 49, 49, 49, 52, 52, 52, 49, 52, 52, 52, 52, 55, 55, 55,   // 91A0 - 91AF
	55, 55, 58, 58, 58, 58, 58, 58, 58, 61, 61, 61, 61, 61, 61, 61,   // 91B0 - 91BF
	61, 61, 61, 61, 61, 61, 19, 22, 31, 34, 34, 58, 19, 25, 31, 34,   // 91C0 - 91CF
	52, 22, 22, 25, 25, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28,   // 91D0 - 91DF
	28, 28, 28, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31,   // 91E0 - 91EF
	31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 34, 34, 34,   // 91F0 - 91FF
	34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34,   // 9200 - 920F
	34, 34, 31, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34,   // 9210 - 921F
	34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 40, 37, 37,   // 9220 - 922F
	37, 37, 37, 37, 37, 37, 37, 37, 37, 37, 37, 37, 37, 37, 37, 37,   // 9230 - 923F
	37, 37, 37, 37, 37, 34, 37, 37, 37, 37, 37, 37, 37, 37, 37, 37,   // 9240 - 924F
	37, 37, 37, 37, 37, 37, 37, 37, 37, 37, 37, 37, 37, 37, 37, 37,   // 9250 - 925F
	37, 37, 37, 37, 37, 37, 37, 37, 37, 37, 37, 37, 37, 37, 37, 34,   // 9260 - 926F
	37, 37, 37, 37, 37, 40, 40, 40, 40, 40, 40, 40, 40, 40, 40, 40,   // 9270 - 927F
	40, 40, 40, 40, 40, 40, 40, 40, 40, 40, 40, 40, 40, 40, 40, 37,   // 9280 - 928F
	40, 40, 40, 40, 40, 40, 40, 40, 40, 40, 40, 40, 40, 40, 40, 40,   // 9290 - 929F
	40, 40, 40, 40, 40, 40, 40, 40, 40, 40, 40, 40, 40, 40, 40, 40,   // 92A0 - 92AF
	37, 40, 43, 43, 43, 43, 43, 43, 43, 43, 43, 43, 43, 43, 43, 43,   // 92B0 - 92BF
	43, 40, 43, 43, 43, 43, 43, 43, 43, 43, 43, 40, 40, 43, 43, 43,   // 92C0 - 92CF
	43, 43, 43, 43, 43, 43, 43, 43, 43, 43, 43, 43, 43, 43, 43, 43,   // 92D0 - 92DF
	43, 43, 43, 40, 43, 43, 43, 43, 43, 40, 43, 43, 43, 43, 40, 43,   // 92E0 - 92EF
	43, 43, 43, 43, 43, 43, 43, 46, 46, 46, 46, 46, 46, 46, 46, 46,   // 92F0 - 92FF
	46, 46, 46, 46, 46, 46, 46, 46, 46, 46, 46, 46, 46, 46, 46, 46,   // 9300 - 930F
	46, 46, 43, 43, 46, 46, 46, 46, 46, 46, 40, 46, 46, 46, 46, 46,   // 9310 - 931F
	46, 46, 46, 46, 46, 46, 46, 46, 46, 46, 46, 46, 46, 46, 46, 46,   // 9320 - 932F
	46, 46, 46, 46, 46, 43, 46, 46, 46, 46, 43, 46, 46, 46, 46, 46,   // 9330 - 933F
	46, 46, 46, 46, 46, 46, 46, 49, 46, 49, 49, 46, 49, 49, 49, 49,   // 9340 - 934F
	49, 49, 49, 49, 49, 49, 49, 49, 49, 49, 49, 49, 49, 49, 49, 49,   // 9350 - 935F
	49, 49, 49, 46, 49, 49, 49, 49, 49, 46, 49, 49, 49, 49, 49, 49,   // 9360 - 936F
	49, 49, 49, 49, 49, 46, 49, 49, 49, 49, 46, 49, 49, 49, 49, 49,   // 9370 - 937F
	49, 46, 49, 49, 49, 49, 49, 49, 49, 52, 52, 52, 52, 52, 52, 52,   // 9380 - 938F
	52, 52, 52, 52, 52, 52, 52, 52, 52, 52, 49, 52, 52, 49, 52, 52,   // 9390 - 939F
	52, 49, 52, 52, 52, 52, 52, 52, 52, 52, 49, 52, 52, 52, 52, 46,   // 93A0 - 93AF
	52, 52, 52, 52, 52, 52, 52, 52, 52, 49, 49, 52, 52, 52, 49, 52,   // 93B0 - 93BF
	55, 55, 55, 55, 55, 52, 55, 55, 52, 55, 52, 55, 52, 55, 52, 55,   // 93C0 - 93CF
	55, 55, 55, 55, 55, 55, 55, 55, 55, 55, 55, 55, 55, 55, 55, 55,   // 93D0 - 93DF
	52, 55, 55, 55, 55, 55, 55, 55, 55, 55, 55, 55, 55, 55, 55, 55,   // 93E0 - 93EF
	55, 55, 55, 58, 61, 52, 58, 58, 58, 58, 58, 58, 58, 61, 58, 58,   // 93F0 - 93FF
	58, 58, 58, 58, 55, 55, 55, 58, 58, 58, 55, 58, 55, 58, 58, 58,   // 9400 - 940F
	58, 58, 58, 58, 58, 58, 58, 58, 58, 58, 58, 58, 58, 58, 58, 58,   // 9410 - 941F
	58, 58, 58, 58, 58, 58, 58, 58, 58, 58, 61, 58, 61, 58, 61, 55,   // 9420 - 942F
	61, 61, 61, 61, 61, 61, 61, 58, 61, 55, 61, 61, 58, 58, 61, 61,   // 9430 - 943F
	61, 61, 61, 61, 61, 61, 61, 61, 61, 61, 61, 61, 61, 61, 61, 61,   // 9440 - 944F
	61, 61, 61, 61, 61, 61, 61, 61, 61, 61, 61, 61, 61, 61, 61, 61,   // 9450 - 945F
	61, 61, 61, 61, 61, 61, 61, 61, 61, 61, 61, 61, 61, 61, 61, 61,   // 9460 - 946F
	61, 61, 61, 61, 61, 61, 61, 61, 61, 61, 61, 61, 61, 61, 61, 61,   // 9470 - 947F
	61, 61, 61, 61, 61, 13, 16, 16, 19, 19, 19, 19, 19, 22, 22, 22,   // 9480 - 948F
	22, 22, 22, 22, 22, 22, 22, 22, 25, 25, 25, 25, 25, 25, 25, 25,   // 9490 - 949F
	25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25,   // 94A0 - 94AF
	28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28,   // 94B0 - 94BF
	28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 31,   // 94C0 - 94CF
	31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31,   // 94D0 - 94DF
	31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31,   // 94E0 - 94EF
	31, 31, 31, 31, 31, 31, 31, 31, 34, 34, 34, 34, 34, 34, 34, 34,   // 94F0 - 94FF
	34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34,   // 9500 - 950F
	34, 34, 34, 34, 34, 34, 37, 37, 37, 37, 37, 37, 37, 37, 37, 37,   // 9510 - 951F
	37, 37, 37, 37, 37, 37, 37, 37, 37, 37, 37, 37, 37, 37, 37, 37,   // 9520 - 952F
	37, 37, 40, 37, 40, 40, 40, 40, 40, 40, 40, 40, 40, 40, 40, 40,   // 9530 - 953F
	40, 40, 40, 40, 40, 40, 43, 43, 43, 43, 43, 43, 43, 43, 43, 43,   // 9540 - 954F
	43, 43, 43, 43, 43, 43, 46, 46, 46, 46, 46, 46, 46, 46, 46, 46,   // 9550 - 955F
	46, 49, 49, 49, 49, 49, 49, 49, 49, 49, 49, 49, 52, 52, 52, 52,   // 9560 - 956F
	52, 52, 55, 58, 58, 61, 61, 22, 19, 28, 31, 34, 43, 55, 61, 10,   // 9570 - 957F
	22, 25, 25, 28, 28, 28, 31, 31, 31, 31, 31, 34, 34, 34, 34, 34,   // 9580 - 958F
	34, 34, 34, 34, 34, 34, 34, 34, 37, 37, 37, 37, 37, 37, 37, 37,   // 9590 - 959F
	37, 40, 40, 40, 40, 40, 40, 40, 40, 40, 40, 43, 43, 40, 40, 43,   // 95A0 - 95AF
	40, 43, 43, 43, 43, 46, 46, 46, 46, 46, 46, 46, 46, 46, 46, 46,   // 95B0 - 95BF
	49, 46, 46, 49, 49, 49, 49, 49, 49, 49, 49, 49, 49, 46, 49, 49,   // 95C0 - 95CF
	52, 52, 52, 52, 52, 52, 52, 52, 52, 55, 55, 55, 55, 55, 55, 58,   // 95D0 - 95DF
	58, 58, 61, 61, 61, 58, 61, 61,  7, 10, 13, 16, 16, 16, 16, 16,   // 95E0 - 95EF
	19, 19, 19, 19, 19, 19, 19, 19, 22, 22, 25, 25, 25, 25, 25, 25,   // 95F0 - 95FF
	25, 25, 25, 28, 28, 28, 28, 31, 31, 31, 31, 31, 31, 31, 31, 31,   // 9600 - 960F
	31, 34, 34, 34, 34, 34, 37, 37, 37, 37, 40, 46, 22,  4, 10, 10,   // 9610 - 961F
	13, 13, 13, 13, 13, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16,   // 9620 - 962F
	16, 16, 16, 16, 16, 16, 16, 19, 19, 19, 19, 19, 19, 19, 19, 19,   // 9630 - 963F
	19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 22, 22, 22, 22, 22, 22,   // 9640 - 964F
	22, 22, 22, 22, 22, 22, 25, 25, 25, 25, 28, 25, 25, 25, 25, 25,   // 9650 - 965F
	25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 28, 28, 28, 28, 28, 28,   // 9660 - 966F
	28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 31, 28, 31, 31, 31,   // 9670 - 967F
	31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31,   // 9680 - 968F
	31, 34, 34, 34, 34, 34, 34, 31, 34, 34, 37, 37, 37, 37, 34, 37,   // 9690 - 969F
	37, 37, 40, 40, 40, 40, 43, 40, 40, 40, 43, 40, 46, 46, 46, 46,   // 96A0 - 96AF
	46, 46, 46, 49, 52, 55, 22, 46, 49, 22, 28, 28, 28, 28, 28, 31,   // 96B0 - 96BF
	31, 34, 34, 34, 34, 34, 34, 34, 34, 37, 37, 34, 40, 37, 37, 37,   // 96C0 - 96CF
	40, 40, 40, 43, 46, 46, 49, 52, 49, 52, 49, 52, 52, 52, 52, 52,   // 96D0 - 96DF
	52, 55, 52, 55, 61, 61, 61, 61, 22, 31, 31, 31, 34, 31, 34, 34,   // 96E0 - 96EF
	34, 34, 34, 34, 37, 37, 37, 37, 37, 37, 37, 37, 37, 37, 37, 40,   // 96F0 - 96FF
	40, 40, 43, 43, 43, 43, 40, 43, 43, 43, 43, 46, 46, 46, 46, 46,   // 9700 - 970F
	46, 46, 46, 46, 46, 46, 46, 46, 49, 46, 49, 49, 49, 49, 49, 49,   // 9710 - 971F
	49, 49, 52, 52, 52, 52, 55, 52, 55, 52, 55, 55, 55, 55, 58, 58,   // 9720 - 972F
	58, 58, 61, 55, 58, 58, 61, 61, 61, 61, 61, 61, 61, 61, 61, 61,   // 9730 - 973F
	61, 61, 61, 61, 61, 61, 61, 61, 61, 61, 61, 61, 61, 61, 61, 61,   // 9740 - 974F
	61, 22, 22, 34, 34, 37, 37, 40, 40, 40, 43, 46, 46, 52, 22, 34,   // 9750 - 975F
	43, 55, 25, 22, 40, 43, 46, 61, 61, 25, 31, 34, 34, 34, 34, 34,   // 9760 - 976F
	34, 34, 37, 37, 37, 37, 37, 37, 34, 37, 40, 40, 40, 40, 40, 40,   // 9770 - 977F
	40, 40, 40, 40, 40, 40, 40, 43, 43, 43, 43, 43, 43, 43, 43, 43,   // 9780 - 978F
	43, 43, 43, 46, 46, 46, 46, 43, 46, 46, 49, 49, 49, 49, 49, 49,   // 9790 - 979F
	49, 49, 52, 52, 52, 52, 52, 52, 52, 52, 52, 52, 49, 52, 52, 52,   // 97A0 - 97AF
	52, 55, 55, 52, 55, 55, 55, 55, 55, 55, 58, 58, 61, 61, 55, 61,   // 97B0 - 97BF
	61, 61, 61, 61, 61, 61, 61, 61, 61, 61, 61, 25, 34, 40, 40, 43,   // 97C0 - 97CF
	43, 43, 46, 49, 49, 49, 52, 52, 52, 52, 52, 55, 55, 55, 52, 55,   // 97D0 - 97DF
	55, 55, 61, 61, 61, 61, 10, 19, 25, 34, 37, 37, 40, 25, 34, 43,   // 97E0 - 97EF
	46, 49, 55, 25, 37, 37, 40, 40, 46, 52, 49, 55, 55, 58, 58, 58,   // 97F0 - 97FF
	61, 25, 31, 31, 31, 34, 34, 34, 34, 37, 37, 37, 37, 37, 37, 37,   // 9800 - 980F
	37, 37, 37, 37, 40, 40, 40, 40, 40, 40, 40, 43, 43, 43, 43, 43,   // 9810 - 981F
	43, 43, 43, 43, 46, 46, 43, 43, 43, 43, 43, 43, 43, 46, 46, 46,   // 9820 - 982F
	46, 46, 43, 46, 46, 46, 46, 46, 46, 46, 46, 46, 46, 46, 52, 52,   // 9830 - 983F
	49, 49, 49, 49, 49, 49, 49, 49, 49, 49, 49, 52, 52, 52, 52, 52,   // 9840 - 984F
	52, 52, 52, 52, 52, 52, 55, 55, 55, 55, 55, 55, 55, 52, 55, 58,   // 9850 - 985F
	58, 58, 58, 58, 61, 61, 61, 61, 61, 61, 61, 61, 61, 61, 61, 61,   // 9860 - 986F
	61, 61, 61, 61, 61, 16, 22, 22, 25, 25, 25, 25, 28, 28, 28, 28,   // 9870 - 987F
	28, 28, 28, 28, 28, 31, 31, 31, 31, 34, 34, 34, 34, 34, 34, 34,   // 9880 - 988F
	37, 37, 37, 37, 37, 37, 37, 40, 43, 43, 43, 43, 43, 43, 46, 46,   // 9890 - 989F
	46, 46, 52, 52, 55, 58, 61, 61, 25, 34, 34, 37, 37, 40, 40, 40,   // 98A0 - 98AF
	40, 40, 43, 43, 46, 46, 49, 49, 52, 52, 52, 55, 52, 55, 52, 55,   // 98B0 - 98BF
	55, 58, 58, 58, 58, 61, 61, 61, 61, 61, 61, 61, 61, 61, 10, 19,   // 98C0 - 98CF
	25, 25, 25, 34, 37, 37, 40, 40, 43, 46, 46, 25, 61, 61,  7, 25,   // 98D0 - 98DF
	22, 31, 28, 28, 28, 31, 31, 34, 34, 34, 34, 34, 37, 34, 37, 34,   // 98E0 - 98EF
	34, 37, 34, 37, 37, 37, 37, 37, 40, 37, 43, 37, 37, 37, 37, 37,   // 98F0 - 98FF
	37, 40, 40, 40, 40, 40, 40, 40, 43, 40, 40, 43, 40, 43, 40, 40,   // 9900 - 990F
	46, 43, 43, 43, 43, 43, 43, 43, 43, 43, 46, 46, 46, 43, 46, 46,   // 9910 - 991F
	46, 46, 46, 46, 46, 49, 46, 46, 46, 46, 49, 49, 49, 49, 52, 49,   // 9920 - 992F
	49, 49, 49, 49, 46, 49, 49, 49, 49, 52, 52, 52, 52, 49, 52, 49,   // 9930 - 993F
	52, 52, 49, 52, 55, 55, 52, 55, 52, 55, 58, 58, 58, 58, 58, 58,   // 9940 - 994F
	58, 58, 58, 58, 61, 61, 61, 58, 61, 58, 61, 61, 61, 61, 61, 61,   // 9950 - 995F
	61, 61, 61,  7, 13, 13, 16, 16, 19, 19, 19, 19, 19, 19, 19, 22,   // 9960 - 996F
	22, 22, 22, 22, 22, 25, 25, 25, 25, 25, 25, 25, 25, 28, 28, 28,   // 9970 - 997F
	28, 28, 28, 31, 31, 31, 31, 34, 34, 37, 34, 34, 37, 37, 37, 37,   // 9980 - 998F
	37, 40, 40, 43, 43, 61, 25, 31, 49, 25, 37, 40, 40, 40, 46, 46,   // 9990 - 999F
	46, 49, 49, 49, 52, 52, 55, 52, 58, 61, 61, 61, 28, 34, 34, 37,   // 99A0 - 99AF
	37, 37, 37, 37, 37, 37, 40, 40, 40, 40, 37, 40, 40, 40, 40, 40,   // 99B0 - 99BF
	40, 40, 40, 40, 40, 40, 40, 40, 43, 43, 43, 43, 43, 43, 43, 40,   // 99C0 - 99CF
	43, 43, 43, 43, 43, 43, 43, 43, 43, 43, 43, 43, 43, 43, 43, 43,   // 99D0 - 99DF
	43, 46, 46, 46, 46, 46, 46, 46, 46, 46, 46, 46, 46, 46, 46, 46,   // 99E0 - 99EF
	46, 46, 46, 46, 49, 49, 49, 49, 49, 49, 49, 49, 49, 49, 49, 49,   // 99F0 - 99FF
	49, 49, 49, 49, 52, 52, 52, 52, 52, 52, 52, 52, 52, 52, 52, 52,   // 9A00 - 9A0F
	52, 52, 52, 52, 55, 55, 55, 55, 55, 55, 55, 55, 55, 52, 55, 55,   // 9A10 - 9A1F
	55, 55, 55, 55, 55, 55, 55, 52, 55, 55, 55, 58, 58, 55, 58, 58,   // 9A20 - 9A2F
	58, 58, 55, 58, 58, 58, 58, 55, 58, 61, 61, 61, 61, 61, 61, 61,   // 9A30 - 9A3F
	58, 58, 61, 61, 61, 61, 58, 61, 61, 61, 58, 61, 61, 61, 61, 61,   // 9A40 - 9A4F
	61, 61, 61, 61, 61, 61, 61, 61, 61, 61, 61, 61, 61, 61, 61, 61,   // 9A50 - 9A5F
	61, 61, 61, 61, 61, 61, 61, 61, 61, 61, 61, 61,  7, 13, 16, 16,   // 9A60 - 9A6F
	16, 19, 19, 19, 19, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22,   // 9A70 - 9A7F
	22, 25, 25, 25, 25, 25, 25, 25, 25, 25, 28, 28, 28, 28, 28, 28,   // 9A80 - 9A8F
	31, 31, 31, 31, 31, 31, 31, 34, 34, 34, 34, 34, 37, 37, 37, 37,   // 9A90 - 9A9F
	40, 40, 40, 43, 49, 55, 58, 58, 25, 31, 34, 34, 34, 34, 34, 37,   // 9AA0 - 9AAF
	37, 37, 40, 40, 43, 40, 40, 40, 43, 43, 43, 43, 43, 46, 46, 43,   // 9AB0 - 9ABF
	49, 49, 52, 52, 52, 52, 55, 55, 55, 55, 52, 55, 55, 58, 58, 58,   // 9AC0 - 9ACF
	61, 61, 61, 61, 61, 61, 61, 61, 28, 31, 40, 43, 52, 61, 61, 28,   // 9AD0 - 9ADF
	34, 37, 37, 40, 40, 40, 40, 40, 40, 40, 40, 43, 43, 46, 43, 43,   // 9AE0 - 9AEF
	43, 43, 43, 43, 43, 46, 46, 46, 46, 46, 46, 46, 49, 49, 49, 49,   // 9AF0 - 9AFF
	49, 49, 49, 52, 52, 52, 52, 46, 52, 55, 55, 55, 55, 55, 55, 55,   // 9B00 - 9B0F
	58, 58, 58, 58, 58, 58, 61, 61, 61, 61, 61, 61, 61, 61, 61, 61,   // 9B10 - 9B1F
	61, 61, 61, 61, 61, 28, 40, 43, 46, 52, 58, 61, 61, 61, 61, 28,   // 9B20 - 9B2F
	61, 61, 28, 46, 49, 52, 52, 55, 58, 61, 61, 61, 25, 34, 37, 37,   // 9B30 - 9B3F
	37, 37, 37, 40, 40, 40, 40, 43, 46, 46, 49, 49, 49, 49, 49, 49,   // 9B40 - 9B4F
	55, 55, 58, 55, 58, 61, 58, 61, 61, 61, 31, 37, 37, 37, 37, 40,   // 9B50 - 9B5F
	40, 40, 40, 43, 43, 40, 43, 43, 43, 43, 43, 43, 43, 43, 43, 43,   // 9B60 - 9B6F
	43, 43, 43, 43, 43, 43, 43, 43, 43, 43, 46, 46, 46, 46, 46, 46,   // 9B70 - 9B7F
	46, 46, 46, 46, 46, 46, 49, 46, 46, 46, 46, 46, 46, 46, 46, 46,   // 9B80 - 9B8F
	46, 46, 46, 46, 43, 46, 46, 46, 46, 49, 49, 49, 49, 49, 49, 49,   // 9B90 - 9B9F
	49, 49, 49, 46, 49, 49, 49, 49, 49, 49, 49, 49, 49, 49, 49, 49,   // 9BA0 - 9BAF
	49, 49, 49, 49, 49, 52, 52, 52, 52, 52, 49, 52, 52, 52, 52, 52,   // 9BB0 - 9BBF
	52, 52, 52, 52, 52, 49, 52, 52, 49, 52, 52, 52, 52, 52, 49, 52,   // 9BC0 - 9BCF
	52, 52, 52, 52, 55, 55, 55, 52, 55, 55, 55, 55, 55, 55, 55, 55,   // 9BD0 - 9BDF
	55, 55, 55, 55, 55, 55, 55, 55, 55, 55, 55, 55, 55, 55, 55, 55,   // 9BE0 - 9BEF
	55, 55, 55, 55, 55, 55, 58, 58, 58, 58, 55, 58, 58, 52, 58, 58,   // 9BF0 - 9BFF
	58, 58, 58, 58, 58, 58, 58, 58, 58, 58, 58, 58, 58, 58, 55, 58,   // 9C00 - 9C0F
	58, 58, 58, 58, 58, 58, 58, 58, 58, 55, 58, 58, 61, 61, 61, 61,   // 9C10 - 9C1F
	58, 61, 61, 61, 61, 61, 58, 61, 61, 61, 61, 61, 61, 61, 61, 61,   // 9C20 - 9C2F
	58, 61, 61, 61, 61, 61, 61, 61, 61, 61, 61, 61, 61, 61, 61, 61,   // 9C30 - 9C3F
	58, 61, 61, 61, 61, 61, 61, 61, 61, 61, 61, 61, 61, 61, 61, 61,   // 9C40 - 9C4F
	61, 61, 61, 61, 61, 61, 61, 61, 61, 61, 61, 61, 61, 61, 61, 61,   // 9C50 - 9C5F
	61, 61, 61, 61, 61, 61, 61, 61, 61, 61, 61, 61, 61, 61, 61, 61,   // 9C60 - 9C6F
	61, 61, 61, 61, 61, 61, 61, 61, 61, 61, 61, 61, 22, 28, 31, 34,   // 9C70 - 9C7F
	34, 34, 34, 34, 37, 37, 37, 37, 37, 37, 37, 37, 37, 37, 37, 37,   // 9C80 - 9C8F
	37, 40, 40, 40, 40, 40, 40, 40, 40, 40, 40, 40, 40, 40, 40, 40,   // 9C90 - 9C9F
	43, 43, 43, 43, 43, 43, 43, 43, 43, 43, 43, 43, 43, 46, 46, 46,   // 9CA0 - 9CAF
	46, 46, 46, 46, 46, 46, 46, 46, 46, 46, 46, 46, 49, 49, 49, 49,   // 9CB0 - 9CBF
	49, 49, 49, 49, 49, 49, 49, 49, 49, 49, 49, 49, 52, 52, 52, 52,   // 9CC0 - 9CCF
	52, 52, 52, 55, 55, 55, 55, 55, 55, 55, 55, 55, 58, 58, 58, 58,   // 9CD0 - 9CDF
	61, 61, 61, 61, 61, 31, 34, 37, 37, 37, 37, 37, 25, 37, 37, 37,   // 9CE0 - 9CEF
	37, 40, 40, 40, 40, 40, 40, 43, 43, 43, 43, 43, 43, 43, 43, 43,   // 9CF0 - 9CFF
	43, 43, 43, 43, 43, 43, 43, 43, 43, 43, 46, 43, 43, 43, 43, 46,   // 9D00 - 9D0F
	46, 46, 46, 46, 43, 46, 46, 46, 46, 46, 46, 46, 49, 46, 46, 46,   // 9D10 - 9D1F
	46, 46, 46, 46, 46, 46, 46, 46, 46, 46, 46, 46, 46, 49, 49, 49,   // 9D20 - 9D2F
	49, 46, 49, 49, 49, 49, 49, 49, 49, 49, 49, 49, 49, 49, 49, 49,   // 9D30 - 9D3F
	49, 49, 49, 49, 49, 49, 49, 49, 49, 49, 52, 52, 52, 52, 52, 52,   // 9D40 - 9D4F
	52, 52, 52, 52, 52, 52, 52, 52, 52, 52, 52, 52, 52, 52, 52, 52,   // 9D50 - 9D5F
	52, 52, 52, 52, 52, 52, 55, 49, 55, 55, 55, 55, 55, 55, 55, 55,   // 9D60 - 9D6F
	55, 55, 55, 55, 55, 55, 55, 55, 55, 55, 55, 55, 55, 55, 55, 55,   // 9D70 - 9D7F
	55, 55, 55, 55, 55, 55, 55, 55, 55, 55, 55, 55, 55, 55, 55, 55,   // 9D80 - 9D8F
	55, 55, 58, 55, 58, 58, 58, 58, 58, 58, 58, 58, 55, 58, 58, 58,   // 9D90 - 9D9F
	58, 58, 58, 58, 58, 58, 58, 55, 58, 58, 58, 58, 61, 61, 61, 61,   // 9DA0 - 9DAF
	61, 61, 61, 61, 61, 61, 61, 61, 61, 61, 61, 58, 61, 61, 61, 58,   // 9DB0 - 9DBF
	58, 61, 61, 61, 61, 61, 61, 61, 61, 61, 61, 61, 61, 61, 61, 61,   // 9DC0 - 9DCF
	61, 61, 61, 61, 61, 61, 61, 61, 61, 61, 61, 61, 61, 61, 61, 61,   // 9DD0 - 9DDF
	61, 61, 61, 61, 61, 61, 61, 61, 61, 61, 61, 61, 61, 61, 61, 61,   // 9DE0 - 9DEF
	61, 61, 61, 61, 61, 61, 61, 61, 61, 61, 61, 61, 61, 61, 61, 61,   // 9DF0 - 9DFF
	61, 61, 61, 61, 61, 61, 61, 61, 61, 61, 61, 61, 61, 61, 61, 61,   // 9E00 - 9E0F
	61, 61, 61, 61, 61, 61, 61, 61, 61, 61, 61, 61, 61, 61, 61, 13,   // 9E10 - 9E1F
	19, 19, 22, 22, 22, 25, 25, 25, 25, 25, 28, 28, 28, 28, 28, 28,   // 9E20 - 9E2F
	28, 28, 28, 28, 28, 28, 28, 31, 31, 31, 31, 31, 31, 31, 31, 31,   // 9E30 - 9E3F
	34, 34, 34, 34, 34, 34, 34, 34, 34, 37, 37, 37, 37, 37, 37, 37,   // 9E40 - 9E4F
	37, 37, 37, 37, 37, 40, 40, 40, 40, 40, 40, 40, 40, 43, 43, 43,   // 9E50 - 9E5F
	43, 43, 43, 43, 43, 46, 46, 46, 46, 49, 49, 49, 49, 52, 52, 52,   // 9E60 - 9E6F
	52, 52, 52, 61, 61, 31, 43, 46, 55, 58, 58, 61, 61, 61, 46, 31,   // 9E70 - 9E7F
	37, 37, 37, 43, 43, 46, 46, 46, 46, 49, 49, 49, 52, 52, 52, 52,   // 9E80 - 9E8F
	52, 55, 55, 55, 55, 55, 55, 55, 58, 58, 58, 58, 61, 61, 61, 61,   // 9E90 - 9E9F
	61, 61, 61, 61, 61, 31, 19, 40, 43, 43, 43, 43, 46, 46, 46, 49,   // 9EA0 - 9EAF
	49, 52, 52, 55, 55, 58, 61, 61, 31, 43, 46, 31, 40, 40, 43, 49,   // 9EB0 - 9EBF
	55, 58, 61, 34, 31, 43, 43, 46, 46, 46, 49, 49, 61, 34, 43, 49,   // 9EC0 - 9ECF
	61, 34, 31, 43, 46, 46, 46, 46, 46, 43, 49, 49, 49, 49, 49, 52,   // 9ED0 - 9EDF
	52, 52, 55, 55, 58, 58, 58, 58, 58, 58, 58, 61, 61, 61, 61, 61,   // 9EE0 - 9EEF
	61, 61, 61, 61, 61, 61, 61, 61, 61, 34, 46, 49, 55, 37, 22, 49,   // 9EF0 - 9EFF
	52, 52, 52, 55, 55, 61, 61, 61, 61, 61, 61, 34, 37, 58, 34, 40,   // 9F00 - 9F0F
	40, 40, 43, 37, 37, 52, 52, 55, 61, 61, 61, 61, 61, 61, 61, 61,   // 9F10 - 9F1F
	37, 22, 49, 49, 49, 52, 52, 52, 52, 52, 52, 52, 52, 55, 55, 58,   // 9F20 - 9F2F
	58, 61, 61, 61, 61, 61, 61, 61, 61, 61, 61, 40, 46, 46, 49, 49,   // 9F30 - 9F3F
	52, 55, 61, 61, 61, 61, 61, 61, 61, 61, 40, 49, 52, 55, 61, 61,   // 9F40 - 9F4F
	16, 43, 43, 46, 49, 52, 55, 55, 55, 58, 58, 58, 61, 58, 58, 58,   // 9F50 - 9F5F
	58, 58, 49, 58, 61, 61, 61, 61, 61, 61, 61, 61, 61, 61, 61, 61,   // 9F60 - 9F6F
	61, 61, 61, 61, 61, 61, 61, 61, 61, 61, 61, 61, 61, 61, 61, 22,   // 9F70 - 9F7F
	28, 31, 34, 37, 37, 37, 37, 40, 40, 43, 43, 49, 49, 46, 52, 55,   // 9F80 - 9F8F
	55, 58, 61, 61, 61, 61, 61, 61, 61, 13, 31, 31, 49, 61, 61, 19,   // 9F90 - 9F9F
	49, 61, 61, 61, 61, 61,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 9FA0 - 9FAF
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 9FB0 - 9FBF
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 9FC0 - 9FCF
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 9FD0 - 9FDF
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 9FE0 - 9FEF
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // 9FF0 - 9FFF
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // F900 - F90F
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // F910 - F91F
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 40,  0,  0,  0,   // F920 - F92F
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // F930 - F93F
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // F940 - F94F
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // F950 - F95F
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // F960 - F96F
	 0,  0,  0,  0,  0,  0,  0,  0,  0, 28,  0,  0,  0,  0,  0,  0,   // F970 - F97F
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // F980 - F98F
	 0,  0,  0,  0,  0, 22,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // F990 - F99F
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // F9A0 - F9AF
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // F9B0 - F9BF
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // F9C0 - F9CF
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // F9D0 - F9DF
	 0,  0,  0,  0,  0,  0,  0, 37,  0,  0,  0,  0,  0,  0,  0,  0,   // F9E0 - F9EF
	 0, 40,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // F9F0 - F9FF
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  7, 37, 37, 28,   // FA00 - FA0F
	 0, 34,  0, 37, 40,  0,  0,  0, 16,  0,  0,  0,  0,  0,  0, 46,   // FA10 - FA1F
	61, 31,  0, 31, 19,  0,  0, 43, 46, 34,  0,  0,  0,  0,  0,  0,   // FA20 - FA2F
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // FA30 - FA3F
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // FA40 - FA4F
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // FA50 - FA5F
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // FA60 - FA6F
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // FA70 - FA7F
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // FA80 - FA8F
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // FA90 - FA9F
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // FAA0 - FAAF
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // FAB0 - FABF
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // FAC0 - FACF
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // FAD0 - FADF
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // FAE0 - FAEF
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,   // FAF0 - FAFF
};
